/* auxfunc.c- auxilery functions used by psas.c */
#include <stdio.h>
#define NOFUNCTIONS
#include "head.h"
#include "pseudo.h"
#include "psas86.h"
/*input file format:
* size ( OFUNC "name" type stksz predefsz ( len stf len stf ...) stuff )
* size ( OFUNC "name" type stksz predefsz ( len stf len stf ...) stuff )
* ...
* size (OPTEXTERN extcnt ("nm" type prepres [size stuff cnt (sect soff poff)])
*           strlen strstf cnt (sect soff poff))
*/
#define STNORMAL     0 /*jump optimization modes*/
#define STERASE      1
#define STLABEL      2
#define STERASELABEL 3
struct labxref
{ short src,dst;
} *labxref;
short labxcnt;
genjcc(pos,swtched,neg,unsgn) /* generate proper jcc */
{ int x;
  x=opcode[pos];
  switch(x)
  { case OEQ:
     return neg?0x75/* jne */:0x74; /* je */
    break;
    case ONEQ:
     return neg?0x74/* je */:0x75; /* jne */
    break;
    case OTEST:
     return neg?0x74/* je */:0x75; /* jne */
    break;
    case OLT:
     if(neg)
      if(!unsgn) return swtched?0x7e/* jle */ :0x7d;/*jge */
      else return swtched?0x76 /* jbe */ :0x73; /* jae */
     else
      if(!unsgn) return swtched?0x7f /* jg */ :0x7c; /*jl */
      else return swtched?0x77 /* ja */ :0x72; /* jb */
    break;
    case OGT:
     if(neg)
      if(!unsgn) return swtched?0x7d/* jge */ :0x7e;/*jle */
      else return swtched?0x73 /* jae */ :0x76; /* jbe */
     else
      if(!unsgn) return swtched?0x7c/* jl */ :0x7f;/* jg */
      else return swtched?0x72 /* jb */ :0x77; /* ja */
    break;
    case OLE:
     if(neg)
      if(!unsgn) return swtched?0x7c/* jl */ :0x7f;/* jg */
      else return swtched?0x72 /* jb */ :0x77; /* ja */
     else
      if(!unsgn) return swtched?0x7d/* jge */ :0x7e;/*jle */
      else return swtched?0x73 /* jae */ :0x76; /* jbe */
    break;
    case OGE:
     if(neg)
      if(!unsgn) return swtched?0x7f /* jg */ :0x7c; /*jl */
      else return swtched?0x77 /* ja */ :0x72; /* jb */
     else
      if(!unsgn) return swtched?0x7e/* jle */ :0x7d;/*jge */
      else return swtched?0x76 /* jbe */ :0x73; /* jae */
  }
  illegaltype("shouldn't be here");
}
printrpn(rpn) struct stack *rpn;
{ int a;
  fprintf(stderr,"START: %d\n",rpn-rpnstk);
  fprintf(stderr,"lexst %d  place %d  lplace %d  hblkcnt %d lbcnt %d  tp %d\n"
   ,rpn->lexist,rpn->place,rpn->lplace,rpn->hblkcnt,rpn->lbcnt,rpn->tp);
  fprintf(stderr,"ltp %d rpnsln %d\n",rpn->ltp,rpnsln);
  fprintf(stderr,"argreg %d  .reg %d  .use %d  blen %d\n",rpn->argreg
   ,rpn->argreg>=0?rpn->reguse[rpn->argreg].reg:-5
   ,rpn->argreg>=0?rpn->reguse[rpn->argreg].use:-5,rpn->blen);
  fprintf(stderr
   ,"bpxref %x normstat %x intstat %x exref %x bops %x hblk %x lbt %x\n"
   ,rpn->bpxref,rpn->normstat,rpn->intstat,rpn->exref,rpn->bops,rpn->hblk
   ,rpn->lbt);
  for(a=0;a<rpn->hblkcnt;a++)
   fprintf(stderr
    ," hb %d bpxref %x normstat %x intstat %x exref %x bops %x lbt %x\n"
    ,a,rpn->hblk[a].bpxref,rpn->hblk[a].normstat,rpn->hblk[a].intstat
    ,rpn->hblk[a].exref,rpn->hblk[a].bops,rpn->hblk[a].lbt);
  fprintf(stderr,"END:loccnt %d loc %x\n",rpn->loccnt,rpn->loc);
}
initrpnstk()
{ int a;
  struct stack *rpn;
  if(rpnsln&&rpnstk[rpnsln-1].combineflg)
  { rpn=rpnstk+(rpnsln-1);
    rpn->boff=rpn->lexist=0;
    if(startncb)
    { if(rpn->ncbcnt)
      { RAL(rpn->ncb,rpn->ncbcnt+startncb,struct nestcombined); }
      else AL(rpn->ncb,rpn->ncbcnt+startncb,struct nestcombined);
      for(;startncb>0;startncb--)
      { rpn->ncb[rpn->ncbcnt].call=1;
        rpn->ncb[rpn->ncbcnt].hidn=0;
        rpn->ncb[rpn->ncbcnt].nbp=rpn->bpoff;
        rpn->ncb[rpn->ncbcnt++].off=rpn->blen;
      }
    }
  }
  else
  { rpn=rpnstk+rpnsln;
    rpn->place=rpn->sect=rpn->lexist=rpn->tp=rpn->maxfltlev=rpn->scoff
     =rpn->boff=rpn->blen=rpn->bpxcnt=rpn->maxoff=rpn->bpoff=rpn->size
     =rpn->combineflg=rpn->hblkcnt=rpn->lbcnt=rpn->nstatcnt=rpn->istatcnt
     =rpn->loccnt=rpn->lbcnt=rpn->exrcnt=0;
    for(a=0;a<11;a++) rpn->reguse[a].use=0;
    if(startncb)
    { AL(rpn->ncb,startncb,struct nestcombined);
      for(a=0;a<startncb;a++)
      { rpn->ncb[a].call=1;
        rpn->ncb[a].nbp=rpn->ncb[a].hidn=rpn->ncb[a].off=0;
      }
    }
    rpn->ncbcnt=startncb;
    startncb=0;
    AL(rpn->normstat,1,struct staticxref);
    AL(rpn->intstat,1,struct staticxref);
    AL(rpn->exref,1,struct externxref);
    AL(rpn->bpxref,1,long);
  }
  rpn->gzf=rpn->gcsof=0;
}
typesize(n)
{ switch(rpnstk[rpnsln-n].tp%SUNSIGNED)
  { case SINT:     return soint;
    case SLONG:    return solong;
    case SDOUBLE:  return sodouble;
    case SFLOAT:   return sofloat;
    case SPOINTER: return sopoint;
    case SSTRUCT:  return rpnstk[rpnsln-n].size;
    case SSHORT:   return soshort;
    case SCHAR:    return sochar;
    case SFUNC:    break;
    default:
     sprintf(temp,"unknown type in typesize %d",rpnstk[rpnsln-n].tp);
     fatal=1; yyerror(temp);
  }
}
powof2(x) unsigned long x;
{ int pow=0;
  while (1)
  { if(x&1&&x>1) return(-1);
    if(!x) return pow-1;
    x>>=1; pow++;
  }
}
bopsload()
{ int a,b,c,x;
  struct stack *rpp;
  struct block *bk;
  struct hiddenblock *hbk;
  rpp=rpnstk+(rpnsln-1);
  if(rpnsln>1||startcomma) /*prob. comma operater, not related to CALL*/
  { if(!rpnsln||!startcomma) illegaltype("startcomma");
    startcomma--;
    rpp->combineflg=1; /* 0 bpoff */
    if(rpp->ncbcnt)
    { RAL(rpp->ncb,rpp->ncbcnt+1,struct nestcombined); }
    else AL(rpp->ncb,1,struct nestcombined);
    rpp->ncb[rpp->ncbcnt].hidn=rpp->ncb[rpp->ncbcnt].call=0;
    rpp->ncb[rpp->ncbcnt].nbp=rpp->bpoff;
    rpp->ncb[rpp->ncbcnt++].off=rpp->blen;
/*IAM: eventually dump that junk:*/
    /*rpp->lbcnt=rpp->blen=rpp->bpxcnt=rpp->nstatcnt=rpp->istatcnt
      =rpp->exrcnt=0;
    AL(rpp->normstat,1,struct staticxref);
    AL(rpp->intstat,1,struct staticxref);
    AL(rpp->exref,1,struct externxref);
    AL(rpp->bpxref,1,long);
    AL(rpp->bops,1,char);*/
  }
  else
  { if(rpp->hblkcnt) { RAL(rpp->hblk,rpp->hblkcnt+1,struct hiddenblock); }
    else { AL(rpp->hblk,1,struct hiddenblock); }
    if(rpp->ncbcnt)
    { startncb+=rpp->ncbcnt; /* if 1st arg is ?:, bops will load it here */
/*ncb.calls will be messed up, but we can probably trash them anyways*/
/*also made not hidden, but because blen will be=0, this OK*/
      free(rpp->ncb);
    }
    hbk=rpp->hblk+rpp->hblkcnt; /* make end treatable the same */
    hbk->nstatcnt=rpp->nstatcnt; hbk->normstat=rpp->normstat;
    hbk->istatcnt=rpp->istatcnt; hbk->intstat=rpp->intstat;
    hbk->exrcnt=rpp->exrcnt;     hbk->exref=rpp->exref;
    hbk->bpxcnt=rpp->bpxcnt;     hbk->bpxref=rpp->bpxref;
    hbk->lbcnt=rpp->lbcnt;       hbk->lbt=rpp->lbt;
    hbk->blen=rpp->blen;         hbk->bops=rpp->bops;
    hbk=rpp->hblk;
    for(x=0;x<hbk->bpxcnt;x++)
      *(wordptr)(hbk->bops+hbk->bpxref[x])-=spsmaxt;
    free(hbk->bpxref);
    RAL(normstat,nstatcnt+hbk->nstatcnt,struct staticxref);
    for(x=0;x<hbk->nstatcnt;x++)
    { normstat[nstatcnt]=hbk->normstat[x];
      normstat[nstatcnt].blck=blcnt-1; normstat[nstatcnt++].off+=blen;
    }
    free(hbk->normstat);
    RAL(intstat,istatcnt+hbk->istatcnt,struct staticxref);
    for(x=0;x<hbk->istatcnt;x++)
    { intstat[istatcnt]=hbk->intstat[x];
      intstat[istatcnt].blck=blcnt-1; intstat[istatcnt++].off+=blen;
    }
    free(hbk->intstat);
    RAL(exref,exrcnt+hbk->exrcnt,struct externxref);
    for(x=0;x<hbk->exrcnt;x++)
    { exref[exrcnt]=hbk->exref[x];
      exref[exrcnt].blck=blcnt-1; exref[exrcnt++].off+=blen;
    }
    free(hbk->exref);
    RAL(bops,blen+hbk->blen,char);
    memcpy(bops+blen,hbk->bops,hbk->blen);
    blen+=hbk->blen;
    free(hbk->bops);
    if(hbk->lbcnt)
    { for(a=0;a<hbk->lbcnt;a++)
      { b=hbk->lbt[a].block;
        if(b>=lbtbllen)
        { RAL(lbtbl,b+1,struct labels);
          while(b>=lbtbllen) lbtbl[lbtbllen++].here=0;
        }
        if(lbtbl[b].here)
        { fatal=1; sprintf(temp,"2 definitions of label number %d",b);
          yyerror(temp);
        }
        lbtbl[b].block=blcnt-1;
        lbtbl[b].off=hbk->lbt[a].off;
        lbtbl[b].here=1;
      }
      free(hbk->lbt);
    }
    RAL(block,blcnt+rpp->hblkcnt,struct block);
    bk=block+(blcnt-1);
    for(a=1,hbk=rpp->hblk;a<=rpp->hblkcnt;a++,blcnt++)
    { block[blcnt].outoff=bk->outoff+blen;
      bk->len=blen; bk->ops=bops;
      bk->jmppos=hbk->jmppos; bk->swtched=hbk->swtched; bk->unsgn=hbk->unsgn;
      bk->jmpsz=JSSMALL;
      hbk++; bk++;
      for(x=0;x<hbk->bpxcnt;x++)
        *(wordptr)(hbk->bops+hbk->bpxref[x])-=spsmaxt;
      free(hbk->bpxref);
      RAL(normstat,nstatcnt+hbk->nstatcnt,struct staticxref);
      for(x=0;x<hbk->nstatcnt;x++)
      { normstat[nstatcnt]=hbk->normstat[x]; normstat[nstatcnt++].blck=blcnt; }
      free(hbk->normstat);
      RAL(intstat,istatcnt+hbk->istatcnt,struct staticxref);
      for(x=0;x<hbk->istatcnt;x++)
      { intstat[istatcnt]=hbk->intstat[x]; intstat[istatcnt++].blck=blcnt; }
      free(hbk->intstat);
      RAL(exref,exrcnt+hbk->exrcnt,struct externxref);
      for(x=0;x<hbk->exrcnt;x++)
      { exref[exrcnt]=hbk->exref[x]; exref[exrcnt++].blck=blcnt; }
      free(hbk->exref);
      if(hbk->lbcnt)
      { for(c=0;c<hbk->lbcnt;c++)
        { b=hbk->lbt[c].block;
          if(b>=lbtbllen)
          { RAL(lbtbl,b+1,struct labels);
            while(b>=lbtbllen) lbtbl[lbtbllen++].here=0;
          }
          if(lbtbl[b].here)
          { fatal=1; sprintf(temp,"2 definitions of label number %d",b);
            yyerror(temp);
          }
          lbtbl[b].block=blcnt;
          lbtbl[b].off=hbk->lbt[c].off;
          lbtbl[b].here=1;
        }
        free(hbk->lbt);
      }
      blen=hbk->blen; bops=hbk->bops;
    }
    free(rpp->hblk);
    rpnsln--;
  }
}
struct memindx genmemin(indx,rp1p,rsto,sect,scoff,boff,lstpoint,n,bpoff)
/* rp1p-     highest priority
 * rsto-     argreg, a value like -1,8 does is an error
 * sect-     if memory, this specifies what type
 * scoff-    either offset from base or (for ext. table index)
 * boff-     offset from base of variable- used for struct.
 * lstpoint- if 0 then access register that pointer is stored in, not object
 * n-        if 2, access second word of a double word
 * bpoff-    used for stack
 */
{ struct memindx out;
  long x;
  out.segexist=out.xexist=0; out.sz=1;
  switch(rp1p)
  { case PCMEMORY:
     switch(sect)   /* when consts include boff, it includes n */
     { case SCARG:
        /* [bp+consts] (offset+boff+6+x(other pushed registers)) */
        x=boff+n+scoff+22; /* room for ret addrs and pushed regs */
       goto bphandle;
       case SCAUTO:   /* [bp+consts]   (offset+boff) */
        x=boff+n+scoff-spsmaxt;
       bphandle:
        if(x<(-128)||x>127)
        { /* [bp+off16] */
          *out.stf=0x86;
          RBU(out.stf,out.sz)=x; out.sz+=2;
        }
        else
        { /* [bp+off8] */
          *out.stf=0x46;
          out.stf[out.sz++]=x;
        }
        out.pushseg=0x16;
       break;
       case SCSTATIC: /* [consts]  (offset+boff put in xref table) */
        x=boff+n+scoff;
        out.xexist=XREXSTATIC; out.xoff=1;
       goto cnsthandle;
       case SCPUBLIC: /* [consts] (boff only-off by link-put in xref table) */
        x=boff+n;
        out.xexist=XREXTERN; out.xoff=1;
        out.scoff=scoff;
       cnsthandle:
        *out.stf=0x06;
        RBU(out.stf,out.sz)=x; out.sz+=2;
        out.pushseg=0x1e;
       break;
       default: fatal=1; yyerror("unknown variable section in genmemin()");
     }
    break;
    case PCLSTPOINT:
if(rsto==8&&n!=2) { fatal=1; yyerror("gen"); }
     if(!lstpoint) goto registr;
     rsto=indx;
     if(boff+n)
     { /* es:[bx+consts] (boff) */
       n+=boff;
       if(n>=(-128)&&n<=127)
       { switch(rsto)
         { case 3: *out.stf=0x47; break;
           case 6: *out.stf=0x44; break;
           case 7: *out.stf=0x45; break;
           default: fatal=1; yyerror("1nonindexable register");
         }
         out.stf[out.sz++]=n;
       }
       else
       { switch(rsto)
         { case 3: *out.stf=0x87; break;
           case 6: *out.stf=0x84; break;
           case 7: *out.stf=0x85; break;
           default: fatal=1; yyerror("2nonindexable register");
         }
         RBU(out.stf,out.sz)=n; out.sz+=2;
       }
     }
     else
     { /* es:[rg] */
       switch(rsto)
       { case 3: *out.stf=0x7; break;
         case 6: *out.stf=0x4; break;
         case 7: *out.stf=0x5; break;
         default: fatal=1; yyerror("3nonindexable register");
       }
     }
     out.segexist=1; out.seg=0x26;  /* es: */ out.pushseg=0x06;
    break;
    case PCSTACK:
     /* [bp+cnsts] (bpoff+boff) */
     *out.stf=0x86;
     RBU(out.stf,out.sz)=bpoff+n; out.sz+=2;
     out.xexist=XRSTACK; out.xoff=1; out.pushseg=0x16;
    break;
    case PCREG:
    registr:
     /* RG
      * c0+reg(if off=2, use reguse[].reg) */
if(rsto<0||rsto>7)
{ illegaltype("rsto in genmem"); }
     *out.stf=0xc0+rsto;
    break;
    case PCCONST:
     x=boff+n;
     out.xexist=XRCNSTDOUBLE; out.xoff=1;
    goto cnsthandle;
    case PCMATH:
    default:
     fatal=1; yyerror("unknown position in genmemin()");
     fprintf(stderr,"  at rp1p %d\n",rp1p);
  }
 return out;
}
xrfill(rpn,emem) struct stack *rpn; struct memindx emem;
/* called after stf has been put on the stack */
{ long pos;
  pos=rpn->blen-emem.sz+emem.xoff;
  switch(emem.xexist)
  { case 0: break;  /* no xref */
    case XREXSTATIC:
     RAL(rpn->normstat,rpn->nstatcnt+1,struct staticxref);
     rpn->normstat[rpn->nstatcnt++].off=pos; /* blck blank till out of stck */
    break;
    case XREXTERN:
     RAL(rpn->exref,rpn->exrcnt+1,struct externxref);
     rpn->exref[rpn->exrcnt].ptrfnc=0;
     rpn->exref[rpn->exrcnt].off=pos; /* blck blank till out of stck */
     rpn->exref[rpn->exrcnt++].scoff=emem.scoff;
    break;
    case XRSTACK:
     RAL(rpn->bpxref,rpn->bpxcnt+1,long);
     rpn->bpxref[rpn->bpxcnt++]=pos;
    break;
    case XRCNSTDOUBLE:
     RAL(rpn->intstat,rpn->istatcnt+1,struct staticxref);
     rpn->intstat[rpn->istatcnt++].off=pos;
    break;
    default: fatal=1; yyerror("unknown type of extern in xrfill");
  }
}
struct bld binaryloadit(srcconst,dstmem,srcmem,swtchable,argtp,argreg
   ,lrgfld,lngmth,ldiff,nodxout,preserve,cmpjmp,preswitched)
/* srcconsts- source can be constant
 * dstmem   - destination can be storage memory (this excludes near stacktop)
 * srcmem   - source can be memory (only for MATH and argrp 1st and EITHER)
 * swtchable- op a,b  become op b,a  for making memory src (!dst)?
 *             (only in argtp NONE)
 * argtp    - no reg restrict/1st/2nd/either restricted
 * argreg    - what above is restricted to
 * lrgfld   - if 1 then reg field of mod-r/m byte is left 0
 * lngmth   - longs must be in math coprossesor?
 * ldiff    - legal if types differ?
 * nodxout  - (-1) to disable, 2 for disabling use of dx with argtp 1st
 * preserve - preserve rp1 LSTPOINT regs if existent
 * cmpjmp   - used to indicate that 2nd argument can be memory even while
 *             first is constant
 */
#define PD1LSTPT  1
#define PD2LSTPT  3
#define PD1LDIT   5
#define PD1LDIT2  6
#define PD2LDIT   7
#define PD2LDIT2  8
#define PDCOMBINE 9
#define PDXCHG    10
#define PDXCHG2   11
{ struct bld o;
  long ltmp,x;
  int fltlev,swfltlev,umath,ruse,swruse,r1lp,r2lp,rlpreg,r2lpreg;
  struct moveit
  { char prcd,reg; } swpd[16],pd[16],*p;
  int pc,r1lded,r2lded;
  int fwait,swpdc,pdc,ncnst1st,ncnst2nd,lp1st,outplc,swoutplc,mem,swmem;
  int bpo1,bpo2,mbpo1,mbpo2,mxbpoff,swmxbpoff;
  int dblwo2nd,dblwo1st,rp1p,rp2p,itmp;
  struct stack rpn,*rp1,*rp2;
  struct regusage rut[14],swrut[14];
  int prsrv1=0,swprsrv1=0,p1rs2,swp1rs2,trst,trs2;
  int rsto,r2sto,rsto2,r2sto2,const,swconst;
  long cval,swcval;
  rp1=rpnstk+(rpnsln-2); /* 1st argument */
  rp2=rpnstk+(rpnsln-1); /* 2nd argument */
  if(preserve&&!dstmem)
  { rp1->lexist=1; rp1->lplace=rp1->place; rp1->ltp=rp1->tp;
    rp1->llprg=rp1->argreg;
    if(rp1->argreg>=0) rp1->lpprg2=rp1->reguse[rp1->argreg].reg;
    if(rp1->place!=PCMEMORY&&rp1->place!=PCLSTPOINT)
    { fatal=1; yyerror("preserve non lexist?"); }
    rp1->lboff=rp1->boff;
    if(rp1->place!=PCLSTPOINT) preserve=0;
  }
  else preserve=0;
  umath
   =(rp1->tp==SFLOAT||rp1->tp==SDOUBLE||(rp1->tp%SUNSIGNED==SLONG&&lngmth));
  rp1p=rp1->place;
  rp2p=rp2->place;
  fwait=swpdc=pdc=0;
  if(umath)
  {/*LASTPOINTs 1st and 2nd*/
    itmp=findreg(0,rut,2,0,rut,-1,-1,-1,-1,-1,-1);
    if(rp1p==PCLSTPOINT)
    { if(rp1->reguse[rp1->argreg].reg!=8)
        regloadit(rp1,rp1,rp1->place,rp1->reguse[rp1->argreg].reg,1,2,8);
      rsto=rp1->argreg;
      if(rsto!=3&&rsto!=6&&rsto!=7)
        regloadit(rp1,rp1,rp1->place,rp1->argreg,1,0,itmp);
      else itmp=rsto;
      rp1->argreg=itmp;
      swrut[itmp].use=rut[itmp].use=1; swrut[8].use=rut[8].use=1;
      rp1->reguse[itmp].use=RP1STPT; rp1->reguse[itmp].reg=8;
      rp1->reguse[8].use=RP2NDPT;    rp1->reguse[8].reg=itmp;
    }
    if(rp2p==PCLSTPOINT)
    { if(rp2->reguse[rp2->argreg].reg!=8)
        regloadit(rp2,rp2,rp2->place,rp2->reguse[rp2->argreg].reg,1,2,8);
      rsto=rp2->argreg;
      if(rsto!=3&&rsto!=6&&rsto!=7)
        regloadit(rp2,rp2,rp2->place,rp2->argreg,1,0,itmp);
      else itmp=rsto;
      rp2->argreg=itmp;
      swrut[itmp].use=rut[itmp].use=1; swrut[8].use=rut[8].use=1;
      rp2->reguse[itmp].use=RP1STPT; rp2->reguse[itmp].reg=8;
      rp2->reguse[8].use=RP2NDPT;    rp2->reguse[8].reg=itmp;
    }
    x=findreg(0,rut,2,0,rut,itmp,-1,-1,-1,-1,-1);
    if(rp1p==PCCONST&&rp1->tp%SUNSIGNED==SLONG)
    { regloadit(rp1,rp1,rp1->place,-1,1,2,x);
      regloadit(rp1,rp1,rp1->place,-1,1,0,itmp);
      rp1->argreg=itmp; rp1->place=rp1p=PCREG;
      rp1->reguse[itmp].use=RP1STPT; rp1->reguse[itmp].reg=x;
      rp1->reguse[x].use=RP2NDPT;    rp1->reguse[x].reg=itmp;
    }
    if(rp2p==PCCONST&&rp2->tp%SUNSIGNED==SLONG)
    { regloadit(rp2,rp2,rp2->place,-1,1,2,x);
      regloadit(rp2,rp2,rp2->place,-1,1,0,itmp);
      rp2->argreg=itmp; rp2->place=rp2p=PCREG;
      rp2->reguse[itmp].use=RP1STPT; rp2->reguse[itmp].reg=x;
      rp2->reguse[x].use=RP2NDPT;    rp2->reguse[x].reg=itmp;
    }
    if(!srcmem)
    { if(!dstmem) fltload(rp1);
      fltload(rp2);
    }
    else
    { if((rp1p!=PCMATH&&rp1p!=PCMEMORY&&rp1p!=PCLSTPOINT)||!swtchable)
        fltload(rp1);
      if(rp2p!=PCMATH&&rp2p!=PCMEMORY&&rp2p!=PCLSTPOINT) fltload(rp2);
    }
  }
  else
  { if(rp1p==PCMATH) fwait=1,stkload(rp1);
    if(rp2p==PCMATH) fwait=1,stkload(rp2);
  }
  rp1p=rp1->place;
  rp2p=rp2->place;
  bpo1=rp1->bpoff;
  bpo2=rp2->bpoff;
  mbpo1=rp1->maxoff;
  mbpo2=rp2->maxoff;
  fltlev=swfltlev=rp1->maxfltlev>rp2->maxfltlev?rp1->maxfltlev:rp2->maxfltlev;
  for(ruse=x=0;x<11;x++)
  { ruse+=swrut[x].use=rut[x].use=(rp1->reguse[x].use||rp2->reguse[x].use); }
  /*NOTE: swtched is used to determine order when in math
   * order (mem,reg/reg,mem) is used when in 80386 */
  swruse=ruse;
  const=swconst=0;
  if(umath)
  {/*LASTPOINTs 1st and 2nd*/
    swmxbpoff=mxbpoff=rp1->maxoff;
    if(rp2->maxoff>mxbpoff) rp2->maxoff=mxbpoff;
/*IAMHERE:more: loadit above where it used to be/ preserve auto. implies
  switched for MATH*/
    if(rp2->maxfltlev+1>fltlev) fltlev=rp2->maxfltlev+1;
/*IAM: if preserve set up to recognise the fact that 1st might need preserve*/
    if(rp1->maxfltlev+1>swfltlev) swfltlev=rp1->maxfltlev+1;
    if(fltlev<1) fltlev=1;   /* there is always at least 1 argument preloaded*/
    if(swfltlev<1) swfltlev=1;
    for(swruse=ruse=x=0;x<11;x++)
    { swruse+=swrut[x].use; ruse+=rut[x].use; }
/*IAM: reguse output/ maxbpoff/ and fltlev output */
  }
  else /*does not use math coprocessor*/
  { rsto2=r2sto2=(-2);
    if(rp1p==PCSTACK)
    { if(rp1->tp%SUNSIGNED==SLONG||rp1->tp==SPOINTER) rsto2=(-1);
      rsto=(-1);
    }
    else if(rp1p==PCREG||rp1p==PCLSTPOINT)
    { rsto=rp1->argreg;
   /*   if(rp1p==PCLSTPOINT) rsto2=(-1);*/
      if(rsto>=0&&rp1->reguse[rsto].use==RP1STPT)
       rsto2=rp1->reguse[rsto].reg;
    }
    else rsto=(-2);
    if(rp2p==PCSTACK)
    { if(rp2->tp%SUNSIGNED==SLONG||rp2->tp==SPOINTER) r2sto2=(-1);
      r2sto=(-1);
    }
    else if(rp2p==PCREG||rp2p==PCLSTPOINT)
    { r2sto=rp2->argreg;
   /*   if(rp2p==PCLSTPOINT) r2sto2=(-1);*/
      if(r2sto>=0&&rp2->reguse[r2sto].use==RP1STPT)
       r2sto2=rp2->reguse[r2sto].reg;
    }
    else r2sto=(-2);
    /* -2 = not on stack or in register (probably MEMORY)
     * -1 = on the stack
     * 0-8= in this register
     */
if((rp1p==PCREG||rp1p==PCLSTPOINT)==(rsto<0))
{ fatal=1; yyerror("internal error binaryloadit"); }
    if(rp1p==PCREG&&rsto2==8)
    { /* move out of the way */
      rsto2=findreg(1,rp2->reguse,rp1p==PCLSTPOINT,8,rp1->reguse,rsto
        ,rp2p==PCLSTPOINT?8:-1,nodxout,argtp!=RGNONE?argreg:-1,-1,-1);
      pd[pdc].reg=rsto2;
      pd[pdc++].prcd=PD1LDIT2;
      if(rsto2>=0) rut[rsto2].use=1;
      else bpo1-=2;
    }
    if(rp2p==PCREG&&r2sto2==8)
    { /* move out of the way */
      r2sto2=findreg(0,rut,0,0,rut,rsto,rsto2,nodxout,argtp!=RGNONE?argreg:-1
        ,-1,-1);
      pd[pdc].reg=r2sto2;
      pd[pdc++].prcd=PD2LDIT2;
      if(r2sto2>=0) rut[r2sto2].use=1;
      else bpo2-=2;
    }
    if(rsto>=0)
    { lp1st=(argtp==RGNONE&&(!dstmem&&(!(swtchable&&srcmem)||rp2p==PCLSTPOINT
        ||rp2p==PCMEMORY)))||argtp==RG1ST;
      /* lp1st- if one, indicates that one is going to be a lastpoint first*/
/* if rsto2 is in reg to be modified already or if its in the way of 2's
LSTPOINT necessity, then move */
      if(rsto2>=0&&(rp2->reguse[rsto2].use||(rp2p==PCLSTPOINT
       &&rsto2==8&&!lp1st)))
      { /* move out of the way */
        rsto2=findreg(1,rp2->reguse,rp1p==PCLSTPOINT,8,rp1->reguse,rsto
          ,rp2p==PCLSTPOINT&&!lp1st?8:-1,nodxout,-1,-1,-1);
        pd[pdc].reg=rsto2;
        pd[pdc++].prcd=PD1LDIT2;
        if(rsto2>=0) rut[rsto2].use=1;
        else bpo1-=2;
      }
      if((rsto>=0&&rp2->reguse[rsto].use)||(argtp==RG2ND&&argreg==rsto))
      { /* move out of the way */
        rsto=findreg(1,rp2->reguse,rp1p==PCLSTPOINT?2:(argtp==RG1ST||argtp
          ==RGEITHER),argreg,rp1->reguse,(argtp==RG2ND?argreg:-1),nodxout
          ,rsto2,-1,-1,-1);
        pd[pdc].reg=rsto;
        pd[pdc++].prcd=PD1LDIT;
        if(rsto>=0) rut[rsto].use=1; /* place remains same */
        else bpo1-=2;
      }
      if(lp1st&&r2sto2==8)
      { /* move out of the way */
        r2sto2=findreg(0,rut,0,0,rut,rsto,rsto2,nodxout,-1,-1,-1);
        pd[pdc].reg=r2sto2;
        pd[pdc++].prcd=PD2LDIT2;
        if(r2sto2>=0) rut[r2sto2].use=1;
        else bpo2-=2;
      }
    }
    pd[pdc++].prcd=PDCOMBINE;
    if(bpo1<mbpo1) mbpo1=bpo1;
    if(bpo2<mbpo2) mbpo2=bpo2;
    mxbpoff=mbpo1<mbpo2+bpo1?mbpo1:mbpo2+bpo1;
    ncnst1st=rp1p!=PCCONST||!srcconst||!swtchable;
    ncnst2nd=rp2p!=PCCONST||!srcconst;
    dblwo2nd=rp2->tp%SUNSIGNED==SLONG||rp2->tp==SPOINTER;
    dblwo1st=rp1->tp%SUNSIGNED==SLONG||rp1->tp==SPOINTER;
/*HERE: we will need to go through and adjust register find&lstpnt*/
    switch(argtp)
    { case RGEITHER:
       if(dblwo2nd)
       { fatal=1;
         yyerror("Not currently programmed to have restricted longs");
       }
       if(rp1p!=PCREG||rsto!=argreg)
       {/* LSTPNT 2nd */
         outplc=2;
         if(rp2p==PCLSTPOINT)
         { pd[pdc].prcd=PD2LSTPT;
           rut[8].use=1; r2sto2=8;
           if(r2sto!=3&&r2sto!=6&&r2sto!=7)
             r2sto=findreg(0,rut,2,0,rut,rsto,rsto2,-1,-1,-1,-1);
if(r2sto<3) { fatal=1; yyerror("didn't do LSTPOINT right"); }
           rut[r2sto].use=1;
           pd[pdc++].reg=r2sto;
         }
        /* LOADIT 2nd, argreg */
         if(rp2p!=PCREG||r2sto!=argreg)
         { rp2p=PCREG;
           rut[argreg].use=1;
           pd[pdc].reg=r2sto=argreg;
           pd[pdc++].prcd=PD2LDIT;
         }
        /* LSTPOINT 1st */
         if(rp1p==PCLSTPOINT)
         { pd[pdc].prcd=PD1LSTPT;
           rut[8].use=1; rsto2=8;
           if(rsto!=3&&rsto!=6&&rsto!=7)
             rsto=findreg(0,rut,2,0,rut,r2sto,argreg,-1,-1,-1,-1);
if(rsto<3) { fatal=1; yyerror("didn't do LSTPOINT right"); }
           rut[rsto].use=1;
           pd[pdc++].reg=rsto;
         }
         if(ncnst1st&&(rp1p!=PCREG||rsto<0)
           &&((rp1p!=PCLSTPOINT&&rp1p!=PCMEMORY)||!(srcmem||dstmem)))
         {/* LOADIT 1st, !argreg */
           rp1p=PCREG;
           rsto=findreg(0,rut,0,0,rut,r2sto,argreg,preserve?rsto:-1
             ,preserve?rsto2:-1,-1,-1);
if(rsto<0) { fatal=1; yyerror("didn't do LDIT right"); }
           rut[rsto].use=1;
           pd[pdc].reg=rsto;
           pd[pdc++].prcd=PD1LDIT;
         }
         mem=1;
         if(!ncnst1st)
         { const=1; cval=rp1->cval; mem=2; }
       }
/*MERE:somewhere the index/ else the copy */
       else
       {/* LSTPOINT 2nd */
         outplc=1;
         if(rp2p==PCLSTPOINT)
         { pd[pdc].prcd=PD2LSTPT;
           rut[8].use=1; r2sto2=8;
           if(r2sto!=3&&r2sto!=6&&r2sto!=7)
             r2sto=findreg(0,rut,2,0,rut,rsto,-1,-1,-1,-1,-1);
if(r2sto<3) { fatal=1; yyerror("didn't do LSTPOINT right"); }
           rut[r2sto].use=1;
           pd[pdc++].reg=r2sto;
         }
         if(ncnst2nd&&(rp2p!=PCREG||r2sto<0)
           &&((rp2p!=PCLSTPOINT&&rp2p!=PCMEMORY)||!srcmem))
         {/* LOADIT 2nd */
           rp2p=PCREG;
           r2sto=findreg(0,rut,0,0,rut,rsto,-1,-1,-1,-1,-1);
if(r2sto<0) { fatal=1; yyerror("didn't do LDIT right"); }
           rut[r2sto].use=1;
           pd[pdc].reg=r2sto;
           pd[pdc++].prcd=PD2LDIT;
         }
         mem=2;
         if(!ncnst2nd)
         { const=1; cval=rp2->cval; mem=1; }
       }
      break;
      case RG1ST:
       /* load 2nd any., load 1st res.*/
       if(dblwo2nd)
       { fatal=1;
         yyerror("Not currently programmed to have restricted longs");
       }
       if(rp2p==PCREG&&r2sto==argreg&&rp1p==PCREG&&rsto>=0&&rsto!=nodxout)
        pd[pdc++].prcd=PDXCHG;
       else
       {/* POP 2nd */
         if((r2sto==-1&&(rsto2==-1||rsto==-1))||r2sto==argreg
            ||(r2sto>=0&&r2sto==nodxout))
         { /* POP 2nd anywhere */
           r2sto=findreg(0,rut,rp2p==PCLSTPOINT?2:0,0,rut,rsto
             ,r2sto2,rsto2,nodxout,argreg,-1);
if(r2sto<0) { fatal=1; yyerror("didn't do LDIT right"); }
           rut[r2sto].use=1;
           pd[pdc].reg=r2sto;
           pd[pdc++].prcd=PD2LDIT;
         }
         if((r2sto2==-1&&(rsto2==-1||rsto==-1))||r2sto2==argreg)
         { r2sto2=findreg(0,rut,rp2p==PCLSTPOINT,8,rut,rsto
            ,rsto2,r2sto,nodxout,argreg,-1);
if(r2sto2<0) { fatal=1; yyerror("didn't do LDIT right"); }
           rut[r2sto2].use=1;
           pd[pdc].reg=r2sto2;
           pd[pdc++].prcd=PD2LDIT2;
         }
        /* LSTPOINT 1st */
         trs2=trst=(-1);
         if(rp1p==PCLSTPOINT)
         { pd[pdc].prcd=PD1LSTPT;
           trs2=rsto2;
           if(rp2p!=PCLSTPOINT) trs2=(-1);
           rut[8].use=1; rsto2=8;
           if(rsto!=3&&rsto!=6&&rsto!=7)
            rsto=findreg(0,rut,2,0,rut,r2sto,r2sto2,nodxout,-1,-1,-1);
           trst=rsto;
           if(trs2==trst) trs2=(-1);
if(rsto<3) { fatal=1; yyerror("didn't do LSTPOINT right"); }
           rut[rsto].use=1;
           pd[pdc++].reg=rsto;
           if(!preserve) trst=trs2=(-1);
         }
        /* LOAD 1st */
         if(rp1p!=PCREG||rsto!=argreg)
         { rp1p=PCREG;
           rsto=argreg;
if(rsto<0) { fatal=1; yyerror("didn't do LDIT right"); }
           rut[rsto].use=1;
           pd[pdc].reg=rsto;
           pd[pdc++].prcd=PD1LDIT;
         }
        /* LSTPOINT 2nd */
         if(rp2p==PCLSTPOINT)
         { if(preserve)
            if(trs2==8||trs2<0)
            { prsrv1=1;
              p1rs2=trs2=findreg(0,rut,0,0,rut,rsto,r2sto2,r2sto,trst
                ,nodxout,-1);
            }
            else prsrv1=2;
           pd[pdc].prcd=PD2LSTPT;
           rut[8].use=1; r2sto2=8;
           if(r2sto!=3&&r2sto!=6&&r2sto!=7)
             r2sto=findreg(0,rut,2,0,rut,rsto,-1,trst,trs2,-1,-1);
if(r2sto<3) { fatal=1; yyerror("didn't do LSTPOINT right"); }
           rut[r2sto].use=1;
           pd[pdc++].reg=r2sto;
         }
        /* if LOAD 2nd */
         if(ncnst2nd&&(rp2p!=PCREG||r2sto<0||r2sto==argreg||r2sto==nodxout)
           &&((rp2p!=PCLSTPOINT&&rp2p!=PCMEMORY)||!srcmem))
         {/* LOADIT 2nd,not argreg */
           rp2p=PCREG;
           r2sto=findreg(0,rut,0,0,rut,rsto,trst,trs2,nodxout,-1,-1);
if(r2sto<0) { fatal=1; yyerror("didn't do LDIT right"); }
           rut[r2sto].use=1;
           pd[pdc].reg=r2sto;
           pd[pdc++].prcd=PD2LDIT;
         }
         mem=2;
         if(!ncnst2nd) /* if constants can't be used, ncnst2nd will be 1 */
         { const=1; cval=rp2->cval; mem=1; }
       }
       outplc=1;
      break;
      case RG2ND:
       /* ready to use xchg if 1st in place 2nd needs to be & 2nd is a rg */
       if(dblwo2nd)
       { fatal=1;
         yyerror("Not currently programmed to have restricted longs");
       }
       if(rp1p==PCREG&&rsto==argreg&&rp2p==PCREG&&r2sto>=0&&r2sto!=nodxout)
       { pd[pdc++].prcd=PDXCHG; /* currently immpossible */
         if(dblwo1st)
         { if(rsto2<0||rsto2==nodxout)
           {/*LOADIT 1st (word 2)*/
             rsto2=findreg(0,rut,0,0,rut,r2sto,rsto,nodxout,-1,-1,-1);
  if(rsto2<0) { fatal=1; yyerror("didn't do LDIT right"); }
             rut[rsto2].use=1;
             pd[pdc].reg=rsto2;
             pd[pdc++].prcd=PD1LDIT2;
           }
         }
       }
       else if(dblwo1st&&rp1p==PCREG&&rsto2==argreg&&rp2p==PCREG&&r2sto>=0
         &&r2sto!=nodxout)
       { pd[pdc++].prcd=PDXCHG2; /* currently immpossible */
         if(rsto<0||rsto==nodxout)
         {/*LOADIT 1st*/
           rsto=findreg(0,rut,0,0,rut,r2sto,rsto2,nodxout,-1,-1,-1);
  if(rsto<0) { fatal=1; yyerror("didn't do LDIT right"); }
           rut[rsto].use=1;
           pd[pdc].reg=rsto;
           pd[pdc++].prcd=PD1LDIT;
         }
       }
       else
       {/* LSTPOINT 2nd */
         if(rp2p==PCLSTPOINT)
         { pd[pdc].prcd=PD2LSTPT;
           rut[8].use=1; r2sto2=8;
           if(r2sto!=3&&r2sto!=6&&r2sto!=7)
             r2sto=findreg(0,rut,2,0,rut,rsto,rsto2,nodxout,-1,-1,-1);
if(r2sto<3) { fatal=1; yyerror("didn't do LSTPOINT right"); }
           rut[r2sto].use=1;
           pd[pdc++].reg=r2sto;
         }
        /* LOADIT 2nd */
         rp2p=PCREG;
         r2sto=argreg;
if(r2sto<0) { fatal=1; yyerror("didn't do LDIT right"); }
         rut[r2sto].use=1;
         pd[pdc].reg=r2sto;
         pd[pdc++].prcd=PD2LDIT;
        /* LSTPOINT 1st */
         if(rp1p==PCLSTPOINT)
         { pd[pdc].prcd=PD1LSTPT;
           rut[8].use=1; rsto2=8;
           if(rsto!=3&&rsto!=6&&rsto!=7)
             rsto=findreg(0,rut,2,0,rut,r2sto,argreg,nodxout,-1,-1,-1);
if(rsto<3) { fatal=1; yyerror("didn't do LSTPOINT right"); }
           rut[rsto].use=1;
           pd[pdc++].reg=rsto;
         }
         if(ncnst1st&&((rp1p!=PCLSTPOINT&&rp1p!=PCMEMORY)||!dstmem))
         { trst=rsto;
           if(!preserve) trst=trs2=(-1);
           if(rp1p!=PCREG||rsto<0)
           {/* LOADIT 1st */
             rsto=findreg(0,rut,0,0,rut,r2sto,(rp1p!=PCLSTPOINT&&dblwo1st)
               ||preserve?rsto2:-1,nodxout,(rp1p==PCLSTPOINT&&dblwo1st)
               ||preserve?rsto:-1,-1,-1);
  if(rsto<0) { fatal=1; yyerror("didn't do LDIT right"); }
             rut[rsto].use=1;
             pd[pdc].reg=rsto;
             pd[pdc++].prcd=PD1LDIT;
           }
           if(dblwo1st&&(rp1p!=PCREG||rsto2<0))
           {/* LOADIT 1st (second part) */
             rsto2=findreg(0,rut,0,0,rut,r2sto,rsto,nodxout,preserve?trst:-1,-1
               ,-1);
             /*note above: if preserve, rsto2 will be 8, which can't be index*/
  if(rsto2<0) { fatal=1; yyerror("didn't do LDIT right"); }
             rut[rsto2].use=1;
             pd[pdc].reg=rsto2;
             pd[pdc++].prcd=PD1LDIT2;
           }
           rp1p=PCREG;
         }
         mem=1;
         if(!ncnst1st)
         { const=1; cval=rp1->cval; mem=2; }
       }
       outplc=1; /* is this true? */
      break;
      case RGNONE:
       if(dstmem)
       { if(ncnst2nd)
         {/* LSTPOINT 2nd */
           if(rp2p==PCLSTPOINT)
           { pd[pdc].prcd=PD2LSTPT;
             rut[8].use=1; r2sto2=8;
             if(r2sto!=3&&r2sto!=6&&r2sto!=7)
               r2sto=findreg(0,rut,2,0,rut,rsto,rsto2,nodxout,-1,-1,-1);
if(r2sto<3) { fatal=1; yyerror("didn't do LSTPOINT right"); }
             rut[r2sto].use=1;
             pd[pdc++].reg=r2sto;
           }
          /* LOADIT 2nd */
           if(rp2p!=PCREG||r2sto<0)
           { r2sto=findreg(0,rut,0,0,rut,rsto,rsto2,r2sto2
              ,dblwo2nd&&rp2p==PCLSTPOINT?r2sto:-1,nodxout,-1);
if(r2sto<0) { fatal=1; yyerror("didn't do LDIT right"); }
             rut[r2sto].use=1;
             pd[pdc].reg=r2sto;
             pd[pdc++].prcd=PD2LDIT;
           }
           if(dblwo2nd&&(rp2p!=PCREG||r2sto2<0))
           { r2sto2=findreg(0,rut,0,0,rut,rsto,rsto2,r2sto,nodxout,-1,-1);
if(r2sto2<0) { fatal=1; yyerror("didn't do LDIT right"); }
             rut[r2sto2].use=1;
             pd[pdc].reg=r2sto2;
             pd[pdc++].prcd=PD2LDIT2;
           }
           else if(!dblwo2nd) r2sto2=(-1);
           rp2p=PCREG;
         }
         else
         { const=1; cval=rp2->cval; }
        /* LSTPOINT 1st */
         if(rp1p==PCLSTPOINT)
         { pd[pdc].prcd=PD1LSTPT;
           rut[8].use=1; rsto2=8;
           if(rsto!=3&&rsto!=6&&rsto!=7)
             rsto=findreg(0,rut,2,0,rut,r2sto,r2sto2,nodxout,-1,-1,-1);
if(rsto<3) { fatal=1; yyerror("didn't do LSTPOINT right"); }
           rut[rsto].use=1;
           pd[pdc++].reg=rsto;
         }
         mem=1;
         outplc=2; /* because source is register stuff/not stored stuff*/
       }
       else if(swtchable&&srcmem)
       { if(rp2p==PCMEMORY||rp2p==PCLSTPOINT) goto notswtched;
         else if(rp1p==PCMEMORY||rp1p==PCLSTPOINT)
         {/* LOADIT 2nd */
           if(ncnst2nd||!cmpjmp)
           { if(rp2p!=PCREG||r2sto<0)
             { r2sto=findreg(0,rut,0,0,rut,rsto,rsto2,nodxout,-1,-1,-1);
if(r2sto<0) { fatal=1; yyerror("didn't do LDIT right"); }
               rut[r2sto].use=1;
               pd[pdc].reg=r2sto;
               pd[pdc++].prcd=PD2LDIT;
             }
             if(dblwo2nd&&(rp2p!=PCREG||r2sto2<0))
             { r2sto2=findreg(0,rut,0,0,rut,rsto,rsto2,r2sto,nodxout,-1,-1);
if(r2sto2<0) { fatal=1; yyerror("didn't do LDIT right"); }
               rut[r2sto2].use=1;
               pd[pdc].reg=r2sto2;
               pd[pdc++].prcd=PD2LDIT2;
             }
             else if(!dblwo2nd) r2sto2=(-1);
           }
           else
           { const=1; cval=rp2->cval; }
           rp2p=PCREG;
          /* LSTPOINT 1st */
           if(rp1p==PCLSTPOINT)
           { pd[pdc].prcd=PD1LSTPT;
             rut[8].use=1; rsto2=8;
             if(rsto!=3&&rsto!=6&&rsto!=7)
               rsto=findreg(0,rut,2,0,rut,r2sto,r2sto2,nodxout,-1,-1,-1);
if(rsto<3) { fatal=1; yyerror("didn't do LSTPOINT right"); }
             rut[rsto].use=1;
             pd[pdc++].reg=rsto;
           }
           mem=1;
           outplc=2;
         }
         else
         { itmp=0;
           if(preserve) { fatal=1; yyerror("preserve shouldn't reach here"); }
           if(ncnst2nd)
           {/* LOADIT 2nd */
             if(rp2p!=PCREG||r2sto<0)
             { r2sto=findreg(0,rut,0,0,rut,rsto,rsto2,r2sto2,nodxout,-1,-1);
if(r2sto<0) { fatal=1; yyerror("didn't do LDIT right"); }
               rut[r2sto].use=1;
               pd[pdc].reg=r2sto;
               pd[pdc++].prcd=PD2LDIT;
             }
             if(dblwo2nd&&(rp2p!=PCREG||r2sto2<0))
             { r2sto2=findreg(0,rut,0,0,rut,rsto,rsto2,r2sto,nodxout,-1,-1);
if(r2sto2<0) { fatal=1; yyerror("didn't do LDIT right"); }
               rut[r2sto2].use=1;
               pd[pdc].reg=r2sto2;
               pd[pdc++].prcd=PD2LDIT2;
             }
             else if(!dblwo2nd) r2sto2=(-1);
             rp2p=PCREG;
             itmp=1;
             mem=2;
             outplc=1;
           }
           else
           { const=1; cval=rp2->cval; }
           if((!itmp)||ncnst1st)
           {/* LOADIT 1st */
             if(rp1p!=PCREG||rsto<0)
             { rsto=findreg(0,rut,0,0,rut,r2sto,rsto2,r2sto2,nodxout,-1,-1);
if(rsto<0) { fatal=1; yyerror("didn't do LDIT right"); }
               rut[rsto].use=1;
               pd[pdc].reg=rsto;
               pd[pdc++].prcd=PD1LDIT;
             }
             if(dblwo1st&&(rp1p!=PCREG||rsto2<0))
             { rsto2=findreg(0,rut,0,0,rut,rsto,r2sto2,r2sto,nodxout,-1,-1);
if(rsto2<0) { fatal=1; yyerror("didn't do LDIT right"); }
               rut[rsto2].use=1;
               pd[pdc].reg=rsto2;
               pd[pdc++].prcd=PD1LDIT2;
             }
             else if(!dblwo1st) rsto2=(-1);
             rp1p=PCREG;
             mem=1;
             if(!const) outplc=2;
             else outplc=1;
           }
           else
           { const=1; cval=rp1->cval; }
         }
       }
       else
       {notswtched:
         /* if both on stack, need to get off in right order */
         if(r2sto==-1&&(rsto2==-1||rsto==-1))
         { /* POP 2nd anywhere */
           r2sto=findreg(0,rut,rp2p==PCLSTPOINT?2:0,0,rut,rsto,r2sto2,rsto2
            ,nodxout,-1,-1);
if(r2sto<0) { fatal=1; yyerror("didn't do LDIT right"); }
           rut[r2sto].use=1;
           pd[pdc].reg=r2sto;
           pd[pdc++].prcd=PD2LDIT;
         }
         if(r2sto2==-1&&(rsto2==-1||rsto==-1))
         { r2sto2=findreg(0,rut,rp2p==PCLSTPOINT,8,rut,rsto,rsto2,r2sto,nodxout
             ,-1,-1);
if(r2sto2<0) { fatal=1; yyerror("didn't do LDIT right"); }
           rut[r2sto2].use=1;
           pd[pdc].reg=r2sto2;
           pd[pdc++].prcd=PD2LDIT2;
         }
        /* LSTPOINT 1st */
         trs2=trst=(-1);
         if(rp1p==PCLSTPOINT)
         { pd[pdc].prcd=PD1LSTPT;
           trs2=rsto2;
           if(rp2p!=PCLSTPOINT) trs2=(-1);
           rut[8].use=1; rsto2=8;
           if(rsto!=3&&rsto!=6&&rsto!=7)
             rsto=findreg(0,rut,2,0,rut,r2sto,r2sto2,nodxout,-1,-1,-1);
           trst=rsto;
if(rsto<3) { fatal=1; yyerror("didn't do LSTPOINT right"); }
           rut[rsto].use=1;
           pd[pdc++].reg=rsto;
           if(!preserve) trst=trs2=(-1);
         }
        /* LOADIT 1st */
         if(ncnst1st)
         { if(rp1p!=PCREG||rsto<0)
           { rsto=findreg(0,rut,0,0,rut,r2sto,rsto2,r2sto2
              ,(dblwo1st&&rp1p==PCLSTPOINT)||preserve?rsto:-1,nodxout,-1);
if(rsto<0) { fatal=1; yyerror("didn't do LDIT right"); }
             rut[rsto].use=1;
             pd[pdc].reg=rsto;
             pd[pdc++].prcd=PD1LDIT;
           }
           if(dblwo1st&&(rp1p!=PCREG||rsto2<0))
           { rsto2=findreg(0,rut,0,0,rut,rsto,r2sto2,r2sto,trst,nodxout,-1);
if(rsto2<0) { fatal=1; yyerror("didn't do LDIT right"); }
             rut[rsto2].use=1;
             pd[pdc].reg=rsto2;
             pd[pdc++].prcd=PD1LDIT2;
           }
           else if(!dblwo1st) rsto2=(-1);
           mem=1;
           rp1p=PCREG;
         }
         else
         { const=1; cval=rp1->cval; }
        /* LSTPOINT 2nd */
         if(rp2p==PCLSTPOINT)
         { if(preserve)
            if(trs2==8||trs2<0)
            { prsrv1=1;
              p1rs2=trs2=findreg(0,rut,0,0,rut,rsto,r2sto2,r2sto,trst
                ,nodxout,-1);
            }
            else prsrv1=2;
           pd[pdc].prcd=PD2LSTPT;
           rut[8].use=1; r2sto2=8;
           if(r2sto!=3&&r2sto!=6&&r2sto!=7)
             r2sto=findreg(0,rut,2,0,rut,rsto,rsto2,trst,trs2,nodxout,-1);
if(r2sto<3) { fatal=1; yyerror("didn't do LSTPOINT right"); }
           rut[r2sto].use=1;
           pd[pdc++].reg=r2sto;
         }
         if((!ncnst1st&&!cmpjmp)||((ncnst2nd&&rp2p!=PCLSTPOINT
           &&rp2p!=PCMEMORY)||!srcmem))
         {/* LOADIT 2nd */
           if(rp2p!=PCREG||r2sto<0)
           { r2sto=findreg(0,rut,0,0,rut,rsto,rsto2,r2sto2
              ,dblwo2nd&&rp2p==PCLSTPOINT?r2sto:-1,trst,trs2);
if(r2sto<0) { fatal=1; yyerror("didn't do LDIT right"); }
             rut[r2sto].use=1;
             pd[pdc].reg=r2sto;
             pd[pdc++].prcd=PD2LDIT;
           }
           if(dblwo2nd&&(rp2p!=PCREG||r2sto2<0))
           { r2sto2=findreg(0,rut,0,0,rut,rsto,rsto2,r2sto,trst,trs2,nodxout);
if(r2sto2<0) { fatal=1; yyerror("didn't do LDIT right"); }
             rut[r2sto2].use=1;
             pd[pdc].reg=r2sto2;
             pd[pdc++].prcd=PD2LDIT2;
           }
           rp2p=PCREG;
           mem=2;
         }
         outplc=1;
         if(!ncnst2nd&&!const)
         { const=1; cval=rp2->cval; }
       }
      break;
      default: fatal=1; yyerror("unknown argtp in binaryloadit");
    }
    if(rp2p==PCLSTPOINT||rp2p==PCMEMORY) mem=2;
    if(rp1p==PCLSTPOINT||rp1p==PCMEMORY)
    { if(mem!=1) yyerror("mem warning");
      mem=1;
    }
    rp1p=rp1->place;
    rp2p=rp2->place;
    bpo1=rp1->bpoff;
    bpo2=rp2->bpoff;
    mbpo1=rp1->maxoff;
    mbpo2=rp2->maxoff;
    for(ruse=x=0;x<9;x++)
    { ruse+=rut[x].use;
      rut[x].use=(rp1->reguse[x].use||rp2->reguse[x].use);
    }
    rsto2=r2sto2=(-2);
    if(rp1p==PCSTACK)
    { if(rp1->tp%SUNSIGNED==SLONG||rp1->tp==SPOINTER) rsto2=(-1);
      rsto=(-1);
    }
    else if(rp1p==PCREG||rp1p==PCLSTPOINT)
    { rsto=rp1->argreg;
/*      if(rp1p==PCLSTPOINT) rsto2=(-1);*/
      if(rsto>=0&&rp1->reguse[rsto].use==RP1STPT)
       rsto2=rp1->reguse[rsto].reg;
    }
    else rsto=(-2);
    if(rp2p==PCSTACK)
    { if(rp2->tp%SUNSIGNED==SLONG||rp2->tp==SPOINTER) r2sto2=(-1);
      r2sto=(-1);
    }
    else if(rp2p==PCREG||rp2p==PCLSTPOINT)
    { r2sto=rp2->argreg;
/*      if(rp2p==PCLSTPOINT) r2sto2=(-1);*/
      if(r2sto>=0&&rp2->reguse[r2sto].use==RP1STPT)
       r2sto2=rp2->reguse[r2sto].reg;
    }
    else r2sto=(-2);
    /* -2 = not on stack or in register (probably MEMORY)
     * -1 = on the stack
     * 0-8= in this register
     */
    if(rp1p==PCREG&&rsto2==8)
    { /* move out of the way */
      rsto2=findreg(1,rp2->reguse,rp1p==PCLSTPOINT,8,rp1->reguse,rsto
        ,rp2p==PCLSTPOINT?8:-1,nodxout,argtp!=RGNONE?argreg:-1,-1,-1);
      swpd[swpdc].reg=rsto2;
      swpd[swpdc++].prcd=PD1LDIT2;
      if(rsto2>=0) rut[rsto2].use=1;
      else bpo1-=2;
    }
    if(rp2p==PCREG&&r2sto2==8)
    { /* move out of the way */
      r2sto2=findreg(0,rut,0,0,rut,rsto,rsto2,nodxout,argtp!=RGNONE?argreg:-1
        ,-1,-1);
      swpd[swpdc].reg=r2sto2;
      swpd[swpdc++].prcd=PD2LDIT2;
      if(r2sto2>=0) rut[r2sto2].use=1;
      else bpo2-=2;
    }
    if(rsto>=0)
    { lp1st=(argtp==RGNONE&&(dstmem||((swtchable&&srcmem)&&!(rp2p==PCLSTPOINT
        ||rp2p==PCMEMORY)&&(rp1p==PCLSTPOINT||rp1p==PCMEMORY))))||argtp==RG2ND;
      /* lp1st refers to second argument being lstpointed first */
      if(r2sto2>=0&&(rp1->reguse[r2sto2].use||(rp1p==PCLSTPOINT
       &&r2sto2==8&&!lp1st)))
      { /* move out of the way */
        r2sto2=findreg(1,rp1->reguse,rp2p==PCLSTPOINT,8,rp2->reguse,r2sto
          ,rp1p==PCLSTPOINT&&!lp1st?8:-1,nodxout,-1,-1,-1);
        swpd[swpdc].reg=r2sto2;
        swpd[swpdc++].prcd=PD2LDIT2;
        if(r2sto2>=0) rut[r2sto2].use=1;
        else bpo2-=2;
      }
      if((r2sto>=0&&rp1->reguse[r2sto].use)||(argtp==RG1ST&&r2sto==argreg))
      { /* move out of the way */
        r2sto=findreg(1,rp1->reguse,rp1p==PCLSTPOINT?2:(argtp==RG2ND||argtp
          ==RGEITHER),argreg,rp2->reguse,(argtp==RG1ST?argreg:-1),nodxout
          ,r2sto2,-1,-1,-1);
        swpd[swpdc].reg=r2sto;
        swpd[swpdc++].prcd=PD2LDIT;
        if(r2sto>=0) rut[r2sto].use=1; /* place remains same */
        else bpo2-=2;
      }
      if(lp1st&&rsto2==8)
      { /* move out of the way */
        rsto2=findreg(0,rut,0,0,rut,r2sto,r2sto2,nodxout,-1,-1,-1);
        swpd[swpdc].reg=rsto2;
        swpd[swpdc++].prcd=PD1LDIT2;
        if(rsto2>=0) rut[rsto2].use=1;
        else bpo1-=2;
      }
    }
    swpd[swpdc++].prcd=PDCOMBINE;
    if(bpo1<mbpo1) mbpo1=bpo1;
    if(bpo2<mbpo2) mbpo2=bpo2;
    swmxbpoff=mbpo1<mbpo2+bpo1?mbpo1:mbpo2+bpo1;
    switch(argtp)
    { case RGEITHER:
       if(r2sto!=argreg)
       {/* LSTPOINT 1st */
         trst=trs2=(-1);
         if(rp1p==PCLSTPOINT)
         { swpd[swpdc].prcd=PD1LSTPT;
           trs2=rsto2;
           if(rp2p!=PCLSTPOINT) trs2=(-1);
           rut[8].use=1; rsto2=8;
           if(rsto!=3&&rsto!=6&&rsto!=7)
             rsto=findreg(0,rut,2,0,rut,r2sto,r2sto2,-1,-1,-1,-1);
           trst=rsto;
           if(trst==trs2) trs2=(-1);
if(rsto<3) { fatal=1; yyerror("didn't do LSTPOINT right"); }
           rut[rsto].use=1;
           swpd[swpdc++].reg=rsto;
           if(!preserve) trst=trs2=(-1);
         }
        /* LOADIT 1st,argreg */
         if(rp1p!=PCREG||rsto!=argreg)
         { rp1p=PCREG;
           rsto=argreg;
if(rsto<0) { fatal=1; yyerror("didn't do LDIT right"); }
           rut[rsto].use=1;
           swpd[swpdc].reg=rsto;
           swpd[swpdc++].prcd=PD1LDIT;
         }
        /* LSTPOINT 2nd */
         if(rp2p==PCLSTPOINT)
         { if(preserve)
            if(trs2==8||trs2<0)
            { swprsrv1=1;
              swp1rs2=trs2=findreg(0,rut,0,0,rut,rsto,r2sto2,r2sto,trst
                ,-1,-1);
            }
            else swprsrv1=2;
           swpd[swpdc].prcd=PD2LSTPT;
           rut[8].use=1; r2sto2=8;
           if(r2sto!=3&&r2sto!=6&&r2sto!=7)
             r2sto=findreg(0,rut,2,0,rut,rsto,rsto2,argreg,trst,trs2,-1);
if(r2sto<3) { fatal=1; yyerror("didn't do LSTPOINT right"); }
           rut[r2sto].use=1;
           swpd[swpdc++].reg=r2sto;
         }
         if(ncnst2nd&&((rp2p!=PCLSTPOINT&&rp2p!=PCMEMORY)||!srcmem))
         {/* LOADIT 2nd */
           rp2p=PCREG;
           r2sto=findreg(0,rut,0,0,rut,rsto,argreg,trst,trs2,-1,-1);
if(r2sto<0) { fatal=1; yyerror("didn't do LDIT right"); }
           rut[r2sto].use=1;
           swpd[swpdc].reg=r2sto;
           swpd[swpdc++].prcd=PD2LDIT;
         }
         swmem=2;
         if(!ncnst2nd)
         { swconst=1; swcval=rp2->cval; swmem=1; }
         swoutplc=1;
       }
       else /* 2nd in argreg already */
       {/* LSTPOINT 1st */
         if(rp1p==PCLSTPOINT)
         { swpd[swpdc].prcd=PD1LSTPT;
           rut[8].use=1; rsto2=8;
           if(rsto!=3&&rsto!=6&&rsto!=7)
            trst=rsto=findreg(0,rut,2,0,rut,r2sto,argreg,-1,-1,-1,-1);
if(rsto<3) { fatal=1; yyerror("didn't do LSTPOINT right"); }
           rut[rsto].use=1;
           swpd[swpdc++].reg=rsto;
           if(!preserve) trst=trs2=(-1);
         }
         if(ncnst1st&&((rp1p!=PCLSTPOINT&&rp1p!=PCMEMORY)||!(srcmem||dstmem)))
         {/* LOADIT 1st,!argreg */
           rsto=findreg(0,rut,0,0,rut,argreg,trst,-1,-1,-1,-1);
if(rsto<0) { fatal=1; yyerror("didn't do LDIT right"); }
           rut[rsto].use=1;
           swpd[swpdc].reg=rsto;
           swpd[swpdc++].prcd=PD1LDIT;
         }
         swmem=1;
         if(!ncnst1st)
         { swconst=1; swcval=rp1->cval; swmem=2; }
         swoutplc=2;
       }
      break;
      case RG1ST:
       if(rp2p==PCREG&&r2sto==argreg&&rp1p==PCREG&&rsto>=0&&rsto!=nodxout)
         swpd[swpdc++].prcd=PDXCHG; /* currently immpossible */
       else
       {/* LSTPOINT 1st */
         trst=trs2=(-1);
         if(rp1p==PCLSTPOINT)
         { swpd[swpdc].prcd=PD1LSTPT;
           trs2=rsto2;
           if(rp2p!=PCLSTPOINT) trs2=(-1);
           rut[8].use=1; rsto2=8;
           if(rsto!=3&&rsto!=6&&rsto!=7)
             trst=rsto=findreg(0,rut,2,0,rut,r2sto,argreg,trs2,-1,-1,-1);
if(rsto<3) { fatal=1; yyerror("didn't do LSTPOINT right"); }
           rut[rsto].use=1;
           swpd[swpdc++].reg=rsto;
           if(!preserve) trst=trs2=(-1);
         }
         if(r2sto==argreg)
         {/* LOADIT 2nd */
           r2sto=findreg(0,rut,0,0,rut,rsto,argreg,nodxout,trst,trs2,r2sto2);
if(r2sto<0) { fatal=1; yyerror("didn't do LDIT right"); }
           rut[r2sto].use=1;
           swpd[swpdc].reg=r2sto;
           swpd[swpdc++].prcd=PD2LDIT;
         }
         if(r2sto==argreg)
         {/* LOADIT 2nd */
           r2sto2=findreg(0,rut,0,0,rut,rsto,argreg,nodxout,trst,trs2,r2sto);
if(r2sto2<0) { fatal=1; yyerror("didn't do LDIT right"); }
           rut[r2sto2].use=1;
           swpd[swpdc].reg=r2sto2;
           swpd[swpdc++].prcd=PD2LDIT2;
         }
        /* LOADIT 1st */
         if(rp1p!=PCREG||rsto!=argreg)
         { rsto=argreg;
if(rsto<0) { fatal=1; yyerror("didn't do LDIT right"); }
           rut[rsto].use=1;
           swpd[swpdc].reg=rsto;
           swpd[swpdc++].prcd=PD1LDIT;
         }
        /* LSTPOINT 2nd */
         if(rp2p==PCLSTPOINT)
         { if(preserve)
            if(trs2==8||trs2<0)
            { swprsrv1=1;
              swp1rs2=trs2=findreg(0,rut,0,0,rut,rsto,r2sto2,r2sto,trst
                ,-1,-1);
            }
            else swprsrv1=2;
           swpd[swpdc].prcd=PD2LSTPT;
           rut[8].use=1; r2sto2=8;
           if(r2sto!=3&&r2sto!=6&&r2sto!=7)
             r2sto=findreg(0,rut,2,0,rut,rsto,rsto2,argreg,trst,trs2,-1);
if(r2sto<3) { fatal=1; yyerror("didn't do LSTPOINT right"); }
           rut[r2sto].use=1;
           swpd[swpdc++].reg=r2sto;
         }
         if(ncnst2nd&&(rp2p!=PCREG||r2sto<0||r2sto==nodxout)
           &&((rp2p!=PCLSTPOINT&&rp2p!=PCMEMORY)||!srcmem))
         {/* LOADIT 2nd */
           rp2p=PCREG;
           r2sto=findreg(0,rut,0,0,rut,rsto,argreg,nodxout,trst,trs2,-1);
if(r2sto<0) { fatal=1; yyerror("didn't do LDIT right"); }
           rut[r2sto].use=1;
           swpd[swpdc].reg=r2sto;
           swpd[swpdc++].prcd=PD2LDIT;
         }
         swmem=2;
         if(!ncnst2nd)
         { swconst=1; swcval=rp2->cval; swmem=1; }
       }
       swoutplc=1;
      break;
      case RG2ND:
       if(rp1p==PCREG&&rsto==argreg&&rp2p==PCREG&&r2sto>=0&&r2sto!=nodxout)
       { swpd[swpdc++].prcd=PDXCHG; /* currently immpossible */
         if(dblwo1st)
         { if(rsto2<0||rsto2==nodxout)
           {/*LOADIT 1st (word 2)*/
             rsto2=findreg(0,rut,0,0,rut,nodxout,rsto,r2sto,-1,-1,-1);
if(rsto2<0) { fatal=1; yyerror("didn't do LDIT right"); }
             rut[rsto2].use=1;
             swpd[swpdc].reg=rsto2;
             swpd[swpdc++].prcd=PD1LDIT2;
           }
         }
       }
       else if(dblwo1st&&rp1p==PCREG&&rsto2==argreg&&rp2p==PCREG&&r2sto>=0
         &&r2sto!=nodxout)
       { swpd[swpdc++].prcd=PDXCHG2; /* currently immpossible */
         if(rsto<0||rsto==nodxout)
         {/*LOADIT 1st*/
           rsto=findreg(0,rut,0,0,rut,nodxout,argreg,r2sto,-1,-1,-1);
if(rsto<0) { fatal=1; yyerror("didn't do LDIT right"); }
           rut[rsto].use=1;
           swpd[swpdc].reg=rsto;
           swpd[swpdc++].prcd=PD1LDIT;
         }
       }
       else
       {/* POP 1st */
         if(rsto==-1&&(r2sto2==-1||r2sto==-1))
         { /* POP 1st anywhere */
           rsto=findreg(0,rut,rp1p==PCLSTPOINT?2:0,0,rut,r2sto<0?nodxout:r2sto
            ,r2sto2<0?nodxout:r2sto2,rsto2,argreg,-1,-1);
if(rsto<0) { fatal=1; yyerror("didn't do LDIT right"); }
           rut[rsto].use=1;
           swpd[swpdc].reg=rsto;
           swpd[swpdc++].prcd=PD1LDIT;
         }
         if(rsto2==-1&&(r2sto2==-1||r2sto==-1))
         { rsto2=findreg(0,rut,rp2p==PCLSTPOINT,8,rut,r2sto<0?nodxout:r2sto
             ,r2sto2<0?nodxout:r2sto2,rsto,argreg,-1,-1);
if(rsto2<0) { fatal=1; yyerror("didn't do LDIT right"); }
           rut[rsto2].use=1;
           swpd[swpdc].reg=rsto2;
           swpd[swpdc++].prcd=PD1LDIT2;
         }
        /* LSTPOINT 2nd */
         if(rp2p==PCLSTPOINT)
         { swpd[swpdc].prcd=PD2LSTPT;
           rut[8].use=1; r2sto2=8;
           if(r2sto!=3&&r2sto!=6&&r2sto!=7)
             r2sto=findreg(0,rut,2,0,rut,rsto,rsto2,argreg,nodxout,-1,-1);
if(r2sto<3) { fatal=1; yyerror("didn't do LSTPOINT right"); }
           rut[r2sto].use=1;
           swpd[swpdc++].reg=r2sto;
         }
        /* LOADIT 2nd */
         rp2p=PCREG;
         r2sto=argreg;
if(r2sto<0) { fatal=1; yyerror("didn't do LDIT right"); }
         rut[r2sto].use=1;
         swpd[swpdc].reg=r2sto;
         swpd[swpdc++].prcd=PD2LDIT;
        /* LSTPOINT 1st */
         trst=(-1);
         if(rp1p==PCLSTPOINT)
         { swpd[swpdc].prcd=PD1LSTPT;
           rut[8].use=1; rsto2=8;
           if(rsto!=3&&rsto!=6&&rsto!=7)
            trst=rsto=findreg(0,rut,2,0,rut,r2sto,argreg,nodxout,-1,-1,-1);
if(rsto<3) { fatal=1; yyerror("didn't do LSTPOINT right"); }
           rut[rsto].use=1;
           swpd[swpdc++].reg=rsto;
           if(!preserve) trst=trs2=(-1);
         }
         if(ncnst1st&&((rp1p!=PCLSTPOINT&&rp1p!=PCMEMORY)||!dstmem))
         { if(rp1p!=PCREG||rsto<0)
           {/* LOADIT 1st */
             rsto=findreg(0,rut,0,0,rut,argreg,nodxout,rp1p==PCLSTPOINT
              &&dblwo1st?rsto2:-1,rp1p==PCLSTPOINT&&dblwo1st?rsto:-1,trst,-1);
if(rsto<0) { fatal=1; yyerror("didn't do LDIT right"); }
             rut[rsto].use=1;
             swpd[swpdc].reg=rsto;
             swpd[swpdc++].prcd=PD1LDIT;
           }
           if(dblwo1st&&(rp1p!=PCREG||rsto2<0))
           {/* LOADIT 1st (second part) */
             rsto2=findreg(0,rut,0,0,rut,r2sto,rsto,nodxout,trst,-1,-1);
  if(rsto2<0) { fatal=1; yyerror("didn't do LDIT right"); }
             rut[rsto2].use=1;
             swpd[swpdc].reg=rsto2;
             swpd[swpdc++].prcd=PD1LDIT2;
           }
           rp1p=PCREG;
         }
         swmem=1;
         if(!ncnst1st)
         { swconst=1; swcval=rp1->cval; swmem=2; }
       }
       swoutplc=1;
      break;
      case RGNONE:
       if(dstmem)
       { if(rp1p!=PCMEMORY&&rp1p!=PCLSTPOINT)
         { fatal=1; yyerror("illegal dstmem"); }
        /* POP 1st */
         if(rsto==-1&&(r2sto2==-1||r2sto==-1))
         { /* POP 1st anywhere */
           rsto=findreg(0,rut,rp1p==PCLSTPOINT?2:0,0,rut,r2sto,r2sto2,rsto2
            ,nodxout,-1,-1);
if(rsto<0) { fatal=1; yyerror("1didn't do LDIT right"); }
           rut[rsto].use=1;
           swpd[swpdc].reg=rsto;
           swpd[swpdc++].prcd=PD1LDIT;
         }
         if(rsto2==-1&&(r2sto2==-1||r2sto==-1))
         { rsto2=findreg(0,rut,rp2p==PCLSTPOINT,8,rut,r2sto,r2sto2,rsto,-1,-1
             ,nodxout);
if(rsto2<0) { fatal=1; yyerror("2didn't do LDIT right"); }
           rut[rsto2].use=1;
           swpd[swpdc].reg=rsto2;
           swpd[swpdc++].prcd=PD1LDIT2;
         }
         if(ncnst2nd)
         {/* LSTPOINT 2nd */
           if(rp2p==PCLSTPOINT)
           { swpd[swpdc].prcd=PD2LSTPT;
             rut[8].use=1; r2sto2=8;
             if(r2sto!=3&&r2sto!=6&&r2sto!=7)
               r2sto=findreg(0,rut,2,0,rut,rsto,rsto2,argreg,nodxout,-1,-1);
if(r2sto<3) { fatal=1; yyerror("didn't do LSTPOINT right"); }
             rut[r2sto].use=1;
             swpd[swpdc++].reg=r2sto;
           }
          /* LOADIT 2nd */
           if(rp2p!=PCREG||r2sto<0)
           { r2sto=findreg(0,rut,0,0,rut,rsto,rsto2,r2sto2
              ,dblwo2nd&&rp2p==PCLSTPOINT?r2sto:-1,nodxout,-1);
             rut[r2sto].use=1;
             swpd[swpdc].reg=r2sto;
             swpd[swpdc++].prcd=PD2LDIT;
           }
           if(dblwo2nd&&(rp2p!=PCREG||r2sto2<0))
           { r2sto2=findreg(0,rut,0,0,rut,rsto,rsto2,r2sto,nodxout,-1,-1);
if(r2sto2<0) { fatal=1; yyerror("4didn't do LDIT right"); }
             rut[r2sto2].use=1;
             swpd[swpdc].reg=r2sto2;
             swpd[swpdc++].prcd=PD2LDIT2;
           }
           else if(!dblwo2nd) r2sto2=(-1);
           rp2p=PCREG;
         }
         else
         { swconst=1; swcval=rp2->cval; }
         swmem=1;
         if(!dblwo2nd) r2sto2=(-2);
        /* LSTPOINT 1st */
         if(rp1p==PCLSTPOINT)
         { swpd[swpdc].prcd=PD1LSTPT;
           rut[8].use=1; rsto2=8;
           if(rsto!=3&&rsto!=6&&rsto!=7)
            rsto=findreg(0,rut,2,0,rut,r2sto,r2sto2,nodxout,-1,-1,-1);
if(rsto<3) { fatal=1; yyerror("1didn't do LSTPOINT right"); }
           rut[rsto].use=1;
           swpd[swpdc++].reg=rsto;
         }
         swoutplc=2;
       }
       else if(swtchable&&srcmem)
       { if(rp2p==PCMEMORY||rp2p==PCLSTPOINT) goto swnotswtched;
         else if(rp1p==PCMEMORY||rp1p==PCLSTPOINT)
         {/* POP 1st */
           if(rsto==-1&&(r2sto2==-1||r2sto==-1))
           { /* POP 1st anywhere */
             rsto=findreg(0,rut,rp1p==PCLSTPOINT?2:0,0,rut,r2sto,r2sto2,rsto2
              ,-1,nodxout,-1);
  if(rsto<0) { fatal=1; yyerror("6didn't do LDIT right"); }
             rut[rsto].use=1;
             swpd[swpdc].reg=rsto;
             swpd[swpdc++].prcd=PD1LDIT;
           }
           if(rsto2==-1&&(r2sto2==-1||r2sto==-1))
           { rsto2=findreg(0,rut,rp2p==PCLSTPOINT,8,rut,r2sto,r2sto2,rsto
               ,nodxout,-1,-1);
  if(rsto2<0) { fatal=1; yyerror("7didn't do LDIT right"); }
             rut[rsto2].use=1;
             swpd[swpdc].reg=rsto2;
             swpd[swpdc++].prcd=PD1LDIT2;
           }
           if(ncnst2nd||!cmpjmp)
           {/* LOADIT 2nd */
             if(rp2p!=PCREG||r2sto<0)
             { r2sto=findreg(0,rut,0,0,rut,rsto,rsto2,r2sto2,nodxout,-1,-1);
  if(r2sto<0) { fatal=1; yyerror("8didn't do LDIT right"); }
               rut[r2sto].use=1;
               swpd[swpdc].reg=r2sto;
               swpd[swpdc++].prcd=PD2LDIT;
             }
             if(dblwo2nd&&(rp2p!=PCREG||r2sto2<0))
             { r2sto2=findreg(0,rut,0,0,rut,rsto,rsto2,r2sto,nodxout,-1,-1);
  if(r2sto2<0) { fatal=1; yyerror("9didn't do LDIT right"); }
               rut[r2sto2].use=1;
               swpd[pdc].reg=r2sto2;
               swpd[pdc++].prcd=PD2LDIT2;
             }
             else if(!dblwo2nd) r2sto2=(-1);
             rp2p=PCREG;
           }
           else
           { swconst=2; swcval=rp2->cval; }
           if(!dblwo2nd) r2sto2=(-2);
          /* LSTPOINT 1st */
           if(rp1p==PCLSTPOINT)
           { swpd[swpdc].prcd=PD1LSTPT;
             rut[8].use=1; rsto2=8;
             if(rsto!=3&&rsto!=6&&rsto!=7)
               rsto=findreg(0,rut,2,0,rut,r2sto,r2sto2,nodxout,-1,-1,-1);
  if(rsto<3) { fatal=1; yyerror("10didn't do LSTPOINT right"); }
             rut[rsto].use=1;
             swpd[swpdc++].reg=rsto;
           }
           swmem=1;
           swoutplc=2;
         }
         else
         { itmp=0;
           if(preserve) { fatal=1; yyerror("sw preserve ! make sense here"); }
           if(ncnst1st)
           {/* LOADIT 1st */
             if(rp1p!=PCREG||rsto<0)
             { rsto=findreg(0,rut,0,0,rut,r2sto,rsto2,r2sto2,nodxout,-1,-1);
  if(rsto<0) { fatal=1; yyerror("11didn't do LDIT right"); }
               rut[rsto].use=1;
               swpd[swpdc].reg=rsto;
               swpd[swpdc++].prcd=PD1LDIT;
             }
             if(dblwo1st&&(rp1p!=PCREG||rsto2<0))
             { rsto2=findreg(0,rut,0,0,rut,rsto,r2sto2,r2sto,nodxout,-1,-1);
  if(r2sto2<0) { fatal=1; yyerror("12didn't do LDIT right"); }
               rut[rsto2].use=1;
               swpd[swpdc].reg=rsto2;
               swpd[swpdc++].prcd=PD1LDIT2;
             }
             else if(!dblwo1st) rsto2=(-1);
             rp1p=PCREG;
             itmp=1;
             swmem=1;
             swoutplc=2;
           }
           else
           { swconst=1; swcval=rp1->cval; }
           if(!itmp||ncnst2nd)
           {/* LOADIT 2nd */
             if(rp2p!=PCREG||r2sto<0)
             { r2sto=findreg(0,rut,0,0,rut,rsto,rsto2,r2sto2,nodxout,-1,-1);
  if(r2sto<0) { fatal=1; yyerror("13didn't do LDIT right"); }
               rut[r2sto].use=1;
               swpd[swpdc].reg=r2sto;
               swpd[swpdc++].prcd=PD2LDIT;
             }
             if(dblwo2nd&&(rp2p!=PCREG||r2sto2<0))
             { r2sto2=findreg(0,rut,0,0,rut,rsto,rsto2,r2sto,nodxout,-1,-1);
  if(r2sto2<0) { fatal=1; yyerror("14didn't do LDIT right"); }
               rut[r2sto2].use=1;
               swpd[swpdc].reg=r2sto2;
               swpd[swpdc++].prcd=PD2LDIT2;
             }
             rp2p=PCREG;
             swmem=2;
             swoutplc=1;
           }
           else
           { swconst=1; swcval=rp2->cval; }
         }
       }
       else
       {swnotswtched:
        /* LSTPOINT 1st */
         trs2=trst=(-1);
         if(rp1p==PCLSTPOINT)
         { swpd[swpdc].prcd=PD1LSTPT;
           trs2=rsto2;
           if(rp2p!=PCLSTPOINT) trs2=(-1);
           rut[8].use=1; rsto2=8;
           if(rsto!=3&&rsto!=6&&rsto!=7)
            trst=rsto=findreg(0,rut,2,0,rut,r2sto,r2sto2,trs2,nodxout,-1,-1);
  if(rsto<3) { fatal=1; yyerror("15didn't do LSTPOINT right"); }
           rut[rsto].use=1;
           swpd[swpdc++].reg=rsto;
           if(!preserve) trst=trs2=(-1);
         }
         if(!ncnst1st&&cmpjmp)
         { swconst=1; swcval=rp1->cval; }
         else if(rp1p!=PCREG||rsto<0)
         { /* LOADIT 1st */
           rsto=findreg(0,rut,0,0,rut,r2sto,rsto2,r2sto2
            ,dblwo1st&&rp1p!=PCLSTPOINT?rsto:-1,trs2,trst);
  if(rsto<0) { fatal=1; yyerror("16didn't do LDIT right"); }
           rut[rsto].use=1;
           swpd[swpdc].reg=rsto;
           swpd[swpdc++].prcd=PD1LDIT;
           if(dblwo1st&&(rp1p!=PCREG||rsto2<0))
           { r2sto2=findreg(0,rut,0,0,rut,rsto,r2sto2,r2sto,trst,trs2,nodxout);
  if(r2sto2<0) { fatal=1; yyerror("17didn't do LDIT right"); }
             rut[r2sto2].use=1;
             swpd[swpdc].reg=r2sto2;
             swpd[swpdc++].prcd=PD1LDIT2;
           }
           else if(!dblwo1st) rsto2=(-1);
           rp1p=PCREG;
         }
        /* LSTPOINT 2nd */
         if(rp2p==PCLSTPOINT)
         { if(preserve)
           swpd[swpdc].prcd=PD2LSTPT;
           rut[8].use=1; r2sto2=8;
           if(r2sto!=3&&r2sto!=6&&r2sto!=7)
             r2sto=findreg(0,rut,2,0,rut,rsto,rsto2,argreg,trst,trs2,nodxout);
if(r2sto<3) { fatal=1; yyerror("18didn't do LSTPOINT right"); }
           rut[r2sto].use=1;
           swpd[swpdc++].reg=r2sto;
         }
         if((!ncnst1st&&!cmpjmp)||((ncnst2nd&&rp2p!=PCLSTPOINT
           &&rp2p!=PCMEMORY)||!srcmem))
         {/* LOADIT 2nd */
           if(rp2p!=PCREG||r2sto<0)
           { r2sto=findreg(0,rut,0,0,rut,rsto,rsto2,r2sto2
              ,dblwo2nd&&rp2p!=PCLSTPOINT?r2sto:-1,trst,trs2);
  if(r2sto<0) { fatal=1; yyerror("19didn't do LDIT right"); }
             rut[r2sto].use=1;
             swpd[swpdc].reg=r2sto;
             swpd[swpdc++].prcd=PD2LDIT;
           }
           if(dblwo2nd&&(rp2p!=PCREG||r2sto2<0))
           { r2sto2=findreg(0,rut,0,0,rut,rsto,rsto2,r2sto,trst,trs2,nodxout);
  if(r2sto2<0) { fatal=1; yyerror("20didn't do LDIT right"); }
             rut[r2sto2].use=1;
             swpd[swpdc].reg=r2sto2;
             swpd[swpdc++].prcd=PD2LDIT2;
           }
           rp2p=PCREG;
         }
         swmem=2;
         if(!ncnst2nd&&(ncnst1st||!cmpjmp))
         { swconst=1; swcval=rp2->cval; swmem=1; }
         outplc=1;
       }
      break;
      default: fatal=1; yyerror("unknown argtp swbinaryloadit");
    }
    for(swruse=x=0;x<9;x++) swruse+=rut[x].use;
  }
  /* fltlev/ruse/mbpo */
  if(o.swtched=(umath&&preserve)||swfltlev<fltlev||(swfltlev==fltlev
   &&(swruse<ruse||(swruse==swruse&&swmxbpoff>mxbpoff))))
  { p=swpd; pc=swpdc; prsrv1=swprsrv1; p1rs2=swp1rs2; }
  else
  { p=pd; pc=pdc; }
  if(umath)
  {/*read in at least one/ unless already done?/ generate some of output*/
    o.dstmem=o.const=0;
    if(dstmem) o.swtched=1;
    if(o.swtched)
    {/* LOAD 2nd */
      if(preserve)
      { rp1->llprg=rp1->argreg;
        rp1->lpprg2=rp1->reguse[rp1->argreg].reg;
      }
      if(rp2->place!=PCMATH) fltload(rp2);
      if(o.fltsrcmem=rp1->place!=PCMATH)
        o.m=genmemin(rp1->argreg,rp1p,rsto,rp1->sect,rp1->scoff,rp1->boff,1,0
          ,rp1->bpoff);
      o.tp=rp1->tp;
      rpn=(*rp2); *rp2=(*rp1); *rp1=rpn;
      ltmp=rp2->sect;   rp2->sect=rp1->sect;     rp1->sect=ltmp;
      ltmp=rp2->size;   rp2->size=rp1->size;     rp1->size=ltmp;
      ltmp=rp2->scoff;  rp2->scoff=rp1->scoff;   rp1->scoff=ltmp;
      ltmp=rp2->lexist; rp2->lexist=rp1->lexist; rp1->lexist=ltmp;
      ltmp=rp2->llprg;  rp2->llprg=rp1->llprg;   rp1->llprg=ltmp;
      ltmp=rp2->lpprg2; rp2->lpprg2=rp1->lpprg2; rp1->lpprg2=ltmp;
      ltmp=rp2->ltp;    rp2->ltp=rp1->ltp;       rp1->ltp=ltmp;
      ltmp=rp2->lplace; rp2->lplace=rp1->lplace; rp1->lplace=ltmp;
      ltmp=rp2->lboff;  rp2->lboff=rp1->lboff;   rp1->lboff=ltmp;
      ltmp=rp2->boff;   rp2->boff=rp1->boff;     rp1->boff=ltmp;
      ltmp=rp2->cval;   rp2->cval=rp1->cval;     rp1->cval=ltmp;
    }
    else
    {/* LOAD 1st */
      if(rp1->place!=PCMATH) fltload(rp1);
      if(o.fltsrcmem=rp2->place!=PCMATH)
        o.m=genmemin(rp2->argreg,rp2p,r2sto,rp2->sect,rp2->scoff,rp2->boff,1,0
          ,rp1->bpoff);
      o.tp=rp2->tp;
    }
    rp1->place=PCMATH;
    for(ltmp=0;ltmp<11;ltmp++) rp1->reguse[ltmp]=rut[ltmp];
    combinerpns(rp2,rp1,o.swtched); /* should be no preswtched here/save time*/
/*IAM:maxoff*/
  }
  else
  { o.dstmem=dstmem;
    rsto2=r2sto2=(-2);
    rp1p=rp1->place;
    rp2p=rp2->place;
    if(rp1p==PCSTACK)
    { if(rp1->tp%SUNSIGNED==SLONG||rp1->tp==SPOINTER) rsto2=(-1);
      rsto=(-1);
    }
    else if(rp1p==PCREG||rp1p==PCLSTPOINT)
    { rsto=rp1->argreg;
/*      if(rp1p==PCLSTPOINT) rsto2=(-1);*/
      if(rsto>=0&&rp1->reguse[rsto].use==RP1STPT)
       rsto2=rp1->reguse[rsto].reg;
    }
    else rsto=(-2);
    if(rp2p==PCSTACK)
    { if(rp2->tp%SUNSIGNED==SLONG||rp2->tp==SPOINTER) r2sto2=(-1);
      r2sto=(-1);
    }
    else if(rp2p==PCREG||rp2p==PCLSTPOINT)
    { r2sto=rp2->argreg;
/*      if(rp2p==PCLSTPOINT) r2sto2=(-1);*/
      if(r2sto>=0&&rp2->reguse[r2sto].use==RP1STPT)
       r2sto2=rp2->reguse[r2sto].reg;
    }
    else r2sto=(-2);
    r1lded=r2lded=0;
    for(x=0;x<pc;x++)
    { switch(p[x].prcd)
      { case PD1LDIT:
         if(rp1p!=PCLSTPOINT) r1lded=1;
         switch(p[x].reg)
         { case -1:
            /* push xx
             * 50+rsto */
            RAL(rp1->bops,rp1->blen+1,char);
            rp1->bops[rp1->blen++]=0x50+rsto;
            rp1->bpoff-=2;
           break;
           case 8:
            /* mov es,xx
             * 8e c0+rsto */
            RAL(rp1->bops,rp1->blen+2,char);
            rp1->bops[rp1->blen++]=0x8e; rp1->bops[rp1->blen++]=0xc0+rsto;
           break;
           default:
            /* mov reg,xx
             * 89 c0+p[x].reg+(rsto<<3) */
            RAL(rp1->bops,rp1->blen+2,char);
            rp1->bops[rp1->blen++]=0x89;
            rp1->bops[rp1->blen++]=0xc0+(rsto<<3)+p[x].reg;
            if(rp1p!=PCREG&&rp1p!=PCLSTPOINT) rp1p=PCREG;
         }
         rsto=p[x].reg;
        break;
        case PD1LDIT2:
         switch(p[x].reg)
         { case -1:
            /* push xx
             * 50+rsto2 */
            RAL(rp1->bops,rp1->blen+1,char);
            rp1->bops[rp1->blen++]=rsto2<8?0x50+rsto2:0x6;
            rp1->bpoff-=2;
           break;
           case 8:
            /* mov es,xx
             * 8e c0+rsto2 */
            RAL(rp1->bops,rp1->blen+2,char);
            rp1->bops[rp1->blen++]=0x8e; rp1->bops[rp1->blen++]=0xc0+rsto2;
           break;
           default:
            /* mov reg,xx
             * 89 c0+p[x].reg+(rsto2<<3) */
            RAL(rp1->bops,rp1->blen+2,char);
            if(rsto2<8)
            { rp1->bops[rp1->blen++]=0x89;
              rp1->bops[rp1->blen++]=0xc0+(rsto2<<3)+p[x].reg;
            }
            else /* es */
            { rp1->bops[rp1->blen++]=0x8c;
              rp1->bops[rp1->blen++]=0xc0+p[x].reg;
            }
         }
         rsto2=p[x].reg;
        break;
        case PD2LDIT:
         if(rp2p!=PCLSTPOINT) r2lded=1;
         switch(p[x].reg)
         { case -1:
            /* push xx
             * 50+r2sto */
            RAL(rp2->bops,rp2->blen+1,char);
            rp2->bops[rp2->blen++]=0x50+r2sto;
            rp2->bpoff-=2;
           break;
           case 8:
            /* mov es,xx
             * 8e c0+r2sto */
            RAL(rp2->bops,rp2->blen+2,char);
            rp2->bops[rp2->blen++]=0x8e; rp2->bops[rp2->blen++]=0xc0+r2sto;
           break;
           default:
            /* mov reg,xx
             * 89 c0+p[x].reg+(r2sto<<3) */
            RAL(rp2->bops,rp2->blen+2,char);
            rp2->bops[rp2->blen++]=0x89;
            rp2->bops[rp2->blen++]=0xc0+(r2sto<<3)+p[x].reg;
            if(rp2p!=PCREG&&rp2p!=PCLSTPOINT) rp2p=PCREG;
         }
         r2sto=p[x].reg;
        break;
        case PD2LDIT2:
         switch(p[x].reg)
         { case -1:
            /* push xx
             * 50+r2sto2 */
            RAL(rp2->bops,rp2->blen+1,char);
            rp2->bops[rp2->blen++]=r2sto2<8?0x50+r2sto2:0x6;
            rp2->bpoff-=2;
           break;
           case 8:
            /* mov es,xx
             * 8e c0+r2sto2 */
            RAL(rp2->bops,rp2->blen+2,char);
            rp2->bops[rp2->blen++]=0x8e; rp2->bops[rp2->blen++]=0xc0+r2sto2;
           break;
           default:
            /* mov reg,xx
             * 89 c0+p[x].reg+(r2sto2<<3) */
            RAL(rp2->bops,rp2->blen+2,char);
            if(r2sto2<8)
            { rp2->bops[rp2->blen++]=0x89;
              rp2->bops[rp2->blen++]=0xc0+(r2sto2<<3)+p[x].reg;
            }
            else /* es */
            { rp2->bops[rp2->blen++]=0x8c;
              rp2->bops[rp2->blen++]=0xc0+p[x].reg;
            }
         }
         r2sto2=p[x].reg;
        break;
        case PDCOMBINE:
         if(o.swtched)
         { rpn=(*rp2); *rp2=(*rp1); *rp1=rpn; /* MORE: what here? */
           ltmp=rp2->sect;   rp2->sect=rp1->sect;     rp1->sect=ltmp;
           ltmp=rp2->size;   rp2->size=rp1->size;     rp1->size=ltmp;
           ltmp=rp2->scoff;  rp2->scoff=rp1->scoff;   rp1->scoff=ltmp;
           ltmp=rp2->lexist; rp2->lexist=rp1->lexist; rp1->lexist=ltmp;
           ltmp=rp2->llprg;  rp2->llprg=rp1->llprg;   rp1->llprg=ltmp;
           ltmp=rp2->lpprg2; rp2->lpprg2=rp1->lpprg2; rp1->lpprg2=ltmp;
           ltmp=rp2->ltp;    rp2->ltp=rp1->ltp;       rp1->ltp=ltmp;
           ltmp=rp2->lplace; rp2->lplace=rp1->lplace; rp1->lplace=ltmp;
           ltmp=rp2->lboff;  rp2->lboff=rp1->lboff;   rp1->lboff=ltmp;
           ltmp=rp2->boff;   rp2->boff=rp1->boff;     rp1->boff=ltmp;
           ltmp=rp2->cval;   rp2->cval=rp1->cval;     rp1->cval=ltmp;
           for(ltmp=0;ltmp<11;ltmp++) rp1->reguse[ltmp]=swrut[ltmp];
         }
         else for(ltmp=0;ltmp<11;ltmp++) rp1->reguse[ltmp]=rut[ltmp];
         combinerpns(rp2,rp1,o.swtched^preswitched);
         if(fwait)
         { RAL(rp1->bops,rp1->blen+1,char);
           rp1->bops[rp1->blen++]=0x9b;
         }
        goto combined;
        default:
         fatal=1; yyerror("illegal procedure");
      }
    }
    fatal=1; yyerror("not combined in binaryloadit");
   combined:
    for(r1lp=r2lp=1,x++;x<pc;x++)
    { switch(p[x].prcd)
      { case PD1LSTPT:
         if(rsto!=p[x].reg) regloadit(rp1,rp1,rp1p,rsto,1,0,p[x].reg);
         rlpreg=rsto=p[x].reg;
         if(rsto2!=8) regloadit(rp1,rp1,rp1p,rsto2,1,2,8);
         rp1->llprg=rsto;
         switch(prsrv1)
         { case 1:
            regloadit(rp1,rp1,rp1p,rsto2,1,0,p1rs2);
            rp1->lpprg2=p1rs2;
           break;
           case 2:
            rp1->lpprg2=p1rs2;
           break;
           case 0:
            rp1->lpprg2=8;
           break;
           default:
            illegaltype(prsrv1);
         }
         rsto2=8;
         r1lp=0;
        break;
        case PD2LSTPT:
         if(r2sto!=p[x].reg) regloadit(rp1,rp2,rp2p,r2sto,1,0,p[x].reg);
         r2lpreg=r2sto=p[x].reg;
         if(r2sto2!=8) regloadit(rp1,rp2,rp2p,r2sto2,1,2,8);
         r2sto2=8;
         r2lp=0;
        break;
        case PD1LDIT:
         rp1->argreg=rlpreg;
         regloadit(rp1,rp1,rp1p,rsto,r1lp,0,p[x].reg);
         rsto=p[x].reg;
         if(rp1p!=PCLSTPOINT||!r1lp) r1lded=1;
        break;
        case PD1LDIT2:
         rp1->argreg=rlpreg;
         regloadit(rp1,rp1,rp1p,rsto2,r1lp,2,p[x].reg);
         rsto2=p[x].reg;
        break;
        case PD2LDIT:
         rp1->argreg=r2lpreg;
         regloadit(rp1,rp2,rp2p,r2sto,r2lp,0,p[x].reg);
         r2sto=p[x].reg;
         if(rp2p!=PCLSTPOINT||!r2lp) r2lded=1;
        break;
        case PD2LDIT2:
         rp1->argreg=r2lpreg;
         regloadit(rp1,rp2,rp2p,r2sto2,r2lp,2,p[x].reg);
         r2sto2=p[x].reg;
        break;
        case PDXCHG2:
         /* xchg rsto2,r2sto
          * 87 c0+rsto2+(r2sto<<3) */
         RAL(rp1->bops,rp1->blen+2,char);
         rp1->bops[rp1->blen++]=0x87;
         rp1->bops[rp1->blen++]=0xc0+rsto2+(r2sto<<3);
         itmp=rsto2; rsto2=r2sto; r2sto=itmp;
        break;
        case PDXCHG:
         /* xchg rsto,r2sto
          * 87 c0+rsto+(r2sto<<3) */
         RAL(rp1->bops,rp1->blen+2,char);
         rp1->bops[rp1->blen++]=0x87;
         rp1->bops[rp1->blen++]=0xc0+rsto+(r2sto<<3);
         itmp=rsto; rsto=r2sto; r2sto=itmp;
        break;
        default:
         fatal=1; yyerror("illegal procedure");
      }
    }
    if(o.swtched)
    { o.const=swconst;
      o.cval=swcval;
      mem=swmem;
      outplc=swoutplc;
    }
    else
    { o.const=const;
      o.cval=cval;
    }
    if(nodxout>=0&&rsto==nodxout)
    { a=rsto;
      rsto=findreg(0,rp1->reguse,0,0,rp1->reguse,nodxout,rsto2,r2sto,r2sto2
        ,-1,-1);
      regloadit(rp1,rp1,rp1p,a,1,0,rsto);
      rp1->reguse[rsto].use=1;
    }
    if(nodxout>=0&&r2sto==nodxout)
    { a=r2sto;
      r2sto=findreg(0,rp1->reguse,0,0,rp1->reguse,nodxout,rsto2,r2sto,r2sto2
        ,-1,-1);
      regloadit(rp1,rp2,rp2p,a,1,0,r2sto);
      rp1->reguse[r2sto].use=1;
    }
    if(outplc==2&&mem==1&&r2sto2<0&&dblwo1st&&r2sto>=0)
    { if(dblwo2nd||rp1p!=PCREG||rsto2==-1)
      { a=r2sto2;
        r2sto2=findreg(0,rp1->reguse,0,0,rp1->reguse,rsto,rsto2,r2sto,nodxout
          ,-1,-1);
        rp1->argreg=rsto;
        regloadit(rp1,rp1,rp1p,a,1,2,r2sto2);
        rp1->reguse[r2sto2].use=1;
      }
      else r2sto2=rsto2;
    }
    else if(outplc==1&&mem==2&&rsto2<0&&dblwo2nd&&rsto>=0)
    { if(dblwo1st||rp1p!=PCREG||rsto2==-1)
      { a=rsto2;
        rsto2=findreg(0,rp1->reguse,0,0,rp1->reguse,rsto,r2sto2,r2sto,nodxout
         ,-1,-1);
        rp1->argreg=r2sto;
        regloadit(rp1,rp2,rp2p,a,1,2,rsto2);
        rp1->reguse[rsto2].use=1;
      }
      else rsto2=r2sto2;
    }
    if(r1lded) rp1p=PCREG;
    if(r2lded) rp2p=PCREG;
    if(mem==1)
    { o.m=genmemin(rsto,rp1p,rsto,rp1->sect,rp1->scoff,rp1->boff,!r1lp,0
        ,rp1->bpoff);
      if(dblwo1st)
      { o.m2=genmemin(rsto,rp1p,rsto2,rp1->sect,rp1->scoff,rp1->boff
          ,!r1lp,2,rp1->bpoff);
        if(!const&&!lrgfld&&r2sto2>=0&&r2sto2<8) *o.m2.stf+=(r2sto2<<3);
      }
      if(!const&&!lrgfld&&r2sto>=0) *o.m.stf+=(r2sto<<3);
    }
    else
    { if(mem!=2) { fatal=1; yyerror("internal error"); }
      o.m=genmemin(r2sto,rp2p,r2sto,rp2->sect,rp2->scoff,rp2->boff,!r2lp,0
        ,rp2->bpoff);
      if(dblwo2nd)
      { o.m2=genmemin(r2sto,rp2p,r2sto2,rp2->sect,rp2->scoff,rp2->boff
          ,!r2lp,2,rp1->bpoff);
        if(!const&&!lrgfld&&rsto2>=0&&rsto2<8) *o.m2.stf+=(rsto2<<3);
      } /*if(dstmem) not needed because it would not have mem==2*/
      if(!const&&!lrgfld&&rsto>=0) *o.m.stf+=(rsto<<3);
    }
if(rsto==r2sto&&rsto>=0) fprintf(stderr,"r&r2= %d\n",rsto);
    if(outplc==2)
    { rsto=r2sto; rp1p=rp2p; rsto2=r2sto2;
      if(rp1p==PCCONST) rp1->cval=rp2->cval;
    }
    else if(outplc!=1) { fatal=1; yyerror("outplc err"); }
    rp1->argreg=rsto; /* should already be flagged used */
    rp1->place=rp1p;
    /*if place is memory or lstpoint, must be dstmem, how dstmem comes*/
    if(rsto2>=0)
    { if(rsto<0) { fatal=1; yyerror("2nd in register but not 1st"); }
      rp1->reguse[rsto].use=RP1STPT;
      rp1->reguse[rsto].reg=rsto2;
      rp1->reguse[rsto2].use=RP2NDPT;
      rp1->reguse[rsto2].reg=rsto;
    }
    else if((dblwo2nd||dblwo1st)&&rsto>=0) illegaltype("rsto2");
  }
  if(o.swtched) { if(rp1->maxoff>swmxbpoff) rp1->maxoff=swmxbpoff; }
  else if(rp1->maxoff>mxbpoff) rp1->maxoff=mxbpoff;
  if(cmpjmp&&!umath) o.swtched=mem-1;
  o.mem=mem!=outplc&&!dstmem;
  rp1->gzf=rp1->gcsof=0;
 return o;
}
fltload(rp1) struct stack *rp1;
{ int fop,pop=0,popsz,regadd,x,out=0,y;
/*out not used. Why? */
  struct memindx m,m2;
  if(rp1->place==PCMATH) return 0;
  if(rp1->maxfltlev<1) rp1->maxfltlev=1;
  switch(rp1->tp)
  { case SLONG:
     /*  push xx
      *  push yy
      * fild dw [something]
      * */
     if(rp1->place==PCREG)
     { pop=1; popsz=4;
       if(rp1->argreg<0||rp1->argreg>8||rp1->reguse[rp1->argreg].use!=RP1STPT
        ||rp1->reguse[rp1->argreg].reg<0||rp1->reguse[rp1->argreg].reg>8)
       { fatal=1; yyerror("illegal register in fltload"); }
       RAL(rp1->bops,rp1->blen+2,char);
       rp1->bops[rp1->blen++]=rp1->reguse[rp1->argreg].reg<8?0x50
         +rp1->reguse[rp1->argreg].reg:0x06;
       rp1->bops[rp1->blen++]=rp1->argreg<8?0x50+rp1->argreg:0x06;
       rp1->bpoff-=4;
       rp1->place=PCSTACK;
     }
     else if(rp1->place==PCSTACK) { pop=1; popsz=4; }
     fop=0xdb; regadd=0;
    break;
    case SUNSIGNED+SLONG:
     if(x=rp1->place!=PCREG)
     { m=genmemin(rp1->argreg,rp1->place,0,rp1->sect,rp1->scoff,rp1->boff,1,0
         ,rp1->bpoff);
       m2=genmemin(rp1->argreg,rp1->place,0,rp1->sect,rp1->scoff,rp1->boff,1,2
         ,rp1->bpoff);
     }
     if(rp1->place==PCSTACK)
     { /* pop xx
        * pop yy
        * */
       RAL(rp1->bops,rp1->blen+8,char);
       rp1->argreg=findreg(0,rp1->reguse,0,0,rp1->reguse,-1,-1,-1,-1,-1,-1);
       rp1->reguse[rp1->argreg].reg=findreg(0,rp1->reguse,0,0,rp1->reguse
         ,rp1->argreg,-1,-1,-1,-1,-1);
       rp1->reguse[rp1->argreg].use=RP1STPT;
       rp1->reguse[rp1->reguse[rp1->argreg].reg].use=RP2NDPT;
       rp1->reguse[rp1->reguse[rp1->argreg].reg].reg=rp1->argreg;
       rp1->bops[rp1->blen++]=0x58+rp1->reguse[rp1->argreg].reg;
       rp1->bops[rp1->blen++]=0x58+rp1->argreg;
       x=0;
       rp1->bpoff+=4;
       rp1->place=PCREG;
     }
     else RAL(rp1->bops,rp1->blen+(x?6+m.sz+m2.sz+m.segexist+m2.segexist:6)
           ,char);
     /* xor zz,zz
      * push zz
      * push zz
      * push xx
      * push yy
      * fild qw [something]
      * wait
      * add sp,8
      * */
     out=1;
     if(!x||rp1->place==PCLSTPOINT)
      y=findreg(0,rp1->reguse,0,0,rp1->reguse,rp1->argreg
        ,rp1->reguse[rp1->argreg].reg,-1,-1,-1,-1);
     else y=findreg(0,rp1->reguse,0,0,rp1->reguse,-1,-1,-1,-1,-1,-1);
     rp1->bops[rp1->blen++]=0x33; rp1->bops[rp1->blen++]=0xc0+y+(y<<3);
     rp1->bops[rp1->blen++]=0x50+y; rp1->bops[rp1->blen++]=0x50+y;
     rp1->reguse[y].use=1;
     if(x)
     { if(m2.segexist) rp1->bops[rp1->blen++]=m2.seg;
       rp1->bops[rp1->blen++]=0xff;
       *m2.stf+=6<<3; *m.stf+=6<<3;
       memcpy(rp1->bops+rp1->blen,m2.stf,m2.sz); rp1->bops+=m2.sz;
       xrfill(rp1,m2);
       if(m.segexist) rp1->bops[rp1->blen++]=m.seg;
       rp1->bops[rp1->blen++]=0xff;
       memcpy(rp1->bops+rp1->blen,m.stf,m.sz); rp1->bops+=m.sz;
       xrfill(rp1,m);
     }
     else
     { if(rp1->argreg<0||rp1->argreg>8||rp1->reguse[rp1->argreg].use!=RP1STPT
        ||rp1->reguse[rp1->argreg].reg<0||rp1->reguse[rp1->argreg].reg>8)
       { fatal=1; yyerror("illegal register in fltload"); }
       rp1->bops[rp1->blen++]=rp1->reguse[rp1->argreg].reg<8?0x50
         +rp1->reguse[rp1->argreg].reg:0x06;
       rp1->bops[rp1->blen++]=rp1->argreg<8?0x50+rp1->argreg:0x06;
     }
     rp1->place=PCSTACK;
     rp1->bpoff-=8;
     pop=1; popsz=8;
     fop=0xdf; regadd=0x28;
    break;
    case SFLOAT:
     /* fld dw [something] */
     if(rp1->place==PCSTACK) goto reallydouble;
     fop=0xd9; regadd=0;
    break;
    case SDOUBLE:
    reallydouble:
     /* fld qw [something] */
     if(rp1->place==PCSTACK) { pop=1; popsz=8; }
     fop=0xdd; regadd=0;
    break;
    default: yyerror("unknown type in fltloadit");
  }
  if(rp1->bpoff<rp1->maxoff) rp1->maxoff=rp1->bpoff;
  if(rp1->maxfltlev<1) rp1->maxfltlev=1;
  m=genmemin(rp1->argreg,rp1->place,rp1->argreg,rp1->sect,rp1->scoff
    ,rp1->boff,1,0,rp1->bpoff);
  RAL(rp1->bops,rp1->blen+m.segexist+m.sz+1+4*pop,char);
  if(m.segexist) rp1->bops[rp1->blen++]=m.seg;
  rp1->bops[rp1->blen++]=fop; /* some type of fld */
  *m.stf+=regadd;
  memcpy(rp1->bops+rp1->blen,m.stf,m.sz); rp1->blen+=m.sz;
  xrfill(rp1,m);
  if(pop)
  { *(wordptr)(rp1->bops+rp1->blen)=0x839b; /*wait*/
    rp1->blen+=2;
    rp1->bops[rp1->blen++]=0xc4;
    rp1->bops[rp1->blen++]=popsz;
    rp1->bpoff+=popsz;
  }
  rp1->place=PCMATH;
 return out;
}
stkload(rp1) struct stack *rp1;
/* load to stack */
{ struct bld bo;
  int lng,a;
  switch(rp1->place)
  { case PCREG:
     /* push rg2
      * push rg
      * 50+rg 50+rg */
     RAL(rp1->bops,rp1->blen+2,char);
     if(rp1->argreg<0) illegaltype("stkload 1");
     lng=(rp1->tp==SPOINTER||rp1->tp%SUNSIGNED==SLONG);
     if(lng)
       if(rp1->reguse[rp1->argreg].reg==8) rp1->bops[rp1->blen++]=0x6;
       else rp1->bops[rp1->blen++]=0x50+rp1->reguse[rp1->argreg].reg;
     rp1->bops[rp1->blen++]=0x50+rp1->argreg;
     rp1->place=PCSTACK;
     rp1->bpoff-=lng?4:2;
    return 0;
    case PCCONST:
     if(rp1->tp==SDOUBLE) goto lastpointmath; /*constant double*/
     /* mov rg,##
      * push rg
      * mov rg,##
      * push rg
      * b8+rg ## 50+rg b8+rg ## 50+rg */
     lng=(rp1->tp==SPOINTER||rp1->tp%SUNSIGNED==SLONG);
     a=findreg(0,rp1->reguse,0,0,rp1->reguse,-1,-1,-1,-1,-1,-1);
     RAL(rp1->bops,rp1->blen+4+lng*4,char);
     if(lng)
     { rp1->bops[rp1->blen++]=0xb8+a;
       *(wordptr)(rp1->bops+rp1->blen)=(rp1->cval>>16); rp1->blen+=2;
       rp1->bops[rp1->blen++]=0x50+a;
     }
     rp1->bops[rp1->blen++]=0xb8+a;
     *(wordptr)(rp1->bops+rp1->blen)=rp1->cval; rp1->blen+=2;
     rp1->bops[rp1->blen++]=0x50+a;
     rp1->place=PCSTACK;
     rp1->bpoff-=lng?4:2;
    case PCSTACK:
    return 0;
    case PCLSTPOINT:
    case PCMEMORY:
     monoploadit(rp1,1);
     switch(rp1->tp%SUNSIGNED)
     { case SINT:
       case SLONG:
       case SPOINTER:
        /* push arg2
         * push arg
         * ff mem2+6 ff mem+6*/
        bo.m=genmemin(rp1->argreg,rp1->place,rp1->argreg,rp1->sect,rp1->scoff
          ,rp1->boff,1,0,rp1->bpoff);
        if(lng=(rp1->tp==SPOINTER||rp1->tp%SUNSIGNED==SLONG))
         bo.m2=genmemin(rp1->argreg,rp1->place,rp1->argreg>=0&&rp1->argreg<8
           ?rp1->reguse[rp1->argreg].reg:-1,rp1->sect,rp1->scoff,rp1->boff
           ,1,2,rp1->bpoff);
        *bo.m.stf+=0x30;
        *bo.m2.stf+=0x30;
        if(lng) addinstr(rp1,bo,2,0xff);
        addinstr(rp1,bo,0,0xff);
        rp1->place=PCSTACK;
        rp1->bpoff-=lng?4:2;
       return 0;
       case SFLOAT:
       case SDOUBLE:
       lastpointmath:
        fltload(rp1);
       goto atmath;
       default: fatal=1; yyerror("don't support loading weird types on stack");
     }
    break;
    case PCMATH:
    atmath:
     switch(rp1->tp)
     { case SLONG:
        /* sub sp,4
         * fistp dw [bp+]
         * 83 ec 4 db 9e bpoff*/
        RAL(rp1->bops,rp1->blen+7,char);
        RAL(rp1->bpxref,rp1->bpxcnt+3,long);
        *(wordptr)(rp1->bops+rp1->blen)=0xec83; rp1->blen+=2;
        *(wordptr)(rp1->bops+rp1->blen)=0xdb04; rp1->blen+=2;
        rp1->bops[rp1->blen++]=0x9e;
        rp1->bpoff-=4;
        rp1->bpxref[rp1->bpxcnt++]=rp1->blen;
        *(wordptr)(rp1->bops+rp1->blen)=rp1->bpoff; rp1->blen+=2;
       return 1;
       case SUNSIGNED+SLONG:
        /* sub sp,8
         * fistp qw [bp+]
         * wait
         * pop [bp+]
         * pop [bp+]
         * 83 ec 8 df be bpoff 9b 8f 86 bpoff 8f 86 bpoff */
        RAL(rp1->bops,rp1->blen+16,char);
        RAL(rp1->bpxref,rp1->bpxcnt+3,long);
        *(wordptr)(rp1->bops+rp1->blen)=0xec83; rp1->blen+=2;
        *(wordptr)(rp1->bops+rp1->blen)=0xdf08; rp1->blen+=2;
        rp1->bops[rp1->blen++]=0xbe;
        rp1->bpoff-=8;
        rp1->bpxref[rp1->bpxcnt++]=rp1->blen;
        *(wordptr)(rp1->bops+rp1->blen)=rp1->bpoff; rp1->blen+=2;
        *(wordptr)(rp1->bops+rp1->blen)=0x8f9b; rp1->blen+=2;
        rp1->bops[rp1->blen++]=0x86;
        rp1->bpxref[rp1->bpxcnt++]=rp1->blen;
        *(wordptr)(rp1->bops+rp1->blen)=rp1->bpoff; rp1->blen+=2;
        rp1->bpoff+=2;
        *(wordptr)(rp1->bops+rp1->blen)=0x868f; rp1->blen+=2;
        rp1->bpxref[rp1->bpxcnt++]=rp1->blen;
        *(wordptr)(rp1->bops+rp1->blen)=rp1->bpoff; rp1->blen+=2;
        rp1->bpoff+=2;
       return 0;
       case SFLOAT:
       case SDOUBLE:
        /* sub sp,8
         * fstp qw [bp+]
         * 83 ec 8 dd 9e bpoff*/
        RAL(rp1->bops,rp1->blen+7,char);
        RAL(rp1->bpxref,rp1->bpxcnt+1,long);
        *(wordptr)(rp1->bops+rp1->blen)=0xec83; rp1->blen+=2;
        *(wordptr)(rp1->bops+rp1->blen)=0xdd08; rp1->blen+=2;
        rp1->bops[rp1->blen++]=0x9e;
        rp1->bpoff-=8;
        rp1->bpxref[rp1->bpxcnt++]=rp1->blen;
        *(wordptr)(rp1->bops+rp1->blen)=rp1->bpoff; rp1->blen+=2;
       return 1;
       default: fatal=1; yyerror("unknown type in stkload");
     }
    break;
    default: yyerror("unknown place in stkloadit");
  }
}
regloadit(rp1,rp2,rp1p,rsto,r1lp,n,reg) struct stack *rp1,*rp2;
/* rp1-  access rp1 structures, bops, bpoff, and argreg for LSTPOINT
 * rp2-  speccifies sect,scoff,boff,cval
 * rp1p- rp1->place as would be now if kept up
 * rsto- rp1->argreg, or -1 if place is stack
 * r1lp- if 1, then access register of pointer, else object pointed to
 * n-    2 if MSW
 * reg-  register to load it into
 */
{ struct memindx m;
  if(reg<0||reg>8) { fatal=1; yyerror("illegal register loading"); }
  if(rp1p==PCCONST)
  { /* mov xx,const
     * b8+rg const */
    RAL(rp1->bops,rp1->blen+3,char);
    if(reg>7) { fatal=1; yyerror("cannot load constant into segment regs"); }
    rp1->bops[rp1->blen++]=0xb8+reg;
    *(wordptr)(rp1->bops+rp1->blen)=rp2->cval>>(n<<3);
    rp1->blen+=2;
  }
  else if(rsto==-1)
  { /* pop reg
     * 0x58+reg */
    RAL(rp1->bops,rp1->blen+1,char);
    rp1->bops[rp1->blen++]=reg==8?0x7:0x58+reg;
    rp1->bpoff+=2;
  }
  else
  { m=genmemin(rp1->argreg,rp1p,rsto,rp2->sect,rp2->scoff,rp2->boff,!r1lp,n
      ,rp1->bpoff);
    switch(reg)
    { case 8:
       /* mov es,xx
        * 8e c0+rsto */
       RAL(rp1->bops,rp1->blen+2+m.sz,char);
       if(m.segexist) rp1->bops[rp1->blen++]=m.seg;
       rp1->bops[rp1->blen++]=0x8e;
       memcpy(rp1->bops+rp1->blen,m.stf,m.sz);
       rp1->blen+=m.sz;
       xrfill(rp1,m);
      break;
      default:
       /* mov reg,xx
        * 8b c0+reg */
       RAL(rp1->bops,rp1->blen+2+m.sz,char);
       if(m.segexist) rp1->bops[rp1->blen++]=m.seg;
       rp1->bops[rp1->blen++]=0x8b;
       *m.stf+=reg<<3;
       memcpy(rp1->bops+rp1->blen,m.stf,m.sz);
       rp1->blen+=m.sz;
       xrfill(rp1,m);
    }
  }
}
findreg(urgu,rgu,atp,arg,rgi,notr,notr2,notr3,notr4,notr5,notr6)
 struct regusage *rgi,*rgu;
/* urgu - should I even consider below?
 * rgu  - don't use anything here
 * rgi  - any used here are prefered for use to minimize reg usage
 * notr - can't use this register
 * atp  - 0- no limit, 1- use arg if possible, 2- use [bx,si,di] if possible
 * arg  - see above
 */
{ int good=(-1);
  switch(atp)
  { case 1:
     if((urgu&&rgu[arg].use)||arg==notr||arg==notr2||arg==notr3||arg==notr4
       ||arg==notr5||arg==notr6)
      goto anything;
     good=arg;
    break;
    case 2:
     if(notr3!=3&&notr4!=3&&notr2!=3&&notr!=3&&rgi[3].use&&notr5!=3&&notr6!=3
       &&!(urgu&&rgu[3].use))
      good=3;
     else if(notr3!=6&&notr4!=6&&notr2!=6&&notr!=6&&rgi[6].use
       &&notr5!=6&&notr6!=6&&!(urgu&&rgu[6].use))
      good=6;
     else if(notr3!=7&&notr4!=7&&notr2!=7&&notr!=7&&notr5!=7&&notr6!=7
       &&!(urgu&&rgu[7].use))
      good=7;
     else if(notr3!=3&&notr4!=3&&notr2!=3&&notr!=3&&notr5!=3&&notr6!=3
       &&!(urgu&&rgu[3].use))
      good=3;
     else if(notr3!=6&&notr4!=6&&notr2!=6&&notr!=6&&notr5!=6&&notr6!=6
       &&!(urgu&&rgu[6].use))
      good=6;
     else goto anything;
    break;
    case 0:
    anything:
     for(good=0;good<3;good++)
      if(good!=notr3&&good!=notr4&&good!=notr&&good!=notr2&&rgi[good].use
        &&good!=notr5&&good!=notr6&&!(urgu&&rgu[good].use))
       goto end;
     for(good=0;good<3;good++)
      if(good!=notr3&&good!=notr4&&good!=notr&&good!=notr2
        &&good!=notr5&&good!=notr6&&(!(urgu&&rgu[good].use)))
       goto end;
     for(good=3;good<8;good++)
      if(good!=4&&good!=5&&good!=notr3&&good!=notr4&&good!=notr&&good!=notr2
        &&good!=notr5&&good!=notr6&&rgi[good].use&&!(urgu&&rgu[good].use))
       goto end;
     for(good=3;good<8;good++)
      if(good!=4&&good!=5&&good!=notr3&&good!=notr4&&good!=notr&&good!=notr2
        &&good!=notr5&&good!=notr6&&(!(urgu&&rgu[good].use)))
       goto end;
     good=(-1);
    break;
    default: fatal=1; yyerror("unknown atp in findreg");
  }
 end:
 return good;
}
struct bld monoploadit(rp1,lstpnt) struct stack *rp1;
/*monop- load rp1;   lstpnt==1 indicates that operand are ready to access,
 * but not loaded (usefull for pointers accesing a func, for example
 */
{ int rsto,r2sto,dblwo,a;
  struct bld o;
  rp1->gzf=rp1->gcsof=0;
  if(rp1->tp==SFLOAT||rp1->tp==SDOUBLE)
  { if(rp1->place==PCMATH) return o;
    if(!lstpnt)
    { monoploadit(rp1,1);
      fltload(rp1);
     return o;
    }
  }
  r2sto=rp1->place==PCLSTPOINT?rp1->reguse[rp1->argreg].reg:-1;
  rsto=rp1->place==PCLSTPOINT?rp1->argreg:-1;
  rsto=findreg(0,rp1->reguse,0,0,rp1->reguse,r2sto,-1,-1,-1,-1,-1);
  dblwo=rp1->tp%SUNSIGNED==SLONG||rp1->tp==SPOINTER;
  if(dblwo)
   r2sto=findreg(0,rp1->reguse,0,0,rp1->reguse,rsto,-1,-1,-1,-1,-1);
  switch(rp1->place)
  { case PCMATH:
     if(rp1->tp%SUNSIGNED==SLONG)
     { stkload(rp1);
      goto loadit;
     }
    break;
    case PCLSTPOINT:
     /* prepare for access */
     if(rp1->reguse[rp1->argreg].reg!=8)
       regloadit(rp1,rp1,PCLSTPOINT,rp1->reguse[rp1->argreg].reg,1,2,8);
     if(rp1->argreg!=3&&rp1->argreg!=6&&rp1->argreg!=7)
     { a=findreg(0,rp1->reguse,2,0,rp1->reguse,rp1->reguse[rp1->argreg].reg
         ,-1,-1,-1,-1,-1);
if(rp1->argreg<0||rp1->reguse[rp1->argreg].use!=RP1STPT)
{ fatal=1; yyerror("monoploadit PCLSTPOINT register"); }
       regloadit(rp1,rp1,PCLSTPOINT,rp1->argreg,1,0,a);
       rp1->argreg=a;
     }
     rp1->reguse[rp1->argreg].reg=8; rp1->reguse[8].reg=rp1->argreg;
     rp1->reguse[rp1->argreg].use=RP1STPT;
     rp1->reguse[8].use=RP2NDPT;
    case PCMEMORY:
     rp1->lexist=1; rp1->lplace=rp1->place; rp1->ltp=rp1->tp;
     rp1->llprg=rp1->argreg;
     if(rp1->argreg>=0) rp1->lpprg2=rp1->reguse[rp1->argreg].reg;
     rp1->lboff=rp1->boff;
    case PCSTACK:
     if(lstpnt) break;/*lstpnt also used in convert to insure access possible*/
    case PCCONST:
    loadit:
     regloadit(rp1,rp1,rp1->place,rp1->argreg,0,0,rsto);
     if(dblwo)
     { regloadit(rp1,rp1,rp1->place,rp1->reguse[rp1->argreg].reg,0,2,r2sto);
       rp1->reguse[rsto].use=RP1STPT; rp1->reguse[rsto].reg=r2sto;
       rp1->reguse[r2sto].use=RP2NDPT; rp1->reguse[r2sto].reg=rsto;
     }
     else rp1->reguse[rsto].use=1;
     rp1->argreg=rsto;
     rp1->place=PCREG;
    case PCREG:
    break;
    default: fatal=1; yyerror("unknown place in monoploadit");
  }
  o.m=genmemin(rp1->argreg,rp1->place,rp1->argreg,rp1->sect,rp1->scoff,rp1->boff
    ,!lstpnt,0,rp1->bpoff);
  if(dblwo)
   o.m2=genmemin(rp1->argreg,rp1->place,rp1->reguse[rp1->argreg].reg,rp1->sect
     ,rp1->scoff,rp1->boff,2,0,rp1->bpoff);
 return o;
}
addinstr(rpp,bo,n,op) struct stack *rpp; struct bld bo;
{ if(n==2) bo.m=bo.m2; /* this is done with a copy: no overwrite of non-stack*/
  RAL(rpp->bops,rpp->blen+bo.m.sz+bo.m.segexist+1,char);
  if(bo.m.segexist) R1=bo.m.seg;
  R1=op;
  memcpy(rpp->bops+rpp->blen,bo.m.stf,bo.m.sz);
  rpp->blen+=bo.m.sz;
  xrfill(rpp,bo);
}
addcinstr(rpp,bo,n,op) struct stack *rpp; struct bld bo;
{ int c;
  if(n==2)
  { bo.m=bo.m2; /*see addinstr*/
    c=bo.cval>>16;
  }
  else c=bo.cval;
  *bo.m.stf+=(op<<3); /* work with call to cut out bits */
  if(c>127||c<-128)
  { addinstr(rpp,bo,0,0x81);
    RAL(rpp->bops,rpp->blen+2,char);
    RB1=c; RBI1;
  }
  else
  { addinstr(rpp,bo,0,0x83);
    RAL(rpp->bops,rpp->blen+1,char);
    R1=c;
  }
}
combinerpns(rp1,rp2,swtched) struct stack *rp1,*rp2;
/* use with
 * rp2 op rp1;
 * if swtched, need to adjust hblocks
 */
{ int start1,a;
  if(!swtched)
  { /* 2 hblcks
     * 2 main [joined to 1st hblck(if exist) or main]
     * 1 hblck
     * 1 main
     */
    start1=0;
  }
  else
  { int cuthb;
    /* 1 hblcks before mark (if exist)
     * 2 hblcks
     * 2 main [joined to 1st hblck(if exist) or main
     * 1 hblcks after mark
     * 1 main
     */
    /* find cut-off if existent (if non-exist; cut-off=0) */
    cuthb=rp1->ncbcnt?rp1->hblkcnt-rp1->ncb[rp1->ncbcnt-1].hidn:0;
    for(a=rp1->hblkcnt-1;a>=cuthb&&a>=0;a--)
      if(rp1->hblk[a].cntnusrch) break;
    if(a>=0)
    { start1=a+1;
      /*mv lab at beginning of (1 hblcks after) to beginning of 2 hblcks */
      if(start1<rp1->hblkcnt&&rp1->hblk[start1].lbcnt)
      { for(a=0;a<rp1->hblk[start1].lbcnt;a++)
          if(rp1->hblk[start1].lbt[a].off) { fatal=1; yyerror("hlabels"); }
        if(!rp2->hblk->lbcnt)
        { rp2->hblk->lbt=rp1->hblk[start1].lbt;
          rp2->hblk->lbcnt=rp1->hblk[start1].lbcnt;
        }
        else
        { RAL(rp2->hblk->lbt,rp2->hblk->lbcnt+rp1->hblk->lbcnt,struct labels);
          overmemcpy((char *)(rp2->hblk->lbt+rp2->hblk->lbcnt)
            ,rp2->hblk->lbt,rp1->hblk[start1].lbcnt*sizeof(struct labels));
          memcpy(rp2->hblk->lbt,rp1->hblk[start1].lbt
            ,rp1->hblk[start1].lbcnt*sizeof(struct labels));
          rp2->hblk->lbcnt+=rp1->hblk[start1].lbcnt;
          free(rp1->hblk[start1].lbt);
        }
        rp1->hblk[start1].lbcnt=0;
      }
      /* insert (1 hblks before) to beginning of 2 hblcks */
      RAL(rp2->hblk,rp2->hblkcnt+start1,struct hiddenblock);
      overmemcpy((char *)(rp2->hblk+start1),rp2->hblk
        ,rp2->hblkcnt*sizeof(struct hiddenblock));
      memcpy(rp2->hblk,rp1->hblk,start1*sizeof(struct hiddenblock));
      rp2->hblkcnt+=start1;
    }
    else start1=0;
/*put 1hblocks before 2hblocks&&start0 inc && label move*/
  }
  /* 2 hblocks already here */
  if(start1>=rp1->hblkcnt)
  { /* join 2 main to 1 main &&xrefs*/
    /* 1 main */
    /*combine ncbs: everything split as follows:(ignore those flaged hidden)
     *  use highest ncb.  if its hidden, all should be.
     *  rp1's table of ncb just tacked on end of rp2's
     *  xrefs need to take into account above.
     * rp1 before
     * rp2
     * rp1 after
     */
    long *bpx,cut;
    int nbp;
    struct staticxref *stt;
    struct externxref *exr;
    if((rp1->ncbcnt&&!swtched)||(swtched&&rp2->ncbcnt))
      illegaltype("combine ncb swtched last");
    if(rp1->ncbcnt&&!rp1->ncb[rp1->ncbcnt-1].hidn)
    { cut=rp1->ncb[rp1->ncbcnt-1].off;
      nbp=rp1->ncb[rp1->ncbcnt-1].nbp;
    }
    else nbp=cut=0;
    if(cut)
     for(bpx=rp2->bpxref,a=0;a<rp2->bpxcnt;a++,bpx++)
     { *(wordptr)(rp2->bops+*bpx)+=nbp;
       *bpx+=cut;
     }
    RAL(rp2->bpxref,rp2->bpxcnt+rp1->bpxcnt,long);
/*exrefs of all types may get out of order */
    for(bpx=rp1->bpxref,a=0;a<rp1->bpxcnt;a++,bpx++)
    { if(*bpx>=cut) *(wordptr)(rp1->bops+*bpx)+=rp2->bpoff;
      rp2->bpxref[rp2->bpxcnt++]=(*bpx)+(*bpx>=cut?rp2->blen:0);
    }
    free(rp1->bpxref);
    if(cut) for(stt=rp2->normstat,a=0;a<rp2->nstatcnt;a++,stt++) stt->off+=cut;
    RAL(rp2->normstat,rp2->nstatcnt+rp1->nstatcnt,struct staticxref);
    for(stt=rp1->normstat,a=0;a<rp1->nstatcnt;a++,stt++)
    { if(stt->off>=cut) stt->off+=rp2->blen;
      rp2->normstat[rp2->nstatcnt++]=(*stt);
    }
    free(rp1->normstat);
    if(cut) for(stt=rp2->intstat,a=0;a<rp2->istatcnt;a++,stt++) stt->off+=cut;
    RAL(rp2->intstat,rp2->istatcnt+rp1->istatcnt,struct staticxref);
    for(stt=rp1->intstat,a=0;a<rp1->istatcnt;a++,stt++)
    { if(stt->off>=cut) stt->off+=rp2->blen;
      rp2->intstat[rp2->istatcnt++]=(*stt);
    }
    free(rp1->intstat);
    if(cut) for(exr=rp2->exref,a=0;a<rp2->exrcnt;a++,exr++) exr->off+=cut;
    RAL(rp2->exref,rp2->exrcnt+rp1->exrcnt,struct externxref);
    for(exr=rp1->exref,a=0;a<rp1->exrcnt;a++,exr++)
    { if(exr->off>=cut) exr->off+=rp2->blen;
      rp2->exref[rp2->exrcnt++]=(*exr);
    }
    free(rp1->exref);
    if(rp2->lbcnt)
    { RAL(rp2->lbt,rp2->lbcnt+rp1->lbcnt,struct labels);
      if(cut) for(a=0;a<rp2->lbcnt;a++) rp2->lbt[a].off+=cut;
      for(a=0;a<rp1->lbcnt;a++)
      { if(rp1->lbt[a].off>=cut) rp1->lbt[a].off+=rp2->blen;
        rp2->lbt[rp2->lbcnt++]=rp1->lbt[a];
      }
      if(rp1->lbcnt) free(rp1->lbt);
    }
    else
    { for(a=0;a<rp1->lbcnt;a++)
        if(rp1->lbt[a].off>=cut) rp1->lbt[a].off+=rp2->blen;
      rp2->lbt=rp1->lbt; rp2->lbcnt=rp1->lbcnt;
    }
    RAL(rp2->bops,rp2->blen+rp1->blen,char);
    if(cut) overmemcpy(rp2->bops+cut,rp2->bops,rp2->blen);
    memcpy(rp2->bops,rp1->bops,cut);
    memcpy(rp2->bops+rp2->blen+cut,rp1->bops+cut,rp1->blen-cut);
    rp2->blen+=rp1->blen;
    free(rp1->bops);
    if(rp1->ncbcnt)
    { RAL(rp1->ncb,rp1->ncbcnt+rp2->ncbcnt,struct nestcombined);
      for(a=0;a<rp2->ncbcnt;a++)
      { rp2->ncb[a].off+=cut;
        rp2->ncb[a].nbp+=nbp;
        if(rp2->ncb[a].hidn) illegaltype("not handle hidden here1");
        rp1->ncb[rp1->ncbcnt++]=rp2->ncb[a];
      }
      if(rp2->ncbcnt) free(rp2->ncb);
      rp2->ncbcnt=rp1->ncbcnt; rp2->ncb=rp1->ncb;
    } /*else nothing*/
  }
  else
  { /* join 2 main to 1 hblk[start1] &&xrefs*/
    /* remaining hblocks already there? */
    long *bpx,cut;
    int nbp;
    struct staticxref *stt;
    struct externxref *exr;
    struct hiddenblock *hbk;
    if((rp1->ncbcnt&&!swtched)||(swtched&&rp2->ncbcnt))
      illegaltype("combine ncb swtched last");
    if(rp1->ncbcnt&&rp1->hblkcnt-rp1->ncb[rp1->ncbcnt-1].hidn==start1)
    { cut=rp1->ncb[rp1->ncbcnt-1].off;
      nbp=rp1->ncb[rp1->ncbcnt-1].nbp;
    }
    else nbp=cut=0;
    hbk=rp1->hblk+start1;
    if(cut)
     for(bpx=rp2->bpxref,a=0;a<rp2->bpxcnt;a++,bpx++)
     { *(wordptr)(rp2->bops+*bpx)+=nbp;
       *bpx+=cut;
     }
    RAL(rp2->bpxref,rp2->bpxcnt+hbk->bpxcnt,long);
    for(bpx=hbk->bpxref,a=0;a<hbk->bpxcnt;a++,bpx++)
    { if(*bpx>=cut) *(wordptr)(hbk->bops+*bpx)+=rp2->bpoff;
      rp2->bpxref[rp2->bpxcnt++]=(*bpx)+(*bpx>=cut?rp2->blen:0);
    }
    free(hbk->bpxref);
    if(cut) for(stt=rp2->normstat,a=0;a<rp2->nstatcnt;a++,stt++) stt->off+=cut;
    RAL(rp2->normstat,rp2->nstatcnt+hbk->nstatcnt,struct staticxref);
    for(stt=hbk->normstat,a=0;a<hbk->nstatcnt;a++,stt++)
    { if(stt->off>=cut) stt->off+=rp2->blen;
      rp2->normstat[rp2->nstatcnt++]=(*stt);
    }
    free(hbk->normstat);
    if(cut) for(stt=rp2->intstat,a=0;a<rp2->istatcnt;a++,stt++) stt->off+=cut;
    RAL(rp2->intstat,rp2->istatcnt+hbk->istatcnt,struct staticxref);
    for(stt=hbk->intstat,a=0;a<hbk->istatcnt;a++,stt++)
    { if(stt->off>=cut) stt->off+=rp2->blen;
      rp2->intstat[rp2->istatcnt++]=(*stt);
    }
    free(hbk->intstat);
    if(cut) for(exr=rp2->exref,a=0;a<rp2->exrcnt;a++,exr++) exr->off+=cut;
    RAL(rp2->exref,rp2->exrcnt+hbk->exrcnt,struct externxref);
    for(exr=hbk->exref,a=0;a<hbk->exrcnt;a++,exr++)
    { if(exr->off>=cut) exr->off+=rp2->blen;
      rp2->exref[rp2->exrcnt++]=(*exr);
    }
    free(hbk->exref);
    if(rp2->lbcnt)
    { RAL(rp2->lbt,rp2->lbcnt+hbk->lbcnt,struct labels);
      for(a=0;a<hbk->lbcnt;a++)
      { if(hbk->lbt[a].off>=cut) hbk->lbt[a].off+=rp2->blen;
        rp2->lbt[rp2->lbcnt++]=hbk->lbt[a];
      }
      if(hbk->lbcnt) free(hbk->lbt);
    }
    else
    { for(a=0;a<hbk->lbcnt;a++)
        if(hbk->lbt[a].off>=cut) hbk->lbt[a].off+=rp2->blen;
      rp2->lbt=hbk->lbt; rp2->lbcnt=hbk->lbcnt;
    }
    RAL(rp2->bops,rp2->blen+hbk->blen,char);
    if(cut) overmemcpy(rp2->bops+cut,rp2->bops,rp2->blen);
    memcpy(rp2->bops,hbk->bops,cut);
    memcpy(rp2->bops+rp2->blen+cut,hbk->bops+cut,hbk->blen-cut);
    rp2->blen+=hbk->blen;
    free(hbk->bops);
    hbk->bpxref=rp2->bpxref;     hbk->bpxcnt=rp2->bpxcnt;
    hbk->normstat=rp2->normstat; hbk->nstatcnt=rp2->nstatcnt;
    hbk->intstat=rp2->intstat;   hbk->istatcnt=rp2->istatcnt;
    hbk->exref=rp2->exref;       hbk->exrcnt=rp2->exrcnt;
    hbk->lbt=rp2->lbt;           hbk->lbcnt=rp2->lbcnt;
    hbk->bops=rp2->bops;         hbk->blen=rp2->blen;
    rp1->hblkcnt-=start1;
    if(rp1->ncbcnt)
    { RAL(rp1->ncb,rp1->ncbcnt+rp2->ncbcnt,struct nestcombined);
      for(a=0;a<rp2->ncbcnt;a++)
      { rp2->ncb[a].off+=cut;
        rp2->ncb[a].nbp+=nbp;
        if(rp2->ncb[a].hidn) illegaltype("not handle hidden here7");
        rp2->ncb[a].hidn+=start1;
        rp1->ncb[rp1->ncbcnt++]=rp2->ncb[a];
      }
      if(rp2->ncbcnt) free(rp2->ncb);
      rp2->ncbcnt=rp1->ncbcnt; rp2->ncb=rp1->ncb;
    } /*else nothing*/
    if(rp2->hblkcnt)
    { RAL(rp2->hblk,rp2->hblkcnt+rp1->hblkcnt,struct hiddenblock); }
    else AL(rp2->hblk,rp1->hblkcnt,struct hiddenblock);
    memcpy(rp2->hblk+rp2->hblkcnt,hbk,rp1->hblkcnt*sizeof(struct hiddenblock));
    rp2->hblkcnt+=rp1->hblkcnt;
    free(rp1->hblk);
    rp2->bpxref=rp1->bpxref;     rp2->bpxcnt=rp1->bpxcnt;
    rp2->normstat=rp1->normstat; rp2->nstatcnt=rp1->nstatcnt;
    rp2->intstat=rp1->intstat;   rp2->istatcnt=rp1->istatcnt;
    rp2->exref=rp1->exref;       rp2->exrcnt=rp1->exrcnt;
    rp2->lbt=rp1->lbt;           rp2->lbcnt=rp1->lbcnt;
    rp2->bops=rp1->bops;         rp2->blen=rp1->blen;
  }
  rp2->bpoff+=rp1->bpoff;
  if(rp1->loccnt)
  { if(rp2->loccnt) { RAL(rp2->loc,rp2->loccnt+rp1->loccnt,struct locations); }
    else AL(rp2->loc,rp2->loccnt+rp1->loccnt,struct locations);
    memcpy(rp2->loc+rp2->loccnt,rp1->loc,rp1->loccnt*sizeof(struct locations));
    rp2->loccnt+=rp1->loccnt;
    free(rp1->loc);
  }
}
illegaltype(x) char *x;
{ fatal=1;
  yyerror("illegal type/operator combination");
  fprintf(stderr,"letter: %s\n",x);
}
/*table autoinit: size(long) { stkoff(long) len(char) stuff(spcfd by len) }*/
/*table extnmtp: count(long) { name '\0' tp(char poss. long) ispre(char)
 * [poss. (len comes from size len) prestf(spcfd by len) ] } */
autinitinc()
{ long c;
  c=getlong();
  oppos+=c;
  /*while(c--)
  { oppos+=solong;
    d=GETCHAR();
    oppos+=d;
  }*/
 return c;
}
typeposinc(flg)
{ int ch;
  ch=GETCHAR();
  if(flg) ftp=ch;
  switch(ch%SUNSIGNED)
  { case SCHAR:
    case SSHORT:
    case SINT:
    case SLONG:
    case SFUNC:
    break;
    case SFLOAT:
    case SDOUBLE:
     mathuse=1;
    break;
    case SPOINTER:
    case SSTRUCT:
     if(flg) fsz=(*(unsigned long *)(opcode+oppos));
     oppos+=solong;
    break;
    default: fprintf(stderr,"#1unknown type %d  oppos %d\n",ch,oppos);
  }
}
/*prntlab(s) char *s;
{ long t;
  int x;
  for(x=t=0;x<SAL;x++) t<<=8,t+=(unsigned char)(GETCHAR());
  printf("%s: %d   ",s,t);
}*/
long getlong()
{ long x;
  int l;
  char buf[32];
  for(l=0;l<solong;l++)
   buf[l]=GETCHAR();
  SRDLONG(buf,x);
  return x;
}
/*prntlong(s) char *s;
{ long x;
  int l;
  char buf[32];
  for(l=0;l<solong;l++)
   buf[l]=GETCHAR();
  SRDLONG(buf,x);
  printf("%s: %ld  ",s,x);
}
prntint(s) char *s;
{ int l,x;
  char buf[32];
  for(l=0;l<soint;l++)
   buf[l]=GETCHAR();
  SRDINT(buf,x);
  printf("%s: %d  ",s,x);
}
prntchar(s) char *s;
{ printf("%s: '%c'   ",s,GETCHAR());
}
prntcharv(s) char *s;
{ printf("%s: %d   ",s,GETCHAR());
}
prnttype(s) char *s;
{ int ch;
  ch=GETCHAR();
  printf("%s: %s ",s,ch>SUNSIGNED?"unsigned":"");
  switch(ch%SUNSIGNED)
  { case SCHAR: printf("SCHAR   "); break;
    case SSHORT: printf("SSHORT   "); break;
    case SINT: printf("SINT   "); break;
    case SLONG: printf("SLONG   "); break;
    case SFLOAT: printf("SFLOAT   "); break;
    case SDOUBLE: printf("SDOUBLE   "); break;
    case SFUNC: printf("SFUNC   "); break;
    case SPOINTER: printf("SPOINTER: "); prntlong("size"); break;
    case SSTRUCT: printf("SSTRUCT: "); prntlong("size"); break;
    default: fprintf(stderr,"#2unknown type %d  ",ch);
  }
}
prntstring(s) char *s;
{ printf("%s: ",s); prntlong("offset"); prntlong("length"); }
prntdouble(s) char *s;
{ int l;
  double x;
  char buf[32];
  for(l=0;l<sodouble;l++)
   buf[l]=GETCHAR();
  SRDINT(buf,x);
  printf("%s: %lf  ",s,x);
}*/
yyerror(s) char *s; /* replace standard error routine with my own */
{ fprintf(stderr,"psas: %s: scan %d line %d file %d\n",s,scan,inline,inpfile);
}
