/* general header file for C compiler */
#ifndef NULL
# define NULL 0
#endif
#define E_MEM (-2) /* error codes */
#define E_FILE (-3) /* error codes */
typedef unsigned char uchar;
typedef int flong;
 /* flong is possible future long, but since sizeof(int)==sizeof(long)...*/
struct predefgen /*MERE: move this to general file and DEFINE its elements */
{ char *p;
  flong len,pcnt;
  struct predefptr { char sect; flong boff,poff,soff; } *ptr;
} curprd;
#define SCARG       0    /* offset is relative first arg on stack */
#define SCPUBLIC    2    /* offset is offset of table being built */
#define SCAUTO      3    /* offset is relative 1st byte automatic stack */
#define SCINTPUBLIC 4    /* used by psas.c for internal static vars */
#define SCREGISTER  0x10 /* offset is 1 of above for use if reg cant be used*/

#define SCPDEFAULT 0 /* scopes */
#define SCPSTATIC 1
#define SCPEXTERN 2

struct exttbl
{ char *nm,tp,*pre,prepres,scope; /* scope is PUBLIC or STATIC */
  flong presz,size;
} *exttbl;
flong exttblsz,extxcnt;
struct prexref
{ char sect;
  flong eoff,soff,poff;
} *extxref;
/* eoff- if pointer is external; this gives offset in table
 * sect,soff- gives sect/offset of thing pointer points to
 * poff- gives offset from beginning of variable of the pointer's own location
 */
flong a,b; /* temporary variables */
int sochar,soshort,soint,solong,sopoint,sofloat,sodouble,fatal;
FILE *infile,*outfile;
char *malloc(),*realloc(),temp[512];
char RALmsg[],ALmsg[];
#define AL(place,size,type) { (place)=(type *)malloc((unsigned)(sizeof(type)\
  *(size))+1);\
 if ((char *)(place)==NULL)\
  yyerror(ALmsg),exit(E_MEM); }
#define RAL(place,size,type) { (place)=(type *)realloc((char *)(place)\
  ,(unsigned)(sizeof(type)*(size))+1);\
 if ((char *)(place)==NULL)\
  yyerror(RALmsg),exit(E_MEM); }
/*#define free(x) testfree(x)
*/
