/* preprecessor for C compiler */
#include <ctype.h>
#include <stdio.h>
#define MAXFNM    32 /* max nested include files */
#define MAXNESTIF 32
#define MAXDARGS  32
#define BUFSZ     32
#define STRINGSZ 256
char *malloc(),*realloc();
#define AL(place,size,type) { (place)=(type *)malloc((unsigned)(sizeof(type)\
  *(size))+1);\
 if ((char *)(place)==NULL)\
  fatalerror("AL() can't get enough memory"),exit(-1); }
#define RAL(place,size,type) { (place)=(type *)realloc((char *)(place)\
  ,(unsigned)(sizeof(type)*(size))+1);\
 if ((char *)(place)==NULL)\
  fatalerror("RAL() can't get enough memory"),exit(-1); }
#define NTEND  1 /* nested if types; end with endif only */
#define NTELSE 2 /* end with else,elif or endif */
#define NTDONE 3 /* only used when self-calling ; skip ifs to the endif */
struct files
{ FILE *inp;
  char *file;
  int npnl,line;
} file[MAXFNM];
struct definitions
{ char *nm,parexist,argcnt;
  int fillcnt;
  struct fillstuff
  { char *stf,argnum;
  } *fill;
} *defs,*autodefs;
int defcnt,adefcnt,undefcnt;
struct undefs
{ char *nm,used;
} *undefs,*unptr;
char *buf,*buf2;
int blen2,blen,donl,fc,bufnpnl,identit;
FILE *outf;
int fatal=0;

int assemblycomments;

main(argc,argv) char *argv[];
{ int c,c2,derlen,len,dernamelen,deral,a,b,d,nestifcnt;
  char *derstf,*prefix,*test;
  char nestif[MAXNESTIF];
  char *defargs[MAXDARGS],temp[STRINGSZ];
  int defargcnt,localnpnl,startfillspot,endch;
  char *defprefix;

#ifdef ISUNIX
  defprefix="/uer/matthew/doscc/";
#else
  defprefix="A:\\";
#endif

  AL(derstf,1,char);
  deral=0;
  AL(defs,1,struct definitions);
  AL(autodefs,1,struct definitions);
  AL(undefs,1,struct undefs);
  AL(file->file,1,char);
  AL(buf,1,char);
  AL(buf2,1,char);
  for(a=1;a<argc;a++)
  { if(*argv[a]=='-'&&argv[a][2])
    { switch(argv[a][1])
      { case 'I':
         defprefix=argv[a]+2;
        continue;
        case 'D':
         RAL(autodefs,adefcnt+1,struct definitions);
         autodefs[adefcnt].nm=argv[a]+2;
         autodefs[adefcnt].fillcnt=1;
         autodefs[adefcnt].argcnt=0;
         autodefs[adefcnt].parexist=0;
         for(b=2;argv[a][b]&&argv[a][b]!='=';b++) ;
         AL(autodefs[adefcnt].fill,1,struct fillstuff);
         autodefs[adefcnt].fill->argnum= -1;
         autodefs[adefcnt].fill->stf=argv[a]+b+(argv[a][b]!='\0');
         argv[a][b]='\0'; adefcnt++;
        continue;
        case 'U':
         RAL(undefs,undefcnt+1,struct undefs);
         undefs[undefcnt++].nm=argv[a]+2;
        continue;
        case 'a':
         if(!strcmp(argv[a],"-asm"))
         { assemblycomments=1;
          continue;
         }
        break;
        case 'n':
         if(!strcmp(argv[a],"-noasm"))
         { assemblycomments=0;
          continue;
         }
        break;
      }
    }
    defcnt=nestifcnt=blen=blen2=donl=fc=bufnpnl=identit=0;

    RAL(defs,adefcnt,struct definitions);
    for(;defcnt<adefcnt;defcnt++,defs++,autodefs++)
    { struct fillstuff *fill,*srcfill;
      *defs= *autodefs;
      Scp(&defs->nm,autodefs->nm);
      AL(defs->fill,autodefs->fillcnt+1,struct fillstuff);

      for(srcfill=autodefs->fill,fill=defs->fill,defs->fillcnt=0
            ;defs->fillcnt<autodefs->fillcnt
            ;defs->fillcnt++,srcfill++,fill++)
      { fill->argnum=srcfill->argnum;
        Scp(&fill->stf,srcfill->stf);
      }
    }
    defs-=defcnt; autodefs-=defcnt;
    for(b=0;b<undefcnt;b++) undefs[b].used=0;

    RAL(buf,1,char);
    RAL(buf2,1,char);
    file->inp=fopen(argv[a],"r");
    file->line=file->npnl=0;
    if(!file->inp)
    { fatalerror("can't open input file");
     continue;
    }
    len=strlen(argv[a]);
    RAL(file->file,len+1,char);
    memcpy(file->file,argv[a],len+1);
    argv[a][len-1]='i';
    outf=fopen(argv[a],"w");
    if(!file->inp)
    { fatalerror("can't open output file");
     exit(-1);
    }
    fprintf(outf,"/*%dL%s%d*/",strlen(file->file),file->file,file->line);
   goto startatnewline;
   stop_err_mesg_that_loop_not_entered_at_the_top:
    while(1)
    { c=commentpass();
     again:
      if(c==EOF)
      { if(nestifcnt) warning("missing endif(s)");
       goto newfile;
      }
      if(c=='\n')
      { putc(c,outf);
       startatnewline:
        c2=commentpass();
        if(c2=='#')
        {/* remove white space get line */
          do c2=commentpass(); while(c2==' '||c2=='\t');
          if(!isalpha(c2)) goto dererror;
          dernamelen=derlen=0;
          while(c2!='\n'&&c2!=EOF)
          { if(derlen>=deral)
            { deral=derlen+BUFSZ;
              RAL(derstf,deral+1,char); /* give room for \0 always */
            }
            if(!isalpha(c2)&&!dernamelen) dernamelen=derlen;
            derstf[derlen++]=c2;
            c2=commentpass();
          }
          if(!dernamelen) /* single word, got out of loop before rec.*/
            dernamelen=derlen;
          derstf[derlen]='\0'; /* deral+1 above insures enough room. */
          switch(dernamelen)
          { case 2: /* if */
             if(!strncmp(derstf,"if",2))
             { warning("treating if as an ifdef");
              goto handleasifdef;
             }
             else goto dererror;
            break;
            case 4: /* elif else line */
             if(!strncmp(derstf,"elif",4)||!strncmp(derstf,"else",4))
             { if(nestifcnt<=0||nestif[nestifcnt-1]!=NTELSE)
                 fatalerror("else-ing non-existent if");
               else nestifcnt--;
               skipifstuff(derstf[2]=='i'?NTELSE:NTEND,c2=='\n');
             }
             else if(!strncmp(derstf,"line",4))
             { int good,filehere;
               good=filehere=0;
               sscanf(derstf+4,"%d %n\"%[^\"\n]\"%n",&file[fc].line,&good,temp
                  ,&filehere);
               if(!good) warning("illegal (#line) ppc command arguments");
               if(filehere) Scp(&file[fc].file,temp);
               fprintf(outf,"/*%dL%s%d*/",strlen(file[fc].file),file[fc].file
                  ,file[fc].line);
             }
             else goto dererror;
            break;
            case 5: /* ifdef undef endif ident */
             if(!strncmp(derstf,"ifdef",5))
             {handleasifdef:
               getpiece(derstf,&dernamelen,&len,' ','\t',' ');
               if(scan(derstf+dernamelen,len)>=0)
               { if(nestifcnt<MAXNESTIF) nestif[nestifcnt++]=NTELSE;
                 else fatalerror("exceeded maximum number of nested ifs");
               }
               else
               { if(skipifstuff(NTELSE,c2=='\n'))
                 { if(nestifcnt<MAXNESTIF) nestif[nestifcnt++]=NTEND;
                   else fatalerror("exceeded maximum number of nested ifs");
                 }
               }
             }
             else if(!strncmp(derstf,"undef",5))
             { getpiece(derstf,&dernamelen,&len,' ','\t',' ');
               b=scan(derstf+dernamelen,len);
               if(b>=0)
               { free(defs[b].nm);
                 for(d=0;d<defs[b].fillcnt;d++) free(defs[b].fill[d].stf);
                 free(defs[b].fill);
                 memmove(defs+b,defs+b+1
                   ,(defcnt-b-1)*sizeof(struct definitions));
               }
               else warning("undef nondefined id");
             }
             else if(!strncmp(derstf,"endif",5))
             { if(nestifcnt<=0) fatalerror("ending non-existent if");
               else nestifcnt--;
             }
             else if(!strncmp(derstf,"ident",5))
             { warning("ident derective not implemented");
             }
             else goto dererror;
            break;
            case 6: /* define ifndef */
             if(!strncmp(derstf,"define",6))
             { getpiece(derstf,&dernamelen,&len,' ','\t','(');
               for(d=0;d<undefcnt;d++)
                 if(!undefs[d].used
                    &&!strncmp(derstf+dernamelen,undefs[d].nm,len)
                    &&strlen(undefs[d].nm)==len)
                 { undefs[d].used=1;
                  goto skipdefine;
                 }
               b=scan(derstf+dernamelen,len);
               if(b>=0)
               { warning("multiple definitions of an identifier");
fprintf(stderr,"nm %s\n",defs[b].nm);
                 for(d=0;d<defs[b].fillcnt;d++) free(defs[b].fill[d].stf);
                 free(defs[b].fill);
               }
               else
               { b= -1-b;
                 RAL(defs,defcnt+1,struct definitions);
                 memmove(defs+b+1,defs+b
                   ,(defcnt-b)*sizeof(struct definitions));
                 AL(defs[b].nm,len+1,char);
                 memcpy(defs[b].nm,derstf+dernamelen,len);
                 defs[b].nm[len]='\0'; defcnt++;
               }
               switch(derstf[dernamelen+len])
               { case ' ':
                 case '\t':
                  /* direct simple copy. */
                  AL(defs[b].fill,1,struct fillstuff);
                  Scp(&(defs[b].fill->stf),derstf+dernamelen+len);
                  defs[b].fill->argnum= -1;
                  defs[b].parexist=defs[b].argcnt=0;
                  defs[b].fillcnt=1;
                 break;
                 case '\0': /* ended with \n */
                  /* blank. defn */
                  defs[b].fillcnt=defs[b].parexist=defs[b].argcnt=0;
                  AL(defs[b].fill,1,struct fillstuff);
                  AL(defs[b].fill->stf,1,char);
                  *defs[b].fill->stf='\0';
                 break;
                 case '(':
                  dernamelen+=len+1;
                  d=derstf[dernamelen];
                  defargcnt=0;
                  if(d==')') dernamelen++;
                  else while(d!=')')
                  { getpiece(derstf,&dernamelen,&len,',',')',',');
                    if(derstf[dernamelen+len]!=','
                      &&derstf[dernamelen+len]!=')')
                     fatalerror("unknown ending");
                    d=derstf[dernamelen+len];
                    derstf[dernamelen+len]='\0';
                    Scp(defargs+defargcnt,derstf+dernamelen);
                    if(defargcnt<MAXDARGS-1) defargcnt++;
                    else fatalerror("too many macro arguments");
                    dernamelen+=len+1;
                  }
                  AL(defs[b].fill,1,struct fillstuff);
                  defs[b].argcnt=defargcnt;
                  defs[b].parexist=1; defs[b].fillcnt=0;
                  startfillspot=dernamelen;
                  do
                  { switch(derstf[dernamelen])
                    { case '\"':
                       do if(derstf[++dernamelen]=='\\') dernamelen++;
                       while(derstf[dernamelen]!='\"'&&derstf[dernamelen]);
                      break;
                      case '\'':
                       if(derstf[++dernamelen]=='\\') dernamelen++;
                       while(derstf[++dernamelen]!='\''&&derstf[dernamelen]);
                      break;
                      default:
                       if(isalnum(derstf[dernamelen]))
                       { for(len=0;isalnum(derstf[dernamelen+len])
                           ||derstf[dernamelen+len]=='_';len++);
                         for(d=0;d<defargcnt;d++)
                          if((!defargs[d][len])
                             &&!strncmp(defargs[d],derstf+dernamelen,len))
                          { RAL(defs[b].fill,defs[b].fillcnt+1
                              ,struct fillstuff);
                            AL(defs[b].fill[defs[b].fillcnt].stf
                              ,dernamelen+1-startfillspot,char);
                            memcpy(defs[b].fill[defs[b].fillcnt].stf
                              ,derstf+startfillspot,dernamelen-startfillspot);
                            defs[b].fill[defs[b].fillcnt].stf
                              [dernamelen-startfillspot]='\0';
                            defs[b].fill[defs[b].fillcnt++].argnum=d;
                            startfillspot=dernamelen+len;
                           break;
                          }
                         dernamelen+=len;
                        continue;
                       }
                    }
                    if(derstf[dernamelen]) dernamelen++;
                  } while(derstf[dernamelen]);
                  if(dernamelen!=startfillspot)
                  { RAL(defs[b].fill,defs[b].fillcnt+1,struct fillstuff);
                    AL(defs[b].fill[defs[b].fillcnt].stf
                      ,dernamelen+1-startfillspot,char);
                    memcpy(defs[b].fill[defs[b].fillcnt].stf
                      ,derstf+startfillspot,dernamelen-startfillspot);
                    defs[b].fill[defs[b].fillcnt].stf[dernamelen-startfillspot]
                      ='\0';
                    defs[b].fill[defs[b].fillcnt++].argnum= -1;
                    startfillspot=dernamelen+len;
                  }
                 break;
                 default: fatalerror("internal inconsistency");
fprintf(stderr,"derective [%s] name %d dlen %d len %d\n"
,derstf,dernamelen,derlen,len);
               }
              skipdefine: ;
             }
             else if(!strncmp(derstf,"ifndef",6))
             { getpiece(derstf,&dernamelen,&len,' ','\t',' ');
               if(scan(derstf+dernamelen,len)<0)
               { if(nestifcnt<MAXNESTIF) nestif[nestifcnt++]=NTELSE;
                 else fatalerror("exceeded maximum number of nested ifs");
               }
               else
               { if(skipifstuff(NTELSE,c2=='\n'))
                 { if(nestifcnt<MAXNESTIF) nestif[nestifcnt++]=NTEND;
                   else fatalerror("exceeded maximum number of nested ifs");
                 }
               }
             }
             else goto dererror;
            break;
            case 7: /* include */
             if(!strncmp(derstf,"include",7))
             { fc++;
               getpiece(derstf,&dernamelen,&len,' ','\t',' '); /*file*/
               if(dernamelen>=derlen||fc>=MAXFNM)
               { fatalerror("nothing to include or too many nested");
                 fc--;
               }
               else
               { switch(derstf[dernamelen])
                 { case '<':
                    if(derstf[dernamelen+len-1]!='>')
                      fatalerror("include <name(non >)");
                    prefix=defprefix; /* sometime change this */
                   break;
                   case '\"':
                    if(derstf[dernamelen+len-1]!='\"')
                      fatalerror("include <name(non \")");
                    prefix="";
                   break;
                   default: fatalerror("illegal specification file[fc].file");
                 }
                 dernamelen++; len-=2; /* correct for quoting junk */
                 b=strlen(prefix);
                 AL(file[fc].file,b+len,char);
                 memcpy(file[fc].file,prefix,b);
                 memcpy(file[fc].file+b,derstf+dernamelen,len);
                 file[fc].file[b+len]='\0';
                 file[fc].npnl=0; file[fc].line=0;
                 file[fc].inp=fopen(file[fc].file,"r");
                 if(!file[fc].inp)
                 { fatalerror("can't open include file");
                   free(file[fc].file);
                   fc--;
                 }
                 else
                  fprintf(outf,"/*%dL%s%d*/",b+len,file[fc].file
                     ,file[fc].line);
               }
             }
             else goto dererror;
            break;
            default:
            dererror:
              fatalerror("unknown derective for preprocessor");
fprintf(stderr,"derective [%s] name %d len %d\n",derstf,dernamelen,derlen);
          }
        }
        c=c2;
       goto again;
      }
      else if(isalnum(c)||c=='_') /*getid*/
      { /* get word/ compare with predefs print word or unget defined */
        localnpnl=dernamelen=derlen=0;
        do
        { if(derlen>=deral)
          { deral=derlen+BUFSZ;
            RAL(derstf,deral+1,char); /* give room for \0 always */
          }
          derstf[derlen++]=c;
          c=commentpass();
        } while(isalnum(c)||c=='_');
        derstf[derlen]='\0'; /* deral+1 above insures enough room. */
        b=scan(derstf,derlen);
        if(b<0)
        { fprintf(outf,"%s",derstf);
         goto again;
        }
        else
        { if(defs[b].parexist)
          { /*HEREfuture:complex: seperate args*/
            len=defargcnt=0;
            d=1; /* here, d is counting nested () */
            while(c!='(') c=commentpass();
            AL(defargs[defargcnt],1,char);
            c=commentpass();
            while((c!=')'||d>1)&&c!=EOF)
            { if(!(len%BUFSZ))
              { RAL(defargs[defargcnt],len+BUFSZ,char);
              }
              defargs[defargcnt][len++]=c;
              switch(c)
              { case ')':
                 if(--d<0) fatalerror("internal error ()'s");
                break;
                case ',':
                 if(d==1)
                 { defargs[defargcnt][--len]='\0';
                   if(defargcnt<MAXDARGS-1) defargcnt++;
                   else fatalerror("too many macro arguments");
                   len=0;
                   AL(defargs[defargcnt],1,char);
                 }
                break;
                case '\n':
                 defargs[defargcnt][len-1]=' ';
                 localnpnl++;
                break;
                case '(':   d++; break;
                case '\'':
                 endch='\'';
                goto fillargquote;
                case '\"':
                 endch='\"';
                fillargquote:
                 c=commentpass();
                 while(c!=endch&&c!=EOF)
                 { if(c=='\\')
                   { if(!(len%BUFSZ))
                     { RAL(defargs[defargcnt],len+BUFSZ,char);
                     }
                     defargs[defargcnt][len++]=c;
                     c=commentpass();
                   }
                   if(!(len%BUFSZ))
                   { RAL(defargs[defargcnt],len+BUFSZ,char);
                   }
                   defargs[defargcnt][len++]=c;
                   c=commentpass();
                 }
                 if(!(len%BUFSZ))
                 { RAL(defargs[defargcnt],len+BUFSZ,char);
                 }
                 defargs[defargcnt][len++]=c;
              }
              c=commentpass();
            }
            if(len) /* get last one, unlike earlier, don't unget a , */
            { if(!(len%BUFSZ))
              { RAL(defargs[defargcnt],len+BUFSZ,char);
              }
              defargs[defargcnt][len]='\0';
              if(defargcnt<MAXDARGS-1) defargcnt++; /*count last one*/
              else fatalerror("too many macro arguments");
            }
            if(c==EOF) fatalerror("unexpected end of input"),exit(-1);
            if(defargcnt!=defs[b].argcnt)
               fatalerror("argument count mismatch");
          }
          else
          { if(defs[b].fillcnt>1||(defs[b].fillcnt&&defs[b].fill->argnum!=-1))
              fatalerror("weird fillcnt");
            ungetchr2(c);
          }
          while(localnpnl--) ungetchr2('\n');
          for(d=defs[b].fillcnt-1;d>=0;d--)
          { if(defs[b].fill[d].argnum>=0)
            { if(defs[b].fill[d].argnum<defargcnt)
                ungetstr2(defargs[defs[b].fill[d].argnum]);
              else warning("ignoring fill request for argnum>defargcnt");
            }
            ungetstr2(defs[b].fill[d].stf);
          }
        }
      }
      else if(c=='\"'||c=='\'')
      { c2=c;
        putc(c,outf);
        do
        {stringloopagain:
          c=commentpass();
          if(c==EOF)
          { fatalerror("end of file in middle of string");
           exit(-1);
          }
          else if(c=='\\')
          { putc(c,outf);
            c=commentpass();
            if(c==EOF)
            { fatalerror("quoted end of file in middle of string");
             exit(-1);
            }
            putc(c,outf);
           goto stringloopagain;
          }
          else if(c=='\n') warning("raw new line in middle of string");
          putc(c,outf);
        } while(c!=c2);
      }
      else putc(c,outf);
    }
   newfile:;
  }
 exit(fatal);
}

getpiece(str,off,len,ec1,ec2,ec3) char *str; int *off,*len;
{ while(str[*off]==ec1||str[*off]==ec2||str[*off]==ec3) (*off)++;
  *len=0;
  while(str[*off+*len]!=ec1&&str[*off+*len]!=ec2&&str[*off+*len]!=ec3
    &&str[*off+*len]!='\0')
   (*len)++;
}

skipifstuff(tp,isnew)
/* skip char(except newlines) until a matching else, elif,endif is found*/
/* elif is handled here: either ignore it and keep scanning, or return */
{ int npnl=0,a,c,c2,tlen,out;
  char temp[STRINGSZ];
  if(isnew) goto newline;
  while(1)
  { c=commentpass();
   doc2:
    if(c==EOF)
    { fatalerror("unexpected end of file");
     return 0;
    }
    else if(c=='\n')
    { npnl++;
     newline:
      c2=commentpass();
      if(c2=='#')
      { do c2=commentpass(); while(c2==' '||c2=='\t');
        tlen=0;
        while(isalpha(c2)&&tlen<10)
        { temp[tlen++]=c2;
          c2=commentpass();
        }
        temp[tlen]='\0';
        switch(tlen)
        { case 2: /* if */
           if(!strcmp(temp,"if")) skipifstuff(NTDONE,0);
          break;
          case 4: /* else elif */
           if(!strcmp(temp,"else"))
           { while(c2!='\n'&&c2!=EOF)
             { c2=commentpass();
               if(c2=='\n') npnl++;
               if(isalnum(c2)) warning("junk after else");
             }
             switch(tp)
             { case NTEND:
                fatalerror("expecting endif, got else");
               case NTELSE:
                out=1;
               goto exitthis;
               case NTDONE:
               break;
               default: fatalerror("internal error unknown nest if type");
             }
           }
           else if(!strcmp(temp,"elif"))
           { /*HEREfuture: cc continue or return as above*/
             switch(tp)
             { case NTEND:
                fatalerror("expecting endif, got else");
                out=0;
               goto exitthis;
               case NTELSE:/*HEREfuture*/
               case NTDONE:
               break;
               default: fatalerror("internal error unknown nest if type2");
             }
           }
          break;
          case 5: /* endif ifdef */
           if(!strcmp(temp,"endif"))
           { out=0;
            exitthis:
             while(c2!='\n'&&c2!=EOF)
             { c2=commentpass();
               if(c2=='\n') npnl++;
               if(isalnum(c2)) warning("junk after endif");
             }
             while(npnl--) putc('\n',outf);
            return out;
           }
           else if(!strcmp(temp,"ifdef")) skipifstuff(NTDONE,0);
          break;
          case 6: /* ifndef */
           if(!strcmp(temp,"ifndef")) skipifstuff(NTDONE,0);
          break;
        }
      }
      c=c2;
     goto doc2;
    }
  }
}

scan(s,l) char *s; int l;
/* binary search defs for string s
 * if not present then return -1-(pos where should be placed) */
{ int c,v;
  int mid,low,high;
  c=s[l];
  s[l]='\0';
  low=0; high=defcnt-1;
  while(1)
  { if(low>high) break;
    mid=(low+high)/2;
    v=strcmp(defs[mid].nm,s);
    if(v<0) low=mid+1;
    else if(v>0) high=mid-1;
    else /*v==0*/
    { s[l]=c;
     return mid;
    }
  } /* not in table, insert it at low */
  s[l]=c;
 return -1-low;
}

ungetchr2(ch)
{ if(!(blen2%BUFSZ)) RAL(buf2,blen2+BUFSZ,char);
  buf2[blen2++]=ch;
}

ungetstr2(s) char *s;
{ int len,a;
  len=strlen(s);
  a=BUFSZ-blen2%BUFSZ;
  if(a==BUFSZ||len>=a) RAL(buf2,blen2+len+BUFSZ,char);
  for(a=len-1;a>=0;a--) buf2[blen2++]=s[a];
}

commentpass()
/* erases comments; concatenates lines, recognises strings */
{ int c,c2;
  static int quote=0,qchar,string=0,strch;
  if(blen2)
  { c=buf2[--blen2];
    if(!(blen2%BUFSZ)) RAL(buf2,blen2+BUFSZ,char);
   return c;
  }
  if(quote)
  { c=qchar;
    quote=0;
  }
  else if(string)
  { c=getchr();
   stringagain:
    if(c==strch) string=0;
    else if(c=='\\')
    { c2=getchr();
      if(c2=='\n')
      { donl=0;
        ungetnl(1);
        c=getchr();
       goto stringagain;
      }
      else
      { qchar=c2;
        quote=1;
      }
    }
  }
  else
  { c=getchr();
    switch(c)
    { case '/':
       if(identit)
       { identit=0;
        break;
       }
       c2=getchr();
       if(c2=='*')
       { int lastc,npnl=0;
         do
         { lastc=c;
           c=getchr();
           if(c=='\n') npnl++;
           if(c==EOF)
           { fprintf(stderr,"EOF in a comment (illegal)\n");
            exit(-1);
           }
         } while(c!='/'||lastc!='*');
         if(npnl) { npnl--; c='\n'; donl=1; }
         else c=' ';
         ungetnl(npnl);
       }
       else ungetchr(c2);
      break;
      case '\\':
       c2=getchr();
       if(c2=='\n')
       { donl=0;
         ungetnl(1);
         c=getchr();
       }
       else
       { quote=1;
         qchar=c2;
       }
      break;
      case ';':
       if(assemblycomments)
       { do c=getchr(); while(c!='\n'&&c!=EOF);
       }
      break;
      case '"':
      case '\'':
       string=1;
       strch=c;
    }
  }
 return c;
}

getchr() /* get character from any one of several sources */
/* donl- indicates to return any npnl's */
{ int c;
  char temp[STRINGSZ];
  if(donl)
  { if(bufnpnl)
    { bufnpnl--;
      file[fc].line++;
warning("printing lines in buffer");
     return '\n';
    }
    else if(file[fc].npnl)
    { file[fc].npnl--;
/*      file[fc].line++;
*/
     return '\n';
    }
    else donl=0;
  }
  if(blen)
  { c=buf[--blen];
    if(!(blen%BUFSZ)) RAL(buf,blen+BUFSZ,char);
  }
  else
  { while(c=getc(file[fc].inp),c==0x1a); /*for MS-DOS embedded EOF character*/
    if(c==EOF&&fc)
    { file[fc-1].npnl+=file[fc].npnl;
      free(file[fc].file);
      fclose(file[fc--].inp);
      c=strlen(file[fc].file);
      sprintf(temp,"*%dL%s%d*/\n",c,file[fc].file,file[fc].line);
      ungetstr2(temp);
      identit=1;
      c='/';
    }
  }
  if(c=='\n')
  { donl=1;
    file[fc].line++;
  }
 return c;
}

ungetnl(n)
{ if(blen) bufnpnl+=n;
  else file[fc].npnl+=n;
}

ungetchr(ch)
{ if(!(blen%BUFSZ)) RAL(buf,blen+BUFSZ,char);
  buf[blen++]=ch;
}

ungetstr(s) char *s;
{ int len,a;
  len=strlen(s);
  a=BUFSZ-blen%BUFSZ;
  if(a==BUFSZ||len>=a) RAL(buf,blen+len+BUFSZ,char);
  for(a=len-1;a>=0;a--) buf[blen++]=s[a];
}

warning(s) char *s;
{ fprintf(stderr,"warning: %s: file \"%s\" line %d\n",s,file[fc].file
   ,file[fc].line+1);
}

fatalerror(s) char *s;
{ fatal=1;
  fprintf(stderr,"fatal error: %s: file \"%s\" line %d\n",s,file[fc].file
   ,file[fc].line+1);
}
