/* some string IO stuff (including printf's core) */
#include <ctype.h>
#define EOF -1
putstr(s) char *s;
{ int a=0;
  while(s[a]) putchar(s[a++]);
}
getstr(s) char *s;
{ int a=0,c;
  while(c=getchar(),c!='\n'&&c!='\r')
  { if (c=='\b')
    { putstr(" \b");
      if(a>0) a--;
    }
    else s[a++]=c;
  }
  s[a]='\0';
}
#define BCDLEN 17
static padd0(strfunc,size) int (*strfunc)();
{ int err=0;
  for(;size>0;size-=10) err|=(*strfunc)("0000000000",(size>10?10:size));
 return err;
}
static paddspace(strfunc,size) int (*strfunc)();
{ int err=0;
  for(;size>0;size-=20)
    err|=(*strfunc)("                    ",(size>20?20:size));
 return err;
}
static inttobasestr(s,n,precision,shift,mask,tensvalue)
 char *s;
 unsigned n;
{ int e=0,f,maxdigits;
  char t[64];
  for(;n;n>>=shift)
  { f=(n&mask);
    t[e++]=(f<10?f+'0':f+tensvalue);
  }
  maxdigits=e;
  if(e<precision) e=precision;
  s[e]='\0'; f=0;
  while(f<maxdigits) s[--e]=t[f++];
  while(e) s[--e]='0';
}
_dcc_printf(charfunc,stringfunc,argsptr,stopchar,stopchar2)
   char *argsptr; int (*charfunc)(),(*stringfunc)(),stopchar,stopchar2;
/* this function assumes that int,long, and unsigned counterparts are
 *   all same size, and that when a short is pushed onto stack, it becomes int.
 *   also, assumes that stack image is push last first when calling
 *   so *argstr=fist argument; argstr[+something]=later arguments.
 * (*charfunc)(x) - output char x to appropriate place
 * (*stringfunc)(str,len) - output string str of length len
 * stopchar - stringfunc can't print this char correctly
 *   (used as $,\n in int 21 function ah=9)
 *    assume %s and %c and control string only places char might occur
 * argstr - pointst to stack image
 */
{ char *out,*original,*control,*lstcontrol,temp[1500]; /* printfdefs */
    /* temp big enough for '%lf' */
  int padwith0,width,usespace,usesign,alternateform,dash,err=0,len;
  int totalchar=0,val,islong,isshort,point,precision,a,exponent,Eore;
  int negative,removezeros;
  double dbl;
  original=control=lstcontrol= *(char **)argsptr; argsptr+=sizeof(char *);
  for(;*control;)
  { if(*control=='%')
    { err|=(*stringfunc)(lstcontrol,control-lstcontrol);
      totalchar+=control-lstcontrol;
      width= -1; padwith0=usespace=usesign=alternateform=dash=0;
     gotnonpointsoswitchagain: /* all calls chould let following inc control*/
      control++;
      switch(*control)
       /* all of this is before . in %[-](*|[0-9]*)(.(*|[0-9]*))?X*/
      { case '-':
#ifndef OPTIMIZED
         if(dash) puts("multiple '-' in printf format string/ using one only");
#endif
         dash^=1;
        goto gotnonpointsoswitchagain;
        case '*':
         width= *(int *)(argsptr); argsptr+=sizeof(int);
         if(width<0)
         { dash^=1;
           width= -width;
         }
         control++;
        case '.':
        break;
        case ' ':
         usespace=1;
        goto gotnonpointsoswitchagain;
        case '+':
         usesign=1;
        goto gotnonpointsoswitchagain;
        case '#':
         alternateform=1;
        goto gotnonpointsoswitchagain;
        case '0':
         padwith0=1;
        goto gotnonpointsoswitchagain;
        default:
         if(!isdigit(*control)) break; /* let 2nd switch check it */
         width=atoi(control);
         while(isdigit(*control)) control++;
      }
      point=isshort=islong=0; precision= -1;
     donepartbutswitch2:
      switch(*control) /* this handles stuff after . in format specifier */
      { case '.':
#ifndef OPTIMIZED
         if(point) puts("multiple . in printf format string");
#endif
         point=1;
         switch(*++control)
         { case '*':
            precision= *(int *)(argsptr); argsptr+=sizeof(int);
            if(precision<0) precision=0;
            control++;
           break;
           default:
            if(!isdigit(*control)) break;
            precision=atoi(control);
            while(isdigit(*control)) control++;
         }
        goto donepartbutswitch2;
        case '%': /* don't update so this will be printed */
         lstcontrol=control++; /* string on this (second) %; don't process it*/
        continue; /* main search loop */
        case 'i':
        case 'd':/*in this version, isshort and islong can be ignored*/
         dbl=(double)*(int *)(argsptr);
         argsptr+=sizeof(int);
         out=temp+1;
         if(precision<0) precision=1+(dbl<0);
         else precision+=(dbl<0);
         _dcc_inttostring(out,dbl,precision);
         if(dbl>=0)
         { if(usesign) *(out=temp)='+';
           else if(usespace) *(out=temp)=' ';
         }
        printitout:
         len=strlen(out);
         totalchar+=(len>width?len:width);
         if(padwith0&&!dash&&(*out=='-'||*out=='+'||*out==' '))
         { err|(*charfunc)(*out);
           width--; len--;
           out++;
         }
         if(!dash)
         { if(padwith0) err|=padd0(stringfunc,width-len);
           else err|=paddspace(stringfunc,width-len);
         }
         err|=(*stringfunc)(out,len);
         if(dash) err|=paddspace(stringfunc,width-len);
         control++;
        break;
        case 'o':
         out=temp+1;
         if(precision<0) precision=1;
         inttobasestr(out,*(int *)(argsptr),precision,3,7,'a');
         argsptr+=sizeof(int);
         if(*out!='0'&&alternateform) *(out=temp)='0';
        goto printitout;
        case 'x':
        case 'X':
         out=temp+2;
         if(precision<0) precision=1;
         inttobasestr(out,(val= *(int *)(argsptr)),precision
           ,4,15,(*control+('A'-'X'-10)));
         argsptr+=sizeof(int);
         if(val&&alternateform) { *(out=temp)='0'; temp[1]= *control; }
        goto printitout;
        case 'u':
         if(precision<0) precision=1;
         _dcc_inttostring((out=temp),(double)*(unsigned *)(argsptr),precision);
         argsptr+=sizeof(unsigned);
        goto printitout;
        case 'c':
         err|=(*charfunc)(*(int *)(argsptr)); argsptr+=sizeof(int);
         control++; totalchar++;
        break;
        case 's':
         out= *(char **)(argsptr); argsptr+=sizeof(char *);
         len=strlen(out);
         if(precision>=0&&len>precision)
         { val=out[precision];
           out[precision]='\0';
         }
         else precision=len;
         totalchar+=(precision>width?precision:width);
         if(!dash)
         { if(padwith0) err|=padd0(stringfunc,width-precision);
           else err|=paddspace(stringfunc,width-precision);
         }
         for(a=0;out[a];a++)
          if(out[a]==stopchar||out[a]==stopchar2)
          { err|=(*stringfunc)(out,a);
            err|=(*charfunc)(out[a]);
            out+=a+1; a= -1;/* will be incremented to 0 */
          }
         err|=(*stringfunc)(out,a);
         if(precision>=0&&len>precision) out[a]=val;
         if(dash) err|=paddspace(stringfunc,width-precision);
         control++;
        break;
        case 'f':
        case 'F':
         removezeros=0;
         out=temp+1; /* room for [ +];below for decimal point */
         if(precision<0) precision=6; /* 6 digits after . */
         val=_dcc_dbltostring(out+1,(dbl= *(double *)(argsptr)),precision,-1);
         /* val is exponent; out[1] is first digit or '-' */
         argsptr+=sizeof(double);
        usef:
           /*?-0.XXXXX OR ?-XXX.XXX*/
         exponent=val;
         negative=(out[1]=='-');
         if(negative) out++; /* out[1] is first numeric digit */
         for(len=BCDLEN+1;len<=precision+exponent+1;len++) out[len]='0';
          /* the +1 and <= are a result of the first digit being in out[1] */
          /* second +1 is for the fact that you need a digit before the '.' */
         len=exponent;
         if(exponent<0)
         { len= -exponent;
           if(precision>=len) overmemcpy(out+len+1,out+1,precision-len+1);
           for(;len>0;len--) out[len]='0'; /* fill out[1] through out[len] */
           /* note: len=0; */
         }
         len++; /* for first digit ... (exponent+1 digits before point) */
         overmemcpy(out-1,out,len+1); /* make room for '.' ; insure '-' */
         out[len]='.';
         if(removezeros)
         { while(out[len+precision]=='0') precision--;
           if(alternateform||out[len+precision]!='.') precision++;
         }
         else len+=(alternateform||precision); /* cc for '.' */
         out[len+precision]='\0';
         if(!negative)
         { if(usesign) *(out=temp)='+';
           else if(usespace) *(out=temp)=' ';
         }
         else out--;
        goto printitout;
        case 'e':
        case 'E':
         removezeros=0;
         /*val becomes exponent*/
         /*?X.XXXXXXXXXXXXXXXXXX*/
         if(precision<0) precision=6; /* 6 digits after . */
         out=temp+1;
         val=_dcc_dbltostring(out+1,(dbl= *(double *)(argsptr)),-1,precision);
         argsptr+=sizeof(double);
         /* make temp[precision]='E' */
         Eore= *control;
        use_eorE:
         negative=(out[1]=='-');
         if(negative) *out++='-';
         *out=out[1]; out[1]='.';
         if(precision!=0||alternateform) precision+=2; /* 'X.' */
         else precision=1; /* just 'X' */
         if(precision>100) precision=100;
         for(len=BCDLEN+1;len<=precision;len++) out[len]='0';
          /* +1 and <= result of out[1] being first digit */
         if(removezeros)
         { while(out[precision]=='0') precision--;
           if(alternateform||out[precision]!='.') precision++;
         }
         out[precision++]=Eore;
         if(val>=0) out[precision++]='+';
         _dcc_inttostring(out+precision,(double)val,2+(val<0));
         if(!negative)
         { if(usesign) *(out=temp)='+';
           else if(usespace) *(out=temp)=' ';
         }
         else out--;
        goto printitout;
        case 'g':
        case 'G':
         removezeros=(alternateform^1);
         if(precision<0) precision=6; /* 6 digits after . */
         if(--precision<0) precision=0;
         out=temp+1;
         dbl= *(double *)(argsptr);
         argsptr+=sizeof(double);
         val=_dcc_dbltostring(out+1,dbl,-1,precision);
         if(val<-4||val>precision||precision<0)
         { Eore= *control+('E'-'G');
          goto use_eorE;
         }
         precision-=val;
         if(precision<0) precision=0;
        goto usef;
        case 'l':
#ifndef OPTIMIZED
         if(isshort||islong)
         { putstr("multiple [lh] in printf specifier ");
           puts(original);
         }
#endif
         islong=1;
         control++;
        goto donepartbutswitch2;
        case 'h':
#ifndef OPTIMIZED
         if(isshort||islong)
         { putstr("multiple [lh] in printf specifier ");
           puts(original);
         }
#endif
         isshort=1;
         control++;
        goto donepartbutswitch2;
#ifndef OPTIMIZED
        default:
         putstr("unknown character in ");
         puts(original);
#endif
      }
      lstcontrol=control;
    }
    else if(*control==stopchar||*control==stopchar2)
    { err|=(*stringfunc)(lstcontrol,control-lstcontrol);
      err|=(*charfunc)(*control++);
      totalchar+=control-lstcontrol;
      lstcontrol=control;
    }
    else control++;
  }
  err|=(*stringfunc)(lstcontrol,control-lstcontrol);
  totalchar+=control-lstcontrol;
 return err?EOF:totalchar;
}
/* scanf stuff starts here */
double atof();
long atol();
#define SZDEFAULT 0  /* used in scanf for tracking %lx %hx */
#define SZLONG    1
#define SZSHORT   2
#define MAXSZ  512  /* maximum size of array (MUST be >=256 so temp with [])*/
static int ridspace(func,total) int (*func)(),*total;
{ int c;
  do
  { c=(*func)();
    (*total)++;
  } while(c==' '||c=='\t'||c=='\n');
 return c;
}
_dcc_scanf(getfunc,ungetfunc,argsptr)
   char **argsptr; int (*getfunc)(),(*ungetfunc)();
/* getfunc obtains a character; ungetfunc(c) ungets character c
 *   (requires its last getchar?)
 * *argsptr is assumed to be a pointer to the control string
 *  argsptr[x] ; 1<=x<=#args   ARE pointers to the places things are stored
 * assumptions similar to printf above; assume that int and long the same
 * assume that atoi will convert unsigned integers
 * assume ascii codes '0'<'9'<'A'<'F'<'a'<'f'
 *   and that '0'-'9','A'-'F','a'-'f' are continuous
 */
{ long longout;  /*scanfdefs*/
  int width,dontassign,totalchar=0,convcnt=0,tsz,size,a,c,endch,negate;
  int gotdigit,nullterminate;
  double dblout;
  char temp[MAXSZ],*control,*stringdst;
/*HERE: if bufferring ever done, then flush output buffer */
  control= *argsptr; argsptr++;
  while(*control)
  { switch(*control)
    { case '%':
       width= -1; dontassign=0; size=SZDEFAULT;
       control++;
      continuescanning:
       switch(*control++)
       { case '*':
#ifndef OPTIMIZED
          if(dontassign||size!=SZDEFAULT)
            puts("recoverable syntax error in for scanf");
#endif
          dontassign=1;
         goto continuescanning;
         case 'l':
#ifndef OPTIMIZED
          if(size!=SZDEFAULT)
            puts("multiple l's and h's in scanf control string");
#endif
          size=SZLONG;
         goto continuescanning;
         case 'h':
#ifndef OPTIMIZED
          if(size!=SZDEFAULT)
            puts("multiple l's and h's in scanf control string");
#endif
          size=SZSHORT;
         goto continuescanning;
         case '%':
          control--;
         goto expectcharacter;
         case 'd':
         case 'u':
          c=ridspace(getfunc,&totalchar);
          if(width<0||width>MAXSZ-2) width=MAXSZ-2; /* -1 for '\0' */
          tsz=0;
         isdecimal:
          if(c=='-') goto negative_d_start;
         decimalnoneg: /* char in c; width,tsz correct */
          while(isdigit(c)&&tsz<width)
          {negative_d_start: /* for negative; c is set to '-'; tsz=0 */
            temp[tsz++]=c;
            c=(*getfunc)(); totalchar++;
          }
          temp[tsz]='\0';
          longout=atol(temp);
         integerout: /* longout with value; c contains thing to unget */
          totalchar--;
          if(c!=EOF) (*ungetfunc)(c);
          if(tsz==1&&*temp=='-')
          { (*ungetfunc)('-'); c='-';
           goto condreturn;
          }
          if(tsz==0) goto condreturn;
          if(dontassign) break;
          switch(size)
          { case SZDEFAULT:
            case SZLONG:
             *(int *)*(argsptr++)=longout;
            break;
            default:
             puts("bad size");
            break;
            case SZSHORT:
             *(short *)*(argsptr++)=longout;
          }
          convcnt++;
         break;
/*         case 'u': /* NOTE: this commented out and placed in %d */
/*          c=ridspace(getfunc,&totalchar);
/*          if(width<0||width>MAXSZ-2) width=MAXSZ-2; /* -1 for '\0' */
/*          tsz=0;
/*         goto decimalnoneg; */
         case 'o':
          c=ridspace(getfunc,&totalchar);
          tsz=0; *temp=c;
          if(negate=(c=='-'))
          { c=(*getfunc)(c); totalchar++;
            tsz++;
          }
          if(width<0||width>MAXSZ-2) width=MAXSZ-2; /* -1 for '\0' */
         octalnumber: /* nothing in c ; tsz=1 to always OK; negate set*/
          longout=0;
          while(c>='0'&&c<='7'&&tsz<width)
          { longout<<=3; longout+=c-'0'; tsz++;
            c=(*getfunc)();
            totalchar++;
          }
          if(negate) longout= -longout;
         goto integerout;
         case 'x':
          c=ridspace(getfunc,&totalchar);
          tsz=0; *temp=c;
          if(negate=(c=='-'))
          { c=(*getfunc)(c); totalchar++;
            tsz++;
          }
          if(width<0||width>MAXSZ-2) width=MAXSZ-2; /* -1 for '\0' */
         hexnumber: /* nothing in c ; tsz=1 to always OK; negate set*/
          longout=0;
          while(isxdigit(c)&&tsz<width)
          { longout<<=4;
            if(c<='9') longout+=c-'0';
            else if(c<='F') longout+=c+(10-'A');
            else longout+=c+(10-'a');
            tsz++;
            c=(*getfunc)();
            totalchar++;
          }
          if(negate) longout= -longout;
         goto integerout;
         case 'i':
          if(width<0||width>MAXSZ-2) width=MAXSZ-2; /* -1 for '\0' */
          c=ridspace(getfunc,&totalchar);
          tsz=0; *temp=c;
          negate=(c=='-');
          if(negate)
          { if(tsz>=width)
            { (*ungetfunc)(c); /* totalchar-- not needed */
             goto condreturn;
            }
            c=(*getfunc)(); totalchar++;
            tsz++;
          }
          if(c=='0'&&tsz<width)
          { c=(*getfunc)(); totalchar++; tsz++;
            if(c=='x'||c=='X')
            { a=(*getfunc)(); totalchar++; tsz++;
                 /* totalchar uneffected by these 2 lines */
              if(!isxdigit(a)||tsz>=width)
              { (*ungetfunc)(a); (*ungetfunc)(c); c='0'; totalchar-=2; tsz-=2;
               goto integerdecimal;
              }
              c=a;
            /*  tsz=2; /* for "0x"; needed for comparison with width */
if(tsz-negate!=2) puts("warning about tsz 2");
             goto hexnumber;
            }
            else
            { if(c!=EOF) (*ungetfunc)(c);
              totalchar--; tsz--; c='0';
if(tsz-negate!=0) puts("warning about tsz 1");
             goto octalnumber;
            }
          }
         integerdecimal:
          if(isdigit(c))
          { if(negate)
            { (*ungetfunc)(c); c='-'; totalchar--; tsz--;
            }
if(tsz!=0) puts("warning about tsz 3");
           goto isdecimal;
          }
          if(c!=EOF) /* tsz doesn't matter here because of goto condreturn */
          { (*ungetfunc)(c); /* totalchar--; not needed */
          }
          if(negate)
          { (*ungetfunc)('-'); c='-'; /* totalchar--; not needed */
          }
         goto condreturn;
         case 'n':
          switch(size)
          { case SZDEFAULT:
            case SZLONG:
             *(int *)*(argsptr++)=totalchar;
            break;
            default:
             puts("bad size");
            break;
            case SZSHORT:
             *(short *)*(argsptr++)=totalchar;
          }
          /* HERE: dontassign here? dontassign convcnt?*/
         break;
         case 'e':
         case 'f':
         case 'g': /*[+-][0-9]*[.][0-9]*E[+-][0-9]*/
          c=ridspace(getfunc,&totalchar);
          gotdigit=tsz=0;
          if(width<0||width>MAXSZ-2) width=MAXSZ-2; /* -1 for '\0' */
          if(!isdigit(c)&&c!='+'&&c!='-') goto nostartdigits;
          do
          { temp[tsz++]=c;
            if(!gotdigit&&isdigit(c)) gotdigit=1;
            c=(*getfunc)();
            totalchar++;
          } while(isdigit(c)&&tsz<width);
         nostartdigits:
          if(tsz>=width) goto dofloatnow;
          switch(c)
          { case '.':
             temp[tsz++]='.';
             while((c=(*getfunc)()),totalchar++,isdigit(c)&&tsz<width)
             { temp[tsz++]=c;
               if(!gotdigit&&isdigit(c)) gotdigit=1;
             }
             if(tsz>=width||toupper(c)!='E') goto dofloatnow;
            case 'E':
            case 'e':
             if(!gotdigit) break;
             temp[tsz++]=c;
             c=(*getfunc)();
             totalchar++;
             if((!isdigit(c)&&c!='+'&&c!='-')||tsz>=width) goto dofloatnow;
             do
             { temp[tsz++]=c;
               c=(*getfunc)();
               totalchar++;
             } while(isdigit(c)&&tsz<width);
          }
         dofloatnow: /* c=character to unget; tsz is size of it */
          temp[tsz]='\0';
          totalchar--;
          if(c!=EOF) (*ungetfunc)(c);
          if(!gotdigit)
          { if(tsz)
            { c= *temp;
              while(tsz) (*ungetfunc)(temp[--tsz]);
            }
           goto condreturn;
          }
          if(dontassign) break;
          dblout=atof(temp);
          switch(size)
          { case SZDEFAULT:
            case SZSHORT:
             *(float *)(*argsptr++)=dblout;
            break;
            case SZLONG:
             *(double *)(*argsptr++)=dblout;
          }
          convcnt++;
         break;
         case 's':
          nullterminate=1;
          c=ridspace(getfunc,&totalchar);
          for(a=0;a<256;a++) temp[a]=1; /* enable all chars */
          temp[' ']=temp['\t']=temp['\n']=0;
         stringjmp: /* c is first character */
              /* temp[0..255] are use/don't use for each ascii code */
          tsz=0;
          if(!dontassign) stringdst= *argsptr++;
          while(c!=EOF&&temp[c]&&(width<0||tsz<width))
          { if(!dontassign) *stringdst++=c;
            tsz++;
            c=(*getfunc)();
            totalchar++;
          }
          totalchar--;
          if(c!=EOF) (*ungetfunc)(c);
          if(tsz==0) goto condreturn;
          if(!dontassign)
          { if(nullterminate) *stringdst='\0';
            convcnt++;
          }
         break;
         case 'c':
          nullterminate=0;
          if(width<0) width=1;
          c=(*getfunc)();
          totalchar++;
          for(a=0;a<256;a++) temp[a]=1; /* enable all chars */
         goto stringjmp;
         case '[':
          nullterminate=1;
          for(a=0;a<256;a++) temp[a]=0; /* disable all chars */
          c= *control++;
          negate=(c=='^');
          if(negate) c= *control++;
          do   /* create list of legal chars */
          { endch=c;
            if(*control=='-')
            { control++;
              switch(*control)
              { case ']':
                 control--;
                break;
                default:
                 endch= *control++;
              }
            }
            for(;c<=endch;c++) temp[c]=1;
            c= *control++;
          } while(c!=']');
          if(negate) for(a=0;a<256;a++) temp[a]^=1;
          c=(*getfunc)();
          totalchar++;
         goto stringjmp;
#ifndef OPTIMIZED
         case '\0':
          puts("unexpected end of scanf control string");
         break;
#endif
         default:
          control--;
          if(isdigit(*control))
          { width=atoi(control);
            while(isdigit(*control)) control++;
          }
#ifndef OPTIMIZED
          else puts("syntax err in control string");
          if(size!=SZDEFAULT) puts("syntax error in scanf control string");
#endif
         goto continuescanning;
       }
      break;
      case ' ':
      case '\t':
      case '\n':
       control++;
       while(totalchar++,c=(*getfunc)(),c==' '||c=='\n'||c=='\t');
       totalchar--;
       if(c!=EOF) (*ungetfunc)(c);
      break;
      default:
      expectcharacter:
       c=(*getfunc)();
       totalchar++;
       if(c==EOF) goto eofreturn;
       if(c!= *control)
       { (*ungetfunc)(c); /* totalchar-- not needed! */
        goto normalreturn;
       }
       control++;
    }
  }
 /* note that the main loop exits here when the null is encountered */
 normalreturn: /* totalchar doesn't need to be correct here. */
     /* character buffer properly arranged; return convcnt */
 return convcnt;

 condreturn:
  if(c==EOF) goto eofreturn;
 return convcnt;

 eofreturn: /* nothing in c; just return */
  if(convcnt>0) goto normalreturn;
 return EOF;
}
/* memory allocation junk. */
static int spacefound=0,alloccnt=0;
static char *maxposition,*firstchunk;
char *_dccgetstacklocn(),*_dccgettopofprogram();
/* each chunk allocated as follows:
 *size          4  ; SIZEPIECE
 *pointertonext 4  ; NEXTPIECE
 *pointertoprev 4  ; PREVPIECE
 *userspace     sz ; located at byte offset HEADSZ
 */
#define SIZEPIECE(ptr) (*((int *)(ptr)))
#define NEXTPIECE(ptr) (((char **)(ptr))[1])
#define PREVPIECE(ptr) (((char **)(ptr))[2])
#define HEADSZ 12
#define NULL 0
char *malloc(sz) int sz;
{ char *chunk,*startptr,*endptr;
  int a,fullsize;
  if(!spacefound)
  { firstchunk=(char *)(((int)_dccgettopofprogram()+3)&0xfffffffc);
    maxposition=_dccgetstacklocn()-1000;
printf("_dccgetstacklocn() %x\n",_dccgetstacklocn());
    SIZEPIECE(firstchunk)=HEADSZ;
    NEXTPIECE(firstchunk)=NULL;
printf("firstchunk %x maxposition %x\n",firstchunk,maxposition);
    spacefound=1;
  }
  sz=((sz+(HEADSZ+3))&0xfffffffc);
  for(chunk=firstchunk,a=0;a<=alloccnt;a++,chunk=NEXTPIECE(chunk))
  { startptr=chunk+SIZEPIECE(chunk);
    if(a==alloccnt) endptr=maxposition;
    else endptr=NEXTPIECE(chunk);
    fullsize=endptr-startptr;
/*printf("fullsize %d sz %d endptr %x alloccnt %d a %d\n",fullsize,sz,endptr
,alloccnt,a);
*/
    if(fullsize<0) return NULL;
    if(fullsize>=sz)
    { NEXTPIECE(startptr)=NEXTPIECE(chunk);
      NEXTPIECE(chunk)=startptr;
      if(NEXTPIECE(startptr)!=NULL) PREVPIECE(NEXTPIECE(startptr))=startptr;
      PREVPIECE(startptr)=chunk;
      SIZEPIECE(startptr)=sz;
      alloccnt++;
     return startptr+HEADSZ;
    }
  }
printf("NULL firstchunk %d maxposition %d\n",firstchunk,maxposition);
 return NULL;
}
char *realloc(ptr,sz) char *ptr;
{ char *chunk,*startptr,*endptr,*prevchunk;
  int fullsize;
  if(!spacefound) return NULL;
  sz+=HEADSZ;
  chunk=ptr-HEADSZ;
  prevchunk=PREVPIECE(chunk);
  startptr=prevchunk+SIZEPIECE(prevchunk);
  endptr=NEXTPIECE(chunk);
  if(endptr==NULL) endptr=maxposition;
  fullsize=endptr-startptr;
/*printf("fullsize %d sz %d startptr %x chunk %x\n",fullsize,sz,startptr,chunk);
*/
  if(fullsize<0) return NULL;
  if(fullsize>=sz)
  { if(startptr!=chunk)
    { overmemcpy(startptr,chunk,sz);
      NEXTPIECE(prevchunk)=startptr;
      if(NEXTPIECE(startptr)!=NULL) PREVPIECE(NEXTPIECE(startptr))=startptr;
      chunk=startptr;
    }
    SIZEPIECE(chunk)=sz;
   return chunk+HEADSZ;
  }
  else
  { sz-=HEADSZ; chunk+=HEADSZ;
    startptr=malloc(sz);
    if(startptr!=NULL)
    { memcpy(startptr,chunk,sz);
      free(chunk);
    }
   return startptr;
  }
}
free(ptr) char *ptr;
{ if(!spacefound) return;
  ptr-=HEADSZ;
  NEXTPIECE(PREVPIECE(ptr))=NEXTPIECE(ptr);
  if(NEXTPIECE(ptr)!=NULL) PREVPIECE(NEXTPIECE(ptr))=PREVPIECE(ptr);
  alloccnt--;
}
