/* scanf tests */
#define EOF (-1)
#define MAXSTRINGSZ 32
double fabs();
main()
{ test1();
  test2();
}
test1()
{ int a,b,c,d,e,retd;
  short h1,h2,h3,h4,h5;
  long l1,l2,l3;
  char temp1[MAXSTRINGSZ],temp2[MAXSTRINGSZ],temp3[MAXSTRINGSZ],c1,c2,c3;
  char c4,c5,c6;
  float f1,f2,f3,f4,f5,f6,f7,f8,f9,f10;
  double d1,d2,d3,d4;
  retd=sscanf(" 1234\nthis was","%d%s%n%s",&a,temp1,&b,temp2);
  printf("a %d temp1 [%s] temp2 [%s] retd %d b %d\n",a,temp1,temp2,retd,b);
  if(retd!=3||a!=1234||strcmp(temp1,"this")||strcmp(temp2,"was")||b!=10)
    error("A");
  retd=sscanf("4321THIS\t\n \n\n-54-3","%d%c%s%c%d%n%c",&a,&c1,temp1,&c2,&d,&b
    ,&c3);
  if(retd!=6||a!=4321||c1!='T'||strcmp(temp1,"HIS")||c2!='\t'||d!=-54||c3!='-'
     ||b!=16)
    error("B");
  c= -1;
  retd=sscanf("0 ","%d%n%d%n",&a,&b,&d,&c); /*d still -54 from above */
  if(retd!=1||a!=0||d!=-54||b!=1||c!=-1)                           error("C");
  retd=sscanf("56 -- PRINT\n","%d%n%d%n%s",&a,&b,&d,&c,temp1);
  if(retd!=1||a!=56||b!=2||c!=-1||d!=-54||strcmp(temp1,"HIS"))     error("D");
  c= -2;
  retd=sscanf("  KIND166 \t\t  TEMP","%s%n%d%s%n",temp1,&b,&a,temp2,&c);
  /*a=56;temp2="was"*/
  if(retd!=1||a!=56||strcmp(temp1,"KIND166")||strcmp(temp2,"was")||b!=9||c!=-2)
    error("E");
  retd=sscanf("\t\n  t","%d%s",&a,temp1); /*a=56;temp1="KIND166"*/
  if(retd!=0||a!=56||strcmp(temp1,"KIND166"))          error("F");
  retd=sscanf("\t  \n","%d%s",&a,temp1); /*a=56;temp1="KIND166"*/
  if(retd!=EOF||a!=56||strcmp(temp1,"KIND166"))        error("G");
  retd=sscanf("\t  \n","%u%s",&a,temp1);
  if(retd!=EOF||a!=56||strcmp(temp1,"KIND166"))        error("H");
  retd=sscanf("58996  -68933","%n%u%n%u",&c,&b,&d,&a);
  if(retd!=2||b!=58996||a!=-68933||c!=0||d!=5)         error("I");
  retd=sscanf("  58t87","%u%c%u%n",&a,&c1,&b,&c);
  if(retd!=3||a!=58||c1!='t'||b!=87||c!=7)            error("J");
  d= -5;
  retd=sscanf("876t","%u%n%u%n",&a,&c,&b,&d);
  if(retd!=1||a!=876||b!=87||c!=3||d!=-5)              error("K");
  retd=sscanf("7668439","%o%n%c%o%n",&a,&c,&c1,&b,&d);
  if(retd!=3||a!=0766||c1!='8'||b!=043||c!=3||d!=6)   error("L");
  retd=sscanf("  8","%n%o%n",&b,&a,&c);
  if(retd!=0||a!=0766||b!=0||c!=3)                    error("M");
  retd=sscanf("0-37","%o%n%o%n",&a,&c,&b,&d);
  if(retd!=2||a!=0||b!=-037||c!=1||d!=4)               error("N");
  retd=sscanf("333 4aa Afb3 AGFC","%x%x%x%n%x",&a,&b,&c,&e,&d);
  if(retd!=4||a!=0x333||b!=0x4aa||c!=0xafb3||d!=0xa||e!=12) error("O");
  retd=sscanf("56a -a5d","%x%n%x%n",&a,&c,&b,&d);
  if(retd!=2||a!=0x56a||b!=-0xa5d||c!=3||d!=8)         error("P");
  d= -7;
  retd=sscanf("fec","%x%n%x%n",&a,&c,&b,&d);
  if(retd!=1||a!=0xfec||b!=-0xa5d||c!=3||d!=-7)        error("Q");
  retd=sscanf("  0","%x%n%x%n",&a,&c,&b,&d);
  if(retd!=1||a!=0||b!=-0xa5d||c!=3||d!=-7)            error("R");
  retd=sscanf("  \t\n\n  ","%x%n%x",&a,&b,&d);
  if(retd!=EOF||a!=0||b!=-0xa5d||d!=-7)                error("S");
  retd=sscanf("st","%x%c",&a,&c1);
  if(retd!=0||a!=0||c1!='8')                           error("T");
  retd=sscanf("","%x",&b);
  if(retd!=EOF||b!=-0xa5d)                             error("U");
  retd=sscanf("0 0X ","%i%n%i%n",&a,&c,&b,&d);
  if(retd!=2||a!=0||b!=0||c!=1||d!=3)                  error("V");
  d= -12;
  retd=sscanf("-18f","%i%n%i%n",&a,&c,&b,&d);
  if(retd!=1||a!=-18||b!=0||c!=3||d!=-12)              error("W");
  retd=sscanf("    56 056 0x56","%i%i%n%i%n",&a,&b,&d,&c,&e);
  if(retd!=3||a!=56||b!=056||c!=0x56||d!=10||e!=15)    error("X");
  c= -13;
  retd=sscanf(" abc","%i%n%i",&a,&c,&b);
  if(retd!=0||a!=56||b!=056||c!=-13)                   error("Y");
  retd=sscanf("","%i",&a);
  if(retd!=EOF||a!=56)                                 error("Z");
  retd=sscanf(" 0Xfft 07789","%i%n%i%i",&a,&d,&b,&c);
  if(retd!=1||a!=0xff||b!=056||c!=-13||d!=5)          error("a");
  retd=sscanf("0x-g","%i%c%n",&a,&c1,&b);
  if(retd!=2||a!=0||c1!='x'||b!=2)                    error("b");
  retd=sscanf("-0 2 -3 .456 -.456 65.38e20 76.374E+5 7.643e-6 0 1e-6"
    ,"%f%g%e%f%n%g%e%f%g%e%f%n",&f1,&f2,&f3,&f4,&b,&f5,&f6,&f7,&f8,&f9
    ,&f10,&a);
  if(retd!=10||f1!=0||f2!=2||f3!=-3||fabs(f4-.456)>.456/100000
    ||fabs(f5+.456)>.456/100000||fabs(f6-65.38e20)>65.38e20/100000
    ||fabs(f7-76.374e5)>76.374e5/100000||fabs(f8-7.643e-6)>7.643e-6/100000
    ||f9!=0||fabs(f10-1e-6)>1e-6/100000||a!=53||b!=12)  error("c");
  retd=sscanf("1.4e20 0e34 1e24 1e-25 0.e-2 ","%f%f%f%n%f%f%n%f",&f1,&f2,&f3,&a
    ,&f4,&f5,&b,&f6);
  if(retd!=5||fabs(f1-1.4e20)>1.4e20/100000||f2!=0||fabs(f3-1e24)>1e24/100000
    ||fabs(f4-1e-25)>1e-25/100000||f5!=0||fabs(f6-65.38e20)>65.38e20/100000
    ||a!=16||b!=28)
      error("d");
  b= -56;
  retd=sscanf("+.567e5 +4e-3 +4","%f%f%n%f%f%n",&f1,&f2,&a,&f3,&f4,&b);
  if(retd!=3||fabs(f1-.567e5)>.567e5/100000||fabs(f2-4e-3)>4e-3/100000||f3!=4
    ||fabs(f4-1e-25)>1e-25/100000||a!=13||b!=-56)
      error("e");
  retd=sscanf("56.e34t","%n%f%c%n",&a,&f1,&c1,&b);
  if(retd!=2||fabs(f1-56e34)>56e34/100000||c1!='t'||a!=0||b!=7) error("f");
  b= -134;
  retd=sscanf("  e35","%n%f%n",&a,&f1,&b);
  if(retd!=0||fabs(f1-56e34)>56e34/100000||a!=0||b!=-134) error("g");
  retd=sscanf(" .e21","%f",&f1);
  if(retd!=0||fabs(f1-56e34)>56e34/100000)      error("h");
  retd=sscanf("","%f",&f1);
  if(retd!=EOF||fabs(f1-56e34)>56e34/100000)    error("i");
  retd=sscanf(" 5et","%f%n",&f1,&a);
  if(retd!=1||f1!=5||a!=3)                      error("j");
  retd=sscanf(" 9e","%f%n",&f1,&a);
  if(retd!=1||f1!=9||a!=3)                      error("k");
  retd=sscanf("-.e98\n\tABCD ABCxx\t  \n","%s%c%s%n%c%c%s%n",temp1,&c1,temp2,&a
    ,&c2,&c3,temp3,&b);
  if(retd!=6||c1!='\n'||c2!=' '||c3!='A'||strcmp(temp1,"-.e98")||a!=11||b!=17
    ||strcmp(temp2,"ABCD")||strcmp(temp3,"BCxx")) error("l");
  b= -158;
  retd=sscanf(".-eA= \t\n  ","%s%c%n%s%n",temp1,&c1,&a,temp2,&b);
  if(retd!=2||c1!=' '||strcmp(temp1,".-eA=")||strcmp(temp2,"ABCD")||a!=6
     ||b!=-158)                                error("m");
  retd=sscanf("   XXX","%s%n%s%n",temp1,&a,temp2,&b);
  if(retd!=1||strcmp(temp1,"XXX")||strcmp(temp2,"ABCD")||a!=6||b!=-158)
    error("n");
  retd=sscanf("   \t\t\n\n","%n%s%n",&a,temp1,&b);
  if(retd!=EOF||strcmp(temp1,"XXX")||a!=0||b!=-158) error("o");
  retd=sscanf("","%s",temp1);
  if(retd!=EOF||strcmp(temp1,"XXX"))         error("p");
  retd=sscanf(" \t\n .-eA","%c%c%n%c%c%c%c%n",&c1,&c2,&a,&c3,&c4,&c5,&c6,&b);
  if(retd!=6||c1!=' '||c2!='\t'||c3!='\n'||c4!=' '||c5!='.'||c6!='-'||a!=2
      ||b!=6)
     error("q");
}
test2()
{ int a2,a,b,c,d,e,retd;
  short h1,h2,h3,h4,h5;
  long l1,l2,l3;
  char temp1[MAXSTRINGSZ],temp2[MAXSTRINGSZ],temp3[MAXSTRINGSZ],c1,c2,c3;
  char c4,c5,c6;
  float f1,f2,f3,f4,f5,f6,f7,f8,f9,f10;
  double d1,d2,d3,d4;
  int a3;
  printf("test2\n");
  retd=sscanf(" .\\eAB","%c%c%c%c%c%c",&c1,&c2,&c3,&c4,&c5,&c6);
  if(retd!=6||c1!=' '||c2!='.'||c3!='\\'||c4!='e'||c5!='A'||c6!='B')
     error("r");
  retd=sscanf("AZaz\7","%c%c%c%c%c%c",&c1,&c2,&c3,&c4,&c5,&c6);
  if(retd!=5||c1!='A'||c2!='Z'||c3!='a'||c4!='z'||c5!='\7'||c6!='B')
     error("s");
  retd=sscanf("","%c",&c1);
  if(retd!=EOF||c1!='A')                            error("t");
/* UNIX's C makes retd=0.  I think this may be a bug.  Check bcc */
  printf("??retd %d c1 %d\n",retd,c1);
  retd=sscanf(" \t\n\\AZaz09\7-YXCIDaCIH","%[^X]%[^D-H]%n%c%[^D-H]%n",temp1
    ,temp2,&a,&c1,temp3,&b);
  if(retd!=4||strcmp(temp1," \t\n\\AZaz09\7-Y")||strcmp(temp2,"XCI")
    ||strcmp(temp3,"aCI")||c1!='D'||a!=16||b!=20)
      error("u");
  retd=sscanf("CDFQGHICPBKLMNOPa","%[C-P]%c%[C-P]%c%n%[C-P]%c%n",temp1,&c1
    ,temp2,&c2,&a,temp3,&c3,&b);
  if(retd!=6||c1!='Q'||c2!='B'||c3!='a'||strcmp(temp1,"CDF")
    ||strcmp(temp2,"GHICP")||strcmp(temp3,"KLMNOP")||a!=10||b!=17)
      error("v");
  retd=sscanf("  DKLa  CPK\t -PCKLJ%","%[C-P ]%c%[ C-P]%c%[-% C-P]%n"
   ,temp1,&c1,temp2,&c2,temp3,&a);
  if(retd!=5||c1!='a'||c2!='\t'||strcmp(temp1,"  DKL")||strcmp(temp2,"  CPK")
     ||strcmp(temp3," -PCKLJ%")||a!=20)        error("w");
  retd=sscanf("[ABC]DEF]","%[]A-C[]%[^]A-C[]%[^]A-C[]",temp1,temp2,temp3);
  if(retd!=2||strcmp(temp1,"[ABC]")||strcmp(temp2,"DEF")
     ||strcmp(temp3," -PCKLJ%"))              error("x");
  retd=sscanf("ABBC","%[BCA]%n",temp1,&a);
  if(retd!=1||strcmp(temp1,"ABBC")||a!=4)     error("y");
  retd=sscanf("abccdB JJA KLK[","%[^]A-C[]%c%[^]A-C[]%c%[^]A-C[]%c",temp1,&c1
    ,temp2,&c2,temp3,&c3);
  if(retd!=6||c1!='B'||c2!='A'||c3!='['||strcmp(temp1,"abccd")
    ||strcmp(temp2," JJ")||strcmp(temp3," KLK")) error("z");
/*printf("retd %d c1 %c c2 %c c3 %c temp1 [%s] temp2 [%s] temp3 [%s]\n",retd
,c1,c2,c3,temp1,temp2,temp3);*/
  h1=h5=0x1234;
  retd=sscanf("563 -567 -aCC7","%hd%ho%hx%n",&h2,&h3,&h4,&a);
  if(retd!=3||h1!=0x1234||h2!=563||h3!=- 0567||h4!=((- 0xacc7)&0xffff)
      ||h5!=0x1234||a!=14)
    error("aa");
/*printf("-acc7 %x ",- 0xacc7);
printf("retd %d h1 %x h2 %d h3 %o h4 %x h5 %x\n",retd,h1,h2,h3,h4,h5);
*/
  l1=l2=l3= -1;
  retd=sscanf("667445998344afF865d","%lo%ld%lx%n",&l1,&l2,&l3,&a);
  if(retd!=3||l1!=0667445||l2!=998344||l3!=0xaff865d||a!=19) error("bb");
  retd=sscanf("66.37e-3 77.89 12","%hf%hf%hf%n",&f1,&f2,&f3,&a);
  if(retd!=3||fabs(f1-66.37e-3)>66.37e-3/100000||fabs(f2-77.89)>77.89/100000
    ||f3!=12||a!=17)                                      error("cc");
  retd=sscanf("1.56e20 -5.67e3 -67.3","%lf%lf%lf%n",&d1,&d2,&d3,&a);
  if(retd!=3||fabs(d1-1.56e20)>1.56e20/100000000||a!=21
     ||fabs(d2+5.67e3)>5.67e3/10000000||fabs(d3+67.3)>67.3/100000000)
    error("dd");
  a=b=c=d=e=0x53284abf; f1=3.52e10; c1='X';
  strcpy(temp1,"This 1"); strcpy(temp2,"tHIS 2");
  retd=sscanf("-45 38 5678aFBC 03672 56.3e-1 ABKK\tBBCFEG"
    ,"%*d%*u%*o%ln%*x%*i%*e%*s%*c%*[B-G]%ln",&l2,&l1,&a,&b);
/* NOTE: applies to %* below too; junk on end shouldn't be effected. */
  if(retd!=0||a!=0x53284abf||b!=a||l1!=41||l2!=10)
    error("ee");
/*printf("retd %d l1 %ld l2 %ld\n",retd,l1,l2);
*/
  retd=sscanf("  \t\t\n\n  \tXABCD.-%^"," %n%cABCD.-%%%n%c%n",&a,&c1,&b,&c2
    ,&c);
  if(retd!=2||c1!='X'||c2!='^'||a!=9||b!=17||c!=18)         error("ff");
  b= -248;
  retd=sscanf("  \t\t\n\n \tY.,K","\t%c.%n.%n%c",&c1,&a,&b,&c2);
  if(retd!=1||c1!='Y'||c2!='^'||a!=10||b!=-248)   error("gg");
  a= -247;
  retd=sscanf("ABCLK","\nABK%c%n",&c1,&a);
  if(retd!=0||c1!='Y'||a!=-247)                  error("hh");
  b= -8; c= -9;
  retd=sscanf("CKIL","CKIL%nK%n%c%n",&a,&c1,&b,&c);
  if(retd!=EOF||c1!='Y'||a!=4||b!=-8||c!=-9)    error("ii");
  a=0;
  retd=sscanf("this","%s%n",temp1,&a);
  if(retd!=1||strcmp(temp1,"this")||a!=4)       error("jj");
  a=0x12345678;
  retd=sscanf("ThIsO","%s%hn",temp1,&a);
  if(retd!=1||strcmp(temp1,"ThIsO")||a!=0x12340005) error("kk");
  a=0x12345678;
  retd=sscanf("ThIsO","%s%*hn",temp1,&a);
  if(retd!=1||strcmp(temp1,"ThIsO")||a!=0x12340005) error("ll");
  a=0x12345678;
  retd=sscanf("ThIsO","%s%*n",temp1,&a);
  if(retd!=1||strcmp(temp1,"ThIsO")||a!=5)          error("mm");
  retd=sscanf("  \nKeep  \t\n","%n%s%n %n",&a,temp1,&b,&c);
  if(retd!=1||a!=0||b!=7||c!=11||strcmp(temp1,"Keep")) error("nn");
  e=0x45678123; l1=l2= -89;
  retd=sscanf("123d-34","%1d%1u%1o%1x%ln%1d%ln",&a,&b,&c,&d,&l1,&e,&l2);
  if(retd!=4||a!=1||b!=2||c!=3||d!=0xd||e!=0x45678123||l1!=4||l2!=-89)
    error("oo");
  c=7; d= -9;
  retd=sscanf("05-34","%1i%c%n%1u%n",&a,&c1,&b,&c,&d);
  if(retd!=2||a!=0||c1!='5'||b!=2||c!=7||d!=-9)       error("pp");
  retd=sscanf("56-76","%1i%c%n%1o%n",&a,&c1,&b,&c,&d);
  if(retd!=2||a!=5||c1!='6'||b!=2||c!=7||d!=-9)       error("qq");
  retd=sscanf("0x3-53","%1i%c%c%n%1x%n",&a,&c1,&c2,&b,&c,&d);
  if(retd!=3||a!=0||c1!='x'||c2!='3'||b!=3||c!=7||d!=-9) error("rr");
  retd=sscanf("15-5","%1f%c%n%1i%n",&f1,&c1,&a,&b,&c);
  b= -93; c= -1;
  if(retd!=2||f1!=1.0||c1!='5'||a!=2||b!=-93||c!=-1)  error("ss");
  retd=sscanf("07-03","%1f%c%n%1i%n",&f1,&c1,&a,&b,&c);
  if(retd!=2||f1!=0.0||c1!='7'||a!=2||b!=-93||c!=-1)  error("tt");
  retd=sscanf("  3.-0x34","%1f%c%n%1i%n",&f1,&c1,&a,&b,&c);
  if(retd!=2||f1!=3.0||c1!='.'||a!=4||b!=-93||c!=-1)  error("uu");
  f1=78;
  retd=sscanf("-03e12","%1f",&f1);
  if(retd!=0||f1!=78.0)                               error("vv");
  retd=sscanf("-3.5","%1f",&f1);
  if(retd!=0||f1!=78.0)                               error("ww");
  retd=sscanf(".4e3","%1f",&f1);
  if(retd!=0||f1!=78.0)                               error("xx");
  strcpy(temp3,"ZYXWVUT");
  retd=sscanf("ABCDEF","%1s%1[^a]%1c%2c",temp1,temp2,&c1,temp3);
  if(retd!=4||strcmp(temp1,"A")||strcmp(temp2,"B")||c1!='C'
    ||strcmp(temp3,"DEXWVUT"))                        error("yy");
  retd=sscanf("56773-66915234-1107","%4d%c%n%4d%4o%c%4o%ln",&a,&c1,&b,&c,&d
    ,&c2,&e,&l1);
  if(retd!=6||a!=5677||c1!='3'||b!=5||c!=-669||d!=01523||c2!='4'||e!=- 0110
    ||l1!=18)                                         error("zz");
  retd=sscanf("5aDf3-e5a07626","%4x%c%n%4x%4i%n",&a,&c1,&b,&c,&d,&e);
  if(retd!=4||a!=0x5adf||c1!='3'||b!=5||c!=- 0xe5a||d!=0762||e!=13)
    error("ab");
  retd=sscanf("0x4a67893-4670X","%4i%n%4i%c%4i%n",&a,&b,&c,&c1,&d,&e);
  if(retd!=4||a!=0x4a||b!=4||c!=6789||c1!='3'||d!=-467||e!=13) error("ac");
  retd=sscanf("-0453-0x53-0x6\n","%4i%c%n%4i%c%3i%c%n",&a,&c1,&b,&c,&c2,&d,&c3
    ,&e);
  if(retd!=6||a!=- 045||c1!='3'||b!=5||c!=- 0x5||c2!='3'||d!=0||c3!='x'||e!=13)
    error("ad (for UNIX, this always occurs)");
  retd=sscanf("+12.34e-563.4e+3.43e34.38e34.38.-87.34."
     ,"%9f%6f%5f%n%5e%c%3f%2f%c%2f%n",&f1,&f2,&f3,&a,&f4,&c1,&f5,&f6,&c2,&f7
     ,&b);
  if(retd!=9||fabs(f1-12.34e-5)>12.34e-5/100000||fabs(f2-63.4)>63.4/100000
    ||fabs(f3-3.43)>3.43/100000||fabs(f4-34.38)>34.38/100000||c1!='e'||f5!=34.0
    ||f6!=38||c2!='.'||f7!=-8||a!=20||b!=34)
   error("ae (for UNIX, this allways occurs)");
/*printf("retd %d a %d b %d c %d d %d e %d c1 %c c2 %c c3 %c temp1 [%s] temp2\
 [%s] f1 %f l1 %ld\n",retd,a,b,c,d,e,c1,c2,c3,temp1,temp2,f1,l1);
printf("f2 %f f3 %f f4 %f f5 %f f6 %f f7 %f\n",f2,f3,f4,f5,f6,f7);
*/
/*MERE: next: negative %1i, Legal&illegal %f; %s %c small test of %[]
 * test %7 on each. test %2 %3 %4 on %f and %i */
}
error(s) char *s;
{ printf("error \"%s\" in scanf test program\n",s);
}
