/* mt2.c - test specific aspects of malloc [realloc(0) and too many
 *         small free space] */
#include <stdio.h>
#include <malloc.h>

main()
{ char *ptr;
  char **ptr2;
  int a,size;

  ptr=realloc(0,100);    /* test realloc(0) and free(0) */
  fprintf(stderr,"ptr %#x\n",ptr);
  for(a=0;a<100;a++) ptr[a]=a+7;
  free(ptr);

  ptr2=(char **)malloc(100000*sizeof(*ptr2)); /* fill up with small pieces */
  for(a=0;a<100000;a++)
  { ptr2[a]=malloc(10);
    if(!ptr2[a]) break;
  }
  size=a;

  for(a=0;a<size;a+=2)
     /* create little free space areas until suffiecient free nodes */
  { free(ptr2[a]);
    ptr=malloc(7);
    if(!ptr) break;
    free(ptr);
  }
  fprintf(stderr,"no malloc at size %d a %d\n",size,a);

  for(a=1;a<size;a+=2)
     /* free up suffieceint large areas to allow necessary nodes */
  { free(ptr2[a]);
    ptr=malloc(7);
    if(ptr) break;
    free(ptr);
  }
  fprintf(stderr,"did malloc size %d a %d\n",size,a);
}
