/* auxfunc.c- auxilery functions used by psas.c */
#include <stdio.h>
#define NOFUNCTIONS
#define ISPSAS
#include "genhead.h"
#include "pseudo.h"
#include "psas.h"
/*input file format:
* size ( OFUNC "name" type stksz predefsz ( len stf len stf ...) stuff )
* size ( OFUNC "name" type stksz predefsz ( len stf len stf ...) stuff )
* ...
* size (OPTEXTERN extcnt ("nm" type prepres [size stuff cnt (sect soff poff)])
*           strlen strstf cnt (sect soff poff))
*/

addconst(rpp,reg,cval) struct stack *rpp;
{ if(cval)
  { RAL(rpp->bops,rpp->blen+6,char);
    if(cval==1)
    { /* inc argreg
       * 40+reg */
      R1=0x40+reg;
    }
    else if(cval==-1)
    { /* dec argreg
       * 48+reg */
      R1=0x48+reg;
    }
    else if(cval<128&&cval>=-128)
    { /* add argreg,cval
       * 83 c0+reg cval */
      R1=0x83; R1=0xc0+reg; R1=cval;
    }
    else if(reg)
    { /* add argreg,cval
       * 81 c0+reg cval */
      R1=0x81; R1=0xc0+reg; RB1=cval; RBI1;
    }
    else
    { /* add eax,cval
       * 05 cval */
      R1=0x05; RB1=cval; RBI1;
    }
  }
}

leareg(rpp,flg) struct stack *rpp;
{ struct bld bo;
  int reg;
  reg=findreg(0,rpp->reguse,1,3,rpp->reguse,-1,-1,-1,-1);
  switch(rpp->place)
  { case PCMEMORY:
     /* mov reg,offset
      * b8+reg offset */
     bo=monoploadit(rpp,1,0);
     if(*bo.m.stf==0x05) /* just a 32bit offset */
     { RAL(rpp->bops,rpp->blen+bo.m.sz,char);
       R1=0xb8+reg;
       memcpy(rpp->bops+rpp->blen,bo.m.stf+1,bo.m.sz-1);
       rpp->blen+=bo.m.sz-1;
       xrfill(rpp,bo.m);
     }
     else /* on stack */
     { *bo.m.stf+=(reg<<3); addinstr(rpp,bo,0x8d); /* lea reg,[mem] */
     }
     rpp->reguse[reg].use=1;
    break;
    case PCLSTPOINT:
     addconst(rpp,rpp->argreg,rpp->boff);
     reg=rpp->argreg;
    break;
    default: fatal=1; yyerror("unknown place of result in leareg()");
  }
  if(flg)
  { rpp->argreg=reg;
    rpp->place=PCREG; rpp->tp=SPOINTER;
    rpp->boff=0;
  }
 return reg;
}

lexistaxmov(rpp,reg) struct stack *rpp;
{ int x;
  if(rpp->lexist&&rpp->lplace==PCLSTPOINT&&rpp->llprg==reg)
  { /* mov erg,eax
     * 89 c0+reg */
    x=rpp->llprg=findreg(0,rpp->reguse,0,0,rpp->reguse,reg,-1,-1,-1);
    rpp->reguse[x].use=1;
    RAL(rpp->bops,rpp->blen+2,char);
    rpp->bops[rpp->blen++]=0x89; rpp->bops[rpp->blen++]=0xc0+x+(reg<<3);
  }
}

char *tempname;
static FILE *tempfile;
static tempfileAL=0;

virtualmalloc(a)
{ if(block[a].virtualm&VMFREE)
  { AL(block[a].ops,block[a].len,char);
    fseek(tempfile,block[a].fileoff,0);
    fread(block[a].ops,1,block[a].len,tempfile);
    block[a].virtualm-=VMFREE;
  }
  block[a].virtualm|=VMINUSE;
}

virtualmfree(a)
{ block[a].virtualm&= ~VMINUSE;
  if(a>100) virtualmwrite(a);
}

virtualmwrite(a)
{ if(block[a].virtualm&VMFREE) return 1;
  if(!tempfileAL)
  { tempfile=fopen(tempname,"w+");
    if(!tempfile) { fatal=1; yyerror("Can't open temppsas file"); exit(-1); }
    tempfileAL=1;
  }
  if(!(block[a].virtualm&VMFILEAL))
  { fseek(tempfile,0,2);
    block[a].fileoff=ftell(tempfile);
    fwrite(block[a].ops,1,block[a].len,tempfile);
    fwrite("                     ",1,20,tempfile);
      /* space for growth of jmpsize */
  }
  else
  { fseek(tempfile,block[a].fileoff,0);
    fwrite(block[a].ops,1,block[a].len,tempfile);
  }
  free(block[a].ops);
  block[a].virtualm|=VMFILEAL+VMFREE;
 return 0;
}

virtualmdump(a)
{ block[a].virtualm=VMFILEAL+VMFREE;
}

static vscan,vlastblcnt= -5;

char *vmalloc(size)
{ char *out;
  if(blcnt!=vlastblcnt)
  { vscan=blcnt-2;
     vlastblcnt=blcnt;
  }
  do
  { out=malloc(size);
    if(out!=NULL) return out;
    while(vscan>=0&&virtualmfree(vscan--)) ;
    if(vscan<0) yyerror(ALmsg),exit(E_MEM);
  } while(1);
}

char *vrealloc(place,size) char *place;
{ char *out;
  if(blcnt!=vlastblcnt)
  { vscan=blcnt-2;
     vlastblcnt=blcnt;
  }
  do
  { out=realloc(place,size);
    if(out!=NULL) return out;
    while(vscan>=0&&virtualmfree(vscan--)) ;
    if(vscan<0) yyerror(RALmsg),exit(E_MEM);
  } while(1);
}

structalloc(size) int size;
{ static out;
  if(!structretsize)
  { RAL(exttbl,exttblsz+1,struct exttbl);
    exttbl[exttblsz].tp=SSTRUCT;
    exttbl[exttblsz].size=structretsize=1;
    exttbl[exttblsz].prepres=0;
    exttbl[exttblsz].scope=SCPEXTERN;
    Scp(&(exttbl[exttblsz].nm),"_dcc$structreturn");
    out= -1-exttblsz++;
  }
  if(size>structretsize) exttbl[-1-out].size=structretsize=size;
 return out;
}

allocmemcpy()
{ static out;
  if(!alreadyallocmemcpy)
  { RAL(exttbl,exttblsz+1,struct exttbl);
    exttbl[exttblsz].tp=SFUNC;
    exttbl[exttblsz].size=exttbl[exttblsz].prepres=0;
    exttbl[exttblsz].scope=SCPEXTERN;
    Scp(&(exttbl[exttblsz].nm),"memcpy");
    alreadyallocmemcpy=1;
    out= -1-exttblsz++;
  }
 return out;
}

alloc387rnd()
{ static out;
  if(!alreadyalloc387rnd)
  { RAL(exttbl,exttblsz+2,struct exttbl);
    AL(exttbl[exttblsz].pre,2,char);
    *(wordptr)(exttbl[exttblsz].pre)=0xf3f; exttbl[exttblsz].presz=2;
    exttbl[exttblsz].tp=SARRAY;
    exttbl[exttblsz].size=2; exttbl[exttblsz].prepres=1;
    exttbl[exttblsz].scope=SCPEXTERN;
    Scp(&(exttbl[exttblsz].nm),"_dcc387rnd_chop");
    exttblsz++;
    AL(exttbl[exttblsz].pre,2,char);
    *(wordptr)(exttbl[exttblsz].pre)=0x33f; exttbl[exttblsz].presz=2;
    exttbl[exttblsz].tp=SARRAY;
    exttbl[exttblsz].size=2; exttbl[exttblsz].prepres=1;
    exttbl[exttblsz].scope=SCPEXTERN;
    Scp(&(exttbl[exttblsz].nm),"_dcc387rnd_near");
    alreadyalloc387rnd=1;
    out= -1-exttblsz++;
  }
 return out;
}

movechar(rpp) struct stack *rpp;
/* make shure character is in register that can be made a byte e[a-d]x */
{ int x;
  if(rpp->argreg>=4)
  { x=findreg(0,rpp->reguse,0,0,rpp->reguse
      ,rpp->lexist&&rpp->lplace==PCLSTPOINT?rpp->llprg:-1,6,7,-1);
if(x<0||x>=4) { illegaltype("no char move"); }
    regloadit(rpp,rpp,rpp->place,rpp->argreg,0,x);
    rpp->reguse[x].use=1;
    rpp->argreg=x;
  }
}

mklexist(rpp) struct stack *rpp;
{ if(rpp->place==PCMEMORY||rpp->place==PCLSTPOINT)
  { rpp->lexist=1; rpp->lplace=rpp->place; rpp->ltp=rpp->tp;
    rpp->llprg=rpp->argreg;
    rpp->lboff=rpp->boff;
  }
}

genjcc(pos,swtched,neg,unsgn) /* generate proper jcc */
{ int x;
  x=opcode[pos];
  switch(x)
  { case OEQ:
     return neg?0x75/* jne */:0x74; /* je */
    break;
    case ONEQ:
     return neg?0x74/* je */:0x75; /* jne */
    break;
    case OTEST:
     return neg?0x74/* je */:0x75; /* jne */
    break;
    case OLT:
     if(neg)
      if(!unsgn) return swtched?0x7e/* jle */ :0x7d;/*jge */
      else return swtched?0x76 /* jbe */ :0x73; /* jae */
     else
      if(!unsgn) return swtched?0x7f /* jg */ :0x7c; /*jl */
      else return swtched?0x77 /* ja */ :0x72; /* jb */
    break;
    case OGT:
     if(neg)
      if(!unsgn) return swtched?0x7d/* jge */ :0x7e;/*jle */
      else return swtched?0x73 /* jae */ :0x76; /* jbe */
     else
      if(!unsgn) return swtched?0x7c/* jl */ :0x7f;/* jg */
      else return swtched?0x72 /* jb */ :0x77; /* ja */
    break;
    case OLE:
     if(neg)
      if(!unsgn) return swtched?0x7c/* jl */ :0x7f;/* jg */
      else return swtched?0x72 /* jb */ :0x77; /* ja */
     else
      if(!unsgn) return swtched?0x7d/* jge */ :0x7e;/*jle */
      else return swtched?0x73 /* jae */ :0x76; /* jbe */
    break;
    case OGE:
     if(neg)
      if(!unsgn) return swtched?0x7f /* jg */ :0x7c; /*jl */
      else return swtched?0x77 /* ja */ :0x72; /* jb */
     else
      if(!unsgn) return swtched?0x7e/* jle */ :0x7d;/*jge */
      else return swtched?0x76 /* jbe */ :0x73; /* jae */
  }
  illegaltype("shouldn't be here");
}

printrpn(rpn) struct stack *rpn;
{ int a;
  fprintf(stderr,"START: %d\n",rpn-rpnstk);
  fprintf(stderr,"lexst %d  place %d  lplace %d  hblkcnt %d lbcnt %d  tp %d\n"
   ,rpn->lexist,rpn->place,rpn->lplace,rpn->hblkcnt,rpn->lbcnt,rpn->tp);
  fprintf(stderr,"ltp %d rpnsln %d\n",rpn->ltp,rpnsln);
  fprintf(stderr,"argreg %d blen %d\n",rpn->argreg,rpn->blen);
  fprintf(stderr
   ,"bpxref %x exref %x bops %x hblk %x lbt %x\n"
   ,rpn->bpxref,rpn->exref,rpn->bops,rpn->hblk,rpn->lbt);
  for(a=0;a<rpn->hblkcnt;a++)
   fprintf(stderr
    ," hb %d bpxref %x exref %x bops %x lbt %x\n"
    ,a,rpn->hblk[a].bpxref
    ,rpn->hblk[a].exref,rpn->hblk[a].bops,rpn->hblk[a].lbt);
  fprintf(stderr,"END:loccnt %d loc %x\n",rpn->loccnt,rpn->loc);
}

initrpnstk()
{ int a;
  struct stack *rpn;
  if(rpnsln&&rpnstk[rpnsln-1].combineflg)
  { rpn=rpnstk+(rpnsln-1);
    rpn->boff=rpn->lexist=0;
    if(startncb)
    { if(rpn->ncbcnt)
      { RAL(rpn->ncb,rpn->ncbcnt+startncb,struct nestcombined); }
      else AL(rpn->ncb,rpn->ncbcnt+startncb,struct nestcombined);
      for(;startncb>0;startncb--)
      { rpn->ncb[rpn->ncbcnt].call=1;
        rpn->ncb[rpn->ncbcnt].hidn=0;
        rpn->ncb[rpn->ncbcnt].nbp=rpn->bpoff;
        rpn->ncb[rpn->ncbcnt++].off=rpn->blen;
      }
    }
  }
  else
  { rpn=rpnstk+rpnsln;
    rpn->place=rpn->sect=rpn->lexist=rpn->tp=rpn->maxfltlev=rpn->scoff
     =rpn->boff=rpn->blen=rpn->bpxcnt=rpn->maxoff=rpn->bpoff=rpn->size
     =rpn->combineflg=rpn->hblkcnt=rpn->lbcnt=rpn->loccnt=rpn->lbcnt
     =rpn->exrcnt=0;
    for(a=0;a<11;a++) rpn->reguse[a].use=0;
    if(startncb)
    { AL(rpn->ncb,startncb,struct nestcombined);
      for(a=0;a<startncb;a++)
      { rpn->ncb[a].call=1;
        rpn->ncb[a].nbp=rpn->ncb[a].hidn=rpn->ncb[a].off=0;
      }
    }
    rpn->ncbcnt=startncb;
    startncb=0;
    AL(rpn->exref,1,struct externxref);
    AL(rpn->bpxref,1,long);
  }
  rpn->gzf=rpn->gcsof=0;
}

typesize(n)
{ switch(rpnstk[rpnsln-n].tp%SUNSIGNED)
  { case SINT:     return soint;
    case SLONG:    return solong;
    case SDOUBLE:  return sodouble;
    case SFLOAT:   return sofloat;
    case SPOINTER: return sopoint;
    case SSTRUCT:  return rpnstk[rpnsln-n].size;
    case SSHORT:   return soshort;
    case SCHAR:    return sochar;
    case SFUNC:    break;
    default:
     sprintf(temp,"unknown type in typesize %d",rpnstk[rpnsln-n].tp);
     fatal=1; yyerror(temp);
  }
}

powof2(x) unsigned long x;
{ int pow=0;
  while (1)
  { if(x&1&&x>1) return(-1);
    if(!x) return pow-1;
    x>>=1; pow++;
  }
}

bopsload()
{ int a,b,c,x;
  struct stack *rpp;
  struct block *bk;
  struct hiddenblock *hbk;
  rpp=rpnstk+(rpnsln-1);
  if(rpnsln>1||startcomma) /*prob. comma operater, not related to CALL*/
  { if(!rpnsln||!startcomma) illegaltype("startcomma");
    startcomma--;
    rpp->combineflg=1; /* 0 bpoff */
    if(rpp->ncbcnt)
    { RAL(rpp->ncb,rpp->ncbcnt+1,struct nestcombined); }
    else AL(rpp->ncb,1,struct nestcombined);
    rpp->ncb[rpp->ncbcnt].hidn=rpp->ncb[rpp->ncbcnt].call=0;
    rpp->ncb[rpp->ncbcnt].nbp=rpp->bpoff;
    rpp->ncb[rpp->ncbcnt++].off=rpp->blen;
  }
  else
  { if(rpp->hblkcnt) { RAL(rpp->hblk,rpp->hblkcnt+1,struct hiddenblock); }
    else { AL(rpp->hblk,1,struct hiddenblock); }
    if(rpp->ncbcnt)
    { startncb+=rpp->ncbcnt; /* if 1st arg is ?:, bops will load it here */
      free(rpp->ncb);
    }
    hbk=rpp->hblk+rpp->hblkcnt; /* make end treatable the same */
    hbk->exrcnt=rpp->exrcnt;     hbk->exref=rpp->exref;
    hbk->bpxcnt=rpp->bpxcnt;     hbk->bpxref=rpp->bpxref;
    hbk->lbcnt=rpp->lbcnt;       hbk->lbt=rpp->lbt;
    hbk->blen=rpp->blen;         hbk->bops=rpp->bops;
    hbk=rpp->hblk;
    for(x=0;x<hbk->bpxcnt;x++)
      *(dwordptr)(hbk->bops+hbk->bpxref[x])-=spsmaxt;
    free(hbk->bpxref);
    RAL(exref,exrcnt+hbk->exrcnt,struct externxref);
    for(x=0;x<hbk->exrcnt;x++)
    { exref[exrcnt]=hbk->exref[x];
      exref[exrcnt].blck=blcnt-1; exref[exrcnt++].off+=blen;
    }
    free(hbk->exref);
    RAL(bops,blen+hbk->blen,char);
    memcpy(bops+blen,hbk->bops,hbk->blen);
    blen+=hbk->blen;
    free(hbk->bops);
    if(hbk->lbcnt)
    { for(a=0;a<hbk->lbcnt;a++)
      { b=hbk->lbt[a].block;
        if(b>=lbtbllen)
        { RAL(lbtbl,b+1,struct labels);
          while(b>=lbtbllen) lbtbl[lbtbllen++].here=0;
        }
        if(lbtbl[b].here)
        { fatal=1; sprintf(temp,"2 definitions of label number %d",b);
          yyerror(temp);
        }
        lbtbl[b].block=blcnt-1;
        lbtbl[b].off=hbk->lbt[a].off;
        lbtbl[b].here=1;
      }
      free(hbk->lbt);
    }
    RAL(block,blcnt+rpp->hblkcnt,struct block);
    bk=block+(blcnt-1);
    for(a=1,hbk=rpp->hblk;a<=rpp->hblkcnt;a++,blcnt++)
    { block[blcnt].outoff=bk->outoff+blen;
      bk->len=blen; bk->ops=bops; bk->virtualm=VMNEW;
      bk->jmppos=hbk->jmppos; bk->swtched=hbk->swtched; bk->unsgn=hbk->unsgn;
      bk->jmpsz=JSSMALL;
      hbk++; bk++;
      for(x=0;x<hbk->bpxcnt;x++)
        *(dwordptr)(hbk->bops+hbk->bpxref[x])-=spsmaxt;
      free(hbk->bpxref);
      RAL(exref,exrcnt+hbk->exrcnt,struct externxref);
      for(x=0;x<hbk->exrcnt;x++)
      { exref[exrcnt]=hbk->exref[x]; exref[exrcnt++].blck=blcnt; }
      free(hbk->exref);
      if(hbk->lbcnt)
      { for(c=0;c<hbk->lbcnt;c++)
        { b=hbk->lbt[c].block;
          if(b>=lbtbllen)
          { RAL(lbtbl,b+1,struct labels);
            while(b>=lbtbllen) lbtbl[lbtbllen++].here=0;
          }
          if(lbtbl[b].here)
          { fatal=1; sprintf(temp,"2 definitions of label number %d",b);
            yyerror(temp);
          }
          lbtbl[b].block=blcnt;
          lbtbl[b].off=hbk->lbt[c].off;
          lbtbl[b].here=1;
        }
        free(hbk->lbt);
      }
      blen=hbk->blen; bops=hbk->bops;
    }
    free(rpp->hblk);
    rpnsln--;
  }
}

struct memindx genmemin(indx,rp1p,rsto,sect,scoff,boff,lstpoint,bpoff)
/* rp1p-     highest priority
 * rsto-     argreg, a value like -1,8 does is an error
 * sect-     if memory, this specifies what type
 * scoff-    either offset from base or (for ext. table index)
 * boff-     offset from base of variable- used for struct.
 * lstpoint- if 0 then access register that pointer is stored in, not object
 * bpoff-    used for stack
 */
{ struct memindx out;
  long x;
  out.xexist=0; out.sz=1;
  switch(rp1p)
  { case PCMEMORY:
     switch(sect)   /* when consts include boff, it includes n */
     { case SCARG:
        /* [bp+consts] (offset+boff+6+x(other pushed registers)) */
        x=boff+scoff+36; /* room for ret addrs and pushed regs */
       goto bphandle;
       case SCAUTO:   /* [bp+consts]   (offset+boff) */
        x=boff+scoff-spsmaxt;
       bphandle:
        if(x<(-128)||x>127)
        { /* [bp+off16] */
          *out.stf=0x85;
          RBU(out.stf,out.sz)=x; out.sz+=4;
        }
        else
        { /* [bp+off8] */
          *out.stf=0x45;
          out.stf[out.sz++]=x;
        }
       break;
       case SCINTPUBLIC:
        x=boff;
        out.xexist=XREXTERN; out.xoff=1;
        out.scoff= -1-scoff; /* negaitive value is flag */
       goto cnsthandle;
       case SCPUBLIC: /* [consts] (boff only-off by link-put in xref table) */
        x=boff;
        out.xexist=XREXTERN; out.xoff=1;
        out.scoff=scoff;
       cnsthandle:
        *out.stf=0x05;
        RBU(out.stf,out.sz)=x; out.sz+=4;
       break;
       default: fatal=1; yyerror("unknown variable section in genmemin()");
     }
    break;
    case PCLSTPOINT:
     if(!lstpoint) goto registr;
     rsto=indx;
     if(boff)
     { /* es:[bx+consts] (boff) */
       if(boff>=(-128)&&boff<=127)
       { *out.stf=0x40+rsto;
         out.stf[out.sz++]=boff;
       }
       else
       { *out.stf=0x80+rsto;
         RBU(out.stf,out.sz)=boff; out.sz+=4;
       }
     }
     else
     { /* es:[rg] */
       *out.stf=rsto;
     }
    break;
    case PCSTACK:
     /* [bp+cnsts] (bpoff+boff) */
     *out.stf=0x85;
     RBU(out.stf,out.sz)=bpoff; out.sz+=4;
     out.xexist=XRSTACK; out.xoff=1;
    break;
    case PCREG:
    registr:
     /* RG
      * c0+reg(if off=2, use reguse[].reg) */
if(rsto<0||rsto>7)
{ illegaltype("rsto in genmem"); }
     *out.stf=0xc0+rsto;
    break;
    case PCMATH:
    default:
     fatal=1; yyerror("unknown position in genmemin()");
     fprintf(stderr,"  at rp1p %d\n",rp1p);
  }
 return out;
}

xrfill(rpn,emem) struct stack *rpn; struct memindx emem;
/* called after stf has been put on the stack */
{ long pos;
  pos=rpn->blen-emem.sz+emem.xoff;
  switch(emem.xexist)
  { case 0: break;  /* no xref */
    case XREXTERN:
     RAL(rpn->exref,rpn->exrcnt+1,struct externxref);
     rpn->exref[rpn->exrcnt].ptrfnc=0;
     rpn->exref[rpn->exrcnt].off=pos; /* blck blank till out of stck */
     rpn->exref[rpn->exrcnt++].scoff=emem.scoff;
    break;
    case XRSTACK:
     RAL(rpn->bpxref,rpn->bpxcnt+1,long);
     rpn->bpxref[rpn->bpxcnt++]=pos;
    break;
    default: fatal=1; yyerror("unknown type of extern in xrfill");
  }
}

struct bld binaryloadit(srcconst,dstmem,srcmem,swtchable,argtp,argreg
   ,lrgfld,nodxout,preserve,cmpjmp,preswitched,allowboff)
/* srcconsts- source can be constant
 * dstmem   - destination can be storage memory (this excludes near stacktop)
 * srcmem   - source can be memory (only for MATH and argrp 1st and EITHER)
 * swtchable- op a,b  become op b,a  for making memory src (!dst)?
 *             (only in argtp NONE)
 * argtp    - no reg restrict/1st/2nd/either restricted
 * argreg    - what above is restricted to
 * lrgfld   - if 1 then reg field of mod-r/m byte is left 0
 * nodxout  - (-1) to disable, 2 for disabling use of dx with argtp 1st
 * preserve - preserve rp1 LSTPOINT regs if existent
 * cmpjmp   - used to indicate that 2nd argument can be memory even while
 *             first is constant
 * allowboff- if 1 then boff can be non zero when PCREG && SPOINTER
 */
#define PD1LSTPT  1
#define PD2LSTPT  2
#define PD1LDIT   3
#define PD2LDIT   4
#define PDXCHG    5
#define PDCOMBINE 6
#define PDPRESLDIT 7
#define LSTPOINT1ST(pd,pdc,rut,noreg,norg2) \
  if(rp1p==PCLSTPOINT) \
  { if(rsto<0||rsto==(noreg)||rsto==(norg2)) \
      rsto=findreg(0,rut,0,0,rut,r2sto,(noreg),(norg2),-1); \
    if(rsto<0) illegaltype("LSTPOINT1ST"); \
    if(preserve) prsrvrsto=rsto; \
    rut[rsto].use=1; pd[pdc].prcd=PD1LSTPT; pd[pdc++].reg=rsto; }
#define LSTPOINT2ND(pd,pdc,rut,norg1,norg2) \
  if(rp2p==PCLSTPOINT) \
  { if(r2sto<0||r2sto==(norg1)||r2sto==(norg2)) \
      r2sto=findreg(0,rut,0,0,rut,rsto,(norg1),(norg2),prsrvrsto); \
    if(r2sto<0) illegaltype("LSTPOINT2ND"); \
    rut[r2sto].use=1; pd[pdc].prcd=PD2LSTPT; pd[pdc++].reg=r2sto; }
#define LDIT1ST(pd,pdc,rut,place) \
  if(rp1p!=PCREG||rsto!=place) \
  { rut[place].use=1; pd[pdc].prcd=PD1LDIT; pd[pdc++].reg=rsto=place; \
    rp1p=PCREG; }
#define LDIT2ND(pd,pdc,rut,place) \
  if(rp2p!=PCREG||r2sto!=place) \
  { rut[place].use=1; pd[pdc].prcd=PD2LDIT; pd[pdc++].reg=r2sto=place; \
    rp2p=PCREG; }
#define LDIT1STfind(pd,pdc,rut,norg1,norg2) \
  if(rp1p!=PCREG||rsto<0||rsto==norg1||rsto==norg2) \
  { rsto=findreg(0,rut,0,0,rut,r2sto,(norg1),(norg2),prsrvrsto); \
    if(rsto<0) illegaltype("LDIT1STfind"); \
    rut[rsto].use=1; pd[pdc].prcd=PD1LDIT; pd[pdc++].reg=rsto; rp1p=PCREG; }
#define LDIT2NDfind(pd,pdc,rut,norg1,norg2) \
  if(rp2p!=PCREG||r2sto<0||r2sto==norg1||r2sto==norg2) \
  { r2sto=findreg(0,rut,0,0,rut,rsto,(norg1),(norg2),prsrvrsto); \
    if(r2sto<0) illegaltype("LDIT2NDfind"); \
    rut[r2sto].use=1; pd[pdc].prcd=PD2LDIT; pd[pdc++].reg=r2sto; rp2p=PCREG; }
{ struct bld o;
  long ltmp,x;
  int fltlev,swfltlev,umath,ruse,swruse,r1lp,r2lp,rlpreg,r2lpreg;
  int noreg1st,noreg2nd;
  struct moveit
  { char prcd,reg; } swpd[16],pd[16],*p;
  int pc,r1lded,r2lded;
  int fwait,swpdc,pdc,ncnst1st,ncnst2nd,outplc,swoutplc,mem,swmem;
  int bpo1,bpo2,mbpo1,mbpo2,mxbpoff,swmxbpoff;
  int rp1p,rp2p,itmp,rp1orgplace,rp2orgplace;
  struct stack rpn,*rp1,*rp2;
  struct regusage rut[14],swrut[14];
  int orgprsrvrsto= -1,prsrvrsto;
  int rsto,r2sto,const,swconst;
  long cval,swcval;
  rp1=rpnstk+(rpnsln-2); /* 1st argument */
  rp2=rpnstk+(rpnsln-1); /* 2nd argument */
  rp1orgplace=rp1->place; rp2orgplace=rp2->place;
  if(rp1->place==PCREG&&!allowboff&&rp1->boff) monoploadit(rp1,0,0);
  if(rp2->place==PCREG&&!allowboff&&rp2->boff) monoploadit(rp2,0,0);
  if((preserve&&!dstmem)||(rp1->lexist&&preserve))
  { mklexist(rp1);
    if(!rp1->lexist)
    { fatal=1; yyerror("preserve non lexist?"); }
    if(rp1->lplace!=PCLSTPOINT) preserve=0;
    else if(rp1->place!=PCLSTPOINT)
    { orgprsrvrsto=rp1->llprg;
      dstmem=preserve=0;
    }
  }
  else preserve=0;
  umath
   =(rp1->tp==SFLOAT||rp1->tp==SDOUBLE);
  rp1p=rp1->place;
  rp2p=rp2->place;
  fwait=swpdc=pdc=0;
  if(umath)
  { if(!srcmem)
    { if(!dstmem) fltload(rp1);
      fltload(rp2);
    }
    else
    { if((rp1p!=PCMATH&&rp1p!=PCMEMORY&&rp1p!=PCLSTPOINT)||!swtchable)
        fltload(rp1);
      if(rp2p!=PCMATH&&rp2p!=PCMEMORY&&rp2p!=PCLSTPOINT) fltload(rp2);
    }
  }
  else
   if(rp1p==PCMATH||rp2p==PCMATH) illegaltype("binaryloadit non math in math");
  rp1p=rp1->place;
  rp2p=rp2->place;
  bpo1=rp1->bpoff;
  bpo2=rp2->bpoff;
  mbpo1=rp1->maxoff;
  mbpo2=rp2->maxoff;
  fltlev=swfltlev=rp1->maxfltlev>rp2->maxfltlev?rp1->maxfltlev:rp2->maxfltlev;
  for(ruse=x=0;x<11;x++)
  { ruse+=swrut[x].use=rut[x].use=(rp1->reguse[x].use||rp2->reguse[x].use); }
  /*NOTE: swtched is used to determine order when in math
   * order (mem,reg/reg,mem) is used when in 80386 */
  swruse=ruse;
  const=swconst=0;
  if(umath)
  {/*LASTPOINTs 1st and 2nd*/
    swmxbpoff=mxbpoff=rp1->maxoff;
    if(rp2->maxoff>mxbpoff) rp2->maxoff=mxbpoff;
    if(rp2->maxfltlev+1>fltlev) fltlev=rp2->maxfltlev+1;
    if(rp1->maxfltlev+1>swfltlev) swfltlev=rp1->maxfltlev+1;
    if(fltlev<1||swfltlev<1) illegaltype("fltlev");
    for(swruse=ruse=x=0;x<11;x++)
    { swruse+=swrut[x].use; ruse+=rut[x].use; }
/*IAM: reguse output/ maxbpoff/ and fltlev output */
  }
  else /*does not use math coprocessor*/
  { if(rp1p==PCSTACK) rsto= -1;
    else if(rp1p==PCREG||rp1p==PCLSTPOINT) rsto=rp1->argreg;
    else rsto=(-2);
    if(rp2p==PCSTACK) r2sto= -1;
    else if(rp2p==PCREG||rp2p==PCLSTPOINT) r2sto=rp2->argreg;
    else r2sto=(-2);
    /* -2 = not on stack or in register (probably MEMORY)
     * -1 = on the stack
     * 0-8= in this register
     */
if((rp1p==PCREG||rp1p==PCLSTPOINT)==(rsto<0))
{ fatal=1; yyerror("internal error binaryloadit"); }
    prsrvrsto=orgprsrvrsto;
    if(prsrvrsto>=0&&(rp2->reguse[prsrvrsto].use||prsrvrsto==nodxout
       ||argreg==prsrvrsto))
    { prsrvrsto=findreg(1,rp2->reguse,1,argreg,rp1->reguse
        ,argreg,nodxout,rsto,-1);
      pd[pdc].reg=prsrvrsto;
      pd[pdc++].prcd=PDPRESLDIT;
      if(rsto>=0) rut[rsto].use=1; /* place remains same */
      else bpo1-=4;
    }
    if(rsto>=0&&(rp2->reguse[rsto].use||prsrvrsto==rsto||((argtp==RG2ND
       ||preserve)&&argtp!=RGNONE&&argreg==rsto))) /* ADDITION*/
    { /* move out of the way;MERE:future just load it in good reg */
      rsto=findreg(1,rp2->reguse,1,argreg,rp1->reguse
         ,(argtp==RG2ND||preserve?argreg:-1),nodxout,prsrvrsto,-1);
      pd[pdc].reg=rsto;
      pd[pdc++].prcd=PD1LDIT;
      if(rsto>=0) rut[rsto].use=1; /* place remains same */
      else bpo1-=4;
    }
    pd[pdc++].prcd=PDCOMBINE;
    if(bpo1<mbpo1) mbpo1=bpo1;
    if(bpo2<mbpo2) mbpo2=bpo2;
    mxbpoff=mbpo1<mbpo2+bpo1?mbpo1:mbpo2+bpo1;
    ncnst1st=rp1p!=PCCONST||!srcconst||!swtchable;
    ncnst2nd=rp2p!=PCCONST||!srcconst;
    noreg1st=((rp1p==PCLSTPOINT||rp1p==PCMEMORY)&&swtchable&&srcmem)
        ||!ncnst1st||dstmem;
    noreg2nd=((rp2p==PCMEMORY||rp2p==PCLSTPOINT)&&srcmem)||!ncnst2nd;
    switch(argtp)
    { case RGEITHER:
       if(r2sto==argreg)
       { if(rp2p==PCLSTPOINT)
         { LSTPOINT2ND(pd,pdc,rut,-1,-1); /* leaves it in argreg */
           LDIT2ND(pd,pdc,rut,argreg);
         }
         else if(rp2p!=PCREG) { fatal=1; yyerror("unknown rp2p"); }
         outplc=2;
        goto ldit1st;
       }
       else if(rsto==argreg)
       { if(rp1p==PCLSTPOINT)
         { LSTPOINT1ST(pd,pdc,rut,-1,-1); /* leaves it in argreg */
           LDIT1ST(pd,pdc,rut,argreg);
         }
         else if(rp1p!=PCREG) { fatal=1; yyerror("unknown rp1p"); }
         outplc=1;
        goto ldit2nd;
       }
       else if(noreg2nd&&!dstmem)
       { LSTPOINT1ST(pd,pdc,rut,-1,-1);
         LDIT1ST(pd,pdc,rut,argreg);
         outplc=1;
        goto ldit2nd;
       }
       else
       { LSTPOINT2ND(pd,pdc,rut,-1,-1);
         LDIT2ND(pd,pdc,rut,argreg);
         outplc=2;
        goto ldit1st;
       }
      break;
      case RG1ST:
       /* load 2nd any., load 1st res.*/
       if(rp2p==PCREG&&r2sto==argreg&&rp1p==PCREG&&rsto>=0&&rsto!=nodxout)
        pd[pdc++].prcd=PDXCHG;
       else
       { if((!noreg2nd&&(rp2p!=PCREG||r2sto<0))
           ||(r2sto==argreg&&rp2p!=PCLSTPOINT))
         /* if (can't be non reg&&not in reg)
          *  or in the way and not to be moved with LSTPOINT */
         { LSTPOINT2ND(pd,pdc,rut,-1,argreg);
           LDIT2NDfind(pd,pdc,rut,nodxout,argreg);
         }
         else LSTPOINT2ND(pd,pdc,rut,nodxout,argreg);
         LSTPOINT1ST(pd,pdc,rut,-1,-1);
         LDIT1ST(pd,pdc,rut,argreg);
       }
       mem=2; outplc=1;
      break;
      case RG2ND:
       /* ready to use xchg if 1st in place 2nd needs to be & 2nd is a rg */
       if(rp1p==PCREG&&rsto==argreg&&rp2p==PCREG&&r2sto>=0&&r2sto!=nodxout)
         pd[pdc++].prcd=PDXCHG; /* currently immpossible */
       else
       { LSTPOINT2ND(pd,pdc,rut,-1,-1);
         LDIT2ND(pd,pdc,rut,argreg);
         outplc=1;
        goto ldit1st;
       }
       outplc=1; /* is this true? */
      break;
      case RGNONE:
       if(dstmem)
       { LSTPOINT2ND(pd,pdc,rut,-1,-1);
         if(ncnst2nd) { LDIT2NDfind(pd,pdc,rut,nodxout,-1); }
         LSTPOINT1ST(pd,pdc,rut,nodxout,-1);
         mem=1; outplc=2;
       }
       else if(noreg2nd&&(!cmpjmp||!noreg1st
         ||((rp1p==PCMEMORY||rp1p==PCLSTPOINT)&&rp2p==PCCONST)))
       { if(cmpjmp&&noreg1st&&((rp1p==PCMEMORY||rp1p==PCLSTPOINT)
           &&rp2p==PCCONST))
         { LSTPOINT1ST(pd,pdc,rut,nodxout,-1);
           outplc=2;
         }
         else
         { LSTPOINT1ST(pd,pdc,rut,-1,-1);
           LDIT1STfind(pd,pdc,rut,nodxout,-1);
           outplc=1;
         }
        goto ldit2nd;
       }
       else
       { if(cmpjmp&&noreg1st&&noreg2nd&&((rp2p==PCMEMORY||rp2p==PCLSTPOINT)
           &&rp1p==PCCONST))
         { LSTPOINT2ND(pd,pdc,rut,nodxout,-1);
           outplc=1;
         }
         else
         { LSTPOINT2ND(pd,pdc,rut,-1,-1);
           LDIT2NDfind(pd,pdc,rut,nodxout,-1);
           if(swtchable) outplc=2;
           else outplc=1;
         }
        goto ldit1st;
       }
      break;
      ldit1st:
       if(noreg1st&&(rp2p==PCREG||(cmpjmp&&(rp2p==PCCONST
         &&(rp1p==PCMEMORY||rp1p==PCLSTPOINT))||((rp2p==PCMEMORY
         ||rp2p==PCLSTPOINT)&&rp1p==PCCONST))))
       { LSTPOINT1ST(pd,pdc,rut,nodxout,-1);
         if(rp1p==PCMEMORY||rp1p==PCLSTPOINT) mem=1;
         else mem=2;
       }
       else
       { LSTPOINT1ST(pd,pdc,rut,-1,-1);
         LDIT1STfind(pd,pdc,rut,nodxout,-1);
         if(rp2p==PCCONST||argtp!=RGNONE) mem=1;
         else mem=2;
       }
      break;
      ldit2nd:
       if(noreg2nd&&(rp1p==PCREG||(cmpjmp&&(rp2p==PCCONST
         &&(rp1p==PCMEMORY||rp1p==PCLSTPOINT))||((rp2p==PCMEMORY
         ||rp2p==PCLSTPOINT)&&rp1p==PCCONST))))
       { LSTPOINT2ND(pd,pdc,rut,nodxout,prsrvrsto);
         if(rp2p==PCLSTPOINT||rp2p==PCMEMORY) mem=2;
         else mem=1;
       }
       else
       { LSTPOINT2ND(pd,pdc,rut,prsrvrsto,-1);
         LDIT2NDfind(pd,pdc,rut,nodxout,prsrvrsto);
         if(rp1p==PCCONST||argtp!=RGNONE) mem=2;
         else mem=1;
       }
      break;
      default: fatal=1; yyerror("unknown argtp in binaryloadit");
    }
    if(orgprsrvrsto>=0&&prsrvrsto<0)
    { prsrvrsto=findreg(0,rut,0,-1,rut,nodxout,rsto,r2sto,-1);
if(prsrvrsto<0) illegaltype("LDITPRES");
      rut[prsrvrsto].use=1;
      pd[pdc].prcd=PDPRESLDIT; pd[pdc++].reg=prsrvrsto;
    }
    if(rp1p==PCCONST) { const=1; cval=rp1->cval; }
    if(rp2p==PCCONST) { const=2; cval=rp2->cval; }
    if(rp2p==PCLSTPOINT||rp2p==PCMEMORY)
    { if(mem!=2) yyerror("mem warning 2");
      mem=2;
    }
    if(rp1p==PCLSTPOINT||rp1p==PCMEMORY)
    { if(mem!=1) yyerror("mem warning");
      mem=1;
    }
    rp1p=rp1->place;
    rp2p=rp2->place;
    bpo1=rp1->bpoff;
    bpo2=rp2->bpoff;
    mbpo1=rp1->maxoff;
    mbpo2=rp2->maxoff;
    for(ruse=x=0;x<9;x++)
    { ruse+=rut[x].use; }
    if(rp1p==PCSTACK) rsto=(-1);
    else if(rp1p==PCREG||rp1p==PCLSTPOINT) rsto=rp1->argreg;
    else rsto=(-2);
    if(rp2p==PCSTACK) r2sto=(-1);
    else if(rp2p==PCREG||rp2p==PCLSTPOINT) r2sto=rp2->argreg;
    else r2sto=(-2);
    /* -2 = not on stack or in register (probably MEMORY)
     * -1 = on the stack
     * 0-8= in this register
     */
    prsrvrsto=orgprsrvrsto;

    if(rsto>=0&&preserve&&argreg==rsto&&argtp==RG1ST) /* ADDITION */
    { /* move out of the way;MERE:future just load it in good reg */
      rsto=findreg(1,rp2->reguse,1,argreg,rp1->reguse
         ,(argtp==RG2ND||preserve?argreg:-1),nodxout,prsrvrsto,-1);
      swpd[swpdc].reg=rsto;
      swpd[swpdc++].prcd=PD1LDIT;
      if(rsto>=0) swrut[rsto].use=1; /* place remains same */
      else bpo1-=4;
    }

    if((r2sto>=0&&rp1->reguse[r2sto].use)||(argtp==RG1ST&&r2sto==argreg))
    { /* move out of the way */
      r2sto=findreg(1,rp1->reguse,1,argreg,rp2->reguse
        ,(argtp==RG1ST?argreg:-1),nodxout,prsrvrsto,-1);
      swpd[swpdc].reg=r2sto;
      swpd[swpdc++].prcd=PD2LDIT;
      if(r2sto>=0) swrut[r2sto].use=1; /* place remains same */
      else bpo2-=4;
    }
    swpd[swpdc++].prcd=PDCOMBINE;
    if(bpo1<mbpo1) mbpo1=bpo1;
    if(bpo2<mbpo2) mbpo2=bpo2;
    swmxbpoff=mbpo1<mbpo2+bpo1?mbpo1:mbpo2+bpo1;
    prsrvrsto= -1;
    switch(argtp)
    { case RGEITHER:
       if(r2sto==argreg)
       { if(rp2p==PCLSTPOINT)
         { LSTPOINT2ND(swpd,swpdc,swrut,-1,-1); /* leaves it in argreg */
           LDIT2ND(swpd,swpdc,swrut,argreg);
         }
         else if(rp2p!=PCREG) { fatal=1; yyerror("unknown rp2p"); }
         swoutplc=2;
        goto swldit1st;
       }
       else if(rsto==argreg)
       { if(rp1p==PCLSTPOINT)
         { LSTPOINT1ST(swpd,swpdc,swrut,-1,-1); /* leaves it in argreg */
           LDIT1ST(swpd,swpdc,swrut,argreg);
         }
         else if(rp1p!=PCREG) { fatal=1; yyerror("unknown rp1p"); }
         swoutplc=1;
        goto swldit2nd;
       }
       else if(noreg2nd&&!dstmem)
       { LSTPOINT1ST(swpd,swpdc,swrut,-1,-1);
         LDIT1ST(swpd,swpdc,swrut,argreg);
         swoutplc=1;
        goto swldit2nd;
       }
       else
       { LSTPOINT2ND(swpd,swpdc,swrut,-1,-1);
         LDIT2ND(swpd,swpdc,swrut,argreg);
         swoutplc=2;
        goto swldit1st;
       }
      break;
      case RG1ST:
       swoutplc=1;
       if(rp1p==PCREG&&r2sto==argreg&&rp2p==PCREG&&rsto>=0&&rsto!=nodxout)
         swpd[swpdc++].prcd=PDXCHG; /* currently immpossible */
       else
       { LSTPOINT1ST(swpd,swpdc,swrut,-1,-1);
         LDIT1ST(swpd,swpdc,swrut,argreg);
        goto swldit2nd;
       }
      break;
      case RG2ND:
       if(rp2p==PCREG&&rsto==argreg&&rp1p==PCREG&&r2sto>=0&&r2sto!=nodxout)
        swpd[swpdc++].prcd=PDXCHG;
       else
       { if((!noreg1st&&(rp1p!=PCREG||rsto<0))
           ||(rsto==argreg&&rp1p!=PCLSTPOINT))
         /* if (can't be non reg&&not in reg)
          *  or in the way and not to be moved with LSTPOINT */
         { LSTPOINT1ST(swpd,swpdc,swrut,argreg,-1);
           LDIT1STfind(swpd,swpdc,swrut,nodxout,argreg);
         }
         else LSTPOINT1ST(swpd,swpdc,swrut,nodxout,argreg);
         LSTPOINT2ND(swpd,swpdc,swrut,-1,-1);
         LDIT2ND(swpd,swpdc,swrut,argreg);
       }
       swmem=1; swoutplc=1;
      break;
      case RGNONE:
       if(dstmem)
       { LSTPOINT2ND(swpd,swpdc,swrut,-1,-1);
         if(rp2p!=PCCONST) { LDIT2NDfind(swpd,swpdc,swrut,nodxout,-1); }
         LSTPOINT1ST(swpd,swpdc,swrut,nodxout,-1);
         swmem=1; swoutplc=2;
       }
       else if(noreg2nd&&(!cmpjmp||!noreg1st
         ||((rp1p==PCMEMORY||rp1p==PCLSTPOINT)&&rp2p==PCCONST)))
       { if(cmpjmp&&noreg1st&&((rp1p==PCMEMORY||rp1p==PCLSTPOINT)
           &&rp2p==PCCONST))
         { LSTPOINT1ST(swpd,swpdc,swrut,nodxout,-1);
           swoutplc=2;
         }
         else
         { LSTPOINT1ST(swpd,swpdc,swrut,-1,-1);
           LDIT1STfind(swpd,swpdc,swrut,nodxout,-1);
           swoutplc=1;
         }
        goto swldit2nd;
       }
       else
       { if(cmpjmp&&noreg1st&&noreg2nd&&((rp2p==PCMEMORY||rp2p==PCLSTPOINT)
           &&rp1p==PCCONST))
         { LSTPOINT2ND(swpd,swpdc,swrut,nodxout,-1);
           swoutplc=1;
         }
         else
         { LSTPOINT2ND(swpd,swpdc,swrut,-1,-1);
           LDIT2NDfind(swpd,swpdc,swrut,nodxout,-1);
           if(swtchable) swoutplc=2;
           else swoutplc=1;
         }
        goto swldit1st;
       }
      break;
      swldit1st:
       if(noreg1st&&(rp2p==PCREG||(cmpjmp&&(rp2p==PCCONST
         &&(rp1p==PCMEMORY||rp1p==PCLSTPOINT))||((rp2p==PCMEMORY
         ||rp2p==PCLSTPOINT)&&rp1p==PCCONST))))
       { LSTPOINT1ST(swpd,swpdc,swrut,nodxout,-1);
         if(rp1p==PCLSTPOINT||rp1p==PCMEMORY) swmem=1;
         else swmem=2;
       }
       else
       { LSTPOINT1ST(swpd,swpdc,swrut,-1,-1);
         LDIT1STfind(swpd,swpdc,swrut,nodxout,-1);
         if(rp2p==PCCONST||argtp!=RGNONE) swmem=1;
         else swmem=2;
       }
      break;
      swldit2nd:
       if(noreg2nd&&(rp1p==PCREG||(cmpjmp&&(rp2p==PCCONST
         &&(rp1p==PCMEMORY||rp1p==PCLSTPOINT))
         ||((rp2p==PCMEMORY||rp2p==PCLSTPOINT)&&rp1p==PCCONST))))
       { LSTPOINT2ND(swpd,swpdc,swrut,nodxout,prsrvrsto);
         if(rp2p==PCLSTPOINT||rp2p==PCMEMORY) swmem=2;
         else swmem=1;
       }
       else
       { LSTPOINT2ND(swpd,swpdc,swrut,prsrvrsto,-1);
         LDIT2NDfind(swpd,swpdc,swrut,nodxout,prsrvrsto);
         if(rp1p==PCCONST||argtp!=RGNONE) swmem=2;
         else swmem=1;
       }
      break;
      default: fatal=1; yyerror("unknown argtp swbinaryloadit");
    }
    if(orgprsrvrsto>=0&&prsrvrsto==nodxout)
    { prsrvrsto=findreg(0,swrut,0,-1,swrut,nodxout,rsto,r2sto,-1);
if(prsrvrsto<0) illegaltype("LDITPRES");
      swrut[prsrvrsto].use=1;
      swpd[swpdc].prcd=PDPRESLDIT; swpd[swpdc++].reg=prsrvrsto;
    }
    if(rp2p==PCLSTPOINT||rp2p==PCMEMORY)
    { if(swmem!=2) yyerror("switch swmem warning 2");
      swmem=2;
    }
    if(rp1p==PCLSTPOINT||rp1p==PCMEMORY)
    { if(swmem!=1) yyerror("switch swmem warning");
      swmem=1;
    }
    if(rp1p==PCCONST) { swconst=1; swcval=rp1->cval; }
    if(rp2p==PCCONST) { swconst=2; swcval=rp2->cval; }
    for(swruse=x=0;x<9;x++) swruse+=swrut[x].use;
  }
  /* fltlev/ruse/mbpo */
  o.swtched=(umath&&(preserve||orgprsrvrsto>=0))||swfltlev<fltlev
    ||(swfltlev==fltlev&&(swruse<ruse||(swruse==swruse&&swmxbpoff>mxbpoff)));
/*MERE:future: don't always switch for preserve float*/
  if(o.swtched)
  { p=swpd; pc=swpdc; }
  else
  { p=pd; pc=pdc; }
  if(umath)
  {/*read in at least one/ unless already done?/ generate some of output*/
    o.dstmem=o.const=0;
    if(dstmem) o.swtched=1;
    if(o.swtched)
    {/* LOAD 2nd */
      if(preserve)
      { rp1->llprg=rp1->argreg;
      }
      if(rp2->place!=PCMATH) fltload(rp2);
      if(o.fltsrcmem=rp1->place!=PCMATH)
        o.m=genmemin(rp1->argreg,rp1p,rsto,rp1->sect,rp1->scoff,rp1->boff,1
          ,rp1->bpoff);
      o.tp=rp1->tp;
      rpn=(*rp2); *rp2=(*rp1); *rp1=rpn;
      ltmp=rp2->sect;   rp2->sect=rp1->sect;     rp1->sect=ltmp;
      ltmp=rp2->size;   rp2->size=rp1->size;     rp1->size=ltmp;
      ltmp=rp2->tp;     rp2->tp=rp1->tp;         rp1->tp=ltmp;
      ltmp=rp2->scoff;  rp2->scoff=rp1->scoff;   rp1->scoff=ltmp;
      ltmp=rp2->lexist; rp2->lexist=rp1->lexist; rp1->lexist=ltmp;
      ltmp=rp2->llprg;  rp2->llprg=rp1->llprg;   rp1->llprg=ltmp;
      ltmp=rp2->ltp;    rp2->ltp=rp1->ltp;       rp1->ltp=ltmp;
      ltmp=rp2->lplace; rp2->lplace=rp1->lplace; rp1->lplace=ltmp;
      ltmp=rp2->lboff;  rp2->lboff=rp1->lboff;   rp1->lboff=ltmp;
      ltmp=rp2->boff;   rp2->boff=rp1->boff;     rp1->boff=ltmp;
      ltmp=rp2->cval;   rp2->cval=rp1->cval;     rp1->cval=ltmp;
    }
    else
    {/* LOAD 1st */
      if(rp1->place!=PCMATH) fltload(rp1);
      if(o.fltsrcmem=rp2->place!=PCMATH)
        o.m=genmemin(rp2->argreg,rp2p,r2sto,rp2->sect,rp2->scoff,rp2->boff,1
          ,rp1->bpoff);
      o.tp=rp2->tp;
    }
    rp1->place=PCMATH;
    for(ltmp=0;ltmp<11;ltmp++) rp1->reguse[ltmp]=rut[ltmp];
    combinerpns(rp2,rp1,o.swtched); /* should be no preswtched here/save time*/
/*IAM:maxoff*/
  }
  else
  { o.dstmem=dstmem;
    rp1p=rp1->place;
    rp2p=rp2->place;
    if(rp1p==PCSTACK) rsto=(-1);
    else if(rp1p==PCREG||rp1p==PCLSTPOINT) rsto=rp1->argreg;
    else rsto=(-2);
    if(rp2p==PCSTACK) r2sto=(-1);
    else if(rp2p==PCREG||rp2p==PCLSTPOINT) r2sto=rp2->argreg;
    else r2sto=(-2);
    r1lded=r2lded=0;
    prsrvrsto=orgprsrvrsto;
    for(x=0;x<pc;x++)
    { switch(p[x].prcd)
      { case PD1LDIT:
         if(rp1p!=PCLSTPOINT) r1lded=1;
         switch(p[x].reg)
         { case -1:
            /* push exx
             * 50+rsto */
            RAL(rp1->bops,rp1->blen+1,char);
            rp1->bops[rp1->blen++]=0x50+rsto;
            rp1->bpoff-=4;
           break;
           default:
            /* mov ereg,exx
             * 89 c0+p[x].reg+(rsto<<3) */
            RAL(rp1->bops,rp1->blen+2,char);
            rp1->bops[rp1->blen++]=0x89;
            rp1->bops[rp1->blen++]=0xc0+(rsto<<3)+p[x].reg;
            if(rp1p!=PCREG&&rp1p!=PCLSTPOINT) rp1p=PCREG;
         }
         rsto=p[x].reg;
        break;
        case PD2LDIT:
         if(rp2p!=PCLSTPOINT) r2lded=1;
         switch(p[x].reg)
         { case -1:
            /* push exx
             * 50+r2sto */
            RAL(rp2->bops,rp2->blen+1,char);
            rp2->bops[rp2->blen++]=0x50+r2sto;
            rp2->bpoff-=4;
           break;
           default:
            /* mov ereg,exx
             * 89 c0+p[x].reg+(r2sto<<3) */
            RAL(rp2->bops,rp2->blen+2,char);
            rp2->bops[rp2->blen++]=0x89;
            rp2->bops[rp2->blen++]=0xc0+(r2sto<<3)+p[x].reg;
            if(rp2p!=PCREG&&rp2p!=PCLSTPOINT) rp2p=PCREG;
         }
         r2sto=p[x].reg;
        break;
        case PDCOMBINE:
         if(o.swtched)
         { rpn=(*rp2); *rp2=(*rp1); *rp1=rpn; /* MORE: what here? */
           ltmp=rp2->sect;   rp2->sect=rp1->sect;     rp1->sect=ltmp;
           ltmp=rp2->size;   rp2->size=rp1->size;     rp1->size=ltmp;
           ltmp=rp2->tp;     rp2->tp=rp1->tp;         rp1->tp=ltmp;
           ltmp=rp2->scoff;  rp2->scoff=rp1->scoff;   rp1->scoff=ltmp;
           ltmp=rp2->lexist; rp2->lexist=rp1->lexist; rp1->lexist=ltmp;
           ltmp=rp2->llprg;  rp2->llprg=rp1->llprg;   rp1->llprg=ltmp;
           ltmp=rp2->ltp;    rp2->ltp=rp1->ltp;       rp1->ltp=ltmp;
           ltmp=rp2->lplace; rp2->lplace=rp1->lplace; rp1->lplace=ltmp;
           ltmp=rp2->lboff;  rp2->lboff=rp1->lboff;   rp1->lboff=ltmp;
           ltmp=rp2->boff;   rp2->boff=rp1->boff;     rp1->boff=ltmp;
           ltmp=rp2->cval;   rp2->cval=rp1->cval;     rp1->cval=ltmp;
           for(ltmp=0;ltmp<11;ltmp++) rp1->reguse[ltmp]=swrut[ltmp];
         }
         else for(ltmp=0;ltmp<11;ltmp++) rp1->reguse[ltmp]=rut[ltmp];
         combinerpns(rp2,rp1,o.swtched^preswitched);
         if(fwait)
         { RAL(rp1->bops,rp1->blen+1,char);
           rp1->bops[rp1->blen++]=0x9b;
         }
        goto combined;
        case PDPRESLDIT:
         switch(p[x].reg)
         { case -1:
            /* push exx
             * 50+rsto */
            RAL(rp1->bops,rp1->blen+1,char);
            rp1->bops[rp1->blen++]=0x50+prsrvrsto;
            rp1->bpoff-=4;
           break;
           default:
            /* mov ereg,exx
             * 89 c0+p[x].reg+(rsto<<3) */
            RAL(rp1->bops,rp1->blen+2,char);
            rp1->bops[rp1->blen++]=0x89;
            rp1->bops[rp1->blen++]=0xc0+(prsrvrsto<<3)+p[x].reg;
            if(rp1p!=PCREG&&rp1p!=PCLSTPOINT) rp1p=PCREG;
         }
         rp1->llprg=prsrvrsto=p[x].reg;
        break;
        default:
         fatal=1; yyerror("illegal procedure");
      }
    }
    fatal=1; yyerror("not combined in binaryloadit");
   combined:
    for(r1lp=r2lp=1,x++;x<pc;x++)
    { switch(p[x].prcd)
      { case PD1LSTPT:
         if(rsto!=p[x].reg) regloadit(rp1,rp1,rp1p,rsto,1,p[x].reg);
         rp1->llprg=rlpreg=rsto=p[x].reg;
         r1lp=0;
        break;
        case PD2LSTPT:
/*fprintf(stderr,"p[%d].reg %d rp2p %d r2sto %d\n",x,p[x].reg,rp2p,r2sto);
*/
         if(r2sto!=p[x].reg) regloadit(rp1,rp2,rp2p,r2sto,1,p[x].reg);
         r2lpreg=r2sto=p[x].reg;
         r2lp=0;
        break;
        case PD1LDIT:
         rp1->argreg=rlpreg;
         regloadit(rp1,rp1,rp1p,rsto,r1lp,p[x].reg);
         rsto=p[x].reg;
         if(rp1p!=PCLSTPOINT||!r1lp) r1lded=1;
        break;
        case PD2LDIT:
         rp1->argreg=r2lpreg;
         regloadit(rp1,rp2,rp2p,r2sto,r2lp,p[x].reg);
         r2sto=p[x].reg;
         if(rp2p!=PCLSTPOINT||!r2lp) r2lded=1;
        break;
        case PDXCHG:
         /* xchg rsto,r2sto
          * 87 c0+rsto+(r2sto<<3) */
         RAL(rp1->bops,rp1->blen+2,char);
         rp1->bops[rp1->blen++]=0x87;
         rp1->bops[rp1->blen++]=0xc0+rsto+(r2sto<<3);
         itmp=rsto; rsto=r2sto; r2sto=itmp;
        break;
        case PDPRESLDIT:
         if(prsrvrsto!=p[x].reg) regloadit(rp1,rp1,rp1p,prsrvrsto,1,p[x].reg);
         rp1->llprg=prsrvrsto=p[x].reg;
        break;
        default:
         fatal=1; yyerror("illegal procedure");
      }
    }
    if(o.swtched)
    { o.const=const=swconst;
      o.cval=swcval;
      mem=swmem;
      outplc=swoutplc;
    }
    else
    { o.const=const;
      o.cval=cval;
    }
    if(nodxout>=0&&(r2sto==nodxout||rsto==nodxout))
      illegaltype("should not end up in nodxout");
    if(r1lded) rp1p=PCREG;
    if(r2lded) rp2p=PCREG;
    if(mem==1)
    { o.m=genmemin(rsto,rp1p,rsto,rp1->sect,rp1->scoff,rp1->boff,!r1lp
        ,rp1->bpoff);
      if(!const&&!lrgfld&&r2sto>=0) *o.m.stf+=(r2sto<<3);
    }
    else
    { if(mem!=2) { fatal=1; yyerror("internal error"); }
      o.m=genmemin(r2sto,rp2p,r2sto,rp2->sect,rp2->scoff,rp2->boff,!r2lp
        ,rp2->bpoff);
      if(!const&&!lrgfld&&rsto>=0) *o.m.stf+=(rsto<<3);
    }
if(rsto==r2sto&&rsto>=0)
{ fprintf(stderr,"r&r2= %d swtched %d preserve %d orgp %d pr %d dstmem %d\n"
,rsto,o.swtched,preserve,orgprsrvrsto,prsrvrsto,dstmem);
yyerror("trace r&r2");
}
    if(outplc==2)
    { rsto=r2sto; rp1p=rp2p;/* rp1orgplace=rp2orgplace;*/
      if(rp1p==PCCONST) rp1->cval=rp2->cval;
    }
    else if(outplc!=1) { fatal=1; yyerror("outplc err"); }
    rp1->argreg=rsto; /* should already be flagged used */
    rp1->place=rp1p;
    if(rp1->place==PCREG&&rp1orgplace!=PCREG) rp1->boff=0;
    /*if place is memory or lstpoint, must be dstmem, how dstmem comes*/
  }
  if(o.swtched) { if(rp1->maxoff>swmxbpoff) rp1->maxoff=swmxbpoff; }
  else if(rp1->maxoff>mxbpoff) rp1->maxoff=mxbpoff;
  if(!umath) o.swtched=mem-1;
  o.mem=mem!=outplc&&!dstmem;
  rp1->gzf=rp1->gcsof=0;
 return o;
}

fltload(rp1) struct stack *rp1;
{ int fop,pop=0,wait=0,popsz,regadd,out=0;
/*out not used. Why? */
  struct memindx m;
  if(rp1->place==PCMATH) return 0;
  if(rp1->maxfltlev<1) rp1->maxfltlev=1;
  switch(rp1->tp)
  { case SFLOAT:
     /* fld dw [something] */
     if(rp1->place==PCSTACK) goto reallydouble;
     fop=0xd9; regadd=0;
    break;
    case SDOUBLE:
    reallydouble:
     /* fld qw [something] */
     if(rp1->place==PCSTACK) { pop=1; popsz=8; }
     fop=0xdd; regadd=0;
    break;
    case SINT:
    case SLONG:
    case SPOINTER:
     if(rp1->place==PCREG) stkload(rp1);
     if(rp1->place==PCSTACK) { pop=1; popsz=4; }
     wait=1; fop=0xdb; regadd=0;
    break;
    case SINT+SUNSIGNED:
    case SLONG+SUNSIGNED:
     /* if stack monoploadit */
     /* push 0 */
     /* push it */
     if(rp1->place==PCSTACK) monoploadit(rp1,0,0);
     RAL(rp1->bops,rp1->blen+2,char);
     rp1->bops[rp1->blen++]=0x6a;
     rp1->bops[rp1->blen++]=0;
     rp1->bpoff-=4;
     stkload(rp1);
     pop=1; popsz=8;
     fop=0xdf; regadd=0x28;
    break;
    default: fatal=1; yyerror("unknown type in fltloadit");
  }
  if(rp1->bpoff<rp1->maxoff) rp1->maxoff=rp1->bpoff;
  if(rp1->maxfltlev<1) rp1->maxfltlev=1;
  m=genmemin(rp1->argreg,rp1->place,rp1->argreg,rp1->sect,rp1->scoff
    ,rp1->boff,1,rp1->bpoff);
  RAL(rp1->bops,rp1->blen+m.sz+1+4*pop,char);
  rp1->bops[rp1->blen++]=fop; /* some type of fld */
  *m.stf+=regadd;
  memcpy(rp1->bops+rp1->blen,m.stf,m.sz); rp1->blen+=m.sz;
  xrfill(rp1,m);
  if(pop||wait) rp1->bops[rp1->blen++]=0x9b; /* wait */
  if(pop)
  { rp1->bops[rp1->blen++]=0x83;
    rp1->bops[rp1->blen++]=0xc4;
    rp1->bops[rp1->blen++]=popsz;
    rp1->bpoff+=popsz;
  }
  rp1->place=PCMATH;
 return out;
}

stkload(rp1) struct stack *rp1;
/* load to stack */
{ struct bld bo;
  int reg;
  switch(rp1->place)
  { case PCREG:
     /* push rg
      * 50+rg */
     if(rp1->tp==SPOINTER&&rp1->boff) monoploadit(rp1,1,0);
     RAL(rp1->bops,rp1->blen+1,char);
     if(rp1->argreg<0) illegaltype("stkload 1");
     rp1->bops[rp1->blen++]=0x50+rp1->argreg;
     rp1->place=PCSTACK;
     rp1->bpoff-=4;
    return 0;
    case PCCONST:
     if(rp1->tp==SDOUBLE) goto lastpointmath; /*constant double*/
     /* push ##
      * 68 ## */
     RAL(rp1->bops,rp1->blen+5,char);
     if(rp1->cval<128&&rp1->cval>=-128)
     { rp1->bops[rp1->blen++]=0x6a; rp1->bops[rp1->blen++]=rp1->cval; }
     else
     { rp1->bops[rp1->blen++]=0x68;
       *(dwordptr)(rp1->bops+rp1->blen)=rp1->cval; rp1->blen+=4;
     }
     rp1->place=PCSTACK;
     rp1->bpoff-=4;
    case PCSTACK:
    return 0;
    case PCLSTPOINT:
    case PCMEMORY:
     monoploadit(rp1,1,0);
     switch(rp1->tp%SUNSIGNED)
     { case SFLOAT: /* non-portable, same size */
fprintf(stderr,"warning size float stuff\n");
       case SINT:
       case SLONG:
       case SPOINTER:
        /* push arg
         * ff mem+6*/
        bo.m=genmemin(rp1->argreg,rp1->place,rp1->argreg,rp1->sect,rp1->scoff
          ,rp1->boff,1,rp1->bpoff);
        *bo.m.stf+=0x30;
        addinstr(rp1,bo,0xff);
        rp1->place=PCSTACK;
        rp1->bpoff-=4;
       return 0;
       case SDOUBLE:
       lastpointmath:
        fltload(rp1);
       goto atmath;
       case SSTRUCT:
        /* lea ebx,place
         * sub esp,size
         * push size
         * push ebx
         * lea ebx,[esp+8]
         * push ebx
         * call memcpy
         * add esp,0c
         * ebxstuff 83|81 ec size 6a|68 size 53 8d 5c 24 8 53 e8 memcpy
         * 83 c4 c */
        reg=leareg(rp1,0);

        RAL(rp1->bops,rp1->blen+25,char);
        if(rp1->size<128&&rp1->size>=-128)
        { rp1->bops[rp1->blen++]=0x83;      rp1->bops[rp1->blen++]=0xec;
          rp1->bops[rp1->blen++]=rp1->size; rp1->bops[rp1->blen++]=0x6a;
          rp1->bops[rp1->blen++]=rp1->size;
        }
        else
        { rp1->bops[rp1->blen++]=0x81; rp1->bops[rp1->blen++]=0xec;
          (*(dwordptr)(rp1->bops+rp1->blen))=rp1->size; rp1->blen+=4;
          rp1->bops[rp1->blen++]=0x68;
          (*(dwordptr)(rp1->bops+rp1->blen))=rp1->size; rp1->blen+=4;
        }
        rp1->bops[rp1->blen++]=0x50+reg; rp1->bops[rp1->blen++]=0x8d;
        rp1->bops[rp1->blen++]=0x44+(reg<<3);
        rp1->bops[rp1->blen++]=0x24;
        rp1->bops[rp1->blen++]=0x08; rp1->bops[rp1->blen++]=0x50+reg;

        rp1->bops[rp1->blen++]=0xe8;
        RAL(rp1->exref,1+rp1->exrcnt,struct externxref);
        rp1->exref[rp1->exrcnt].ptrfnc=0;
        rp1->exref[rp1->exrcnt].off=rp1->blen;
        rp1->exref[rp1->exrcnt++].scoff=allocmemcpy();
        rp1->reguse[3].use=1; /* ebx from memcpy return */
        (*(dwordptr)(rp1->bops+rp1->blen))=0x0; rp1->blen+=4;
        rp1->bops[rp1->blen++]=0x83; rp1->bops[rp1->blen++]=0xc4;
        rp1->bops[rp1->blen++]=0xc;
        rp1->place=PCSTACK; rp1->bpoff-=rp1->size;
       break;
       default: fatal=1; yyerror("don't support loading weird types on stack");
     }
    break;
    case PCMATH:
    atmath:
     switch(rp1->tp)
     { case SFLOAT:
       case SDOUBLE:
        /* sub sp,8
         * fstp qw [bp+]
         * 83 ec 8 dd 9d bpoff*/
        RAL(rp1->bops,rp1->blen+9,char);
        RAL(rp1->bpxref,rp1->bpxcnt+1,long);
        *(wordptr)(rp1->bops+rp1->blen)=0xec83; rp1->blen+=2;
        *(wordptr)(rp1->bops+rp1->blen)=0xdd08; rp1->blen+=2;
        rp1->bops[rp1->blen++]=0x9d;
        rp1->bpoff-=8;
        rp1->bpxref[rp1->bpxcnt++]=rp1->blen;
        *(dwordptr)(rp1->bops+rp1->blen)=rp1->bpoff; rp1->blen+=4;
       return 1;
       default: fatal=1; yyerror("unknown type in stkload");
     }
    break;
    default: yyerror("unknown place in stkloadit");
  }
}

regloadit(rp1,rp2,rp1p,rsto,r1lp,reg) struct stack *rp1,*rp2;
/* rp1-  access rp1 structures, bops, bpoff, and argreg for LSTPOINT
 * rp2-  speccifies sect,scoff,boff,cval
 * rp1p- rp1->place as would be now if kept up
 * rsto- rp1->argreg, or -1 if place is stack
 * r1lp- if 1, then access register of pointer, else object pointed to
 * reg-  register to load it into
 */
{ struct memindx m;
  if(reg<0||reg>8) { fatal=1; yyerror("illegal register loading"); }
  if(rp1p==PCCONST)
  { RAL(rp1->bops,rp1->blen+5,char);
    if(reg>7) { fatal=1; yyerror("cannot load constant into segment regs"); }
    if(rp2->cval)
    { /* mov xx,const
       * b8+rg const */
      rp1->bops[rp1->blen++]=0xb8+reg;
      *(dwordptr)(rp1->bops+rp1->blen)=rp2->cval; rp1->blen+=4;
    }
    else
    { /* xor reg,reg
       * 31 c0+reg+(reg<<3) */
      rp1->bops[rp1->blen++]=0x31; rp1->bops[rp1->blen++]=0xc0+reg+(reg<<3);
    }
  }
  else if(rsto==-1||rp1p==PCSTACK)
  { /* pop reg
     * 0x58+reg */
    RAL(rp1->bops,rp1->blen+1,char);
    rp1->bops[rp1->blen++]=reg==8?0x7:0x58+reg;
    rp1->bpoff+=4;
  }
  else
  { m=genmemin(rp1->argreg,rp1p,rsto,rp2->sect,rp2->scoff,rp2->boff,!r1lp
      ,rp1->bpoff);
    /* mov reg,xx
     * 8b c0+reg */
    RAL(rp1->bops,rp1->blen+2+m.sz,char);
    rp1->bops[rp1->blen++]=0x8b;
    *m.stf+=reg<<3;
    memcpy(rp1->bops+rp1->blen,m.stf,m.sz);
    rp1->blen+=m.sz;
    xrfill(rp1,m);
  }
}
findreg(urgu,rgu,atp,arg,rgi,notr,notr2,notr3,notr4)
 struct regusage *rgi,*rgu;
/* urgu - should I even consider below?
 * rgu  - don't use anything here
 * rgi  - any used here are prefered for use to minimize reg usage
 * notr - can't use this register
 * atp  - 0- no limit, 1- use arg if possible
 * arg  - see above
 */
{ int good=(-1);
  switch(atp)
  { case 1:
     if((urgu&&rgu[arg].use)||arg==notr||arg==notr2||arg==notr3||arg==notr4)
       goto anything;
     good=arg;
    break;
    case 0:
    anything:
     for(good=0;good<8;good++)
      if(good!=4&&good!=5&&good!=notr3&&good!=notr&&good!=notr2&&good!=notr4
        &&rgi[good].use&&!(urgu&&rgu[good].use))
       goto end;
     for(good=0;good<8;good++)
      if(good!=4&&good!=5&&good!=notr3&&good!=notr&&good!=notr2&&good!=notr4
        &&(!(urgu&&rgu[good].use)))
       goto end;
     good=(-1);
    break;
    default: fatal=1; yyerror("unknown atp in findreg");
  }
 end:
if(good<0)
yyerror("at -1");
 return good;
}

struct bld monoploadit(rp1,lstpnt,allowboff) struct stack *rp1;
/*monop- load rp1;   lstpnt==1 indicates that operand are ready to access,
 * allowboff=1 if boff can be non-zero when PCREG && SPOINTER
 * but not loaded (usefull for pointers accesing a func, for example
 */
{ int rsto,dblwo;
  struct bld o;
  rp1->gzf=rp1->gcsof=0;
  if(rp1->tp==SFLOAT||rp1->tp==SDOUBLE)
  { if(rp1->place==PCMATH) return o;
    if(!lstpnt)
    { monoploadit(rp1,1,0);
      fltload(rp1);
     return o;
    }
  }
  rsto=findreg(0,rp1->reguse,0,0,rp1->reguse
     ,rp1->place==PCLSTPOINT?rp1->argreg:-1,-1,-1,-1);
/*MERE: future: only exclude argreg if lexist needed.*/
  switch(rp1->place)
  { case PCLSTPOINT:
     /* prepare for access */
     rp1->reguse[rp1->argreg].use=1;
    case PCMEMORY:
     if(lstpnt) break;
     mklexist(rp1);
    case PCSTACK:
     if(lstpnt) break;/*lstpnt also used in convert to insure access possible*/
    case PCCONST:
     if(rp1->tp==SFLOAT||rp1->tp==SDOUBLE) break;
       /* from call to handle point */
    loadit:
     regloadit(rp1,rp1,rp1->place,rp1->argreg,0,rsto);
     rp1->reguse[rsto].use=1; rp1->argreg=rsto;
     rp1->boff=0;
     rp1->place=PCREG;
    break;
    case PCREG:
     if(!allowboff&&rp1->boff)
     {
if(rp1->tp!=SPOINTER) { fatal=1; yyerror("allowboff type error");
fprintf(stderr,"type %d boff %d\n",rp1->tp,rp1->boff);
}
       if(rp1->boff<=127&&rp1->boff>-128)
       { /* add reg,boff
          * 83 c0+reg boff */
         RAL(rp1->bops,rp1->blen+3,char);
         rp1->bops[rp1->blen++]=0x83; rp1->bops[rp1->blen++]=0xc0+rp1->argreg;
         rp1->bops[rp1->blen++]=rp1->boff;
       }
       else
       { if(!rp1->argreg)
         { /* add eax,boff
            * 5 boff */
           RAL(rp1->bops,rp1->blen+5,char);
           rp1->bops[rp1->blen++]=5;
           *(dwordptr)(rp1->bops+rp1->blen)=rp1->boff; rp1->blen+=4;
         }
         else
         { /* add reg,boff
            * 81 c0+reg boff */
           RAL(rp1->bops,rp1->blen+6,char);
           rp1->bops[rp1->blen++]=0x81;
           rp1->bops[rp1->blen++]=0xc0+rp1->argreg;
           *(dwordptr)(rp1->bops+rp1->blen)=rp1->boff; rp1->blen+=4;
         }
       }
       rp1->boff=0;
     }
    break;
    default: fatal=1; yyerror("unknown place in monoploadit");
  }
  o.m=genmemin(rp1->argreg,rp1->place,rp1->argreg,rp1->sect,rp1->scoff,rp1->boff
    ,1,rp1->bpoff);
 return o;
}

addinstr(rpp,bo,op) struct stack *rpp; struct bld bo;
{ RAL(rpp->bops,rpp->blen+bo.m.sz+1,char);
  R1=op;
  memcpy(rpp->bops+rpp->blen,bo.m.stf,bo.m.sz);
  rpp->blen+=bo.m.sz;
  xrfill(rpp,bo);
}

addcinstr(rpp,bo,op) struct stack *rpp; struct bld bo;
{ *bo.m.stf+=(op<<3); /* work with call to cut out bits */
  if(bo.cval>127||bo.cval<-128)
  { if(*bo.m.stf&0xc7==0xc0&&bo.m.sz==1) /* if register EAX, save byte */
    { RAL(rpp->bops,rpp->blen+5,char);
      R1=0x5+(op<<3);
      RB1=bo.cval; RBI1;
    }
    else
    { addinstr(rpp,bo,0x81);
      RAL(rpp->bops,rpp->blen+4,char);
      RB1=bo.cval; RBI1;
    }
  }
  else
  { if((*bo.m.stf&0xc0)!=0xc0) op= -1; /* just a flag */
    switch(op)
    { case 0: /* add */
       addconst(rpp,*bo.m.stf&7,bo.cval);
      break;
      case 0x5: /* sub */
       addconst(rpp,*bo.m.stf&7,-bo.cval);
      break;
      default:
       addinstr(rpp,bo,0x83);
       RAL(rpp->bops,rpp->blen+1,char);
       R1=bo.cval;
    }
  }
}

combinerpns(rp1,rp2,swtched) struct stack *rp1,*rp2;
/* use with
 * rp2 op rp1;
 * if swtched, need to adjust hblocks
 */
{ int start1,a;
  if(!swtched)
  { /* 2 hblcks
     * 2 main [joined to 1st hblck(if exist) or main]
     * 1 hblck
     * 1 main
     */
    start1=0;
  }
  else
  { int cuthb;
    /* 1 hblcks before mark (if exist)
     * 2 hblcks
     * 2 main [joined to 1st hblck(if exist) or main
     * 1 hblcks after mark
     * 1 main
     */
    /* find cut-off if existent (if non-exist; cut-off=0) */
    cuthb=rp1->ncbcnt?rp1->hblkcnt-rp1->ncb[rp1->ncbcnt-1].hidn:0;
    for(a=rp1->hblkcnt-1;a>=cuthb&&a>=0;a--)
      if(rp1->hblk[a].cntnusrch) break;
    if(a>=0)
    { start1=a+1;
      /*mv lab at beginning of (1 hblcks after) to beginning of 2 hblcks */
      if(start1<rp1->hblkcnt&&rp1->hblk[start1].lbcnt)
      { for(a=0;a<rp1->hblk[start1].lbcnt;a++)
          if(rp1->hblk[start1].lbt[a].off) { fatal=1; yyerror("hlabels"); }
        if(rp2->hblkcnt)
        { if(!rp2->hblk->lbcnt)
          { rp2->hblk->lbt=rp1->hblk[start1].lbt;
            rp2->hblk->lbcnt=rp1->hblk[start1].lbcnt;
          }
          else
          { RAL(rp2->hblk->lbt,rp2->hblk->lbcnt+rp1->hblk->lbcnt
              ,struct labels);
            memmove((char *)(rp2->hblk->lbt+rp2->hblk->lbcnt)
              ,rp2->hblk->lbt,rp1->hblk[start1].lbcnt*sizeof(struct labels));
            memcpy(rp2->hblk->lbt,rp1->hblk[start1].lbt
              ,rp1->hblk[start1].lbcnt*sizeof(struct labels));
            rp2->hblk->lbcnt+=rp1->hblk[start1].lbcnt;
            free(rp1->hblk[start1].lbt);
          }
          rp1->hblk[start1].lbcnt=0;
        }
        else
        {/*MERE maybe done: put it in rp2's main labxref*/
          if(!rp2->lbcnt)
          { rp2->lbcnt=rp1->hblk[start1].lbcnt;
            rp2->lbt=rp1->hblk[start1].lbt;
          }
          else
          { RAL(rp2->lbt,rp2->lbcnt+rp1->hblk->lbcnt
              ,struct labels);
            memmove((char *)(rp2->lbt+rp2->lbcnt)
              ,rp2->lbt,rp1->hblk[start1].lbcnt*sizeof(struct labels));
            memcpy(rp2->lbt,rp1->hblk[start1].lbt
              ,rp1->hblk[start1].lbcnt*sizeof(struct labels));
            rp2->lbcnt+=rp1->hblk[start1].lbcnt;
            free(rp1->hblk[start1].lbt);
          }
          rp1->hblk[start1].lbcnt=0;
/*fatal=1; yyerror("not implemented in combinexrefs");
*/
        }
      }
      /* insert (1 hblks before) to beginning of 2 hblcks */
      if(rp2->hblkcnt)
      { RAL(rp2->hblk,rp2->hblkcnt+start1,struct hiddenblock); }
      else AL(rp2->hblk,rp2->hblkcnt+start1,struct hiddenblock);
      memmove((char *)(rp2->hblk+start1),rp2->hblk
        ,rp2->hblkcnt*sizeof(struct hiddenblock));
      memcpy(rp2->hblk,rp1->hblk,start1*sizeof(struct hiddenblock));
      rp2->hblkcnt+=start1;
    }
    else start1=0;
/*put 1hblocks before 2hblocks&&start0 inc && label move*/
  }
  /* 2 hblocks already here */
  if(start1>=rp1->hblkcnt)
  { /* join 2 main to 1 main &&xrefs*/
    /* 1 main */
    /*combine ncbs: everything split as follows:(ignore those flaged hidden)
     *  use highest ncb.  if its hidden, all should be.
     *  rp1's table of ncb just tacked on end of rp2's
     *  xrefs need to take into account above.
     * rp1 before
     * rp2
     * rp1 after
     */
    long *bpx,cut;
    int nbp;
    struct externxref *exr;
    if((rp1->ncbcnt&&!swtched)||(swtched&&rp2->ncbcnt))
      illegaltype("combine ncb swtched last");
    if(rp1->ncbcnt&&!rp1->ncb[rp1->ncbcnt-1].hidn)
    { cut=rp1->ncb[rp1->ncbcnt-1].off;
      nbp=rp1->ncb[rp1->ncbcnt-1].nbp;
    }
    else nbp=cut=0;
    if(cut)
     for(bpx=rp2->bpxref,a=0;a<rp2->bpxcnt;a++,bpx++)
     { *(dwordptr)(rp2->bops+*bpx)+=nbp;
       *bpx+=cut;
     }
    RAL(rp2->bpxref,rp2->bpxcnt+rp1->bpxcnt,long);
/*exrefs of all types may get out of order */
    for(bpx=rp1->bpxref,a=0;a<rp1->bpxcnt;a++,bpx++)
    { if(*bpx>=cut) *(dwordptr)(rp1->bops+*bpx)+=rp2->bpoff;
      rp2->bpxref[rp2->bpxcnt++]=(*bpx)+(*bpx>=cut?rp2->blen:0);
    }
    free(rp1->bpxref);
    if(cut) for(exr=rp2->exref,a=0;a<rp2->exrcnt;a++,exr++) exr->off+=cut;
    RAL(rp2->exref,rp2->exrcnt+rp1->exrcnt,struct externxref);
    for(exr=rp1->exref,a=0;a<rp1->exrcnt;a++,exr++)
    { if(exr->off>=cut) exr->off+=rp2->blen;
      rp2->exref[rp2->exrcnt++]=(*exr);
    }
    free(rp1->exref);
    if(rp2->lbcnt)
    { RAL(rp2->lbt,rp2->lbcnt+rp1->lbcnt,struct labels);
      if(cut) for(a=0;a<rp2->lbcnt;a++) rp2->lbt[a].off+=cut;
      for(a=0;a<rp1->lbcnt;a++)
      { if(rp1->lbt[a].off>=cut) rp1->lbt[a].off+=rp2->blen;
        rp2->lbt[rp2->lbcnt++]=rp1->lbt[a];
      }
      if(rp1->lbcnt) free(rp1->lbt);
    }
    else
    { for(a=0;a<rp1->lbcnt;a++)
        if(rp1->lbt[a].off>=cut) rp1->lbt[a].off+=rp2->blen;
      rp2->lbt=rp1->lbt; rp2->lbcnt=rp1->lbcnt;
    }
    RAL(rp2->bops,rp2->blen+rp1->blen,char);
    if(cut) memmove(rp2->bops+cut,rp2->bops,rp2->blen);
    memcpy(rp2->bops,rp1->bops,cut);
    memcpy(rp2->bops+rp2->blen+cut,rp1->bops+cut,rp1->blen-cut);
    rp2->blen+=rp1->blen;
    free(rp1->bops);
    if(rp1->ncbcnt)
    { RAL(rp1->ncb,rp1->ncbcnt+rp2->ncbcnt,struct nestcombined);
      for(a=0;a<rp2->ncbcnt;a++)
      { rp2->ncb[a].off+=cut;
        rp2->ncb[a].nbp+=nbp;
        if(rp2->ncb[a].hidn) illegaltype("not handle hidden here1");
        rp1->ncb[rp1->ncbcnt++]=rp2->ncb[a];
      }
      if(rp2->ncbcnt) free(rp2->ncb);
      rp2->ncbcnt=rp1->ncbcnt; rp2->ncb=rp1->ncb;
    } /*else nothing*/
  }
  else
  { /* join 2 main to 1 hblk[start1] &&xrefs*/
    /* remaining hblocks already there? */
    long *bpx,cut;
    int nbp;
    struct externxref *exr;
    struct hiddenblock *hbk;
    if((rp1->ncbcnt&&!swtched)||(swtched&&rp2->ncbcnt))
      illegaltype("combine ncb swtched last");
    if(rp1->ncbcnt&&rp1->hblkcnt-rp1->ncb[rp1->ncbcnt-1].hidn==start1)
    { cut=rp1->ncb[rp1->ncbcnt-1].off;
      nbp=rp1->ncb[rp1->ncbcnt-1].nbp;
    }
    else nbp=cut=0;
    hbk=rp1->hblk+start1;
    if(cut)
     for(bpx=rp2->bpxref,a=0;a<rp2->bpxcnt;a++,bpx++)
     { *(dwordptr)(rp2->bops+*bpx)+=nbp;
       *bpx+=cut;
     }
    RAL(rp2->bpxref,rp2->bpxcnt+hbk->bpxcnt,long);
    for(bpx=hbk->bpxref,a=0;a<hbk->bpxcnt;a++,bpx++)
    { if(*bpx>=cut) *(dwordptr)(hbk->bops+*bpx)+=rp2->bpoff;
      rp2->bpxref[rp2->bpxcnt++]=(*bpx)+(*bpx>=cut?rp2->blen:0);
    }
    free(hbk->bpxref);
    if(cut) for(exr=rp2->exref,a=0;a<rp2->exrcnt;a++,exr++) exr->off+=cut;
    RAL(rp2->exref,rp2->exrcnt+hbk->exrcnt,struct externxref);
    for(exr=hbk->exref,a=0;a<hbk->exrcnt;a++,exr++)
    { if(exr->off>=cut) exr->off+=rp2->blen;
      rp2->exref[rp2->exrcnt++]=(*exr);
    }
    free(hbk->exref);
    if(rp2->lbcnt)
    { RAL(rp2->lbt,rp2->lbcnt+hbk->lbcnt,struct labels);
      for(a=0;a<hbk->lbcnt;a++)
      { if(hbk->lbt[a].off>=cut) hbk->lbt[a].off+=rp2->blen;
        rp2->lbt[rp2->lbcnt++]=hbk->lbt[a];
      }
      if(hbk->lbcnt) free(hbk->lbt);
    }
    else
    { for(a=0;a<hbk->lbcnt;a++)
        if(hbk->lbt[a].off>=cut) hbk->lbt[a].off+=rp2->blen;
      rp2->lbt=hbk->lbt; rp2->lbcnt=hbk->lbcnt;
    }
    RAL(rp2->bops,rp2->blen+hbk->blen,char);
    if(cut) memmove(rp2->bops+cut,rp2->bops,rp2->blen);
    memcpy(rp2->bops,hbk->bops,cut);
    memcpy(rp2->bops+rp2->blen+cut,hbk->bops+cut,hbk->blen-cut);
    rp2->blen+=hbk->blen;
    free(hbk->bops);
    hbk->bpxref=rp2->bpxref;     hbk->bpxcnt=rp2->bpxcnt;
    hbk->exref=rp2->exref;       hbk->exrcnt=rp2->exrcnt;
    hbk->lbt=rp2->lbt;           hbk->lbcnt=rp2->lbcnt;
    hbk->bops=rp2->bops;         hbk->blen=rp2->blen;
    rp1->hblkcnt-=start1;
    if(rp1->ncbcnt)
    { RAL(rp1->ncb,rp1->ncbcnt+rp2->ncbcnt,struct nestcombined);
      for(a=0;a<rp2->ncbcnt;a++)
      { rp2->ncb[a].off+=cut;
        rp2->ncb[a].nbp+=nbp;
        if(rp2->ncb[a].hidn) illegaltype("not handle hidden here7");
        rp2->ncb[a].hidn+=start1;
        rp1->ncb[rp1->ncbcnt++]=rp2->ncb[a];
      }
      if(rp2->ncbcnt) free(rp2->ncb);
      rp2->ncbcnt=rp1->ncbcnt; rp2->ncb=rp1->ncb;
    } /*else nothing*/
    if(rp2->hblkcnt)
    { RAL(rp2->hblk,rp2->hblkcnt+rp1->hblkcnt,struct hiddenblock); }
    else AL(rp2->hblk,rp1->hblkcnt,struct hiddenblock);
    memcpy(rp2->hblk+rp2->hblkcnt,hbk,rp1->hblkcnt*sizeof(struct hiddenblock));
    rp2->hblkcnt+=rp1->hblkcnt;
    free(rp1->hblk);
    rp2->bpxref=rp1->bpxref;     rp2->bpxcnt=rp1->bpxcnt;
    rp2->exref=rp1->exref;       rp2->exrcnt=rp1->exrcnt;
    rp2->lbt=rp1->lbt;           rp2->lbcnt=rp1->lbcnt;
    rp2->bops=rp1->bops;         rp2->blen=rp1->blen;
  }
  rp2->bpoff+=rp1->bpoff;
  if(rp1->loccnt)
  { if(rp2->loccnt) { RAL(rp2->loc,rp2->loccnt+rp1->loccnt,struct locations); }
    else AL(rp2->loc,rp2->loccnt+rp1->loccnt,struct locations);
    memcpy(rp2->loc+rp2->loccnt,rp1->loc,rp1->loccnt*sizeof(struct locations));
    rp2->loccnt+=rp1->loccnt;
    free(rp1->loc);
  }
}

illegaltype(x) char *x;
{ fatal=1;
  yyerror("illegal type/operator combination");
  fprintf(stderr,"letter: %s\n",x);
}

/*table autoinit: size(long) { stkoff(long) len(char) stuff(spcfd by len) }*/
/*table extnmtp: count(long) { name '\0' tp(char poss. long) ispre(char)
 * [poss. (len comes from size len) prestf(spcfd by len) ] } */
autinitinc()
{ long c;
  c=getlong();
  oppos+=c;
 return c;
}
typeposinc(flg)
{ int ch;
  ch=GETCHAR();
  if(flg) ftp=ch;
  switch(ch%SUNSIGNED)
  { case SCHAR:
    case SSHORT:
    case SINT:
    case SLONG:
    case SFUNC:
    break;
    case SFLOAT:
    case SDOUBLE:
     mathuse=1;
    break;
    case SPOINTER:
    case SSTRUCT:
     if(flg) fsz=(*(unsigned long *)(opcode+oppos));
     oppos+=solong;
    break;
    default: fprintf(stderr,"#1unknown type %d  oppos %d\n",ch,oppos);
  }
}
long getlong()
{ long x;
  int l;
  char buf[32];
  for(l=0;l<solong;l++)
   buf[l]=GETCHAR();
  SRDLONG(buf,x);
  return x;
}
yyerror(s) char *s; /* replace standard error routine with my own */
{ fprintf(stderr,"psas: %s: scan %d line %d file \"%s\"\n",s,scan,inline
,inpfile);
}
