	.file	"memmove.s"
	.version	"02.01"
	.data
	.text
	.align	4
	.def	memmove;	.val	memmove;	.scl	2;	.type	0142;	.endef
	.globl	memmove
memmove:          /* dest(8) src(12) cnt(16) */
	pushl	%ebp             /* push ebp */
	movl	%esp,%ebp
	pushl	%esi
	pushl	%edi
	pushl %ecx
	movl 12(%ebp),%esi       /* movl esi,in */
	movl 8(%ebp),%edi        /* mov edi,out */
	movl 16(%ebp),%ecx       /* mov ecx,num */
       jcxz .finished
        cmpl %edi,%esi           /* cmp esi,edi */
       je .finished
       jb .backwards
        cld
        testl $3,%esi
        jz .isgood
.startgoodloop:
        movsb
        testl $3,%esi    /* check if aligned best */
       loopnz .startgoodloop
.isgood:
        movb %cl,%al              /* mov al,cl */
        shrl $2,%ecx         /* mov dws */
       rep
         movsl      /* bulk of move done here */
        movb %al,%cl        /* mov cl,al     /* finish off straglers */
        andb $3,%cl          /* and cl,3 */
       rep
         movsb
.finished:
        movl 8(%ebp),%eax    /* mov eax,out */
        popl %ecx
        popl %edi
        popl %esi
        popl %ebp
      ret
.backwards:     /* put this afterwords to avoid needing jumps over it */
      /* UNIX crashes if it gets control after a  std but before cld, */
      /* so I wrote a work-around for the problems with movsb, rep movsl... */
        cld
        pushl %ebx
        addl %ecx,%esi      /* add esi,ecx */
        decl %esi
        addl %ecx,%edi      /* add edi,ecx */
        decl %edi
.backstartgoodloop:
        movl %esi,%ebx   /* save prior esi value */

          /* next two lines:  movsb */
        movb (%esi),%al  /* mov al,[esi] */
        decl %esi
        movb %al,(%edi)  /* mov [edi],al */
        decl %edi

        testl $3,%ebx   /* check if aligned best */
       loopnz .backstartgoodloop
        subl $3,%esi     /* sub esi,3 */
        subl $3,%edi     /* sub edi,3 */
        movb %cl,%al    /* mov al,cl */
        shrl $2,%ecx    /* mov dws */

         /* the next umpteen lines do "rep movsd" */
       jcxz .nofullwords
.anotherfullword:
        movl (%esi),%ebx
        subl $4,%esi
        movl %ebx,(%edi)
        subl $4,%edi
        decl %ecx
       jnz .anotherfullword
.nofullwords:

        movb %al,%cl    /* mov cl,al     /* finish off straglers */
        andb $3,%cl      /* and cl,3 */
        addl $3,%esi     /* add esi,3 */
        addl $3,%edi     /* add edi,3 */

         /* the next umpteen lines do "rep movsb" */
       jcxz .nobytes
.anotherbyte:
        movb (%esi),%al
        decl %esi
        movb %al,(%edi)
        decl %edi
        decl %ecx
       jnz .anotherbyte
.nobytes:

        popl %ebx
      jmp .finished
.L15:
/REGAL	0	NODBL
/REGAL	6	PARAM	16(%ebp)	4
/REGAL	6	PARAM	12(%ebp)	4
/REGAL	6	PARAM	8(%ebp)	4
.L14:
	.def	memmove;	.val	.;	.scl	-1;	.endef
	.data
