/* dcc.c - control program for C compiler */
#include <stdio.h>
#define E_MEM (-2)
#define AL(place,size,type) { (place)=(type *)malloc((unsigned)(sizeof(type)\
  *(size)));\
 if ((char *)(place)==NULL)\
  yyerror("AL() can't get enough memory"),exit(E_MEM); }
#define RAL(place,size,type) { (place)=(type *)realloc((char *)(place)\
  ,(unsigned)(sizeof(type)*(size)));\
 if ((char *)(place)==NULL)\
  yyerror("RAL() can't get enough memory"),exit(E_MEM); }
main(argc,argv) int argc; char *argv[];
{ char *parser,*psas,*link,temp[512],*eparse,*epsas,*eln,*ending,*easm,*oasm;
  char *eppc,*ppc;
  int len,a,ln2;
  eppc="ppc"; eparse="parse 1244448"; epsas="psas"; eln="dln ";
  easm="asm 386";
  ending="out.386";
  AL(ppc,1,char);    *ppc='\0';
  AL(parser,1,char); *parser='\0';
  AL(psas,1,char);   *psas='\0';
  AL(link,1,char);   *link='\0';
  AL(oasm,1,char);   *oasm='\0';
  for(a=1;a<argc;a++)
  { len=strlen(argv[a]);
    if(!strcmp(argv[a],"-o"))
    { if(++a<argc) ending=argv[a]; }
    else if(!strcmp(argv[a],"-86"))
    { eparse="parse 1224448"; epsas="psas86"; eln="dln86 ";
      easm="asm 86";
      if(!strcmp(ending,"out.386")) ending="out.com";
    }
    else if(argv[a][len-2]!='.')
    { sprintf(temp,"unknown ending \"%s\"",argv[a]); yyerror(temp); exit(-1); }
    else switch(argv[a][len-1])
    { default:
       yyerror("illegal postfix; compilation FAILED");
      exit(-1);
      case 'c':
       RAL(ppc,strlen(ppc)+2+len,char);
       memcpy(ppc+strlen(ppc)+1,argv[a],len+1);
       ppc[strlen(ppc)]=' ';
      case 'i':
       argv[a][len-1]='i';
       RAL(parser,strlen(parser)+2+len,char);
       memcpy(parser+strlen(parser)+1,argv[a],len+1);
       parser[strlen(parser)]=' ';
      case 'p':
       argv[a][len-1]='p';
       RAL(psas,strlen(psas)+2+len,char);
       memcpy(psas+strlen(psas)+1,argv[a],len+1);
       psas[strlen(psas)]=' ';
      goto object;
      case 'a':
       RAL(oasm,strlen(oasm)+2+len,char);
       memcpy(oasm+strlen(oasm)+1,argv[a],len+1);
       oasm[strlen(oasm)]=' ';
      object:
      case 'o':
       argv[a][len-1]='o';
       RAL(link,strlen(link)+2+len,char);
       memcpy(link+strlen(link)+1,argv[a],len+1);
       link[strlen(link)]=' ';
    }
  }
  if(len=strlen(ppc))
  { ln2=strlen(eppc);
    RAL(ppc,len+ln2+1,char);
    memmove(ppc+ln2,ppc,len+1);
    memcpy(ppc,eppc,ln2);
    printf("%s\n",ppc);
    if(system(ppc)) { yyerror("compilation FAILED"); exit(-1); }
  }
  if(len=strlen(parser))
  { ln2=strlen(eparse);
    RAL(parser,len+ln2+1,char);
    memmove(parser+ln2,parser,len+1);
    memcpy(parser,eparse,ln2);
    printf("%s\n",parser);
    if(system(parser)) { yyerror("compilation FAILED"); exit(-1); }
  }
  if(len=strlen(psas))
  { ln2=strlen(epsas);
    RAL(psas,len+ln2+1,char);
    memmove(psas+ln2,psas,len+1);
    memcpy(psas,epsas,ln2);
    printf("%s\n",psas);
    if(system(psas)) { yyerror("compilation FAILED"); exit(-1); }
  }
  if(len=strlen(oasm))
  { ln2=strlen(easm);
    RAL(oasm,len+ln2+1,char);
    memmove(oasm+ln2,oasm,len+1);
    memcpy(oasm,easm,ln2);
    printf("%s\n",oasm);
    if(system(oasm)) { yyerror("compilation FAILED"); exit(-1); }
  }
  if(len=strlen(link))
  { ln2=strlen(eln);
    a=strlen(ending);
    RAL(link,len+a+ln2+1,char);
    memmove(link+(ln2+a),link,len+1);
    memcpy(link,eln,ln2);
    memcpy(link+ln2,ending,a);
    printf("%s\n",link);
    if(system(link)) { yyerror("compilation FAILED"); exit(-1); }
  }
}
yyerror(s) char *s;
{ fprintf(stderr,"dcc control: %s: cannot trace further\n",s);
}
