/* psas.c: pseudo code assembler for C compiler */
/* changes that I noticed are needed: ORET, char unsigned;pointer not stack*/
/* inpfile form
/* hblkstuff in combinerpns  creation: see 386 version
/* improper regization << should be >>
/*     find 123 should be 125 in jump fill; -3 should be +3 in CMPJMP ABIG */
/*     OLSTASGN char double x=0x88; */
/*     ftst in TTESTJMP;  ftst if comp. with 0 in TCMP;  LDCDBL 0,1,PI...*/
/*     compare with pointer needs improvement */
/*   add with point, long&lstasgn */
/* pointer that isn't PTRCONVERTED needs to be made so boff=0 */
/* point-int */
/*future flag for zero flag set properly
 *long test with fewer instruct.
 *386 version- use push 0 when possible*/
#include <stdio.h>
#define NOFUNCTIONS
#include "head.h"
#include "pseudo.h"
#include "psas86.h"
/*input file format:
* size ( OFUNC "name" type stksz predefsz ( len stf len stf ...) stuff )
* size ( OFUNC "name" type stksz predefsz ( len stf len stf ...) stuff )
* ...
* size (OPTEXTERN extcnt ("nm" type prepres [size stuff cnt (sect soff poff)])
*           strlen strstf cnt (sect soff poff))
*/
#define STNORMAL     0 /*jump optimization modes*/
#define STERASE      1
#define STLABEL      2
#define STERASELABEL 3
struct labxref
{ short src,dst;
} *labxref;
short labxcnt;
main(argc,argv) int argc; char *argv[];
{ int ch,x,fcnt,lstasgflg,rsto,r2sto,srchlab,lastcaserg,lastjmp;
  struct bld bo;
  long itmp;
  long j1off,j2off;
  struct stack *rpp;
  char status,newstat;
  solong=sofloat=sopoint=4;
  sodouble=8; sochar=1; soint=soshort=2;
  oppos=fatal=0;
  AL(inp,BUFSZ,struct opcode);
  AL(lbtbl,1,struct labels);
  AL(opcode,1,char);
  AL(block,1,struct block);
  AL(bops,1,char);
  AL(intstatstf,1,char); intstatoff=0; /* unlike most tables, intstat kept */
  AL(normstat,1,struct staticxref);
  AL(intstat,1,struct staticxref);
  AL(exref,1,struct externxref);
  AL(labxref,1,struct labxref);
  for(fcnt=1;fcnt<argc;fcnt++)
  { inline=0; inpfile=argv[fcnt];
    infile=fopen(argv[fcnt],"r");
    if(!infile) { fprintf(stderr,"Can't open input file\n"); exit(-1); }
    RAL(inp,BUFSZ,struct opcode);
    RAL(lbtbl,1,struct labels);
    fread(&oplen,1,sizeof(oplen),infile);
    RAL(opcode,oplen,char);
    fread(opcode,oplen,sizeof(char),infile);
    RAL(block,1,struct block);
    RAL(bops,1,char);
    RAL(intstatstf,1,char); intstatoff=0; /* unlike most tables, intstat kept */
    argv[fcnt][strlen(argv[fcnt])-1]='o'; /* adjust suffix of ouput */
    outfile=fopen(argv[fcnt],"w");
    if(!outfile)
    { fprintf(stderr,"Can't open output file \"%s\"\n",argv[fcnt]); exit(-1); }
    RAL(normstat,1,struct staticxref);
    RAL(intstat,1,struct staticxref);
    RAL(exref,1,struct externxref);
    RAL(labxref,1,struct labxref);
    while(1)
    { block->outoff=mathuse=blen=inlen=lbtbllen=spsln=rpnsln=spstot=spsmaxt=0;
      startcomma=nestquest=startncb=labxcnt=oppos=nstatcnt=istatcnt=exrcnt=0;
      lastjmp=0;
      blcnt=1;
     /*PASS1:
      * read in
      * set up stack(for pushd regs local variables and below)
      * coprocessor requirements
      * future: jmp optimization
      */
      status=STNORMAL;
      if(*opcode==OPTEXTERN) break;
      while(ch=GETCHAR(),ch!=EOF)
      { inp[inlen].pos=oppos-1;
        inp[inlen].sp=0;
        if(status!=STLABEL&&status!=STERASELABEL) newstat=status;
        else newstat=STNORMAL;
        switch(ch)
        { case ONEQ:
          case OEQ:
          case OLT:
          case OGT:
          case OLE:
          case OGE:
           inp[inlen].tp=TCMPJMP; oppos+=2*SAL; newstat=STERASE; break;
          case OTEST:
           inp[inlen].tp=TTESTJMP; oppos+=2*SAL; newstat=STERASE; break;
          case OCASECMP:
           inp[inlen].tp=TCASECMP; oppos+=soint+SAL;
           if(status!=STERASE) newstat=STNORMAL;
          break;
          case OSTARTQ:
          case OENDQ:
          case OENDCOMMA:
          case OSTARTCOMMA:
           inp[inlen].tp=TSTATUS; break;
          case OINLINE:
           oppos+=solong; inp[inlen].tp=TSTATUS; break;
          case OINFILE:
           while(GETCHAR()!='\0');
           inp[inlen].tp=TSTATUS; break;
          case OADD:
          case OSUB:
          case OAND:
          case OOR:
          case OXOR:
           inp[inlen].tp=TINTBINARY; break;
          case OSUBSCRPT:
           inp[inlen].tp=TINTBINARY; typeposinc(0); break;
          case OCHS:
          case OMUL:
          case ODIV:
          case OMOD:
          case OLSHFT:
          case ORSHFT:
           inp[inlen].tp=TSTD; break;
          case OLABEL:
           inp[inlen].tp=TLABEL; oppos+=SAL;
           newstat=status;
           switch(status)
           { case STNORMAL:
              newstat=STLABEL;
             goto p1olabel;
             case STERASE:
              newstat=STERASELABEL;
             p1olabel:
             case STLABEL:
             case STERASELABEL:
              a=(*(wordptr)(opcode+(inp[inlen].pos+1)));
              do
              { b=0;
                switch(inp[lastjmp].tp)
                { case TJMP:
                   if(*(wordptr)(opcode+(inp[lastjmp].pos+1))==a)
                    goto p1lberase;
                  break;
                  case TTESTJMP:
                  case TCMPJMP:
                   if(*(wordptr)(opcode+(inp[lastjmp].pos+1))==a)
                   { inp[lastjmp].sp=TSPECIAL1;
                     newstat=STLABEL;
                   }
                   else
                    if(*(wordptr)(opcode+(inp[lastjmp].pos+3))==a)
                    { inp[lastjmp].sp=TSPECIAL2;
                      newstat=STLABEL;
                    }
                  break;
                  case TCASECMP:
                   if(*(wordptr)(opcode+(inp[lastjmp].pos+soint+1))
                     ==a)
                   { /* erase this jump */
                    p1lberase:
                     b=1;
                     overmemcpy(inp+(lastjmp),inp+(lastjmp+1)
                       ,sizeof(struct opcode)*(inlen-lastjmp));
                     while(lastjmp>0&&(inp[--lastjmp].tp==TLABEL
                       ||inp[lastjmp].tp==TSTATUS));
                     inlen--;
                     newstat=STLABEL;
                   }
                }
              } while(b);
             break;
             default: fatal=1; yyerror("unknown status");
           }
          break;
          case OJMP:
           a=(*(wordptr)(opcode+oppos));
           inp[inlen].tp=TJMP; oppos+=SAL;
           newstat=STERASE;
           switch(status)
           { case STERASELABEL:
             case STLABEL:
              RAL(labxref,labxcnt+inlen-lastjmp,struct labxref);
              for(b=0,itmp=lastjmp++;lastjmp<inlen;lastjmp++)
               if(inp[lastjmp].tp==TLABEL)
               { labxref[labxcnt].dst=a;
                 labxref[labxcnt].src
                   =(*(wordptr)(opcode+(inp[lastjmp].pos+1)));
                 if(labxref[labxcnt++].src==a) b=1;
               }
            /*  if(!b) inlen=itmp; /* erase all of these labels */
               /* -1 not needed becuase stats will not cause inlen++ to occur*/
/*why bother erasing labels? will not harm anything.*/
              if(b) status=STLABEL; /* make sure jmp is not erased */
             case STNORMAL:
             case STERASE:
             break;
             default: fatal=1; yyerror("unknown status");
           }
           lastjmp=inlen;
          break;
          case OCALL0:
          case OCALL:
          case OPTRCONVERT:
          case OCONVERT:
           inp[inlen].tp=TSTD; typeposinc(0); break;
          case OTOPTR:
          case OSTOPTR:
           inp[inlen].tp=TSTD; break;
          case ORETURN:
          case OVALRET:
           newstat=STERASE;
           inp[inlen].tp=TSTD; break;
          case OLDFNCARG:
          case OPOP:
          case OSTCLL:
           inp[inlen].tp=TSTD; break;
          case OPOINT:
          case OARROW:
           inp[inlen].tp=TSTD; oppos+=solong; typeposinc(0); break;
          case OFPOINT:
          case OFARROW:
           inp[inlen].tp=TSTD; oppos+=2*sochar+solong; typeposinc(0); break;
          case ORECOG:
           inp[inlen].tp=TRECOG; typeposinc(0); oppos+=sochar+solong; break;
          case OLASTASGN:
          case OASSIGN:
           inp[inlen].tp=TSTD; break;
          case ONOT:
           inp[inlen].tp=TSTD; break;
          case OLCCHAR:   oppos+=sochar; goto ldcntp;
          case OLCSTRING: oppos+=2*solong; goto ldcntp;
          case OLCINT:    oppos+=soint; goto ldcntp;
          case OLCLONG:   oppos+=solong; goto ldcntp;
          case OLCDOUBLE: oppos+=sodouble; goto ldcntp;
          ldcntp:
          case OVINC:
          case OINCV:
          case OVDEC:
          case ODECV:
           inp[inlen].tp=TSTD; break;
          case OFUNC:
          case OSTATFUNC:
           while(GETCHAR()!='\0');
           typeposinc(1);
           spstot+=(spssz[spsln++]=getlong());
           autinitinc();
           inp[inlen].tp=TSTD;
           if(spstot>spsmaxt) spsmaxt=spstot;
          break;
          case OBLOCK:
           spstot+=(spssz[spsln++]=getlong());
           if(!autinitinc()) inp[inlen].tp=TSTATUS;
           else inp[inlen].tp=TSTD;
           if(spstot>spsmaxt) spsmaxt=spstot;
          break;
          case OENDBLCK:
           newstat=status;
           spstot-=spssz[--spsln];
           inp[inlen].tp=TSTATUS;
          break;
          default:
           fprintf(stderr,"#1unknown pseudocode %d,inlen %d  oppos %d\n"
              ,ch,inlen,oppos);
        }
        if((status!=STERASELABEL&&status!=STERASE)
          ||newstat!=STERASE||inp[inlen].tp==TSTATUS)
        { if(inp[inlen].tp!=TLABEL&&inp[inlen].tp!=TSTATUS) lastjmp=inlen;
          inlen++;
        }
        status=newstat;
        if(!(inlen%BUFSZ))
        { RAL(inp,inlen+BUFSZ,struct opcode); }
      }
     /*PASS2:
      * translate to machine
      * any evalation optimization
      */
      for(scan=0;scan<inlen;scan++)
      { rpp=rpnstk+(rpnsln-2);
/*fprintf(stderr,"<<scan %d  tp %d  opc[i[s].p] %d  i[s].p %d  blen %d>>",scan
,inp[scan].tp,opcode[inp[scan].pos],inp[scan].pos,blen);*/
        switch(inp[scan].tp)
        { case TSTATUS:
           switch(opcode[inp[scan].pos])
           { case OSTARTCOMMA:
              startcomma++;
             break;
             case OINLINE:
              inline= *(unsigned long *)(opcode+(inp[scan].pos+1));
             break;
             case OINFILE:
              inpfile=opcode+(inp[scan].pos+1);
             break;
             case OENDCOMMA:
              if(rpnsln)/* it might not be if last instr. a cmp or test */
              { rpp=rpnstk+(rpnsln-1);
                if(!rpnsln||!(rpp->ncbcnt--)||rpp->ncb[rpp->ncbcnt].call)
                  illegaltype("endcomma ncb");
                if(!rpp->ncbcnt) free(rpp->ncb);
                else RAL(rpp->ncb,rpp->ncbcnt,struct nestcombined);
              }
             break;
             case OSTARTQ:
              nestquest++;
             break;
             case OENDQ:
              nestquest--;
             break;
             case OBLOCK:
             case OENDBLCK:
              /*reduce total by value on stack; or if endfunc setup all else */
             break;
             default: fatal=1; yyerror("unknown pseudocode under TSTATUS");
           }
          break;
          case TRECOG: /*ORECOG*/
           /* put in as memory */
           initrpnstk();
           if(rpnsln&&rpnstk[rpnsln-1].combineflg)
           { rpp=rpnstk+(rpnsln-1); rpp->combineflg=0; }
           else
           { rpp=rpnstk+rpnsln++;
             AL(rpp->bops,1,char); rpp->blen=0;
           }
           rpp->place=PCMEMORY;
           rpp->tp=opcode[inp[scan].pos+1];
           rpp->size=(*(unsigned long *)(opcode+inp[scan].pos+2));
           rpp->sect=opcode[inp[scan].pos+2
            +((rpp->tp==SPOINTER||rpp->tp==SSTRUCT)<<2)];
           rpp->scoff=(*(unsigned long *)(opcode+inp[scan].pos+3
            +((rpp->tp==SPOINTER||rpp->tp==SSTRUCT)<<2)));
          break;
          case TINTBINARY:
           switch(opcode[inp[scan].pos])
           { case OADD:
             case OSUBSCRPT:
              b=0; /* used as flag if switched */
              if(rpp->tp==SPOINTER)
              {addorsubpoint:
                a=rpnstk[rpnsln-1].tp%SUNSIGNED;
                if(a!=SLONG&&a!=SINT) illegaltype("ADD/SUBSCRPT");
                itmp=powof2(rpp->size);
                lstasgflg=opcode[inp[scan+1].pos]==OLASTASGN&&opcode[inp[scan+2]
                 .pos]==OPOP;
                bo=binaryloadit(1,lstasgflg,!itmp,opcode[inp[scan].pos]
                  !=OSUB,itmp<0?RG2ND:RGNONE,0,0,0,1,itmp<0?2:(itmp?1:-1)
                  ,opcode[inp[scan+1].pos]==OLASTASGN,0,b);
                /*SC,lsDM,ccSM,ccswtch,ccAR,AX,nlim,noMTH,diflg,ccDX/CX,ncj*/
                if(bo.const)
                { bo.cval*=rpp->size;
                  if(opcode[inp[scan].pos]==OSUB) rpp->boff-=bo.cval;
                  else rpp->boff+=bo.cval;
                }
                else
                { /* mul/shl int
                   * add/sub [m],vl
                   * */
                  rsto=rpp->argreg;
                  r2sto=(*bo.m.stf)&7;/*<<3?*/
                  if(((*bo.m.stf>>6)&3)!=3) r2sto=(-1);
                  if(rsto==r2sto||lstasgflg)
                  { if(!lstasgflg) r2sto=(*bo.m.stf<<3)&7;
                    else r2sto=(-1);
                    x=0;
                  }
                  else x=2;
                  if(rsto==r2sto) { fatal=1; yyerror("improper regization"); }
                  if(itmp==(-1))
                  { a=findreg(0,rpp->reguse,0,0,rpp->reguse,rsto,r2sto
                      ,rpp->reguse[rpp->argreg].reg,-1,-1,-1);
if(a<0) illegaltype("findreg");
                    rpp->reguse[a].use=1;
                    RAL(rpp->bops,rpp->blen+5,char);
                    R2=0xb8+a;  /* mov rg,size */
                    RB2=rpp->size; RBI2;
                    R2=0xf7; R2=0xe0+a; /*mul ax,rg*/
                  }
                  else if(itmp)
                  { RAL(rpp->bops,rpp->blen+4,char);
                    R2=0xb1;  /* mov cl,power */
                    R2=itmp;
                    R2=0xd3; R2=0xe0+r2sto; /*shl r2sto,cl*/
                  }
                  a=(opcode[inp[scan].pos]==OSUB?0x29:0x1)+x;
                  addinstr(rpp,bo,0,a);
                }
                if(opcode[inp[scan].pos]==OSUBSCRPT)
                { rpp->place=PCLSTPOINT;
                  rpp->tp=opcode[inp[scan].pos+1];
                  if(rpp->tp==SPOINTER||rpp->tp==SSTRUCT)
                   rpp->size=(*(wordptr)(opcode+(inp[scan].pos+2)));
                }
                rpnsln--;
                if(lstasgflg)
                { scan+=2;
                  bopsload();
                }
               break;
              }
              else if(rpnstk[rpnsln-1].tp==SPOINTER)
              { b=1; /* being reversed */
                rpnstk[rpnsln]=(*rpp); *rpp=rpnstk[rpnsln-1];
                rpnstk[rpnsln-1]=rpnstk[rpnsln];
               goto addorsubpoint;
              }
              else
              { x=0x11; a=0x01;
               goto binaryintops;
              }
             break;
             case OSUB:
              if(rpp->tp==SPOINTER)
              { if(rpnstk[rpnsln-1].tp!=SPOINTER) goto addorsubpoint;
                if(rpp->size!=rpnstk[rpnsln-1].size) { yyerror("point size"); }
                bo=binaryloadit(0,0,1,0,RGNONE,0,0,0,0,-1
                  ,opcode[inp[scan+1].pos]==OLASTASGN,0,0);
                /*noSC,noDM,SM,noswtch,norest.,NA,nol,NA,nodiff,dxok,ncj*/
                addinstr(rpp,bo,0,0x29); /* sub 1,2 */
                itmp=powof2(rpp->size);
                if(itmp==(-1))
                { if(rpp->argreg) /* not AX */
                    regloadit(rpp,rpp,PCREG,rpp->argreg,0,0,0); /*AX*/
                  RAL(rpp->bops,rpp->blen+7,char);
                  rpp->argreg=0;
                  a=findreg(0,rpp->reguse,0,0,rpp->reguse,rpp->argreg,2,0,-1
                    ,-1,-1);
                  rpp->reguse->use=rpp->reguse[a].use=rpp->reguse[2].use=1;
                  /*DX used above*/
                  R2=0xb8+a;  /* mov rg,size */
                  RB2=rpp->size; RBI2;
                  RB2=0xd231; RBI2; /*xor dx,dx*/
                  R2=0xf7; R2=0xf0+a; /*div ax,rg*/
                }
                else if(itmp)
                { if(rpp->argreg==1) /*CX*/
                  { a=findreg(0,rpp->reguse,0,0,rpp->reguse,1,-1,-1,-1,-1,-1);
                    regloadit(rpp,rpp,PCREG,rpp->argreg,0,0,a);
                    rpp->reguse[a].use=1;
                    rpp->argreg=a;
                  }
                  else rpp->reguse[1].use=1; /*CX*/
                  RAL(rpp->bops,rpp->blen+3,char);
                  R2=0xb1;  /* mov cl,power */
                  R2=itmp;
                  R2=0xd3; R2=0xe8+rpp->argreg; /*shr rg,cl*/
                }
                rpp->reguse[rpp->argreg].use=1;
                rpp->tp=SINT;
                rpnsln--;
               break;
              }
              x=0x19; a=0x29;
             goto binaryintops;
             case OAND: x=a=0x21; goto binaryintops;
             case OOR:  x=a=0x9;  goto binaryintops;
             case OXOR:
              x=a=0x31;
             binaryintops:
              lstasgflg=opcode[inp[scan+1].pos]==OLASTASGN&&opcode[inp[scan+2]
               .pos]==OPOP&&(rpp->tp%SUNSIGNED==SINT
               ||rpp->tp%SUNSIGNED==SLONG);
              if(opcode[inp[scan].pos]==OSUB)
              { bo=binaryloadit(1,lstasgflg,1,0,RGNONE,0,0,0,0,-1
                  ,opcode[inp[scan+1].pos]==OLASTASGN,0,0);
                /*1SC,noDST,1SM,nswitch,noalim,NA,norgfld,nlngmth,nodf,no,ncj*/
              }
              else
                bo=binaryloadit(1,lstasgflg,1,1,RGNONE,0
                  ,0,0,0,-1,opcode[inp[scan+1].pos]==OLASTASGN,0,0);
              /*SRC,noDST,SM,switch,noalim,NA,noregfld,nolongmth,nodf,no,ncj*/
              if(bo.mem) a+=2,x+=2;
              if(rpp->place==PCMATH)
              { if(bo.fltsrcmem)
                { RAL(rpp->bops,rpp->blen+1+bo.m.segexist+bo.m.sz,char);
                  if(bo.m.segexist) R2=bo.m.seg;
                  if(a==1||a==3)
                  { if(bo.tp==SFLOAT) { R2=0xd8; /* *stf+=0 */ }
                    else
                    { if(bo.tp!=SDOUBLE) { illegaltype("float"); }
                      R2=0xdc; /* *stf+=0 */
                    }
                  }
                  else
                  { if(a!=0x29&&a!=0x2b) { illegaltype("1floating binary"); }
                    if(bo.tp==SFLOAT)
                    { R2=0xd8;
                      *bo.m.stf+=0x20+(bo.swtched<<3);
                    }
                    else
                    { if(bo.tp!=SDOUBLE) { illegaltype("float"); }
                      R2=0xdc;
                      *bo.m.stf+=0x20+(bo.swtched<<3);
                    }
                  }
                  memcpy(rpp->bops+rpp->blen,bo.m.stf,bo.m.sz);
                  rpp->blen+=bo.m.sz;
                  xrfill(rpp,bo.m);
                }
                else
                { /* faddp/fsubp/fsubrp st(1),st
                   * DE C1 */
                  RAL(rpp->bops,rpp->blen+2,char);
                  if(a==1||a==3) RB2=0xc1de;
                  else
                  { if(a!=0x29&&a!=0x2b) { illegaltype("2floating binary"); }
                    if(bo.swtched) RB2=0xe1de;
                    else RB2=0xe9de;
                  }
                  RBI2;
                }
              }
              else
              { if(rpnstk[rpnsln-1].tp!=rpp->tp)
                { fatal=1; yyerror("types not equal for int operator"); }
                if(bo.const) addcinstr(rpp,bo,0,a>>3);
                else addinstr(rpp,bo,0,(int)a);
                if(rpnstk[rpnsln-1].tp%SUNSIGNED==SLONG) /*unsign no matter*/
                { if(bo.const) addcinstr(rpp,bo,2,x>>3);
                  else addinstr(rpp,bo,2,(int)x);
                }
                else if(rpnstk[rpnsln-1].tp%SUNSIGNED!=SINT) illegaltype("d");
                if(rpp->tp%SUNSIGNED!=SLONG) rpp->gzf=rpp->gcsof=1;
                /* should already be non zero */
              }
              rpnsln--;
              if(lstasgflg)
              { scan+=2;
                bopsload();
              }
             break;
             default: fatal=1; yyerror("unknown pseudocode under TINTBINARY");
           }
          break;
          case TSTD: /* put in str block current */
           switch(opcode[inp[scan].pos])
           { case OLSHFT: a=0x20; goto shiftintop;
             case ORSHFT: a=0x28+((rpp->tp<SUNSIGNED)<<4);
             shiftintop:
              lstasgflg=opcode[inp[scan+1].pos]==OLASTASGN&&opcode[inp[scan+2]
               .pos]==OPOP&&rpp->tp%SUNSIGNED==SINT;/*if long/too ineffecient*/
              bo=binaryloadit(0,lstasgflg,0,0,RG2ND,1,1,0,1,-1
                ,opcode[inp[scan+1].pos]==OLASTASGN,0,0);
              /*nSC,ccDM,nSM,noswitch,rg2nd,CX,limrgfld,nlngmth,ldff,nodx,ncj*/
              switch(rpp->tp%SUNSIGNED)
              { case SINT:
                 /* shl/sar/shr wo [],cx */
                 RAL(rpp->bops,rpp->blen+1+bo.m.segexist+bo.m.sz,char);
                 if(bo.m.segexist) R2=bo.m.seg;
                 R2=0xd3;
                 *bo.m.stf+=a;
                 memcpy(rpp->bops+rpp->blen,bo.m.stf,bo.m.sz);
                 rpp->blen+=bo.m.sz;
                 xrfill(rpp,bo.m);
                 rpp->gzf=1;
                break;
                case SLONG:
                 /* and cx,3f
                  * jz label2:
                  *label:
                  * shr/sar/shl [m(2?)],1
                  * rcr/rcl [m(2?)],1
                  *loop label:
                  *label2:
                  * 83 e1 74 4+.sz d1 A d1 A e2 f9 */
                 x=bo.m.sz+bo.m.segexist+bo.m2.sz+bo.m.segexist;
                 RAL(rpp->bops,rpp->blen+x+8,char);
                 RB2=0xe183; RBI2; R2=0x74;
                 R2=0x4+x;
                 if(opcode[inp[scan].pos]==OLSHFT)
                 { if(bo.m.segexist) R1=bo.m.seg;
                   R2=0xd1;
                   *bo.m.stf+=a; memcpy(rpp->bops+rpp->blen,bo.m.stf,bo.m.sz);
                   rpp->blen+=bo.m.sz;
                   xrfill(rpp,bo.m);
                   if(bo.m2.segexist) R1=bo.m2.seg;
                   R2=0xd1;
                   *bo.m2.stf+=0x10;
                   memcpy(rpp->bops+rpp->blen,bo.m2.stf,bo.m2.sz);
                   rpp->blen+=bo.m2.sz;
                   xrfill(rpp,bo.m2);
                 }
                 else
                 { if(bo.m2.segexist) R1=bo.m2.seg;
                   R2=0xd1;
                   *bo.m2.stf+=a;
                   memcpy(rpp->bops+rpp->blen,bo.m2.stf,bo.m2.sz);
                   rpp->blen+=bo.m2.sz;
                   xrfill(rpp,bo.m2);
                   if(bo.m.segexist) R1=bo.m.seg;
                   R2=0xd1;
                   *bo.m.stf+=0x18;
                   memcpy(rpp->bops+rpp->blen,bo.m.stf,bo.m.sz);
                   rpp->blen+=bo.m.sz;
                   xrfill(rpp,bo.m);
                 }
                 R2=0xe2; R2=0xfc-x;
                break;
                default: illegaltype("L/RSHIFT");
              }
              rpnsln--;
              if(lstasgflg)
              { scan+=2;
                bopsload();
              }
             break;
             case OCHS:
              rpp=rpnstk+(rpnsln-1);
              bo=monoploadit(rpp,0);
              if(bo.m.segexist) { fatal=1; yyerror("CHSerr"); }
              if(rpp->place==PCMATH)
              { /* fchs st(0)
                 * d9 0e */
                RAL(rpp->bops,rpp->blen+2,char);
                RB1=0x96f7; RBI1;
              }
              else
              { RAL(rpp->bops,rpp->blen+bo.m.sz
                  +(rpp->tp%SUNSIGNED==SLONG)*((bo.m2.sz<<1)+4)+1,char);
                /* neg [m] */
                R1=0xf7; *bo.m.stf+=0x18;
                memcpy(rpp->bops+rpp->blen,bo.m.stf,bo.m.sz);
                rpp->blen+=bo.m.sz;
                xrfill(rpp,bo.m);
                rpp->gzf=rpp->gcsof=1;
                if(rpp->tp%SUNSIGNED==SLONG)
                { /* jc past next
                   * dec [m2]
                   * not [m2]
                   * 72 1+sz ff m2+8 f7 m+10 */
                  rpp->gzf=rpp->gcsof=0;
                  if(bo.m2.segexist) { fatal=1; yyerror("CHSerr2"); }
                  bo.m=bo.m2;
                  R1=0x72; R1=1+bo.m.sz;
                  R1=0xff; *bo.m.stf+=0x8;
                  memcpy(rpp->bops+rpp->blen,bo.m.stf,bo.m.sz);
                  rpp->blen+=bo.m.sz;
                  xrfill(rpp,bo.m);
                  R1=0xf7; *bo.m2.stf+=0x10;
                  memcpy(rpp->bops+rpp->blen,bo.m2.stf,bo.m2.sz);
                  rpp->blen+=bo.m2.sz;
                  xrfill(rpp,bo.m2);
                }
              }
             break;
             case OMUL:
              if(rpp->tp!=rpnstk[rpnsln-1].tp)
              { fatal=1; yyerror("illegal types"); }
              if(rpp->tp==SDOUBLE||rpp->tp==SFLOAT||rpp->tp%SUNSIGNED==SLONG)
              { bo=binaryloadit(0,0,rpp->tp<SUNSIGNED,1,RGNONE,0,1,1,0,2
                  ,opcode[inp[scan+1].pos]==OLASTASGN,0,0);
                /*noSRC,noDST,ccSRM,switch,norg,NA,norgfld,lngmth,nodt,DX,ncj*/
                if(bo.fltsrcmem)
                { RAL(rpp->bops,rpp->blen+bo.m.segexist+bo.m.sz+1,char);
                  if(bo.m.segexist) R2=bo.m.seg;
                  switch(bo.tp)
                  { case SDOUBLE:
                     R2=0xdc;
                     *bo.m.stf+=8;
                    break;
                    case SFLOAT:
                     R2=0xd8;
                     *bo.m.stf+=8;
                    break;
                    case SLONG:
                     R2=0xda;
                     *bo.m.stf+=8;
                    break;
                    default: illegaltype("OMUL1");
                  }
                  memcpy(rpp->bops+rpp->blen,bo.m.stf,bo.m.sz);
                  rpp->blen+=bo.m.sz;
                  xrfill(rpp,bo.m);
                }
                else
                { RAL(rpp->bops,rpp->blen+2,char);
                  RB2=0xc9de; RBI2; /* fmulp st(1),st */
                }
                rpp->place=PCMATH;
              }
              else
              { bo=binaryloadit(0,0,1,1,RGEITHER,0,1,0,0,-1
                  ,opcode[inp[scan+1].pos]==OLASTASGN,0,0);
                /*noSC,noDST,SM,swtch,eitherarg,AX,nrgfld,nlgmth,nodt,nDX,ncj*/
                *bo.m.stf+=rpp->tp>=SUNSIGNED?0x20:0x28;/*mul/imul*/
                addinstr(rpp,bo,0,0xf7);
                rpp->reguse[2].use=1; rpp->argreg=0; rpp->place=PCREG;
              }
              rpnsln--;
             break;
             case ODIV:
             case OMOD:
              if(rpp->tp!=rpnstk[rpnsln-1].tp)
              { fatal=1; yyerror("illegal types"); }
              if(rpp->tp==SDOUBLE||rpp->tp==SFLOAT||rpp->tp%SUNSIGNED==SLONG)
              { if(opcode[inp[scan].pos]==OMOD) { fatal=1; yyerror("DBLMOD"); }
                bo=binaryloadit(0,0,rpp->tp>=SUNSIGNED
                 &&(opcode[inp[scan].pos]==ODIV),1,RGNONE,0,1,1,0,2
                 ,opcode[inp[scan+1].pos]==OLASTASGN,0,0);
                /*noSRC,noDST,ccSRM,switch,norg,NA,norgfld,lngmth,nodt,DX,ncj*/
                if(bo.fltsrcmem)
                { RAL(rpp->bops,rpp->blen+bo.m.segexist+bo.m.sz+1,char);
                  if(bo.m.segexist) R2=bo.m.seg;
                  switch(bo.tp)
                  { case SDOUBLE:
                     R2=0xdc;
                     *bo.m.stf+=0x30+(bo.swtched<<3);
                    break;
                    case SFLOAT:
                     R2=0xd8;
                     *bo.m.stf+=0x30+(bo.swtched<<3);
                    break;
                    case SLONG:
                     R2=0xda;
                     *bo.m.stf+=0x30+(bo.swtched<<3);
                    break;
                    default: illegaltype("ODIV1");
                  }
                  memcpy(rpp->bops+rpp->blen,bo.m.stf,bo.m.sz);
                  rpp->blen+=bo.m.sz;
                  xrfill(rpp,bo.m);
                }
                else if(opcode[inp[scan].pos]==ODIV)
                { RAL(rpp->bops,rpp->blen+2,char);
                  RB2=0xf1de+((!bo.swtched)<<11); RBI2; /*fdivr?p st1,st*/
                }
                else
                { if(opcode[inp[scan].pos]!=OMOD)
                  { illegaltype("MOD"); }
                  RAL(rpp->bops,rpp->blen+4+(bo.swtched<<2),char);
                  if(bo.swtched) { RB2=0xc9d9; RBI2; /*fxch st(1)*/}
                  RB2=0xf8d9; RBI2; /*fprem*/
                  RB2=0xd9dd; RBI2; /*fstop st(1)*/
                }
              }
              else
              { bo=binaryloadit(0,0,1,1,RG1ST,0,1,0,0,2
                  ,opcode[inp[scan+1].pos]==OLASTASGN,0,0);
                /*noSC,noDST,SM,switch,1starg,AX,noregfld,nolgmth,nodt,DX,ncj*/
                /* xor dx,dx
                 * --or--
                 * cwd
                 * div [mem]
                 * (31 d2 | 99) f7 mem+30/38*/
                RAL(rpp->bops,rpp->blen+2,char);
                if(rpp->tp>=SUNSIGNED) { RB2=0xd231; RBI2; *bo.m.stf+=0x30; }
                else { R2=0x99; *bo.m.stf+=0x38; }
                addinstr(rpp,bo,0,0xf7);
                rpp->argreg=opcode[inp[scan].pos]==OMOD?2:0; /*DX,AX*/
                rpp->reguse[2].use=1; rpp->place=PCREG;
              }
              rpnsln--;
             break;
             case ONOT:
              rpp=rpnstk+(rpnsln-1);
              bo=monoploadit(rpp,0);
              *bo.m.stf+=0x18;
              addinstr(rpp,bo,0,0xf7);
              if(rpp->tp%SUNSIGNED==SLONG)
              { *bo.m2.stf+=0x18;
                addinstr(rpp,bo,2,0xf7);
              }
              else if(rpp->tp%SUNSIGNED!=SINT) illegaltype("NOT");
             break;
             case OLCCHAR:
              initrpnstk();
              if(rpnsln&&rpnstk[rpnsln-1].combineflg)
              { rpp=rpnstk+(rpnsln-1); rpp->combineflg=0; }
              else
              { rpp=rpnstk+rpnsln++;
                AL(rpp->bops,1,char); rpp->blen=0;
              }
              rpp->place=PCCONST; rpp->tp=SCHAR;
              rpp->cval=opcode[inp[scan].pos+1];
             break;
             case OLCSTRING:
              /* push ds
               * pop es
               * mov bx,#(off)
               * 1e 07 b8 ## ##*/
              initrpnstk();
              if(rpnsln&&rpnstk[rpnsln-1].combineflg)
              { rpp=rpnstk+(rpnsln-1); rpp->combineflg=0;
                RAL(rpp->bops,rpp->blen+5,char);
              }
              else
              { rpp=rpnstk+rpnsln++;
                AL(rpp->bops,5,char); rpp->blen=0;
              }
              RB1=0x71e; RBI1;
              R1=0xbb; RB1=(*(wordptr)(opcode+inp[scan].pos+1));
              RAL(rpp->normstat,rpp->nstatcnt+1,struct staticxref);
              rpp->normstat[rpp->nstatcnt++].off=rpp->blen; RBI1;
              rpp->tp=SPOINTER; rpp->size=1; rpp->place=PCREG;
              rpp->argreg=3; rpp->reguse[3].use=RP1STPT; rpp->reguse[3].reg=8;
              rpp->reguse[8].use=RP2NDPT; rpp->reguse[8].reg=3;
              rpp->maxoff=(-2);
             break;
             case OLCINT:
              initrpnstk();
              if(rpnsln&&rpnstk[rpnsln-1].combineflg)
              { rpp=rpnstk+(rpnsln-1); rpp->combineflg=0; }
              else
              { rpp=rpnstk+rpnsln++;
                AL(rpp->bops,1,char); rpp->blen=0;
              }
              rpp->cval=(*(wordptr)(opcode+inp[scan].pos+1));
              rpp->place=PCCONST; rpp->tp=SINT;
             break;
             case OLCLONG:
              initrpnstk();
              if(rpnsln&&rpnstk[rpnsln-1].combineflg)
              { rpp=rpnstk+(rpnsln-1); rpp->combineflg=0; }
              else
              { rpp=rpnstk+rpnsln++;
                AL(rpp->bops,1,char); rpp->blen=0;
              }
              rpp->cval=(*(unsigned long *)(opcode+inp[scan].pos+1));
              rpp->place=PCCONST; rpp->tp=SLONG;
             break;
             case OLCDOUBLE:
              /* fld qw [table+offset]
               * dd 06 offst */
              initrpnstk();
              if(rpnsln&&rpnstk[rpnsln-1].combineflg)
              { rpp=rpnstk+(rpnsln-1); rpp->combineflg=0;
                RAL(rpp->bops,rpp->blen+4,char);
              }
              else
              { rpp=rpnstk+rpnsln++;
                AL(rpp->bops,4,char); rpp->blen=0;
              }
              rpp->boff=intstatoff;
              RAL(intstatstf,intstatoff+8,char);
              for(a=0;a<8;a++)
                intstatstf[intstatoff++]=opcode[inp[scan].pos+1+a];
              rpp->place=PCCONST; rpp->tp=SDOUBLE;
             break;
             case OVINC:
              a=0;
             goto varoper;
             case OVDEC:
              /* must be memory or pointer; load value inc the other */
              a=1;
             varoper:
              rpp=rpnstk+(rpnsln-1);
              if(opcode[inp[scan+1].pos]==OPOP)
              {justonvar:
                if(rpp->lexist) /*OCONVERT probably did this*/
                { bo=monoploadit(rpp,0); /*IAM:monop needed?*/
                  lstpntld(rpp);
                  memtmp=genmemin(rpp->llprg,rpp->lplace,-1,rpp->sect
                    ,rpp->scoff,rpp->lboff,1,0,rpp->bpoff);
                  /* index last location that things were at */
                  switch(rpp->ltp%SUNSIGNED)
                  { case SCHAR:
                     if(rpp->argreg==6||rpp->argreg==7)
                     { x=findreg(0,rpp->reguse,0,0,rpp->reguse
                         ,rpp->lplace==PCLSTPOINT?rpp->llprg:-1,6,7,-1,-1,-1);
                       regloadit(rpp,rpp,rpp->place,rpp->argreg,0,0,x);
                       rpp->reguse[x].use=1;
                       rpp->argreg=x;
                     }
                     x=0x88;
                    goto voplcon;
                    case SSHORT: x=0x89;
                    voplcon:
                     /* inc/dec rg
                      * mov [mem],rg
                      * (fe regmem+0/1 seg 88/89 memtmp) */
                     RAL(rpp->bops,3+rpp->blen+memtmp.sz+memtmp.segexist,char);
                     R1=0xfe;
                     if(bo.m.sz!=1||bo.m.segexist)
                      illegaltype("non-register INCDEC");
                     R1=(*bo.m.stf)+(a<<3);
                     rpp->gzf=1;
                    vopmove:
                     if(memtmp.segexist) R1=memtmp.seg;
                     R1=x; memcpy(rpp->bops+rpp->blen,memtmp.stf,memtmp.sz);
                     rpp->blen+=memtmp.sz;
                    break;
                    case SPOINTER:
                     /* inc/dec/add/sub rg,sz
                      * mov [mem],rg;
                      * (fe regmem+0/1)||(83/81 regmem+0/5 sz) gotovopmove*/
                     RAL(rpp->bops,(rpp->size!=1)+(rpp->size>127)+3+rpp->blen
                      +memtmp.sz+memtmp.segexist,char);
                     x=0x89;
                     if(rpp->size==1)
                     { R1=0xfe;
                       if(bo.m.sz!=1||bo.m.segexist)
                        illegaltype("non-register INCDEC");
                       R1=(*bo.m.stf)+(a<<3);
                     }
                     else if(rpp->size>127)
                     { R1=0x81; R1=(*bo.m.stf)+(5<<3)*a; RB1=rpp->size; RBI1; }
                     else
                     { R1=0x83; R1=(*bo.m.stf)+(5<<3)*a; R1=rpp->size; }
                    goto vopmove;
                    case SFLOAT:
                     /* fld1
                      * faddp/subp st(1)
                      * fstp [mem]
                      * d9 e8 d8 c1/e1 seg d9 mem+3 */
                     RAL(rpp->bops,rpp->blen+4+memtmp.sz+memtmp.segexist,char);
                     RB1=0xe8d9; RBI1; R1=0xd8; R1=a?0xe1:0xc1;
                     if(memtmp.segexist) R1=memtmp.seg;
                     R1=0xd9; *memtmp.stf+=18;
                     memcpy(rpp->bops+rpp->blen,memtmp.stf,memtmp.sz);
                     rpp->blen+=memtmp.sz;
                     xrfill(rpp,memtmp);
                    break;
                    default: illegaltype("INCDEC1");
                  }
                }
                else /*not lexist*/
                { bo=monoploadit(rpp,1);
                  switch(rpp->tp%SUNSIGNED)
                  { case SINT:
                     /* inc/dec [mem]
                      * seg ff mem+0/1*/
                     *bo.m.stf+=(a<<3); addinstr(rpp,bo,0,0xff);
                     rpp->gzf=1;
                    break;
                    case SLONG:
                     /* inc/dec [mem],1
                      * jnc +over
                      * inc/dec [mem+2]
                      * seg ff mem+0/1 73 1+sz2+se2 seg ff mem+0/1 */
                     RAL(rpp->bops,rpp->blen+4+bo.m.segexist+bo.m2.segexist
                      +bo.m.sz+bo.m2.sz,char);
                     if(bo.m.segexist) R1=bo.m.seg;
                     R1=0xff; *bo.m.stf+=(a<<3);
                     memcpy(rpp->bops+rpp->blen,bo.m.stf,bo.m.sz);
                     rpp->blen+=bo.m.sz; xrfill(rpp,bo.m);
                     R1=0x73; R1=1+bo.m2.sz+bo.m2.segexist;
                     if(bo.m2.segexist) R1=bo.m2.seg;
                     R1=0xdd; *bo.m2.stf+=(a<<3);
                     memcpy(rpp->bops+rpp->blen,bo.m2.stf,bo.m2.sz);
                     rpp->blen+=bo.m2.sz; xrfill(rpp,bo.m2);
                    break;
                    case SDOUBLE:
                     /* fld1
                      * fadd/subr [mem]
                      * fstp [mem]
                      * d9 e8 seg dc mem+0/48 seg dd mem+18*/
                     RAL(rpp->bops,rpp->blen+4+2*(bo.m.segexist+bo.m.sz)
                      ,char);
                     bo.m2=bo.m;
                     RB1=0xe8d9; RBI1;
                     if(bo.m.segexist) R1=bo.m.seg;
                     R1=0xdc; *bo.m.stf+=a*0x48;
                     memcpy(rpp->bops+rpp->blen,bo.m.stf,bo.m.sz);
                     rpp->blen+=bo.m.sz; xrfill(rpp,bo.m);
                     if(bo.m2.segexist) R1=bo.m2.seg;
                     R1=0xdd; *bo.m2.stf+=a*0x18;
                     memcpy(rpp->bops+rpp->blen,bo.m2.stf,bo.m2.sz);
                     rpp->blen+=bo.m2.sz; xrfill(rpp,bo.m2);
                    break;
                    default: illegaltype("INCDEC2");
                  }
                }
                scan++; bopsload();
               break; /*out of operator switch*/
              }
            /*else not about to pop(because of break)*/
              bo=monoploadit(rpp,0);
              if(!rpp->lexist||(rpp->lplace!=PCMEMORY&&rpp->lplace
                !=PCLSTPOINT))
              { fatal=1; yyerror("1++ or -- without lvalue"); break; }
              lstpntld(rpp);
              memtmp=genmemin(rpp->llprg,rpp->lplace,-1,rpp->sect,rpp->scoff
                ,rpp->lboff,1,0,rpp->bpoff);
              if(rpp->argreg<0||rpp->reguse[rpp->argreg].reg<0)
                illegaltype("4");
              if(rpp->lplace==PCLSTPOINT)
              { itmp=findreg(0,rpp->reguse,0,0,rpp->reguse,rpp->argreg
                  ,rpp->reguse[rpp->argreg].use==RP1STPT?rpp->reguse
                   [rpp->argreg].reg:-1,rpp->llprg,rpp->lpprg2,-1,-1);
                /*avoid 1 and 2 and 1 and 2 lexist*/
              }
              else itmp=findreg(0,rpp->reguse,0,0,rpp->reguse,rpp->argreg
                ,rpp->reguse[rpp->argreg].use==RP1STPT
                ?rpp->reguse[rpp->argreg].reg:-1,-1,-1,-1,-1);
              switch(rpp->ltp%SUNSIGNED)
              { case SCHAR:
                 if(rpp->argreg==6||rpp->argreg==7)
                 { x=findreg(0,rpp->reguse,0,0,rpp->reguse
                     ,rpp->lplace==PCLSTPOINT?rpp->llprg:-1,6,7,-1,-1,-1);
                   regloadit(rpp,rpp,rpp->place,rpp->argreg,0,0,x);
                   rpp->reguse[x].use=1;
                   rpp->argreg=x;
                 }
                 x=0x88;
                goto varopint;
                case SSHORT:
                case SINT:
                case SPOINTER:
                 /* mov xx,rg
                  * inc/dec xx || add/sub xx,sz(pointer)
                  * mov [mem],xx/xl
                  * 8b c0+rg+xx<<3 (40/48+rg | 81/83 c0+xx sz) sg (88 89) mem*/
                 x=0x89;
                varopint:
                 if(bo.m.sz!=1)
                 { fatal=1; yyerror("illegal reg INCDEC"); }
                 RAL(rpp->bops,rpp->blen+memtmp.segexist+memtmp.sz+7,char);
                 R1=0x8b; R1=(*bo.m.stf)+(itmp<<3);
                 if(rpp->argreg<0||rpp->argreg>7)
                 { fatal=1; yyerror("illegal register"); }
                 if(rpp->ltp%SUNSIGNED!=SPOINTER||rpp->size==1)
                   R1=(a?0x48:0x40)+itmp; /* inc/dec xx */
                 else if(rpp->size>127) /* add/sub xx,sz */
                 { R1=0x81; R1=0xc0+(itmp<<3)+a*(5<<3); RB1=rpp->size; RBI1; }
                 else /* add/sub xx,sz */
                 { R1=0x83; R1=0xc0+(itmp<<3)+a*(5<<3); R1=rpp->size; }
                 if(memtmp.segexist) R1=memtmp.seg;
                 R1=x; *memtmp.stf+=(itmp<<3);
                 memcpy(rpp->bops+rpp->blen,memtmp.stf,memtmp.sz);
                 rpp->blen+=memtmp.sz;
                 xrfill(rpp,memtmp);
                 rpp->gzf=1;
                break;
                case SLONG:
                 /* mov xx,rg
                  * inc/dec xx
                  * mov [mem],xx
                  * jnc +6
                  * mov xx,rg2
                  * inc/dec xx
                  * mov [mem+2],xx
                  * 8b mem 40/48+rg seg 88/89 mem 73 4+seg2+mem2
                  * 8b mem2 40/48+rg seg2 88/89 mem2 */
                 memtmp2=genmemin(rpp->argreg,rpp->lplace,-1,rpp->sect
                   ,rpp->scoff,rpp->lboff,1,2,rpp->bpoff);
                 if(bo.m.sz!=1||bo.m2.sz!=1)
                 { fatal=1; yyerror("illegal reg INCDEC"); }
                 RAL(rpp->bops,memtmp2.segexist+memtmp2.sz+rpp->blen
                  +memtmp.segexist+memtmp.sz+10,char);
                 R1=0x8b; R1=(*bo.m.stf)+(itmp<<3);
                 if(rpp->argreg<0||rpp->argreg>7||rpp->reguse[rpp->argreg].reg<0
                  ||rpp->reguse[rpp->argreg].reg>7)
                 { fatal=1; yyerror("illegal register"); }
                 if(rpp->ltp%SUNSIGNED!=SPOINTER||rpp->size==1)
                   R1=(a?0x48:0x40)+rpp->argreg;
                 else if(rpp->size>127)
                 { R1=0x81; R1=0xc0+(itmp<<3)+a*(5<<3); RB1=rpp->size; RBI1; }
                 else
                 { R1=0x83; R1=0xc0+(itmp<<3)+a*(5<<3); R1=rpp->size; }
                 if(memtmp.segexist) R1=memtmp.seg;
                 R1=x; *memtmp.stf+=(itmp<<3);
                 memcpy(rpp->bops+rpp->blen,memtmp.stf,memtmp.sz);
                 rpp->blen+=memtmp.sz;
                 xrfill(rpp,memtmp);
                 R1=0x73; R1=4+memtmp2.segexist+memtmp2.sz;
                 R1=0x8b; R1=(*bo.m2.stf)+(itmp<<3);
                 if(rpp->ltp%SUNSIGNED!=SPOINTER||rpp->size==1)
                   R1=(a?0x48:0x40)+rpp->reguse[rpp->argreg].reg;
                 else if(rpp->size>127)
                 { R1=0x81; R1=0xc0+(itmp<<3)+a*(5<<3); RB1=rpp->size; RBI1; }
                 else
                 { R1=0x83; R1=0xc0+(itmp<<3)+a*(5<<3); R1=rpp->size; }
                 if(memtmp2.segexist) R1=memtmp2.seg;
                 R1=x; *memtmp2.stf+=(itmp<<3);
                 memcpy(rpp->bops+rpp->blen,memtmp2.stf,memtmp2.sz);
                 rpp->blen+=memtmp2.sz;
                 xrfill(rpp,memtmp2);
                break;
                case SFLOAT:
                 x=0xd9;
                goto varopmath;
                case SDOUBLE:
                 x=0xde;
                varopmath:
                 /* fld st(0)
                  * fld1
                  * faddp/fsubp st(1),st(0)
                  * fstp dw/qw [mem]
                  * d9 c0 d9 e8 de (c1 e9) seg (d9 de) mem+3<<3 */
                 RAL(rpp->bops,rpp->blen+memtmp.segexist+memtmp.sz+7,char);
                 RB1=0xc0d9; RBI1; RB1=0xe8d9; RBI1; RB1=a?0xe9de:0xc1de; RBI1;
                 if(memtmp.segexist) R1=memtmp.seg;
                 R1=x; *memtmp.stf+=24;
                 memcpy(rpp->bops+rpp->blen,memtmp.stf,memtmp.sz);
                 rpp->blen+=memtmp.sz;
                 xrfill(rpp,memtmp);
                break;
                default: illegaltype("l");
              }
              rpp->boff=rpp->lexist=0;
             break;
             case OINCV:
              a=0;
             goto opervar;
             case ODECV:
              /* must be memory or pointer; load inc and store */
              a=1;
             opervar:
              rpp=rpnstk+(rpnsln-1);
              if(opcode[inp[scan+1].pos]==OPOP) goto justonvar;
              bo=monoploadit(rpp,0);
              if(!rpp->lexist||(rpp->lplace!=PCMEMORY&&rpp->lplace!=PCLSTPOINT))
              { fatal=1; yyerror("2++ or -- without lvalue"); break; }
              lstpntld(rpp);
              memtmp=genmemin(rpp->llprg,rpp->lplace,-1,rpp->sect,rpp->scoff
                ,rpp->lboff,1,0,rpp->bpoff);
              switch(rpp->ltp%SUNSIGNED)
              { case SCHAR:
                 if(rpp->argreg==6||rpp->argreg==7)
                 { x=findreg(0,rpp->reguse,0,0,rpp->reguse
                     ,rpp->lplace==PCLSTPOINT?rpp->llprg:-1,6,7,-1,-1,-1);
                   regloadit(rpp,rpp,rpp->place,rpp->argreg,0,0,x);
                   rpp->reguse[x].use=1;
                   rpp->argreg=x;
                 }
                 x=0x88;
                goto opvarint;
                case SSHORT:
                case SINT:
                case SPOINTER:
                 /* inc/dec rg
                  * mov [mem],rg/rl
                  * (40/48)+rg seg 88/89 mem */
                 x=0x89;
                opvarint:
                 RAL(rpp->bops,rpp->blen+memtmp.segexist+memtmp.sz+4,char);
                 if(rpp->argreg<0||rpp->argreg>7)
                 { fatal=1; yyerror("illegal register"); }
                 R1=(a?0x48:0x40)+rpp->argreg;
                 if(memtmp.segexist) R1=memtmp.seg;
                 R1=x; *(memtmp.stf)+=rpp->argreg<<3;
                 memcpy(rpp->bops+rpp->blen,memtmp.stf,memtmp.sz);
                 rpp->blen+=memtmp.sz;
                 xrfill(rpp,memtmp);
                 rpp->gzf=1;
                break;
                case SLONG:
                 /* inc/dec rg
                  * mov [mem],rg
                  * jnc end
                  * inc/dec rg2
                  * mov [mem+2],rg2
                 ** 40/48+rg seg 88/89 mem 73 2+seg2+mem2
                  * 40/48+rg2 seg2 88/89 mem2 */
                 memtmp2=genmemin(rpp->argreg,rpp->lplace,-1,rpp->sect
                   ,rpp->scoff,rpp->lboff,1,2,rpp->bpoff);
                 RAL(rpp->bops,rpp->blen+memtmp.segexist+memtmp.sz+memtmp2.sz
                  +memtmp2.segexist+10,char);
                 if(rpp->argreg<0||rpp->argreg>7||rpp->reguse[rpp->argreg].reg<0
                  ||rpp->reguse[rpp->argreg].reg>7)
                 { fatal=1; yyerror("illegal register"); }
                 R1=(a?0x48:0x40)+rpp->argreg;
                 if(memtmp.segexist) R1=memtmp.seg;
                 R1=x; *memtmp.stf+=rpp->argreg<<3;
                 memcpy(rpp->bops+rpp->blen,memtmp.stf,memtmp.sz);
                 rpp->blen+=memtmp.sz;
                 xrfill(rpp,memtmp);
                 R1=0x73; R1=2+memtmp2.sz+memtmp2.segexist;
                 R1=(a?0x48:0x40)+rpp->reguse[rpp->argreg].reg;
                 if(memtmp2.segexist) R1=memtmp2.seg;
                 R1=x; *memtmp2.stf+=rpp->reguse[rpp->argreg].reg<<3;
                 memcpy(rpp->bops+rpp->blen,memtmp2.stf,memtmp.sz);
                 rpp->blen+=memtmp2.sz;
                 xrfill(rpp,memtmp2);
                break;
                case SFLOAT:
                 x=0xd9;
                goto opvarmath;
                case SDOUBLE:
                 /* fld1
                  * faddp/fsubp st(1),st(0)
                  * fst dw/qw [mem]
                  * d9 e8 de (c1 e9) seg (d9 de) mem+2<<3 */
                 x=0xde;
                opvarmath:
                 RAL(rpp->bops,rpp->blen+memtmp.segexist+memtmp.sz+5,char);
                 RB1=0xe8d9; RBI1; RB1=a?0xe9de:0xc1de; RBI1;
                 if(memtmp.segexist) R1=memtmp.seg;
                 R1=x; *memtmp.stf+=16;
                 memcpy(rpp->bops+rpp->blen,memtmp.stf,memtmp.sz);
                 rpp->blen+=memtmp.sz;
                 xrfill(rpp,memtmp);
                break;
                default: illegaltype("m");
              }
              rpp->boff=rpp->lexist=0;
             break;
             case OPTRCONVERT:
              /* make existent pointer PCLSTPOINT. */
              rpp=rpnstk+(rpnsln-1);
              if(opcode[inp[scan+1].pos]==OCALL
               ||opcode[inp[scan+1].pos]==OCALL0)
              { /* call mem; */
                if(opcode[inp[scan].pos+1]!=SFUNC) illegaltype("pcall");
                monoploadit(rpp,1); /*make ready to access*/
                /* access it's memory version */
                memtmp=genmemin(rpp->argreg,rpp->place,rpp->argreg,rpp->sect
                  ,rpp->scoff,rpp->boff,1,0,rpp->bpoff);
                RAL(rpp->bops,rpp->blen+memtmp.segexist+memtmp.sz+1,char);
                if(memtmp.segexist) R2=memtmp.seg;
                R2=0xff; *memtmp.stf+=0x18;
                memcpy(rpp->bops+rpp->blen,memtmp.stf,memtmp.sz);
                rpp->blen+=memtmp.sz;
                xrfill(rpp,memtmp);
                scan++;
               goto pointercall;
              }
              if(rpp->tp!=SPOINTER) { illegaltype("n"); break; }
              if(rpp->place!=PCREG) monoploadit(rpp,0);
              rpp->place=PCLSTPOINT; rpp->tp=opcode[inp[scan].pos+1];
              rpp->size=(*(unsigned long *)(opcode+inp[scan].pos+2));
              rpp->lexist=0;
              rpp->gzf=rpp->gcsof=0;
             break;
             case OCONVERT:
              rpp=rpnstk+(rpnsln-1);
              x=opcode[inp[scan].pos+1];/*to be converted to this*/
              switch(rpp->tp%SUNSIGNED)
              { case SCHAR:
                 if(rpp->place==PCMEMORY||rpp->place==PCLSTPOINT)
                 { rpp->lexist=1; rpp->lplace=rpp->place; rpp->ltp=rpp->tp;
                   rpp->llprg=rpp->argreg;
                   if(rpp->argreg>=0) rpp->lpprg2=rpp->reguse[rpp->argreg].reg;
                   rpp->lboff=rpp->boff;
                 }
                 switch(x%SUNSIGNED)
                 { case SCHAR:
                    rpp->lexist=0;
                   break;
                   case SSHORT:
                   case SINT:
                    /* cbw --or-- xor ah,ah
                     * (98--30 e4) */
                    monoploadit(rpp,1);
                    regloadit(rpp,rpp,rpp->place   /*put low in ax*/
                      ,rpp->place==PCSTACK?-1:rpp->argreg,0,0,0);
                    RAL(rpp->bops,rpp->blen+2,char);
                    if(x>=SUNSIGNED) { RB1=0xe430; RBI1; }
                    else R1=0x98;
                    rpp->place=PCREG; rpp->argreg=0; rpp->reguse->use=1;
                   break;
                   case SLONG:
                   case SPOINTER:
                    /* cbw
                     * --or--
                     * xor ah,ah
                     *
                     * cwd
                     * (98--30 e4) 99 */
                    monoploadit(rpp,1);
                    regloadit(rpp,rpp,rpp->place /*put low in ax*/
                      ,rpp->place==PCSTACK?-1:rpp->argreg,0,0,0);
                    RAL(rpp->bops,rpp->blen+3,char);
                    if(x>=SUNSIGNED) { RB1=0xe430; RBI1; }
                    else R1=0x98;
                    R1=0x99;
                    rpp->place=PCREG; rpp->argreg=0;
                    rpp->reguse->use=RP1STPT; rpp->reguse->reg=2;
                    rpp->reguse[2].use=RP2NDPT; rpp->reguse[2].reg=0;
                   break;
                   case SFLOAT:
                   case SDOUBLE:
                    /* cbw --or-- xor ah,ah
                     * push ax
                     * fild wo/dw [bp+x]
                     * wait
                     * add sp,2/4
                     * (98--30 e4)
                     *  50 df/db 86 bpoff 9b 83 c4 2/4 */
                    if(rpp->place==PCMATH) break;
                    monoploadit(rpp,1);
                    if(rpp->place!=PCREG||rpp->argreg)
                     regloadit(rpp,rpp,rpp->place /*put low in ax*/
                      ,rpp->place==PCSTACK?-1:rpp->argreg,0,0,0);
                    rpp->reguse->use=1;
                    RAL(rpp->bops,rpp->blen+14,char);
                    if(rpp->tp>=SUNSIGNED)
                    { RB1=0xe430; RBI1; }
                    else R1=0x98;
                    R1=0x50; R1=0xdf; R1=0x86;
                    RAL(rpp->bpxref,rpp->bpxcnt+1,long);
                    rpp->bpxref[rpp->bpxcnt++]=rpp->blen;
                    RB1=rpp->bpoff-2; RBI1;
                    if(rpp->bpoff-2<rpp->maxoff) rpp->maxoff=rpp->bpoff-2;
                    if(rpp->maxfltlev<1) rpp->maxfltlev=1;
                    R1=0x9b; RB1=0xc483; RBI1; R1=0x2;
                    rpp->place=PCMATH;
                   break;
                   case SSTRUCT:
                   default: illegaltype("o");
                 }
                break;
                case SSHORT:
                case SINT:
                 switch(x%SUNSIGNED)
                 { case SCHAR:
                   case SSHORT:
                   case SINT:
                   break;
                   case SLONG:
                   case SPOINTER:
                    if(rpp->place==PCMEMORY||rpp->place==PCLSTPOINT)
                    { rpp->lexist=1; rpp->lplace=rpp->place; rpp->ltp=rpp->tp;
                      rpp->llprg=rpp->argreg;
                      if(rpp->argreg>=0)
                        rpp->lpprg2=rpp->reguse[rpp->argreg].reg;
                      rpp->lboff=rpp->boff;
                    }
                    /* cwd --or-- xor dx,dx
                     * (99--31 d2) */
                    monoploadit(rpp,1);
                    regloadit(rpp,rpp,rpp->place /*put low in ax*/
                      ,rpp->place==PCSTACK?-1:rpp->argreg,0,0,0);
                    RAL(rpp->bops,rpp->blen+5,char);
                    if(x>=SUNSIGNED) { RB1=0xd231; RBI1; }
                    else R1=0x99;
                    rpp->place=PCREG; rpp->argreg=0;
                    rpp->reguse->use=RP1STPT; rpp->reguse->reg=2;
                    rpp->reguse[2].use=RP2NDPT; rpp->reguse[2].reg=0;
                   break;
                   case SFLOAT:
                   case SDOUBLE:
                    if(rpp->place==PCMEMORY||rpp->place==PCLSTPOINT)
                    { rpp->lexist=1; rpp->lplace=rpp->place; rpp->ltp=rpp->tp;
                      rpp->llprg=rpp->argreg;
                      if(rpp->argreg>=0)
                        rpp->lpprg2=rpp->reguse[rpp->argreg].reg;
                      rpp->lboff=rpp->boff;
                    }
                    /* U: xor rg,rg
                     * U: push rg
                     * fild wo/dw [bp+]
                     * wait
                     * add sp,2/4
                     * (U: 31 c0+rg 50+rg) df/db 86 bpoff 9b 83 c4 2/4 */
                    if(rpp->place==PCMATH) break;
                    monoploadit(rpp,1);
                    if(rpp->tp>=SUNSIGNED)
                    { if(rpp->place==PCSTACK) monoploadit(rpp,0);
                      itmp=rpp->place==PCLSTPOINT||rpp->place==PCREG;
                      a=findreg(0,rpp->reguse,0,0,rpp->reguse,itmp?rpp->argreg
                        :-1,itmp?rpp->reguse[rpp->argreg].reg:-1,-1,-1,-1,-1);
                      rpp->reguse[a].use=1;
                      RAL(rpp->bops,rpp->blen+5,char);
                      R1=0x31; R1=0xc0+a+(a<<3);
                      R1=0x50+a; rpp->reguse[a].use=1;
                      RB1=0xe430; RBI1;
                      rpp->bpoff-=2;
                    }
                    if(rpp->place==PCREG||rpp->tp>=SUNSIGNED)
                      stkload(rpp);
                    memtmp=genmemin(rpp->argreg,rpp->place,rpp->argreg
                      ,rpp->sect,rpp->scoff,rpp->boff,1,0,rpp->bpoff);
                    RAL(rpp->bops,rpp->blen+5+memtmp.segexist+memtmp.sz,char);
                    if(memtmp.segexist) R1=memtmp.seg;
                    R1=rpp->tp>=SUNSIGNED?0xdb:0xdf;
                    memcpy(rpp->bops+rpp->blen,memtmp.stf,memtmp.sz);
                    rpp->blen+=memtmp.sz; xrfill(rpp,memtmp);
                    R1=0x9b;
                    if(rpp->bpoff<rpp->maxoff) rpp->maxoff=rpp->bpoff;
                    if(rpp->maxfltlev<1) rpp->maxfltlev=1;
                    if(rpp->place==PCSTACK)
                    { RB1=0xc483; RBI1; R1=rpp->tp>=SUNSIGNED?0x4:0x2;
                      rpp->bpoff+=rpp->tp>=SUNSIGNED?0x4:0x2;
                    }
                    rpp->place=PCMATH;
                   break;
                   case SSTRUCT:
                   default: illegaltype("p");
                 }
                break;
                case SLONG:
                case SPOINTER:
                 switch(x%SUNSIGNED)
                 { case SCHAR:
                   case SSHORT:
                   case SINT:
                    monoploadit(rpp,0);
                    rpp->reguse[rpp->argreg].use=1;
                   break;
                   case SLONG:
                   case SPOINTER:
                   break;
                   case SFLOAT:
                   case SDOUBLE:
                    if(rpp->place==PCMEMORY||rpp->place==PCLSTPOINT)
                    { rpp->lexist=1; rpp->lplace=rpp->place; rpp->ltp=rpp->tp;
                      rpp->llprg=rpp->argreg;
                      if(rpp->argreg>=0)
                        rpp->lpprg2=rpp->reguse[rpp->argreg].reg;
                      rpp->lboff=rpp->boff;
                    }
                    monoploadit(rpp,1);
                    fltload(rpp);
                   break;
                   case SSTRUCT:
                   default: illegaltype("q");
                 }
                break;
                case SFLOAT:
                case SDOUBLE:
                 switch(x%SUNSIGNED)
                 { case SCHAR:
                   case SSHORT:
                   case SINT:
                    monoploadit(rpp,0);
                    if(rpp->tp<SUNSIGNED)
                    { /* push ax
                       * fistp wo [bp+] /*MORE: unsigned: store temp. on stack
                       * wait
                       * 50 df 9e bpoff 9b */
                      rpp->bpoff-=2;
                      RAL(rpp->bops,rpp->blen+6,char);
                      RB1=0xdf50; RBI1; R1=0x9e;
                      RAL(rpp->bpxref,rpp->bpxcnt+1,long);
                      rpp->bpxref[rpp->bpxcnt++]=rpp->blen;
                      RB1=rpp->bpoff; RBI1; R1=0x9b;
                      rpp->place=PCSTACK;
                      if(rpp->bpoff<rpp->maxoff) rpp->maxoff=rpp->bpoff;
                    }
                    else
                    { /* sub sp,4
                       * fistp dw [bp+]
                       * wait
                       * LOAD
                       * add sp,2
                       * 83 ec 4 db 9e bpoff 9b 83 c4 2*/
                      rpp->bpoff-=4;
                      RAL(rpp->bops,rpp->blen+8,char);
                      RB1=0xec83; RBI1; RB1=0xdb04; RBI1; R1=0x9e;
                      RAL(rpp->bpxref,rpp->bpxcnt+1,long);
                      rpp->bpxref[rpp->bpxcnt++]=rpp->blen;
                      RB1=rpp->bpoff; RBI1; R1=0x9b;
                      rpp->place=PCSTACK; rpp->tp=x;
                      monoploadit(rpp,0);
                      RAL(rpp->bops,rpp->blen+3,char);
                      if(rpp->bpoff<rpp->maxoff) rpp->maxoff=rpp->bpoff;
                      RB1=0xc483; RBI1; R1=0x2;
                      rpp->bpoff+=2;
                    }
                   break;
                   case SLONG:
                    /* frndint
                     * d9 fc */
                    monoploadit(rpp,0);
                    RAL(rpp->bops,rpp->blen+2,char);
                    RB1=0xfcd9; RBI1;
                   break;
                   case SPOINTER:
                    /* sub sp,4
                     * fistp dw [bp+]
                     * wait
                     * 83 ec 4 db 9e bpoff 9b */
                    monoploadit(rpp,0);
                    rpp->bpoff-=4;
                    RAL(rpp->bops,rpp->blen+8,char);
                    RB1=0xec83; RBI1; RB1=0xdb04; RBI1; R1=0x9e;
                    RAL(rpp->bpxref,rpp->bpxcnt+1,long);
                    rpp->bpxref[rpp->bpxcnt++]=rpp->blen; RB1=rpp->bpoff; RBI1;
                    R1=0x9b;
                    rpp->place=PCSTACK;
                    if(rpp->bpoff<rpp->maxoff) rpp->maxoff=rpp->bpoff;
                   case SFLOAT:
                   break;
                   case SDOUBLE:
                    if(rpp->tp!=SDOUBLE)
                    { if(rpp->place==PCMEMORY||rpp->place==PCLSTPOINT)
                      { rpp->lexist=1; rpp->lplace=rpp->place;
                        rpp->llprg=rpp->argreg; rpp->ltp=rpp->tp;
                        if(rpp->argreg>=0)
                          rpp->lpprg2=rpp->reguse[rpp->argreg].reg;
                        rpp->lboff=rpp->boff;
                      }
                      monoploadit(rpp,0);
                    }
                   break;
                   case SSTRUCT:
                   default: illegaltype("r");
                 }
                break;
                case SSTRUCT:
                default: illegaltype("s");
              }
              if(rpp->lexist==1&&rpp->lplace!=PCMEMORY
               &&rpp->lplace!=PCLSTPOINT)
                rpp->lexist=0;
              rpp->tp=x;
              if(x==SSTRUCT||x==SPOINTER)
                rpp->size=(*(unsigned long *)(opcode+inp[scan].pos+2));
              rpp->gzf=rpp->gcsof=0;
             break;
             case OSTOPTR: /* used with arrays to for indexing */
              rpp=rpnstk+(rpnsln-1);
              if(rpp->place!=PCMEMORY||rpp->tp!=SPOINTER) illegaltype("t");
              bo=monoploadit(rpp,1);
              *bo.m.stf+=0x18; addinstr(rpp,bo,0,0x8d); /* lea bx,[mem] */
              if(bo.m.pushseg!=0x6)
              { /* push seg
                 * pop es
                 * psh 7 */
                RAL(rpp->bops,rpp->blen+bo.m.segexist+bo.m.sz+2,char);
                R1=bo.m.pushseg; R1=0x07;
                if(rpp->bpoff-2<rpp->maxoff) rpp->maxoff=rpp->bpoff-2;
              }
              rpp->place=PCREG;
              rpp->argreg=3; rpp->reguse[3].use=RP1STPT; rpp->reguse[3].reg=8;
              rpp->reguse[8].use=RP2NDPT; rpp->reguse[8].reg=3; rpp->boff=0;
              rpp->gzf=rpp->gcsof=0;
             break;
             case OTOPTR:
              rpp=rpnstk+(rpnsln-1);
              if(rpp->tp==SFUNC)
              { /* mov rg2,seg
                 * mov rg,off
                 * b8+rg2 segmt b8+rg offst */
                if(rpp->place!=PCMEMORY) illegaltype("t2");
                a=findreg(0,rpp->reguse,0,0,rpp->reguse,-1,-1,-1,-1,-1,-1);
                x=findreg(0,rpp->reguse,0,0,rpp->reguse,a,-1,-1,-1,-1,-1);
                rpp->boff=0;
                RAL(rpp->bops,rpp->blen+8,char);
                R1=0xb8+x; RBI1; R1=0xb8+a;
                RAL(rpp->exref,rpp->exrcnt+1,struct externxref);
                rpp->exref[rpp->exrcnt].off=rpp->blen;/* blck blnk */
                rpp->exref[rpp->exrcnt].ptrfnc=1;
                rpp->exref[rpp->exrcnt++].scoff=rpp->scoff;
                RBI1;
                rpp->size=0;
                rpp->tp=SPOINTER; rpp->place=PCREG;
                rpp->argreg=a; rpp->reguse[a].use=RP1STPT; rpp->reguse[a].reg=x;
                rpp->reguse[x].use=RP2NDPT; rpp->reguse[x].reg=a; rpp->boff=0;
              }
              else
              { if(rpp->place!=PCMEMORY&&rpp->place!=PCLSTPOINT)
                  illegaltype("t3");
                bo=monoploadit(rpp,1);
                *bo.m.stf+=0x18; addinstr(rpp,bo,0,0x8d); /* lea bx,[mem] */
                if(bo.m.pushseg!=0x6)
                { /* push seg
                   * pop es
                   * psh 7 */
                  RAL(rpp->bops,rpp->blen+bo.m.segexist+bo.m.sz+2,char);
                  R1=bo.m.pushseg; R1=0x07;
                  if(rpp->bpoff-2<rpp->maxoff) rpp->maxoff=rpp->bpoff-2;
                }
                rpp->size=typesize(1);
                rpp->tp=SPOINTER; rpp->place=PCREG;
                rpp->argreg=3; rpp->reguse[3].use=RP1STPT; rpp->reguse[3].reg=8;
                rpp->reguse[8].use=RP2NDPT; rpp->reguse[8].reg=3; rpp->boff=0;
              }
              rpp->gzf=rpp->gcsof=0;
             break;
             case ORETURN:
              /* ? fild wo [bp]
               * add sp,spsmaxt
               * pop di
               * pop si
               * pop bp
               * pop ax
               * pop bx
               * pop dx
               * pop cx
               * pop ax
               * pop es
               * retf
               * (df 46 0) 81 c5 spsmaxt 5f 5e 5d 58 5b 5a 59 58 07 cb*/
              if(rpnsln) { fatal=1; yyerror("return: something on stack"); }
              RAL(bops,blen+17,char);
              if(ftp==SFLOAT||ftp==SDOUBLE)
              { bops[blen++]=0xdf; bops[blen++]=0x46; bops[blen++]=0; }
              if(spsmaxt)
               if(spsmaxt<128&&spsmaxt>=-128)
               { bops[blen++]=0x83; bops[blen++]=0xc4; bops[blen++]=spsmaxt; }
               else
               { bops[blen++]=0x81; bops[blen++]=0xc4;
                 *(wordptr)(bops+blen)=spsmaxt; blen+=2;
               }
              bops[blen++]=0x5f; bops[blen++]=0x5e; bops[blen++]=0x5d;
              bops[blen++]=0x58; bops[blen++]=0x5b; bops[blen++]=0x5a;
              bops[blen++]=0x59; bops[blen++]=0x58; bops[blen++]=0x07;
              bops[blen++]=0xcb;
             break;
             case OVALRET:
              /* if int put in ax; jmp to handle; float put on stack */
              /* figure out how to put something on the stack and return */
              if(rpnsln!=1) { fatal=1; yyerror("ret:illegal # of arguments"); }
              rpp=rpnstk+(rpnsln-1);
              monoploadit(rpp,0);
              switch(rpp->tp%SUNSIGNED)
              { case SCHAR:
                 /* cbw
                  * mov [bp+],rg
                  * 98 */
                 RAL(rpp->bops,rpp->blen+5,char);
                 R1=0x98;
                goto valretint;
                case SSHORT:
                case SINT:
                 /* mov [bp+10],rg
                  * 89 46 10 */
                 RAL(rpp->bops,rpp->blen+4,char);
                valretint:
                 if(rpp->argreg<0||rpp->argreg>7) illegaltype("invalret");
                 R1=0x89; R1=0x46+(rpp->argreg<<3); R1=0x10;
                break;
                case SLONG:
                 /* mov [bp+10],rg
                  * mov [bp+c],rg2
                  * 89 46 10 89 46 c */
                 RAL(rpp->bops,rpp->blen+8,char);
                 if(rpp->argreg<0||rpp->argreg>7||rpp->reguse[rpp->argreg].use
                    !=RP1STPT||rpp->reguse[rpp->argreg].reg<0
                    ||rpp->reguse[rpp->argreg].reg>7)
                  illegaltype("invalret");
                 R1=0x89; R1=0x46+(rpp->argreg<<3); RB1=0x8910; RBI1;
                 R1=0x46+(rpp->reguse[rpp->argreg].reg<<3); R1=0x0c;
                break;
                case SPOINTER:
                 /* mov [bp+a],rg
                  * mov [bp+12],rg2
                  * 5b 07 89 46 a 89 46 12 */
                 RAL(rpp->bops,rpp->blen+8,char);
                 if(rpp->argreg<0||rpp->argreg>7||rpp->reguse[rpp->argreg].use
                    !=RP1STPT||rpp->reguse[rpp->argreg].reg<0
                    ||rpp->reguse[rpp->argreg].reg>7)
                  illegaltype("invalret");
                 RB1=0x075b; RBI1; RB1=0x4689; RBI1; RB1=0x890a; RBI1;
                 RB1=0x1246; RBI1;
                break;
                case SFLOAT:
                case SDOUBLE: /* nothing */
                break;
                case SSTRUCT:
                 /* copy to special transfer area MORE*/
                 fatal=1; yyerror("return struct not implemented");
                break;
                default: illegaltype("A");
              }
              /* add sp,spsmaxt
               * pop di
               * pop si
               * pop bp
               * pop ax
               * pop bx
               * pop dx
               * pop cx
               * pop ax
               * pop es
               * retf
               * 81 c5 spsmaxt 5f 5e 5d 58 5b 5a 59 58 07 cb*/
              if(rpnsln) { fatal=1; yyerror("endoffunc: something on stack"); }
              RAL(rpp->bops,rpp->blen+14,char);
              if(spsmaxt)
               if(spsmaxt<128&&spsmaxt>=-128)
               { RB1=0xc483; RBI1; R1=spsmaxt; }
               else
               { RB1=0xc481; RBI1; RB1=spsmaxt; RBI1; }
              RB1=0x5e5f; RBI1;
              RB1=0x585d; RBI1; RB1=0x5a5b; RBI1; RB1=0x5859; RBI1;
              RB1=0xcb07; RBI1;
              bopsload();
             break;
             case OLDFNCARG:
              /* push on stack */
              /* after loadit; set up so that we don't have ever climb sz */
              rpp=rpnstk+(rpnsln-1);
              stkload(rpp);
              callstksz[calllev-1]+=typesize(1);
              if(!rpp->ncbcnt||!rpp->ncb[rpp->ncbcnt-1].call)
                illegaltype("LDF out of order");
              rpp->ncb[rpp->ncbcnt-1].off=rpp->blen;
              rpp->ncb[rpp->ncbcnt-1].nbp=rpp->bpoff;
              rpp->ncb[rpp->ncbcnt-1].hidn=0;
              /* code is placed in structure of nested calls! */
              rpp->combineflg=1; /* don't zero bpoff */
              rpp->gzf=rpp->gcsof=0;
             break;
             case OPOP:
              /* if memory or point issue warning; if float do fstp st0 if stck
               * add sp,2,4 or 8 */
              rpp=rpnstk+(rpnsln-1);
              switch(rpp->place)
              { case PCMEMORY:
                case PCLSTPOINT:
                 yyerror("warning: something calculated isn't used");
                break;
                case PCMATH:
                 /* fstp st(0)
                  * dd d8 */
                 RAL(rpp->bops,rpp->blen+2,char);
                 RB1=0xd8dd; RBI1;
                break;
                case PCSTACK:
                 /* add sp,2/4/8
                  * 83 c4 2/4/8 */
                 RAL(rpp->bops,rpp->blen+3,char);
                 RB1=0xc483; RBI1;
                 switch(rpp->tp%SUNSIGNED)
                 { case SCHAR:
                   case SSHORT:
                   case SINT:
                    R1=2;
                   break;
                   case SLONG:
                   case SPOINTER:
                   case SFLOAT:
                    R1=4;
                   break;
                   case SDOUBLE:
                    R1=8;
                   break;
                   default: illegaltype("u");
                 }
                break;
                default: fatal=1; yyerror("unknown place for OPOP");
                case PCREG: ;
              }
              rpp->gzf=rpp->gcsof=0;
              bopsload();
             break;
             case OSTCLL:
              /* set up diff. tbl to keep track of how much stack for each */
              callstksz[calllev++]=0;
              startncb++;
             break;
             case OCALL:
             case OCALL0:
              /* call seg:off
               * (CALL only): add sp,callstksz
               * (9a segmnt offset -or- seg ff genmem+3) 83/81 c4 imm8/imm16 */
              rpp=rpnstk+(rpnsln-1);
              if(rpp->place==PCMEMORY)
              { RAL(rpp->bops,rpp->blen+5,char);
                R1=0x9a;
                RAL(rpp->exref,1+rpp->exrcnt,struct externxref);
                rpp->exref[rpp->exrcnt].ptrfnc=0;
                rpp->exref[rpp->exrcnt].off=rpp->blen;
                rpp->exref[rpp->exrcnt++].scoff=rpp->scoff;
                RBI1; RBI1;
              }
             pointercall:
              if(opcode[inp[scan].pos]==OCALL)
              { RAL(rpp->bops,rpp->blen+4,char);
                if(callstksz[calllev-1]<=127&&callstksz[calllev-1]>=(-128))
                { RB1=0xc483; RBI1; R1=callstksz[calllev-1]; }
                else
                { RB1=0xc481; RBI1; RB1=callstksz[calllev-1]; RBI1; }
                rpp->bpoff+=callstksz[--calllev];
                if(--rpp->ncbcnt<0) illegaltype("1ncbcnt");
                if(!rpp->ncb[rpp->ncbcnt].call) illegaltype("not call");
                if(!rpp->ncbcnt) free(rpp->ncb);
                else RAL(rpp->ncb,rpp->ncbcnt,struct nestcombined);
              }
              rpp->lexist=0;
              rpp->tp=opcode[inp[scan].pos+1];
              rpp->size=(*(unsigned long *)(opcode+(inp[scan].pos+3)));
              switch(rpp->tp%SUNSIGNED)
              { case SCHAR:
                case SSHORT:
                case SINT:/*ax*/
                 rpp->place=PCREG;
                 rpp->argreg=0;
                 rpp->reguse->use=1;
                break;
                case SFLOAT:
                case SDOUBLE:
                 if(rpp->maxfltlev<1) rpp->maxfltlev=1;
                 rpp->place=PCMATH;
                break;
                case SPOINTER:/*es/bx*/
                 rpp->place=PCREG;
                 rpp->argreg=3;
                 rpp->reguse[3].use=RP1STPT;
                 rpp->reguse[3].reg=8;
                 rpp->reguse[8].use=RP2NDPT;
                 rpp->reguse[8].reg=3;
                break;
                case SLONG:/*dx/ax*/
                 rpp->place=PCREG;
                 rpp->argreg=0;
                 rpp->reguse->use=RP1STPT;
                 rpp->reguse->reg=2;
                 rpp->reguse[2].use=RP2NDPT;
                 rpp->reguse[2].reg=0;
                break;
                case SSTRUCT:
                 rpp->place=PCMEMORY; /* MORE? */
                 rpp->sect=SCPUBLIC;
                 rpp->scoff=(-1);
                break;
                default: illegaltype("FUNC");
              }
              rpp->gzf=rpp->gcsof=0;
             break;
             case OPOINT:
              /* add cnst to locate ;boff=you know what*/
              rpp=rpnstk+(rpnsln-1);
              if(rpp->place!=PCMEMORY&&rpp->place!=PCLSTPOINT)
              { fatal=1; yyerror("not lval on . operator"); }
              rpp->boff+=(*(wordptr)(opcode+inp[scan].pos+1));
              rpp->tp=opcode[inp[scan].pos+5]; rpp->lexist=0;
              rpp->size=(*(wordptr)(opcode+inp[scan].pos+6));
              rpp->gzf=rpp->gcsof=0;
             break;
             case OFPOINT:
              /* this should currently be error */
              fatal=1; yyerror("field . not implemented");
             break;
             case OARROW:
              /* add const to pointer; like PTRCONVERT and POINT combined*/
              /* make existent pointer PCLSTPOINT. */
              rpp=rpnstk+(rpnsln-1);
              if(rpp->tp!=SPOINTER) { fatal=1; yyerror("-> on non-pointer"); }
              if(rpp->place!=PCREG) monoploadit(rpp,0);
              rpp->boff=(*(wordptr)(opcode+inp[scan].pos+1));
              rpp->place=PCLSTPOINT;
              rpp->tp=opcode[inp[scan].pos+5]; rpp->lexist=0;
              rpp->size=(*(wordptr)(opcode+inp[scan].pos+6));
              rpp->gzf=rpp->gcsof=0;
             break;
             case OFARROW:
              /* currently error */
              fatal=1; yyerror("field -> not implement misc");
             break;
             case OLASTASGN:
              /* if ip-1 was convert reconvert; see below*/
              rpp=rpnstk+(rpnsln-1);
              lstpntld(rpp);;
              if(!rpp->lexist||(rpp->lplace!=PCMEMORY&&rpp->lplace!=PCLSTPOINT))
              { fatal=1; yyerror("= doesn't have an lvalue"); printrpn(rpp); }
              memtmp=genmemin(rpp->llprg,rpp->lplace,-1,rpp->sect,rpp->scoff
                ,rpp->lboff,1,0,rpp->bpoff);
              switch(rpp->ltp%SUNSIGNED)
              { case SCHAR:
                 if(rpp->argreg==6||rpp->argreg==7)
                 { x=findreg(0,rpp->reguse,0,0,rpp->reguse
                     ,rpp->lplace==PCLSTPOINT?rpp->llprg:-1,6,7,-1,-1,-1);
                   regloadit(rpp,rpp,rpp->place,rpp->argreg,0,0,x);
                   rpp->reguse[x].use=1;
                   rpp->argreg=x;
                 }
                 x=0x88;
                 x=0x88;
                goto lasgnint;
                case SSHORT:
                case SINT:
                 x=0x89;
                lasgnint:
                 /* mov [mem],rg/rl
                  * seg 88/89 mem */
                 RAL(rpp->bops,rpp->blen+memtmp.segexist+memtmp.sz+5,char);
                 if(memtmp.segexist) R2=memtmp.seg;
                 if(rpp->argreg<0||rpp->argreg>7)
                 { fatal=1; yyerror("illegal register LSTASGN"); }
                 R2=x; *memtmp.stf+=rpp->argreg<<3;
                 memcpy(rpp->bops+rpp->blen,memtmp.stf,memtmp.sz);
                 rpp->blen+=memtmp.sz;
                 xrfill(rpp,memtmp);
                break;
                case SLONG:
                case SPOINTER:
                 /* mov [mem],rg
                  * mov [mem+2],rg2
                  * seg 89 mem+rg seg2 89 mem2+rg */
                 memtmp2=genmemin(rpp->argreg,rpp->lplace,-1,rpp->sect
                   ,rpp->scoff,rpp->lboff,1,2,rpp->bpoff);
                 RAL(rpp->bops,rpp->blen+memtmp.segexist+memtmp.sz
                  +memtmp2.segexist+memtmp2.sz+10,char);
                 if(memtmp.segexist) R2=memtmp.seg;
                 if(rpp->argreg<0||rpp->argreg>7||rpp->reguse[rpp->argreg].reg<0
                  ||rpp->reguse[rpp->argreg].reg>7)
                 { fatal=1; yyerror("illegal register LSTASGN"); }
                 R2=x; *memtmp.stf+=(rpp->argreg<<3);
                 memcpy(rpp->bops+rpp->blen,memtmp.stf,memtmp.sz);
                 rpp->blen+=memtmp.sz;
                 xrfill(rpp,memtmp);
                 if(memtmp2.segexist) R2=memtmp2.seg;
                 R2=x; *memtmp.stf+=(rpp->reguse[rpp->argreg].reg<<3);
                 memcpy(rpp->bops+rpp->blen,memtmp2.stf,memtmp2.sz);
                 rpp->blen+=memtmp2.sz;
                 xrfill(rpp,memtmp2);
                break;
                case SSTRUCT:
                 fatal=1; yyerror("struct=struct not implemented");
                break;
                case SFLOAT:
                 x=0xd9;
                goto lasgnflt;
                case SDOUBLE:
                 /* fst(p) dw/qw [mem]
                  * d9/dd mem+(2/3)<<3 */
                 x=0xdd;
                lasgnflt:
                 RAL(rpp->bops,rpp->blen+memtmp.segexist+memtmp.sz+1,char);
                 if(memtmp.segexist) R2=memtmp.seg;
                 R2=x; *memtmp.stf+=opcode[inp[scan+1].pos]==OPOP?24:16;
                 memcpy(rpp->bops+rpp->blen,memtmp.stf,memtmp.sz);
                 rpp->blen+=memtmp.sz;
                 xrfill(rpp,memtmp);
                break;
                default: illegaltype("v");
              }
              rpp->boff=rpp->lexist=0;
              if(opcode[inp[scan+1].pos]==OPOP)
              { scan++; bopsload(); }
              rpp->gzf=rpp->gcsof=0;
             break;
             case OASSIGN:
              /* MUST BE MEMORY;store there if ip+1=OPOP: use fstp else fst */
              if(rpp->place!=PCMEMORY&&rpp->place!=PCLSTPOINT)
              { fatal=1; yyerror("= doesn't have an lvalue"); printrpn(rpp); }
              bo=binaryloadit(1,1,0,0,RGNONE,0,0,0,0,-1,0,0,0);
              /*SC/DST/noSM/nostch/norg/NA/rgfld/nomth/nodt/dxok/nlstASgn,ncj*/
              lstasgflg=opcode[inp[scan+1].pos]==OPOP;
              switch(rpp->tp%SUNSIGNED)
              { case SCHAR:
                 if(rpp->place==PCREG&&(rpp->argreg==6||rpp->argreg==7))
                 { x=findreg(0,rpp->reguse,0,0,rpp->reguse
                     ,rpp->lplace==PCLSTPOINT?rpp->llprg:-1,6,7,-1,-1,-1);
                   regloadit(rpp,rpp,rpp->place,rpp->argreg,0,0,x);
                   rpp->reguse[x].use=1;
                   rpp->argreg=x;
                 }
                 x=0x88;
                goto asgnint;
                case SSHORT:
                case SINT: x=0x89;
                asgnint:
                 /* mov [mem],rg
                  * seg 88/89 mem */
             /*    *bo.m.stf+=(rpp->argreg<<3);*/
                 if(bo.const)
                 { addinstr(rpp,bo,0,x==0x89?0xc7:0xc6);
                   RAL(rpp->bops,rpp->blen+2,char);
                   if(x==0x89) { RB2=bo.cval; RBI2; }
                   else R2=bo.cval;
                 }
                 else addinstr(rpp,bo,0,x);
                break;
                case SLONG:
                case SPOINTER:
                 /* mov [mem],rg
                  * mov [mem+2],rg2
                  * seg 89 mem seg2 89 mem2 */
                 if(bo.const)
                 { addinstr(rpp,bo,0,0xc7);
                   RAL(rpp->bops,rpp->blen+2,char);
                   RB2=bo.cval; RBI2;
                   addinstr(rpp,bo,2,0xc7);
                   RAL(rpp->bops,rpp->blen+2,char);
                   RB2=(bo.cval>>16); RBI2;
                 }
                 else
                 { addinstr(rpp,bo,0,0x89);
                   addinstr(rpp,bo,2,0x89);
                 }
              /*   *bo.m.stf+=(rpp->argreg<<3); */
               /*  *bo.m2.stf+=(rpp->reguse[rpp->argreg].reg<<3); */
                break;
                case SSTRUCT:
                 fatal=1; yyerror("struct=struct not implemented");
                break;
                case SFLOAT:
                 x=0xd9;
                goto asgnflt;
                case SDOUBLE:
                 /* fst(p) dw/qw [mem]
                  * d9/dd mem+(2/3)<<3 */
                 x=0xdd;
                asgnflt:
                 RAL(rpp->bops,rpp->blen+bo.m.segexist+bo.m.sz+1,char);
                 if(bo.m.segexist) R2=bo.m.seg;
                 R2=x; *bo.m.stf+=lstasgflg?24:16;
                 memcpy(rpp->bops+rpp->blen,bo.m.stf,bo.m.sz);
                 rpp->blen+=bo.m.sz;
                 xrfill(rpp,bo.m); rpp->place=PCMATH;
                break;
                default: illegaltype("w");
              }
              rpp->boff=rpp->lexist=0;
              rpp->gzf=rpp->gcsof=0;
              rpnsln--;
              if(lstasgflg)
              { scan++; bopsload(); }
             break;
/*IAMfuture: restrict # of registers saved by keeping track of usage and adding
more to xref because of differing room needed*/
             case OFUNC:
             case OSTATFUNC:
fprintf(stderr,"func\n");
              /* nothing; figuring out heading wil be done after func intern.
                 are scanned */
              /* not above: init bpoff not;add code for init memory,etc; */
              /* push es
               * push ax ; make compatible with pusha instr
               * push cx
               * push dx
               * push bx
               * push sp
               * push bp
               * push si
               * push di
               * mov bp,sp
               * sub sp,spsmaxt
               * 06 50 51 52 53 54 55 56 57 8b ec 81 ec spsmaxt */
              a=strlen(opcode+inp[scan].pos+1);
              RAL(bops,blen+a+20+solong,char);
              bops[blen++]=opcode[inp[scan].pos]; /* keep track wether STAT */
              memcpy(bops+blen,opcode+inp[scan].pos+1,a+2); blen+=a+2;
              if(opcode[inp[scan].pos+a+3]==SSTRUCT
                ||opcode[inp[scan].pos+a+3]==SPOINTER)
              { *(unsigned long *)(bops+blen)=(*(unsigned long *)
                  (inp[scan].pos+a+3+opcode));
                blen+=solong;
              }
              bops[blen++]=0x06; bops[blen++]=0x50;
              bops[blen++]=0x51; bops[blen++]=0x52; bops[blen++]=0x53;
              bops[blen++]=0x54; bops[blen++]=0x55; bops[blen++]=0x56;
              bops[blen++]=0x57;
              bops[blen++]=0x8b; bops[blen++]=0xec;
              if(spsmaxt)
               if(spsmaxt<128&&spsmaxt>=(-128))
               { bops[blen++]=0x83; bops[blen++]=0xec; bops[blen++]=spsmaxt; }
               else
               { bops[blen++]=0x81; bops[blen++]=0xec;
                 *(wordptr)(bops+blen)=spsmaxt; blen+=2;
               }
              for(a=1;opcode[inp[scan].pos+a++];);
              b=opcode[inp[scan].pos+a++];
              if(b==SPOINTER||b==SSTRUCT) a+=4;
              a+=4;
             goto funcldpredef;
             case OBLOCK:
              a=5;
             funcldpredef:
              /* handle total stack needed for function;use stck;tot&maxt
               * bpoff will already be initialized from 1st pass
               * load autinit stuff */
              if(rpnsln)
              { fatal=1; yyerror("stuff on stack at new { state }"); }
              b=(*(wordptr)(opcode+inp[scan].pos+a)); a+=4;
               /*size array*/
              while(b)
              { int toff,tlen;
                toff=(*(wordptr)(opcode+inp[scan].pos+a))-spsmaxt;
                a+=4;
                 /* stkoff */
                b-=solong+1+(tlen=opcode[inp[scan].pos+a++]);
                switch(tlen) /* length of value */
                { case 1:
                   /* mov [bp+],imb
                    * c6 46/86 off byte */
                   RAL(bops,blen+5,char);
                   bops[blen++]=0xc6;
                   if(toff<=127&&toff>=(-128))
                   { bops[blen++]=0x46; bops[blen++]=toff; }
                   else
                   { bops[blen++]=0x86;
                     *(wordptr)(bops+blen)=toff; blen+=2;
                   }
                   bops[blen++]=opcode[inp[scan].pos+a++];
                  break;
                  case 2:
                  case 4:
                  case 8:
                   RAL(bops,blen+3*tlen,char);
                   for(;tlen;tlen-=2)
                   { bops[blen++]=0xc7;
                     if(toff<=127&&toff>=(-128))
                     { bops[blen++]=0x46; bops[blen++]=toff; }
                     else
                     { bops[blen++]=0x86;
                       *(wordptr)(bops+blen)=toff; blen+=2;
                     }
                     *(wordptr)(bops+blen)=(*(wordptr)
                      (opcode+inp[scan].pos+a));
                     a+=2; blen+=2; toff+=2;
                   }
                  break;
                  default: yyerror("illegal autoinit size");
                }
              }
/*fprintf(stderr
,"[scan].pos %d  [scan+1].pos %d  a(off) %d  size of init array %d\n"
,inp[scan].pos,inp[scan+1].pos,a,b);*/
             break;
             default: fprintf(stderr,"#2unknown pseudocode %d\n",ch);
           }
          break;
          case TLABEL: /* add to str label */
           SRDLABEL(opcode+inp[scan].pos+1,b);
           if(rpnsln)
           { rpp=rpnstk+(rpnsln-1);
             for(a=0;a<rpp->loccnt;a++)
              if(rpp->loc[a].lab==b)
              { if(rpp->loc[a].place==PCMATH) fltload(rpp);
                else
                { monoploadit(rpp,1);
                  if(rpp->place!=PCREG||rpp->argreg!=rpp->loc[a].argreg)
                   regloadit(rpp,rpp,rpp->place,rpp->place==PCSTACK
                     ?-1:rpp->argreg,0,0,rpp->loc[a].argreg);
                  if((rpp->tp==SPOINTER||rpp->tp%SUNSIGNED==SLONG)
                   &&(rpp->place!=PCREG||rpp->loc[a].rg2
                   !=rpp->reguse[rpp->loc[a].argreg].reg))
                    regloadit(rpp,rpp,rpp->place
                      ,rpp->place==PCSTACK?-1:rpp->argreg,0,2,rpp->loc[a].rg2);
                  rpp->tp=rpp->loc[a].tp;
                  rpp->place=PCREG;
                  if(rpp->loc[a].place!=PCREG) illegaltype("labreg");
                }
               break;
              }
             for(a=0;a<rpp->hblkcnt;a++)
               if(b==rpp->hblk[a].srchlab) rpp->hblk[a].cntnusrch=0;
             if(!rpp->lbcnt) { AL(rpp->lbt,1,struct labels); }
             else RAL(rpp->lbt,rpp->lbcnt+1,struct labels);
             rpp->lbt[rpp->lbcnt].off=rpp->blen;
             rpp->lbt[rpp->lbcnt++].block=b;
             rpp->gzf=rpp->gcsof=0;
           }
           else
           { if(b>=lbtbllen)
             { RAL(lbtbl,b+1,struct labels);
               while(b>=lbtbllen) lbtbl[lbtbllen++].here=0;
             }
             if(lbtbl[b].here)
             { fatal=1; sprintf(temp,"2 definitions of label number %d",b);
               yyerror(temp);
             }
             lbtbl[b].block=blcnt-1;
             lbtbl[b].off=blen;
             lbtbl[b].here=1;
           }
          break;
          case TJMP: /* start new str block */
           /* jmp []
            * e9 offset */
           if(rpnsln)
           { struct locations *lcn;
             rpp=rpnstk+(rpnsln-1);
             monoploadit(rpp,0); rpp->lexist=0;
             RAL(rpp->bops,rpp->blen+2,char);
             RBI1;
             if(rpp->loccnt) { RAL(rpp->loc,rpp->loccnt+1,struct locations); }
             else AL(rpp->loc,1,struct locations);
             lcn=rpp->loc+rpp->loccnt++;
             srchlab=lcn->lab=(*(wordptr)(opcode+(inp[scan].pos+1)));
             lcn->tp=rpp->tp;
             lcn->place=rpp->place;
             if(lcn->place==PCREG)
             { if(rpp->argreg<0||rpp->argreg>7)
               { fatal=1; yyerror("location"); rpp->argreg=0;/*recovery*/ }
               lcn->argreg=rpp->argreg;
               if(rpp->tp%SUNSIGNED==SLONG||rpp->tp==SPOINTER)
                 lcn->rg2=rpp->reguse[rpp->argreg].reg;
             }
             rpp->gzf=rpp->gcsof=0;
           }
           else
           { RAL(bops,blen+2,char);
             blen+=2;
           }
          goto ldnewblock;
          case TTESTJMP:
          /*MORE: add indicator if flags set properly already */
           rpp=rpnstk+(rpnsln-1);
           if(rpp->gzf)
           { int t;
             t=rpp->tp%SUNSIGNED;
             if(t!=SCHAR&&t!=SSHORT&&t!=SINT) illegaltype("zero flag");
             RAL(rpp->bops,rpp->blen+5,char);
           }
           else
           { bo=monoploadit(rpp,0);
             switch(rpp->tp%SUNSIGNED)
             { case SCHAR:
                if(rpp->place!=PCREG||rpp->argreg<0||rpp->argreg>7)
                   illegaltype("1TESTJMP arg");
                /* or rl,rl
                 * 08 mem+rg */
                *bo.m.stf+=(rpp->argreg<<3);
                addinstr(rpp,bo,0,0x8);
                RAL(rpp->bops,rpp->blen+9,char);
               break;
               case SSHORT:
               case SINT:
                if(rpp->place!=PCREG||rpp->argreg<0||rpp->argreg>7)
                   illegaltype("2TESTJMP arg");
                /* or ax,ax
                 * 09 c0 */
                *bo.m.stf+=(rpp->argreg<<3);
                addinstr(rpp,bo,0,0x9);
                RAL(rpp->bops,rpp->blen+9,char);
               break;
               case SLONG:
               case SPOINTER:
                if(rpp->place!=PCREG||rpp->argreg<0||rpp->argreg>7)
                   illegaltype("3TESTJMP arg");
                /* or rg,rg
                 * jnz +2  ; to jmp true
                 * or rg2,rg2
                 * 09 c0 75 2 09 c0 */
/*(later)HERE: make 3 a 5 if possible  also, pop before jnz instruction*/
                *bo.m.stf+=(rpp->argreg<<3);
                addinstr(rpp,bo,0,0x9);
                RAL(rpp->bops,rpp->blen+2,char);
                RB1=0x275; RBI1;
                *bo.m2.stf+=(rpp->reguse[rpp->argreg<<3].reg);
                addinstr(rpp,bo,2,0x9);
                RAL(rpp->bops,rpp->blen+9,char);
               break;
               case SFLOAT:
               case SDOUBLE:
                /* fldz
                 * fcompp
                 * fstsw ax
                 * sahf
                 * d9 ee de d9 df e0 9e */
/*(later)HERE: use a test instruction if possible */
                RAL(rpp->bops,rpp->blen+15,char);
                RB1=0xeed9; RBI1; RB1=0xd9de; RBI1; RB1=0xe0df; RBI1; R1=0x9e;
               break;
               default: illegaltype("x");
             }
           }
           /* jz +3
            * jmp true
            * jmp false
            * 74 3 e9 true e9 false */
          /* RB1=0x374; RBI1; R1=0xe9; RBI1; R1=0xe9; RBI1;*/
           if(inp[scan].sp) rpp->blen+=2; /* jz short */
           else rpp->blen+=4; /* jz short;jmp short */
           if(rpnsln==1&&!nestquest) bopsload();
           srchlab=(*(wordptr)(opcode+(inp[scan].pos+3)));
          goto ldnewblock;
          case TCMPJMP: /* start new str block */
           a=opcode[inp[scan].pos]; a=a==OEQ||a==ONEQ;
           if(rpp->place==PCCONST&&rpp->cval==0&&((rpnstk[rpnsln-1].gzf
             &&rpnstk[rpnsln-1].gcsof)||(rpnstk[rpnsln-1].gzf&&a)))
           { int t;
             bo.swtched=1;
             t=rpnstk[rpnsln-1].tp%SUNSIGNED;
             if(t!=SCHAR&&t!=SSHORT&&t!=SINT) illegaltype("2zero flag");
             RAL(rpp->bops,rpp->blen+5,char);
             if(rpp->tp!=rpnstk[rpnsln-1].tp)
             { yyerror("1not converted right"); }
             *rpp=rpnstk[rpnsln-1];
           }
           else if(rpnstk[rpnsln-1].place==PCCONST&&rpnstk[rpnsln-1].cval==0
             &&((rpp->gzf&&rpp->gcsof)||(rpp->gzf&&a)))
           { int t;
             bo.swtched=0;
             t=rpp->tp%SUNSIGNED;
             if(t!=SCHAR&&t!=SSHORT&&t!=SINT) illegaltype("3zero flag");
             RAL(rpp->bops,rpp->blen+5,char);
             if(rpp->tp!=rpnstk[rpnsln-1].tp)
             { yyerror("2not converted right"); }
           }
           else
           { bo=binaryloadit(1,0,1,1,RGNONE,0,0,1,0,-1,0,1,0);
             /*SC,nDM,SM,swchble,norstr,NA,nolm,lngmth,nolgdf,ndx,nlstas,cjmp*/
             if(rpp->tp!=rpnstk[rpnsln-1].tp)
             { yyerror("not converted right"); }
             switch(rpp->tp%SUNSIGNED)
             { case SCHAR: a=0x38;
                if(bo.const)
                { /* cmp rg1,cnst */
                  addinstr(rpp,bo,0,0x80);
                  RAL(rpp->bops,rpp->blen+9,char);
                  R2=bo.cval;
                 break;
                }
               goto comparison;
               case SSHORT:
               case SINT:
               case SPOINTER: /*MORE:future:currently assumes segs are ==*/
                a=0x39;
               comparison:
                /* cmp rg1,rg2
                 * 38/39 c8 */
                if(bo.const) addcinstr(rpp,bo,0,a>>3); /* cmp arg,const */
                else addinstr(rpp,bo,0,a); /* cmp arg,arg */
                RAL(rpp->bops,rpp->blen+9,char);
               break;
               case SLONG:
          /*      if(rpp->tp>=SUNSIGNED)
                { /* pop ax
                   * pop dx
                   * pop bx
                   * pop cx
                   * cmp cx,dx
                   * jne +2
                   * cmp bx,ax
                   * 58 5a 5b 59 39/3b ca 75 2 39/3b d8 */
           /*       RAL(rpp->bops,rpp->blen+18,char);
                  RB1=0x5a58; RBI1; RB1=0x595b; RBI1;
                  RB1=0xca3b; RBI1; RB1=0x275; RBI1;
                  RB1=0x3bd8; RBI1;
                 break;
                }*/
               case SFLOAT:
               case SDOUBLE:
                if(bo.fltsrcmem)
                { RAL(rpp->bops,rpp->blen+bo.m.segexist+bo.m.sz+1,char);
                  if(bo.m.segexist) R2=bo.m.seg;
                  switch(bo.tp)
                  { case SDOUBLE: /*fcomp qw []*/
                     R2=0xdc;
                     *bo.m.stf+=0x18;
                    break;
                    case SFLOAT:  /*fcomp dw []*/
                     R2=0xd8;
                     *bo.m.stf+=0x18;
                    break;
                    case SLONG:   /*ficomp dw []*/
                     R2=0xda;
                     *bo.m.stf+=0x18;
                    break;
                    default: illegaltype("OCMPJMP");
                  }
                  memcpy(rpp->bops+rpp->blen,bo.m.stf,bo.m.sz);
                  rpp->blen+=bo.m.sz;
                  xrfill(rpp,bo.m);
                }
                else
                { RAL(rpp->bops,rpp->blen+2,char);
                  RB2=0xd9de; RBI2; /* fcompp st(1),st */
                  bo.swtched= !bo.swtched;
                }
                RAL(rpp->bops,rpp->blen+11,char);
                RB1=0xe0df; RBI1; R1=0x9e; /* fstsw ax; sahf */
                rpp->place=PCMATH;
                   /*not really, but simplest method to signal unsing*/
               break;
               default: illegaltype("y");
             }
           }
           if(inp[scan].sp) rpp->blen+=2; /* jcc short */
           else rpp->blen+=4; /* jcc short;jmp short */
           rpnsln--;
           if(rpnsln==1&&!nestquest) bopsload();
           srchlab=(*(wordptr)(opcode+(inp[scan].pos+3)));
          goto ldnewblock;
          case TCASECMP: /* start new str block */
           if(rpnsln)
           { rpp=rpnstk+(rpnsln-1);
             monoploadit(rpp,0);
             lastcaserg=rpp->argreg;
             if(lastcaserg<0||lastcaserg>7||rpp->place!=PCREG
               ||rpp->tp%SUNSIGNED!=SINT)
              illegaltype("a");
             bopsload();
           }
           if(rpnsln) illegaltype("stack exists in casecmp");
           RAL(bops,blen+8,char);
           a=(short)(*(wordptr)(opcode+inp[scan].pos+1));
           if(!lastcaserg)
           { bops[blen++]=0x3d;  /* cmp ax,imw */
             *(wordptr)(bops+blen)=a; blen+=2;
           }
           else
           { if(a<128&&a>=-128)
             { bops[blen++]=0x83; /* cmp rg,ib */
               bops[blen++]=0xf8+lastcaserg; bops[blen++]=a;
             }
             else
             { bops[blen++]=0x81; /* cmp rg,iw */
               bops[blen++]=0xf8+lastcaserg;
               *(wordptr)(bops+blen)=a; blen+=2;
             }
           }
           blen+=2; /*small jump*/
          ldnewblock:
           if(rpnsln)
           { struct hiddenblock *hbk;
             /* put in table in rpnstk */
             rpp=rpnstk+(rpnsln-1);
             for(a=0;a<rpp->ncbcnt;a++) rpp->ncb[a].hidn++;
             if(!rpp->hblkcnt) { AL(rpp->hblk,1,struct hiddenblock); }
             else RAL(rpp->hblk,rpp->hblkcnt+1,struct hiddenblock);
             hbk=rpp->hblk+rpp->hblkcnt++;
             hbk->lbt=rpp->lbt;           hbk->lbcnt=rpp->lbcnt;
             hbk->bops=rpp->bops;         hbk->blen=rpp->blen;
             hbk->bpxref=rpp->bpxref;     hbk->bpxcnt=rpp->bpxcnt;
             hbk->normstat=rpp->normstat; hbk->nstatcnt=rpp->nstatcnt;
             hbk->intstat=rpp->intstat;   hbk->istatcnt=rpp->istatcnt;
             hbk->exref=rpp->exref;       hbk->exrcnt=rpp->exrcnt;
             hbk->swtched=bo.swtched;
             hbk->unsgn=rpp->tp>=SUNSIGNED||rpp->place==PCMATH;
             hbk->jmppos=scan;
             hbk->cntnusrch=1; hbk->srchlab=srchlab;
             rpp->combineflg=1; /* 0 bpoff */
             rpp->lbcnt=rpp->blen=rpp->bpxcnt=rpp->nstatcnt=rpp->istatcnt
              =rpp->exrcnt=0;
             AL(rpp->normstat,1,struct staticxref);
             AL(rpp->intstat,1,struct staticxref);
             AL(rpp->exref,1,struct externxref);
             AL(rpp->bpxref,1,long);
             AL(rpp->bops,1,char);
           }
           else
           { RAL(block,blcnt+1,struct block);
             block[blcnt].outoff=block[blcnt-1].outoff+blen;
             block[blcnt-1].len=blen; block[blcnt-1].ops=bops;
             block[blcnt-1].jmppos=scan;
             block[blcnt-1].swtched=bo.swtched;
             block[blcnt-1].unsgn=rpp->tp>=SUNSIGNED||rpp->place==PCMATH;
             block[blcnt-1].jmpsz=JSSMALL;
             AL(bops,1,char);
             blen=0;
             blcnt++;
           }
          break;
          default:
           fatal=1;
           yyerror("internal error: unknown inp.tp\n");
        }
      }
/*IAM(future): register usage optimisation: see OFUNC*/
      /* ? fild wo [bp]
       * add sp,spsmaxt
       * pop di
       * pop si
       * pop bp
       * pop ax
       * pop bx
       * pop dx
       * pop cx
       * pop ax
       * pop es
       * retf
       * (df 46 0) 81 c5 spsmaxt 5f 5e 5d 58 5b 5a 59 58 07 cb*/
      if(rpnsln) { fatal=1; yyerror("endofprog: something on stack"); }
      RAL(bops,blen+17,char);
      if(ftp==SFLOAT||ftp==SDOUBLE)
      { bops[blen++]=0xdf; bops[blen++]=0x46; bops[blen++]=0; }
      if(spsmaxt)
       if(spsmaxt<128&&spsmaxt>=-128)
       { bops[blen++]=0x83; bops[blen++]=0xc4; bops[blen++]=spsmaxt; }
       else
       { bops[blen++]=0x81; bops[blen++]=0xc4;
         *(wordptr)(bops+blen)=spsmaxt; blen+=2;
       }
      bops[blen++]=0x5f; bops[blen++]=0x5e; bops[blen++]=0x5d;
      bops[blen++]=0x58; bops[blen++]=0x5b; bops[blen++]=0x5a;
      bops[blen++]=0x59; bops[blen++]=0x58; bops[blen++]=0x07;
      bops[blen++]=0xcb;
      RAL(block,blcnt+1,struct block);
      block[blcnt].outoff=block[blcnt-1].outoff+blen;
      block[blcnt-1].len=blen; block[blcnt-1].ops=bops;
      block[blcnt-1].jmppos=scan;
     /*PASS3:
      * optimise jump offset type (near; far)
      */
      for(itmp=1;itmp;)
      { itmp=0;
        for(a=0;a<labxcnt;a++)
        { if(labxref[a].dst==labxref[a].src) continue;
          for(b=0;b<labxcnt;b++)
           if(labxref[a].dst==labxref[b].src)
           { itmp=1;
             labxref[a].dst=labxref[b].dst;
             break;
           }
        }
      }
      for(a=0;a<labxcnt;a++)
      { if(labxref[a].src>=lbtbllen||labxref[a].dst>=lbtbllen
          ||!lbtbl[labxref[a].dst].here)
        { fatal=1; yyerror("internal error:dest. not present"); }
        lbtbl[labxref[a].src]=lbtbl[labxref[a].dst];
      }
/* CHECK all offsets ENCODE all jmps here(not above/although up mks room)
 * REALLOCATE(and flag that such was done) if needed for longer jmps
 * repeat ENTIRE process until flag doesn't get set
 */
      do
      { itmp=0;
        for(a=0;a<blcnt-1;a++)
        { switch(inp[block[a].jmppos].tp)
          { case TCMPJMP:
            case TTESTJMP:
             x=(*(wordptr)(opcode+inp[block[a].jmppos].pos+3));
             if(!lbtbl[x].here)
             { sprintf(temp,"0unknown label %d",x); fatal=1; yyerror(temp); }
             j2off=block[lbtbl[x]
               .block].outoff+lbtbl[x].off-(block[a].outoff+block[a].len);
             x=(*(wordptr)(opcode+inp[block[a].jmppos].pos+1));
             if(!lbtbl[x].here)
             { sprintf(temp,"1unknown label %d",x); fatal=1; yyerror(temp); }
             j1off=block[lbtbl[x]
               .block].outoff+lbtbl[x].off-(block[a].outoff+block[a].len);
             if(inp[block[a].jmppos].sp)
             { /* SPECIAL SHORT (both)
                * jcc short
                * xx bt
                * SPECIAL LONG (both)
                * jcc +3
                * jmp long
                * xx 3 e9 long */
               if(inp[block[a].jmppos].sp==TSPECIAL1) j1off=j2off;
               if(j1off<128&&j1off>=-128) /*Small*/
               { block[a].ops[block[a].len-2]=genjcc(inp[block[a].jmppos].pos
                  ,block[a].swtched,inp[block[a].jmppos].sp==TSPECIAL1
                  ,block[a].unsgn);
                 block[a].ops[block[a].len-1]=j1off;
               }
               else
               { if(block[a].jmpsz==JSSMALL)
                 { RAL(block[a].ops,block[a].len+3,char);
                   block[a].len+=3;
                   block[a].jmpsz=JS1BIG;
                   for(itmp=a+1;itmp<blcnt;itmp++) block[itmp].outoff+=3;
                   itmp=1;
                 }
                 block[a].ops[block[a].len-5]=genjcc(inp[block[a].jmppos].pos
                  ,block[a].swtched,inp[block[a].jmppos].sp==TSPECIAL2
                  ,block[a].unsgn);
                 *(wordptr)(block[a].ops+(block[a].len-4))=0xe903;
                 *(wordptr)(block[a].ops+(block[a].len-2))=j1off;
               }
             }
             else
             { /* SMALL:
                * jcc short
                * jmp short
                * xx bt eb bt
                * 1BIG:
                * 2BIG:
                * jcc short
                * jmp long
                * xx bt e9 long
                * ABIG:
                * jcc +3
                * jmp long
                * jmp long
                * xx 3 e9 long e9 long */
               b=block[a].jmpsz;
               if(j1off<126&&j1off>=-130&&j2off<128&&j2off>=-128) /* SMALL */
               { block[a].ops[block[a].len-4]=genjcc(inp[block[a].jmppos].pos
                  ,block[a].swtched,0,block[a].unsgn);
                 block[a].ops[block[a].len-3]=j1off+2;
                 block[a].ops[block[a].len-2]=0xeb;
                 block[a].ops[block[a].len-1]=j2off;
               }
               else if((j2off<125&&j2off>=-131)||(j1off<125&&j1off>=-131))
               { if(b==JSSMALL)
                 { RAL(block[a].ops,block[a].len+1,char);
                   block[a].len+=1;
                   block[a].jmpsz=JS1BIG;
                   for(itmp=a+1;itmp<blcnt;itmp++) block[itmp].outoff+=1;
                   itmp=1;
                 }
                 block[a].ops[block[a].len-5]=genjcc(inp[block[a].jmppos].pos
                  ,block[a].swtched,(j2off<125&&j2off>=-131),block[a].unsgn);
                 block[a].ops[block[a].len-4]=(j2off<125&&j2off>=131?j2off
                  :j1off)+3;
                 block[a].ops[block[a].len-3]=0xe9;
                 *(wordptr)(block[a].ops+(block[a].len-2))
                  =j2off<123&&j2off>=-131?j1off:j2off;
               }
               else /* ABIG */
               { if(b==JSSMALL)
                 { RAL(block[a].ops,block[a].len+4,char);
                   block[a].len+=4;
                   block[a].jmpsz=JSABIG;
                   for(itmp=a+1;itmp<blcnt;itmp++) block[itmp].outoff+=4;
                   itmp=1;
                 }
                 else if(b==JS1BIG)
                 { RAL(block[a].ops,block[a].len+3,char);
                   block[a].len+=3;
                   block[a].jmpsz=JSABIG;
                   for(itmp=a+1;itmp<blcnt;itmp++) block[itmp].outoff+=3;
                   itmp=1;
                 }
                 block[a].ops[block[a].len-8]=genjcc(inp[block[a].jmppos].pos
                  ,block[a].swtched,1,block[a].unsgn);
                 *(wordptr)(block[a].ops+(block[a].len-7))=0xe903;
                 *(wordptr)(block[a].ops+(block[a].len-5))=j1off-3;
                 block[a].ops[block[a].len-3]=0xe9;
                 *(wordptr)(block[a].ops+(block[a].len-2))=j2off;
               }
             }
            break;
            case TJMP:
             x=(*(wordptr)(opcode+inp[block[a].jmppos].pos+1));
             j1off=block[lbtbl[x]
               .block].outoff+lbtbl[x].off-(block[a].outoff+block[a].len);
             /* jmp short/long
              * eb/e9 short/long */
             if(j1off<128&&j1off>=-128) /*Small*/
             { block[a].ops[block[a].len-2]=0xeb;
               block[a].ops[block[a].len-1]=j1off;
             }
             else
             { if(block[a].jmpsz==JSSMALL)
               { RAL(block[a].ops,block[a].len+1,char);
                 block[a].len+=1;
                 block[a].jmpsz=JS1BIG;
                 for(itmp=a+1;itmp<blcnt;itmp++) block[itmp].outoff+=1;
                 itmp=1;
               }
               block[a].ops[block[a].len-3]=0xe9;
               *(wordptr)(block[a].ops+(block[a].len-2))=j1off;
             }
            break;
            case TCASECMP:
             x=(*(wordptr)(opcode+inp[block[a].jmppos].pos+3));
             if(!lbtbl[x].here)
             { sprintf(temp,"2unknown label %d",x); fatal=1; yyerror(temp); }
             j1off=block[lbtbl[x]
               .block].outoff+lbtbl[x].off-(block[a].outoff+block[a].len);
             /* SHORT (both)
              * je short
              * 74 bt
              * LONG (both)
              * jne +3
              * jmp long
              * 75 3 e9 long */
             if(j1off<128&&j1off>=-128) /*Small*/
             { block[a].ops[block[a].len-2]=0x74;
               block[a].ops[block[a].len-1]=j1off;
             }
             else
             { if(block[a].jmpsz==JSSMALL)
               { RAL(block[a].ops,block[a].len+3,char);
                 block[a].len+=3;
                 block[a].jmpsz=JS1BIG;
                 for(itmp=a+1;itmp<blcnt;itmp++) block[itmp].outoff+=3;
                 itmp=1;
               }
               block[a].ops[block[a].len-5]=0x75;
               *(wordptr)(block[a].ops+(block[a].len-4))=0xe903;
               *(wordptr)(block[a].ops+(block[a].len-2))=j1off;
             }
            break;
            default: fatal=1; yyerror("unknown tp of instruction");
          }
        }
      } while(itmp);
     /*PASS4:
      * write to disk
      */
      a=block[blcnt-1].outoff+block[blcnt-1].len;
      fwrite(&a,4,1,outfile);
      for(a=0;a<blcnt;a++)
      { /* write a "block" */
        fwrite(block[a].ops,block[a].len,sizeof(char),outfile);
        free(block[a].ops);
      }
      for(a=0;a<exrcnt;a++) exref[a].off+=block[exref[a].blck].outoff;
      for(a=0;a<nstatcnt;a++) normstat[a].off+=block[normstat[a].blck].outoff;
      for(a=0;a<istatcnt;a++) intstat[a].off+=block[intstat[a].blck].outoff;
      fwrite(&exrcnt,sizeof(long),1,outfile);
      fwrite(exref,sizeof(struct externxref),exrcnt,outfile);
      fwrite(&nstatcnt,sizeof(long),1,outfile);
      fwrite(normstat,sizeof(struct staticxref),nstatcnt,outfile);
      fwrite(&istatcnt,sizeof(long),1,outfile);
      fwrite(intstat,sizeof(struct staticxref),istatcnt,outfile);
     /*clear everything*/
      RAL(inp,BUFSZ,struct opcode);
      RAL(lbtbl,1,struct labels);
      if(!fread(&oplen,1,sizeof(oplen),infile)) break;
      RAL(opcode,oplen,char);
      fread(opcode,oplen,sizeof(char),infile);
      RAL(block,1,struct block);
      RAL(bops,1,char);
      RAL(normstat,1,struct staticxref);
      RAL(intstat,1,struct staticxref);
      RAL(exref,1,struct externxref);
      RAL(labxref,1,struct labxref);
    }
    /* write out opcode- it contains all the necessary tables */
    fwrite(&oplen,sizeof(long),1,outfile);
    fwrite(opcode,1,oplen,outfile);
    /* write out internal static */
    fwrite(&intstatoff,sizeof(long),1,outfile);
    fwrite(intstatstf,1,intstatoff,outfile);
    /* close files and exit */
    fclose(infile);
    fclose(outfile);
  }
  exit(fatal);
}
lstpntld(rpp) struct stack *rpp;
{ int a,sto;
  if(rpp->lplace==PCMEMORY) return;
  if(!rpp->lexist||rpp->lplace!=PCLSTPOINT)
    illegaltype("no lexist in lstpntld");
  sto=rpp->argreg;
  if(rpp->lpprg2!=8)
  { rpp->argreg=rpp->llprg;
    regloadit(rpp,rpp,rpp->lplace,rpp->lpprg2,1,2,8);
  }
  if(rpp->llprg!=3&&rpp->llprg!=6&&rpp->llprg!=7)
  { a=findreg(0,rpp->reguse,2,0,rpp->reguse,rpp->place==PCREG?sto:-1
     ,rpp->place==PCREG&&rpp->reguse[sto].use==RP1STPT?rpp->reguse[sto].use:-1
     ,-1,-1,-1,-1);
    regloadit(rpp,rpp,rpp->lplace,rpp->llprg,1,0,a);
  }
  rpp->argreg=sto;
}
