/* stdio.h */
#ifndef _dccSTDIOH
#define _dccSTDIOH
#define NULL 0
#define EOF (-1)

typedef struct _dccfiletp
{ int start,end,al;
  char *buf;
  struct _dccfiletp *next,*prev;
  int handle;
  char read,write,type,bufcntrl,err,lastch,eof;
} FILE;

FILE *stdin,*stdout,*stderr;

int printf(),fprintf(),sprintf(),scanf(),sscanf(),fscanf();
int putc(int ch,FILE *file),putchar(int ch);
int fclose(FILE *file);
FILE *fopen(char *file,char *perm);
int feof(FILE *file),ferror(FILE *file),clearerr(FILE *file);
char *fgets(char *s,int n,FILE *file),*gets(char *s);
int puts(char *s),fputs(char *s,FILE *file);
int fread(char *buf,int size,int nitems,FILE *file);
int fwrite(char *buf,int size,int nitems,FILE *file);
int fseek(FILE *file,int offset,int tp),ftell(FILE *file),rewind(FILE *file);
int getc(FILE *file),getchar(void),ungetc(int ch,FILE *file);
#define getchar() getc(stdin)
#define putchar(ch) putc(ch,stdout)
#endif
