/* printps.c: print pseudocode for C compiler*/
#include <stdio.h>
#include "head.h"
#include "pseudo.h"
#define GETCHAR() (flpos--,getchar())
long flpos;
main()/*(argc,argv) int argc; char *argv[];*/
{ int ch,itmp;
  soint=solong=sofloat=sopoint=4;
  sodouble=8; sochar=1; soshort=2;
  while(!feof(stdin))
  { for(ch=flpos=0;ch<4;ch++)
    { itmp=getchar();
      if(itmp==EOF) exit(0);
      flpos+=(1<<(((unsigned long)ch)<<3))*(unsigned long)itmp;
    }
    printf("length: %ld\n",flpos);
    while(flpos>0&&(ch=GETCHAR(),ch!=EOF))
    { switch(ch)
      { case ONEQ: printf("ONEQ: "); prntlab("TR"); prntlab("FS"); break;
        case OEQ: printf("OEQ: "); prntlab("TR"); prntlab("FS"); break;
        case OLT: printf("OLT: "); prntlab("TR"); prntlab("FS"); break;
        case OGT: printf("OGT: "); prntlab("TR"); prntlab("FS"); break;
        case OLE: printf("OLE: "); prntlab("TR"); prntlab("FS"); break;
        case OGE: printf("OGE: "); prntlab("TR"); prntlab("FS"); break;
        case OTEST: printf("OTEST: "); prntlab("TR"); prntlab("FS"); break;
        case OCASECMP: printf("OCASECMP: "); prntint("value"); prntlab("TR");
         break;
        case OADD: printf("OADD"); break;
        case OSUB: printf("OSUB"); break;
        case OSUBSCRPT: printf("OSUBSCRPT"); prnttype("type"); break;
        case OMUL: printf("OMUL"); break;
        case ODIV: printf("ODIV"); break;
        case OCHS: printf("OCHS"); break;
        case OAND: printf("OAND"); break;
        case OOR: printf("OOR"); break;
        case OXOR: printf("OXOR"); break;
        case OMOD: printf("OMOD"); break;
        case OLSHFT: printf("OLSHFT"); break;
        case ORSHFT: printf("ORSHFT"); break;
        case OENDCOMMA: printf("OENDCOMMA"); break;
        case OSTARTCOMMA: printf("OSTARTCOMMA"); break;
        case OENDQ: printf("OENDQ"); break;
        case OSTARTQ: printf("OSTARTQ"); break;

        case OLABEL: printf("OLABEL: "); prntlab(""); break;
        case OCONVERT: printf("OCONVERT: "); prnttype(""); break;
        case OJMP: printf("OJMP: "); prntlab(""); break;
        case OPTRCONVERT: printf("OPTRCONVERT: "); prnttype("tp"); break;
        case OTOPTR: printf("OTOPTR"); break;
        case OSTOPTR: printf("OSTOPTR"); break;
        case ORETURN: printf("ORETURN"); break;
        case OVALRET: printf("OVALRET"); break;
        case OLDFNCARG: printf("OLDFNCARG"); break;
        case OPOP: printf("OPOP"); break;
        case OCALL0: printf("OCALL0: "); prnttype("tp"); break;
        case OCALL: printf("OCALL: "); prnttype("tp"); break;
        case OPOINT: printf("OPOINT: "); prntlong("off"); prnttype("tp");
         break;
        case OFPOINT: printf("OFPOINT: "); prntlong("off"); prntchar("bit");
         prntchar("blen"); prnttype("tp"); break;
        case OARROW: printf("OARROW: "); prntlong("off"); prnttype("tp");
         break;
        case OFARROW: printf("OFARROW: "); prntlong("off"); prntchar("bit");
         prntchar("blen"); prnttype("tp"); break;
        case ORECOG: printf("ORECOG: "); prnttype("tp"); prntcharv("sect");
         prntlong("off"); break;
        case OSTCLL: printf("OSTCLL"); break;
        case OASSIGN: printf("OASSIGN"); break;
        case OLASTASGN: printf("OLASTASGN"); break;

        case ONOT: printf("ONOT"); break;

        case OLCCHAR: printf("OLCCHAR: "); prntcharv(""); break;
        case OLCSTRING: printf("OLCSTRING: "); prntstring(""); break;
        case OLCINT: printf("OLCINT: "); prntint(""); break;
        case OLCLONG: printf("OLCLONG: "); prntlong(""); break;
        case OLCDOUBLE: printf("OLCDOUBLE: "); prntdouble(""); break;

        case OINLINE: printf("OINLINE: "); prntlong(""); break;
        case OINFILE: printf("OINFILE: "); prntstr(""); break;

        case OVINC: printf("OVINC"); break;
        case OINCV: printf("OINCV"); break;
        case OVDEC: printf("OVDEC"); break;
        case ODECV: printf("ODECV"); break;
        /*case OFUNCREC:
         *printf("OFUNCREC");
         *prntcharv("local");
         *prntstr("name");
        *break;*/
        case OSTATFUNC: printf("OSTATFUNC"); goto ofuncorstatfunc;
        case OFUNC:
         printf("OFUNC");
        ofuncorstatfunc:
         prntstr("name");
         prnttype("type");
        goto autinitstff;
        case OBLOCK:
         printf("OBLCK");
        autinitstff:
         prntlong("stack needed: ");
         { long c;
           char d;
           printf("   size of autoinits: ");
           c=getlong();
           while(c)
           { prntlong("\nstack offset");
             d=GETCHAR();
             c-=solong+1+d;
             printf("autamatic init size: %d ",d);
             while(d--) prntcharv("chval");
           }
         }
        break;
        case OENDBLCK: printf("OENDBLCK");
        break;
        case OPTEXTERN: printf("OPTEXTERN");
         printf("the remainder is not implemented here\n"); exit(0);
        default: printf("unknown pseudocode %d",ch);
      }
      putchar('\n');
    }
  }
  printf("EOF\n");
}
prntstr(s) char *s;
{ int c;
  printf("%s: \"",s);
  while(c=GETCHAR(),c!='\0') printf("%c",c);
  printf("\"  ");
}
long getlong()
{ long x;
  int l;
  char buf[32];
  for(l=0;l<solong;l++)
   buf[l]=GETCHAR();
  SRDLONG(buf,x);
  printf("%ld  ",x);
  return x;
}
prntlab(s) char *s;
{ long t;
  char x,buf[32];
  for(x=0;x<SAL;x++) buf[x]=GETCHAR();
  SRDLABEL(buf,t);
  printf("%s: %d   ",s,t);
}
prntlong(s) char *s;
{ long x;
  int l;
  char buf[32];
  for(l=0;l<solong;l++)
   buf[l]=GETCHAR();
  SRDLONG(buf,x);
  printf("%s: %ld  ",s,x);
}
prntint(s) char *s;
{ int l,x;
  char buf[32];
  for(l=0;l<soint;l++)
   buf[l]=GETCHAR();
  SRDINT(buf,x);
  printf("%s: %d  ",s,x);
}
prntchar(s) char *s;
{ printf("%s: '%c'   ",s,GETCHAR());
}
prntcharv(s) char *s;
{ printf("%s: %d   ",s,GETCHAR());
}
prnttype(s) char *s;
{ int ch;
  ch=GETCHAR();
  printf("%s: %s ",s,ch>SUNSIGNED?"unsigned":"");
  switch(ch%SUNSIGNED)
  { case SCHAR: printf("SCHAR   "); break;
    case SSHORT: printf("SSHORT   "); break;
    case SINT: printf("SINT   "); break;
    case SLONG: printf("SLONG   "); break;
    case SFLOAT: printf("SFLOAT   "); break;
    case SDOUBLE: printf("SDOUBLE   "); break;
    case SFUNC: printf("SFUNC   "); break;
    case SPOINTER: printf("SPOINTER: "); prntlong("size"); break;
    case SSTRUCT: printf("SSTRUCT: "); prntlong("size"); break;
    default: printf("unknown type %d  ",ch);
  }
}
prntstring(s) char *s;
{ printf("%s: ",s); prntlong("offset"); prntlong("length"); }
prntdouble(s) char *s;
{ int l;
  double x;
  char buf[32];
  for(l=0;l<sodouble;l++)
   buf[l]=GETCHAR();
  SRDDOUBLE(buf,x);
  printf("%s: %lf  ",s,x);
}
