/* psas.c: (full 80386 version) pseudo code assembler for C compiler */
/*386 version- use push 0 when possible*/
/* things looked over on first sort for 80386:
 *  future: type void/volatile/register/enum
 *  input/output file formats and diffrences
 */
char RALmsg[]="RAL() can't get enough memory";
char ALmsg[]="AL() can't get enought memory";

#include <math.h>
#include <stdio.h>
#define NOFUNCTIONS
#define ISPSAS
#include "genhead.h"
#include "pseudo.h"
#include "psas.h"
/*input file format:
* size ( OFUNC "name" type stksz predefsz ( len stf len stf ...) stuff )
* size ( OFUNC "name" type stksz predefsz ( len stf len stf ...) stuff )
* ...
* size (OPTEXTERN extcnt ("nm" type prepres [size stuff cnt (sect soff poff)])
*           strlen strstf cnt (sect soff poff))
*/
#define STNORMAL     0 /*jump optimization modes*/
#define STERASE      1
#define STLABEL      2
#define STERASELABEL 3
struct labxref
{ short dst;
  char xrefed,deleted;
} *labxref;
int labxcnt;

struct dblxref
{ double dbl;
  int off;
} *dbxr;
int dbcnt;

char *tempname="temppsas";

main(argc,argv) int argc; char *argv[];
{ int ch,x,fcnt,lstasgflg,rsto,r2sto,srchlab,lastcaserg,lastjmp,createlexist;
  int src,dst,loopable;
  struct bld bo;
  long itmp;
  long j1off,j2off;
  struct stack *rpp;
  char status,newstat;
  double dbl;
/*extern char inchar;
inchar='~';
*/
/*initintegrity('~');*/
  soint=solong=sofloat=sopoint=4;
  sodouble=8; sochar=1; soshort=2;
  blcnt=oppos=fatal=0;
  AL(dbxr,1,struct dblxref);
  AL(inp,BUFSZ,struct opcode);
  AL(lbtbl,1,struct labels);
  AL(opcode,1,char);
  AL(block,1,struct block);
  AL(bops,1,char);
  AL(exref,1,struct externxref);
  AL(labxref,1,struct labxref);
  AL(exttbl,1,struct exttbl);
  for(fcnt=1;fcnt<argc;fcnt++)
  { if(!strncmp("-T",argv[fcnt],2))
    { tempname=argv[fcnt]+2;
     continue;
    }
    dbcnt=alreadyalloc387rnd=structretsize=alreadyallocmemcpy=exttblsz=inline=0;
    strcpy(inpfile,argv[fcnt]);
    infile=fopen(argv[fcnt],"r");
    if(!infile) { fprintf(stderr,"Can't open input file\n"); exit(-1); }
    RAL(inp,BUFSZ,struct opcode);
    RAL(lbtbl,1,struct labels);
    fread(&oplen,1,sizeof(oplen),infile);
    RAL(opcode,oplen,char);
    fread(opcode,oplen,sizeof(char),infile);
    RAL(block,1,struct block);
    RAL(bops,1,char);
    argv[fcnt][strlen(argv[fcnt])-1]='o'; /* adjust suffix of ouput */
    outfile=fopen(argv[fcnt],"w");
    if(!outfile)
    { fprintf(stderr,"Can't open output file \"%s\"\n",argv[fcnt]); exit(-1); }
    RAL(exref,1,struct externxref);
    RAL(labxref,1,struct labxref);
    while(1)
    { block->outoff=mathuse=blen=inlen=lbtbllen=spsln=rpnsln=spstot=spsmaxt=0;
      startcomma=nestquest=startncb=labxcnt=oppos=exrcnt=0;
/*IMERE: VM init/reinit */
      lastjmp=0;
      blcnt=1;
     /*PASS1:
      * read in
      * set up stack(for pushd regs local variables and below)
      * coprocessor requirements
      * future: jmp optimization
      */
      status=STNORMAL;
      if(*opcode==OPTEXTERN) break;
      while(ch=GETCHAR(),ch!=EOF)
      { inp[inlen].pos=oppos-1;
        inp[inlen].sp=0;
        if(status!=STLABEL&&status!=STERASELABEL) newstat=status;
        else newstat=STNORMAL;
        switch(ch)
        { case ONEQ:
          case OEQ:
          case OLT:
          case OGT:
          case OLE:
          case OGE:
           inp[inlen].tp=TCMPJMP; oppos+=2*SAL; newstat=STERASE; break;
          case OTEST:
           inp[inlen].tp=TTESTJMP; oppos+=2*SAL; newstat=STERASE; break;
          case OCASECMP:
           inp[inlen].tp=TCASECMP; oppos+=soint+SAL;
           if(status!=STERASE) newstat=STNORMAL;
          break;
          case OSTARTQ:
          case OENDQ:
          case OENDCOMMA:
          case OSTARTCOMMA:
           inp[inlen].tp=TSTATUS; break;
          case OINLINE:
           oppos+=solong; inp[inlen].tp=TSTATUS; break;
          case OINFILE:
           while(GETCHAR()!='\0');
           inp[inlen].tp=TSTATUS; break;
          case OADD:
          case OSUB:
          case OAND:
          case OOR:
          case OXOR:
           inp[inlen].tp=TINTBINARY; break;
          case OSUBSCRPT:
           inp[inlen].tp=TINTBINARY; typeposinc(0); break;
          case OCHS:
          case OMUL:
          case ODIV:
          case OMOD:
          case OLSHFT:
          case ORSHFT:
           inp[inlen].tp=TSTD; break;
          case OLABEL:
           inp[inlen].tp=TLABEL; oppos+=SAL;
           newstat=status;
           switch(status)
           { case STNORMAL:
              newstat=STLABEL;
             goto p1olabel;
             case STERASE:
              newstat=STERASELABEL;
             p1olabel:
             case STLABEL:
             case STERASELABEL:
              a=(*(labelptr)(opcode+(inp[inlen].pos+1)));
              do
              { b=0;
                switch(inp[lastjmp].tp)
                { case TJMP:
                   if(*(labelptr)(opcode+(inp[lastjmp].pos+1))==a)
                    goto p1lberase;
                  break;
                  case TTESTJMP:
                  case TCMPJMP:
                   if(*(labelptr)(opcode+(inp[lastjmp].pos+1))==a)
                   { inp[lastjmp].sp=TSPECIAL1;
                     newstat=STLABEL;
                   }
                   else
                    if(*(labelptr)(opcode+(inp[lastjmp].pos+3))==a)
                    { inp[lastjmp].sp=TSPECIAL2;
                      newstat=STLABEL;
                    }
                  break;
                  case TCASECMP:
                   if(*(labelptr)(opcode+(inp[lastjmp].pos+soint+1))
                     ==a)
                   { /* erase this jump */
                    p1lberase:
                     b=1;
                     memmove(inp+(lastjmp),inp+(lastjmp+1)
                       ,sizeof(struct opcode)*(inlen-lastjmp));
                     while(lastjmp>0&&(inp[--lastjmp].tp==TLABEL
                       ||inp[lastjmp].tp==TSTATUS));
                     inlen--;
                     newstat=STLABEL;
                   }
                }
              } while(b);
             break;
             default: fatal=1; yyerror("unknown status");
           }
          break;
          case OJMP:
           a=(*(labelptr)(opcode+oppos));
           inp[inlen].tp=TJMP; oppos+=SAL;
           newstat=STERASE;
           x=0;
           switch(status)
           { case STLABEL:
              if((inp[lastjmp].tp==TCMPJMP||inp[lastjmp].tp==TTESTJMP)
                   &&inp[lastjmp].sp)
              { for(b=1,itmp=lastjmp+1;itmp<inlen;itmp++)
                  if(inp[itmp].tp!=TLABEL&&inp[itmp].tp!=TSTATUS)
                  { b=0; break; }
                x=b;
                if(b)
                { inp[lastjmp].sp=0;
                  status=STERASE;
                }
              }
             case STERASELABEL:
              if(a>=labxcnt)
              { a+=10;
                RAL(labxref,a,struct labxref);
                while(labxcnt<a) labxref[labxcnt++].xrefed=0;
                a-=10;
              }

              for(itmp=lastjmp++;lastjmp<inlen;lastjmp++)
               if(inp[lastjmp].tp==TLABEL)
               { src=(*(labelptr)(opcode+(inp[lastjmp].pos+1)));
                 if(src>=labxcnt)
                 { src+=10;
                   RAL(labxref,src,struct labxref);
                   while(labxcnt<src) labxref[labxcnt++].xrefed=0;
                   src-=10;
                 }
/*if(labxref[src].xrefed)
{ fatal=1; yyerror("internal multiple xrefs");
fprintf(stderr,"src %d xrefed %d a %d\n",src,labxref[src].xrefed,a); }
MERE: future: this is OK, if the dest. is between here and jump
*/
                 labxref[src].dst=a; labxref[src].xrefed=1;
               }
              if(labxref[a].xrefed)
              { loopable=0;
                for(b=a;labxref[b].xrefed&&b!=labxref[b].dst
                    &&a!=labxref[b].dst;b=labxref[b].dst)
                  if(!labxref[b].deleted) loopable=1,dst=b;
                src=b;
                b=1;
                /* if src==a then nothing. */
                if(labxref[src].xrefed&&labxref[src].dst==a)
                { if(!loopable) dst=a,b=0;
                }
                else dst=src; /* self-ref or end is src */
              }
              else
              { b=1; dst=a; }

              if(status==STLABEL) b=0;
              /* at this point: dst==place where everything should refrence
               *  (b) iff jmp will be erased */
              for(lastjmp=itmp+1;lastjmp<inlen;lastjmp++)
                if(inp[lastjmp].tp==TLABEL)
                { src=(*(labelptr)(opcode+(inp[lastjmp].pos+1)));
                  labxref[src].dst=dst; labxref[src].deleted=b;
                }
              for(src=a;labxref[src].xrefed /*&&labxref[src].dst!=a*/
                 &&labxref[src].dst!=src;)
              { loopable=labxref[src].dst; /* loopable is temp var. */
                labxref[src].dst=dst;
                src=loopable;
              }
              if(!b) status=STLABEL; /* make sure jmp is not erased */
              else if(x) /* leave open for new SPECIAL */
              { lastjmp=itmp++; /* restore entrance value */
                for(b=itmp;b<inlen;b++)
                  if(inp[b].tp==TSTATUS) inp[itmp++]=inp[b];
                inlen=itmp;
if(status!=STERASE) { fatal=1; yyerror("inernal error labelsX"); exit(-1); }
               break;
              }
             case STNORMAL:
             case STERASE:
              lastjmp=inlen;
             break;
             default: fatal=1; yyerror("unknown status");
           }
          break;
          case OCALL0:
          case OCALL:
          case OPTRCONVERT:
          case OCONVERT:
           inp[inlen].tp=TSTD; typeposinc(0); break;
          case OTOPTR:
          case OSTOPTR:
           inp[inlen].tp=TSTD; break;
          case ORETURN:
          case OVALRET:
           newstat=STERASE;
           inp[inlen].tp=TSTD; break;
          case OLDFNCARG:
          case OPOP:
          case OSTCLL:
           inp[inlen].tp=TSTD; break;
          case OPOINT:
          case OARROW:
           inp[inlen].tp=TSTD; oppos+=solong; typeposinc(0); break;
          case OFPOINT:
          case OFARROW:
           inp[inlen].tp=TSTD; oppos+=2*sochar+solong; typeposinc(0); break;
          case ORECOG:
           inp[inlen].tp=TRECOG; typeposinc(0); oppos+=sochar+solong; break;
          case OLASTASGN:
          case OASSIGN:
           inp[inlen].tp=TSTD; break;
          case ONOT:
           inp[inlen].tp=TSTD; break;
          case OLCCHAR:   oppos+=sochar; goto ldcntp;
          case OLCSTRING: oppos+=2*solong; goto ldcntp;
          case OLCINT:    oppos+=soint; goto ldcntp;
          case OLCLONG:   oppos+=solong; goto ldcntp;
          case OLCDOUBLE: oppos+=sodouble; goto ldcntp;
          ldcntp:
          case OVINC:
          case OINCV:
          case OVDEC:
          case ODECV:
           inp[inlen].tp=TSTD; break;
          case OFUNC:
          case OSTATFUNC:
           while(GETCHAR()!='\0');
           typeposinc(1);
           spstot+=(spssz[spsln++]=getlong());
           autinitinc();
           inp[inlen].tp=TSTD;
           if(spstot>spsmaxt) spsmaxt=spstot;
          break;
          case OBLOCK:
           spstot+=(spssz[spsln++]=getlong());
           if(!autinitinc()) inp[inlen].tp=TSTATUS;
           else inp[inlen].tp=TSTD;
           if(spstot>spsmaxt) spsmaxt=spstot;
          break;
          case OENDBLCK:
           newstat=status;
           spstot-=spssz[--spsln];
           inp[inlen].tp=TSTATUS;
          break;
          default:
           fprintf(stderr,"#1unknown pseudocode %d,inlen %d  oppos %d\n"
              ,ch,inlen,oppos);
        }
        if((status!=STERASELABEL&&status!=STERASE)
          ||newstat!=STERASE||inp[inlen].tp==TSTATUS)
        { if(inp[inlen].tp!=TLABEL&&inp[inlen].tp!=TSTATUS) lastjmp=inlen;
          inlen++;
        }
        status=newstat;
        if(!(inlen%BUFSZ))
        { RAL(inp,inlen+BUFSZ,struct opcode); }
      }
     /*PASS2:
      * translate to machine
      * any evalation optimization
      */
      for(scan=0;scan<inlen;scan++)
      { rpp=rpnstk+(rpnsln-2);
/*if(!(scan%1000))
yyerror("1000 scan");
*/
/*if(inline==1094)
fprintf(stderr,"<<scan %d  tp %d  opc[i[s].p] %d  i[s].p %d  blen %d>>",scan
,inp[scan].tp,opcode[inp[scan].pos],inp[scan].pos,blen);
/*if(rpnsln==0)
fprintf(stderr,"ZEROSTACK ");
*/
        switch(inp[scan].tp)
        { case TSTATUS:
           switch(opcode[inp[scan].pos])
           { case OSTARTCOMMA:
              startcomma++;
             break;
             case OINLINE:
              inline= *(dwordptr)(opcode+(inp[scan].pos+1));
             break;
             case OINFILE:
              strcpy(inpfile,opcode+inp[scan].pos+1);
             break;
             case OENDCOMMA:
              if(rpnsln)/* it might not be if last instr. a cmp or test */
              { rpp=rpnstk+(rpnsln-1);
                if(!rpnsln||!(rpp->ncbcnt--)||rpp->ncb[rpp->ncbcnt].call)
                  illegaltype("endcomma ncb");
                if(!rpp->ncbcnt) free(rpp->ncb);
                else RAL(rpp->ncb,rpp->ncbcnt,struct nestcombined);
              }
             break;
             case OSTARTQ:
              nestquest++;
             break;
             case OENDQ:
              nestquest--;
             break;
             case OBLOCK:
             case OENDBLCK:
              /*reduce total by value on stack; or if endfunc setup all else */
             break;
             default: fatal=1; yyerror("unknown pseudocode under TSTATUS");
           }
          break;
          case TRECOG: /*ORECOG*/
           /* put in as memory */
           initrpnstk();
           if(rpnsln&&rpnstk[rpnsln-1].combineflg)
           { rpp=rpnstk+(rpnsln-1); rpp->combineflg=0; }
           else
           { rpp=rpnstk+rpnsln++;
             AL(rpp->bops,1,char); rpp->blen=0;
           }
           rpp->place=PCMEMORY;
           rpp->tp=opcode[inp[scan].pos+1];
           rpp->size=(*(dwordptr)(opcode+inp[scan].pos+2));
           rpp->sect=opcode[inp[scan].pos+2
            +((rpp->tp==SPOINTER||rpp->tp==SSTRUCT)<<2)];
           rpp->scoff=(*(dwordptr)(opcode+inp[scan].pos+3
            +((rpp->tp==SPOINTER||rpp->tp==SSTRUCT)<<2)));
          break;
          case TINTBINARY:
           switch(opcode[inp[scan].pos])
           { case OADD:
             case OSUBSCRPT:
              b=0; /* used as flag if switched */
              if(rpp->tp==SPOINTER)
              {addorsubpoint:
                a=rpnstk[rpnsln-1].tp%SUNSIGNED;
                if(a!=SLONG&&a!=SINT) illegaltype("ADD/SUBSCRPT");
                itmp=powof2(rpp->size);
                lstasgflg=opcode[inp[scan+1].pos]==OLASTASGN
                  &&opcode[inp[scan+2].pos]==OPOP&&rpp->place!=PCREG;
                createlexist=opcode[inp[scan+1].pos]==OLASTASGN
                   ||(opcode[inp[scan+1].pos]==OCONVERT
                     &&opcode[inp[scan+2].pos]==OLASTASGN);
                bo=binaryloadit(1,lstasgflg,itmp<=0,opcode[inp[scan].pos]
                  !=OSUB,RGNONE,0,0,-1,createlexist,0,b,1);
                /*SC,lsDM,ccSM,ccswtch,none,AX,nlim,noMTH,diflg,noDX,ncj,presw
                 * ,allowboff*/
                if(bo.const)
                { if(!lstasgflg)
                  { bo.cval*=rpp->size;
                    if(opcode[inp[scan].pos]==OSUB) rpp->boff-=bo.cval;
                    else rpp->boff+=bo.cval;
                  }
                  else
                  { bo.cval=(opcode[inp[scan].pos]==OSUB?-bo.cval:bo.cval)
                       *rpp->size;
                    if(bo.cval>127||bo.cval<-128)
                    { /* add dw [mem],const
                       * 81 mem+0 constdw */
                      addinstr(rpp,bo,0x81);
                      RAL(rpp->bops,rpp->blen+4,char);
                      *(dwordptr)(rpp->bops+rpp->blen)=bo.cval;
                      rpp->blen+=4;
                    }
                    else if(bo.cval==1)
                    { /* inc dw [mem]
                       * ff mem+0 */
                      addinstr(rpp,bo,0xff);
                    }
                    else if(bo.cval==-1)
                    { /* dec dw [mem]
                       * ff mem+(1<<3) */
                      *bo.m.stf+=8;
                      addinstr(rpp,bo,0xff);
                    }
                    else if(bo.cval)
                    { /* add dw [mem],const
                       * 83 mem+0 cval */
                      addinstr(rpp,bo,0x83);
                      RAL(rpp->bops,rpp->blen+4,char);
                      R2=bo.cval;
                    }
                  }
                }
                else
                { /* mul/shl int
                   * add/sub [m],vl
                   * */
                  rsto=rpp->argreg;
                  if(rpp->place!=PCREG&&rpp->place!=PCLSTPOINT) rsto= -1;
                  r2sto=(*bo.m.stf)&7;
                  if(((*bo.m.stf>>6)&3)!=3) r2sto=(-1);
                  if(rsto==r2sto||lstasgflg)
                     /* if rsto==-1 then should be lstasgflg */
                  { r2sto=(*bo.m.stf>>3)&7;
                    x=0;
                  }
                  else x=2;
                  if(itmp==(-1))
                  { /* mul reg,reg,size
                     * 6b/69 mem size */
                    a=((bo.swtched?*bo.m.stf:(*bo.m.stf>>3))&7);
                    if(bo.swtched) 
                    { b=(*bo.m.stf&0xc7);
                      if((b&0xc0)!=0xc0)
                        a=findreg(0,rpp->reguse,0,0,rpp->reguse
                           ,rsto,r2sto,-1,-1);
                      else a=b&7;
                    }
                    else { a=(*bo.m.stf>>3)&7; b=0xc0+a; }
                    rpp->reguse[a].use=1;
                    RAL(rpp->bops,rpp->blen+5+bo.m.sz,char);
                    b+=(a<<3);

                    if(bo.swtched)
                    { if(!x) /* rp1 general register is source */
                      { rpp->argreg=a;
if(rpp->place!=PCREG) { fatal=1; yyerror("internal at add ptr"); }
                      }
                      a=(*bo.m.stf&0x38)+0xc0+a;
                      itmp=1;
                    }
                    else
                    { if(x) /* rp1 memory is source */
                      { rpp->argreg=a;
if(rpp->place!=PCREG) { fatal=1; yyerror("internal at add ptr2"); }
                      }
                      a=(*bo.m.stf&0xc7)+(a<<3);
                      itmp=bo.m.sz;
                    }

                    if(rpp->size<128&&rpp->size>=-128)
                    { if((b&0xc0)!=0xc0)
                      { *bo.m.stf=b; addinstr(rpp,bo,0x6b);
                        RAL(rpp->bops,rpp->blen+1,char);
                      }
                      else { R2=0x6b; R2=b; }
                      R2=rpp->size;
                    }
                    else
                    { if((b&0xc0)!=0xc0)
                      { *bo.m.stf=b; addinstr(rpp,bo,0x69);
                        RAL(rpp->bops,rpp->blen+4,char);
                      }
                      else { R2=0x69; R2=b; }
                      RB2=rpp->size; RBI2;
                    }
                    bo.m.sz=itmp; *bo.m.stf=a;
                    if(itmp==1) bo.m.xexist=0;
                  }
                  else if(itmp)
                  { RAL(rpp->bops,rpp->blen+3,char);
                    /*shl rsto,itmp*/
                    if(itmp==1) R2=0xd1;
                    else R2=0xc1;
                    R2=0xe0+((bo.swtched?*bo.m.stf:(*bo.m.stf>>3))&7);
if(bo.swtched&&((*bo.m.stf>>6)&3)!=3)
{ fatal=1; yyerror("not reg in subscrpt"); }
                    if(itmp!=1) R2=itmp;
                  }
                  a=(opcode[inp[scan].pos]==OSUB?0x29:0x1)+x;
                  addinstr(rpp,bo,a);
                }
                if(opcode[inp[scan].pos]==OSUBSCRPT)
                { rpp->place=PCLSTPOINT;
                  rpp->tp=opcode[inp[scan].pos+1];
                  if(rpp->tp==SPOINTER||rpp->tp==SSTRUCT)
                   rpp->size=(*(dwordptr)(opcode+(inp[scan].pos+2)));
                }
                rpnsln--;
                if(lstasgflg)
                { scan+=2;
                  bopsload();
                }
                rpp->gzf=rpp->gcsof=0;
               break;
              }
              else if(rpnstk[rpnsln-1].tp==SPOINTER)
              { b=1; /* being reversed */
                rpnstk[rpnsln]=(*rpp); *rpp=rpnstk[rpnsln-1];
                rpnstk[rpnsln-1]=rpnstk[rpnsln];
               goto addorsubpoint;
              }
              else
              { x=0x11; a=0x01;
               goto binaryintops;
              }
             break;
             case OSUB:
              if(rpp->tp==SPOINTER)
              { if(rpnstk[rpnsln-1].tp!=SPOINTER) goto addorsubpoint;
                if(rpp->size!=rpnstk[rpnsln-1].size) { yyerror("point size"); }
                createlexist=opcode[inp[scan+1].pos]==OLASTASGN
                   ||(opcode[inp[scan+1].pos]==OCONVERT
                     &&opcode[inp[scan+2].pos]==OLASTASGN);
                bo=binaryloadit(0,0,1,0,RGNONE,0,0,-1
                  ,createlexist,0,0,1);
                /*noSC,noDM,SM,noswtch,norest.,NA,nol,NA,nodiff,dxok,ncj*/
                addinstr(rpp,bo,0x29+(bo.swtched<<1)); /* sub 1,2 */
                itmp=powof2(rpp->size);
                if(itmp==(-1))
                { if(rpp->argreg) /* not AX */
                    regloadit(rpp,rpp,PCREG,rpp->argreg,0,0); /*AX*/
                  RAL(rpp->bops,rpp->blen+9,char);
                  rpp->argreg=0;
                  a=findreg(0,rpp->reguse,0,0,rpp->reguse,rpp->argreg,2,0,-1);
                  rpp->reguse->use=rpp->reguse[a].use=rpp->reguse[2].use=1;
                  /*DX used above*/
                  R2=0xb8+a;  /* mov erg,size */
                  RB2=rpp->size; RBI2;
                  RS2=0xd231; RSI2; /*xor edx,edx*/
                  R2=0xf7; R2=0xf0+a; /*div eax,erg*/
                }
                else if(itmp)
                { RAL(rpp->bops,rpp->blen+3,char);
                  if(itmp==1) R2=0xd1;
                  else R2=0xc1;
                  R2=0xf8+rpp->argreg;
                  if(itmp!=1) R2=itmp;
                }
                rpp->reguse[rpp->argreg].use=1;
if(rpp->place!=PCREG) { fatal=1; yyerror("not in register"); }
                rpp->tp=SINT;
                rpnsln--;
                rpp->gzf=rpp->gcsof=0;
               break;
              }
              x=0x19; a=0x29;
             goto binaryintops;
             case OAND: x=a=0x21; goto binaryintops;
             case OOR:  x=a=0x9;  goto binaryintops;
             case OXOR:
              x=a=0x31;
             binaryintops:
              lstasgflg=opcode[inp[scan+1].pos]==OLASTASGN&&opcode[inp[scan+2]
               .pos]==OPOP&&rpp->place!=PCREG&&(rpp->tp%SUNSIGNED==SINT
               ||rpp->tp%SUNSIGNED==SLONG);
              createlexist=opcode[inp[scan+1].pos]==OLASTASGN
                 ||(opcode[inp[scan+1].pos]==OCONVERT
                   &&opcode[inp[scan+2].pos]==OLASTASGN);
              if(opcode[inp[scan].pos]==OSUB)
              { bo=binaryloadit(1,lstasgflg,1,0,RGNONE,0,0,-1
                  ,createlexist,0,0,0);
                /*1SC,noDST,1SM,nswitch,noalim,NA,regfld,nlngmth,nodf,no,ncj*/
              }
              else
                bo=binaryloadit(1,lstasgflg,1,1,RGNONE,0
                  ,0,-1,createlexist,0,0,0);
              /*SRC,noDST,SM,switch,noalim,NA,regfld,nolongmth,nodf,no,ncj*/
              if(bo.mem) a+=2,x+=2;
              if(rpp->place==PCMATH)
              { if(bo.fltsrcmem)
                { RAL(rpp->bops,rpp->blen+1+bo.m.sz,char);
                  if(a==1||a==3)
                  { if(bo.tp==SFLOAT) { R2=0xd8; /* *stf+=0 */ }
                    else
                    { if(bo.tp!=SDOUBLE) { illegaltype("float"); }
                      R2=0xdc; /* *stf+=0 */
                    }
                  }
                  else
                  { if(a!=0x29&&a!=0x2b) { illegaltype("1floating binary"); }
                    if(bo.tp==SFLOAT)
                    { R2=0xd8;
                      *bo.m.stf+=0x20+(bo.swtched<<3);
                    }
                    else
                    { if(bo.tp!=SDOUBLE) { illegaltype("float"); }
                      R2=0xdc;
                      *bo.m.stf+=0x20+(bo.swtched<<3);
                    }
                  }
                  memcpy(rpp->bops+rpp->blen,bo.m.stf,bo.m.sz);
                  rpp->blen+=bo.m.sz;
                  xrfill(rpp,bo.m);
                }
                else
                { /* faddp/fsubp/fsubrp st(1),st
                   * DE C1 */
                  RAL(rpp->bops,rpp->blen+2,char);
                  if(a==1||a==3) RS2=0xc1de;
                  else
                  { if(a!=0x29&&a!=0x2b) { illegaltype("2floating binary"); }
                    if(bo.swtched) RS2=0xe1de;
                    else RS2=0xe9de;
                  }
                  RSI2;
                }
              }
              else
              { if(rpnstk[rpnsln-1].tp!=rpp->tp)
                { fatal=1; yyerror("types not equal for int operator");
fprintf(stderr,"rpn-1.tp %d rpn-2.tp %d rpnsln %d\n"
,rpnstk[rpnsln-1].tp,rpp->tp,rpnsln);
 }
                if(bo.const) addcinstr(rpp,bo,a>>3);
                else addinstr(rpp,bo,(int)a);
                rpp->gzf=rpp->gcsof=1;
                /* should already be non zero */
              }
              rpnsln--;
              if(lstasgflg)
              { scan+=2;
                bopsload();
              }
             break;
             default: fatal=1; yyerror("unknown pseudocode under TINTBINARY");
           }
          break;
          case TSTD: /* put in str block current */
           switch(opcode[inp[scan].pos])
           { case OLSHFT: a=0x20; goto shiftintop;
             case ORSHFT: a=0x28+((rpp->tp<SUNSIGNED)<<4);
             shiftintop:
              lstasgflg=opcode[inp[scan+1].pos]==OLASTASGN&&opcode[inp[scan+2]
               .pos]==OPOP&&rpp->place!=PCREG/*rpp->tp%SUNSIGNED==SINT*/;
/*if long/too ineffecient*/
              createlexist=opcode[inp[scan+1].pos]==OLASTASGN
                 ||(opcode[inp[scan+1].pos]==OCONVERT
                   &&opcode[inp[scan+2].pos]==OLASTASGN);
              bo=binaryloadit(rpnstk[rpnsln-1].place==PCCONST,lstasgflg,0,0
                ,rpnstk[rpnsln-1].place==PCCONST?RGNONE:RG2ND,1,1,-1
                ,createlexist,0,0,0); /*NOTE: assumes that only 1 const */
              /*SC,ccDM,nSM,noswitch,rg2nd,CX,limrgfld,nlngmth,ldff,nodx,ncj*/
              switch(rpp->tp%SUNSIGNED)
              { case SINT:
                case SLONG:
                 *bo.m.stf+=a;
                 if(bo.const)
                 { if(bo.cval==1) addinstr(rpp,bo,0xd1);
                   else
                   { addinstr(rpp,bo,0xc1);
                     RAL(rpp->bops,rpp->blen+1,char);
                     R2=bo.cval;
                   }
                 }
                 else
                 { /* shl/sar/shr dw [],cl */
                   addinstr(rpp,bo,0xd3);
                 }
                 rpp->gzf=1;
                break;
                default: illegaltype("L/RSHIFT");
              }
              rpnsln--;
              if(lstasgflg)
              { scan+=2;
                bopsload();
              }
             break;
             case OCHS:
              rpp=rpnstk+(rpnsln-1);
              bo=monoploadit(rpp,0,0);
              if(rpp->place==PCMATH)
              { /* fchs st(0)
                 * d9 e0 */
                RAL(rpp->bops,rpp->blen+2,char);
                RS1=0xe0d9; RSI1;
              }
              else
              { RAL(rpp->bops,rpp->blen+bo.m.sz+1,char);
                /* neg [m] */
                R1=0xf7; *bo.m.stf+=0x18;
                memcpy(rpp->bops+rpp->blen,bo.m.stf,bo.m.sz);
                rpp->blen+=bo.m.sz;
                xrfill(rpp,bo.m);
                rpp->gzf=rpp->gcsof=1;
              }
             break;
             case OMUL:
              if(rpp->tp!=rpnstk[rpnsln-1].tp)
              { fatal=1; yyerror("illegal types"); }
              createlexist=opcode[inp[scan+1].pos]==OLASTASGN
                 ||(opcode[inp[scan+1].pos]==OCONVERT
                   &&opcode[inp[scan+2].pos]==OLASTASGN);
              lstasgflg=0;
              if(rpp->tp==SDOUBLE||rpp->tp==SFLOAT)
              { bo=binaryloadit(0,0,rpp->tp<SUNSIGNED,1,RGNONE,0,1,2
                  ,createlexist,0,0,0);
                /*noSRC,noDST,ccSRM,switch,norg,NA,norgfld,lngmth,nodt,DX,ncj*/
                if(bo.fltsrcmem)
                { RAL(rpp->bops,rpp->blen+bo.m.sz+1,char);
                  switch(bo.tp)
                  { case SDOUBLE:
                     R2=0xdc;
                     *bo.m.stf+=8;
                    break;
                    case SFLOAT:
                     R2=0xd8;
                     *bo.m.stf+=8;
                    break;
                    default: illegaltype("OMUL1");
                  }
                  memcpy(rpp->bops+rpp->blen,bo.m.stf,bo.m.sz);
                  rpp->blen+=bo.m.sz;
                  xrfill(rpp,bo.m);
                }
                else
                { RAL(rpp->bops,rpp->blen+2,char);
                  RS2=0xc9de; RSI2; /* fmulp st(1),st */
                }
                rpp->place=PCMATH;
              }
              else
              { lstasgflg=opcode[inp[scan+1].pos]==OLASTASGN
                  &&opcode[inp[scan+2].pos]==OPOP&&rpp->place!=PCREG
                  &&rpnstk[rpnsln-1].place==PCCONST
                  &&powof2(rpnstk[rpnsln-1].cval)>=0;
                bo=binaryloadit(1,lstasgflg,1,1,RGNONE,0,0,-1,createlexist,0
                  ,0,0);
/*MERE: future: if constant; enable cmpjmp */
                /*SC,noDST,SM,swtch,eitherarg,AX,nlrgfld,nodt,nDX,ncj*/
                if(bo.const)
                { b=powof2(bo.cval);
if(((*bo.m.stf)&0xc0)!=0xc0&&b<0) { fatal=1; yyerror("internal error omul"); }
                  if(b>=0)
                  { *bo.m.stf+=0x20; /* shl mem,b */
                    if(b==1) addinstr(rpp,bo,0xd1);
                    else
                    { addinstr(rpp,bo,0xc1);
                      RAL(rpp->bops,rpp->blen+1,char);
                      R2=b;
                    }
                  }
                  else
                  { a= *bo.m.stf&0x7;
                    *bo.m.stf+=(a<<3);
                    if(bo.cval<128&&bo.cval>=-128)
                    { addinstr(rpp,bo,0x6b);
                      RAL(rpp->bops,rpp->blen+1,char);
                      R2=bo.cval;
                    }
                    else
                    { addinstr(rpp,bo,0x69);
                      RAL(rpp->bops,rpp->blen+4,char);
                      RB2=bo.cval; RBI2;
                    }
                    rpp->argreg=a; rpp->place=PCREG;
                  }
                }
                else if(rpp->argreg==0)
                {
if((*bo.m.stf&0xc7)==0xc0) *bo.m.stf=0xc0+((*bo.m.stf>>3)&7);
if((*bo.m.stf&0xff)==0xc0)
yyerror("tract mul ax");
                  *bo.m.stf+=rpp->tp>=SUNSIGNED?0x20:0x28;/*mul/imul*/
                  addinstr(rpp,bo,0xf7);
                  rpp->reguse[2].use=1; rpp->argreg=0; rpp->place=PCREG;
                }
                else /* generic multiply */
                { RAL(rpp->bops,rpp->blen+1,char);
                  R2=0x0f; addinstr(rpp,bo,0xaf); rpp->argreg=(*bo.m.stf>>3)&7;
                }
              }
              rpnsln--;
              if(lstasgflg)
              { scan+=2; bopsload(); }
             break;
             case ODIV:
             case OMOD:
              if(rpp->tp!=rpnstk[rpnsln-1].tp)
              { fatal=1; yyerror("illegal types"); }
              createlexist=opcode[inp[scan+1].pos]==OLASTASGN
                 ||(opcode[inp[scan+1].pos]==OCONVERT
                   &&opcode[inp[scan+2].pos]==OLASTASGN);
              lstasgflg=0;
              if(rpp->tp==SDOUBLE||rpp->tp==SFLOAT)
              { if(opcode[inp[scan].pos]==OMOD) { fatal=1; yyerror("DBLMOD"); }
                bo=binaryloadit(0,0,rpp->tp>=SUNSIGNED
                 &&(opcode[inp[scan].pos]==ODIV),1,RGNONE,0,1,2
                 ,createlexist,0,0,0);
                /*noSRC,noDST,ccSRM,switch,norg,NA,norgfld,lngmth,nodt,DX,ncj*/
                if(bo.fltsrcmem)
                { RAL(rpp->bops,rpp->blen+bo.m.sz+1,char);
                  switch(bo.tp)
                  { case SDOUBLE:
                     R2=0xdc;
                     *bo.m.stf+=0x30+(bo.swtched<<3);
                    break;
                    case SFLOAT:
                     R2=0xd8;
                     *bo.m.stf+=0x30+(bo.swtched<<3);
                    break;
                    default: illegaltype("ODIV1");
                  }
                  memcpy(rpp->bops+rpp->blen,bo.m.stf,bo.m.sz);
                  rpp->blen+=bo.m.sz;
                  xrfill(rpp,bo.m);
                }
                else if(opcode[inp[scan].pos]==ODIV)
                { RAL(rpp->bops,rpp->blen+2,char);
                  RS2=0xf1de+((!bo.swtched)<<11); RSI2; /*fdivr?p st1,st*/
                }
                else
                { if(opcode[inp[scan].pos]!=OMOD)
                  { illegaltype("MOD"); }
illegaltype("float mod not implemented");
                  RAL(rpp->bops,rpp->blen+4+(bo.swtched<<2),char);
                  if(bo.swtched) { RB2=0xc9d9; RBI2; /*fxch st(1)*/}
                  RB2=0xf8d9; RBI2; /*fprem*/
                  RB2=0xd9dd; RBI2; /*fstop st(1)*/
                }
              }
              else
              { if(rpnstk[rpnsln-1].place==PCCONST
                   &&(opcode[inp[scan].pos]==ODIV||rpp->tp>=SUNSIGNED)
                   &&(a=powof2(rpnstk[rpnsln-1].cval))>=0)
                { lstasgflg=opcode[inp[scan+1].pos]==OLASTASGN
                    &&opcode[inp[scan+2].pos]==OPOP&&rpp->place!=PCREG;
                  bo=binaryloadit(1,lstasgflg,0,0,RGNONE,0,1,-1,createlexist
                    ,0,0,0);
                  /*SC,ccDM,noSM,nswitch,NONE,N/A,noregfld,noreg,ncj*/
                  if(opcode[inp[scan].pos]==ODIV)
                  { /* sar/shr XX,cnt
                     * */
                    if(rpp->tp>=SUNSIGNED) *bo.m.stf+=0x28; /* shr */
                    else *bo.m.stf+=0x38;
                    if(a==1) addinstr(rpp,bo,0xd1);
                    else
                    { addinstr(rpp,bo,0xc1);
                      RAL(rpp->bops,rpp->blen+1,char);
                      R2=a;
                    }
                  }
                  else
                  { /* and XX,mask
                     * */
                    bo.cval--; *bo.m.stf+=0x20;
                    if(bo.cval<128&&bo.cval>=-128)
                    { addinstr(rpp,bo,0x83);
                      RAL(rpp->bops,rpp->blen+1,char);
                      R2=bo.cval;
                    }
                    else
                    { addinstr(rpp,bo,0x81);
                      RAL(rpp->bops,rpp->blen+4,char);
                      RB2=bo.cval; RBI2;
                    }
                  }
                }
                else
                { bo=binaryloadit(0,0,1,0,RG1ST,0,1,2
                    ,createlexist,0,0,0);
if((*bo.m.stf&0xff)==0xc0)
yyerror("track div ax");
                  /*noSC,noDM,SM,nswitch,1starg,AX,noregfld,DX,ncj*/
                  /* xor dx,dx
                   * --or--
                   * cwd
                   * div [mem]
                   * (31 d2 | 99) f7 mem+30/38*/
                  if(rpp->tp%SUNSIGNED!=SINT&&rpp->tp%SUNSIGNED!=SLONG)
                  { fatal=1; yyerror("illegal type for division");
fprintf(stderr,"tp %d\n",rpp->tp);
}
                  RAL(rpp->bops,rpp->blen+2,char);
                  if(rpp->tp>=SUNSIGNED) { RS2=0xd231; RSI2; *bo.m.stf+=0x30; }
                  else { R2=0x99; *bo.m.stf+=0x38; }
                  addinstr(rpp,bo,0xf7);
                  rpp->argreg=opcode[inp[scan].pos]==OMOD?2:0; /*DX,AX*/
                  rpp->reguse[2].use=1; rpp->place=PCREG;
                }
              }
              rpnsln--;
              if(lstasgflg)
              { scan+=2; bopsload(); }
             break;
             case ONOT:
              rpp=rpnstk+(rpnsln-1);
              bo=monoploadit(rpp,0,0);
              *bo.m.stf+=0x18;
              addinstr(rpp,bo,0xf7);
              if(rpp->tp%SUNSIGNED!=SINT&&rpp->tp%SUNSIGNED!=SLONG)
                 illegaltype("NOT");
             break;
             case OLCCHAR:
              initrpnstk();
              if(rpnsln&&rpnstk[rpnsln-1].combineflg)
              { rpp=rpnstk+(rpnsln-1); rpp->combineflg=0; }
              else
              { rpp=rpnstk+rpnsln++;
                AL(rpp->bops,1,char); rpp->blen=0;
              }
              rpp->place=PCCONST; rpp->tp=SCHAR;
              rpp->cval=opcode[inp[scan].pos+1];
             break;
             case OLCINT:
              initrpnstk();
              if(rpnsln&&rpnstk[rpnsln-1].combineflg)
              { rpp=rpnstk+(rpnsln-1); rpp->combineflg=0; }
              else
              { rpp=rpnstk+rpnsln++;
                AL(rpp->bops,1,char); rpp->blen=0;
              }
              rpp->cval=(*(dwordptr)(opcode+inp[scan].pos+1));
              rpp->place=PCCONST; rpp->tp=SINT;
             break;
             case OLCLONG:
              initrpnstk();
              if(rpnsln&&rpnstk[rpnsln-1].combineflg)
              { rpp=rpnstk+(rpnsln-1); rpp->combineflg=0; }
              else
              { rpp=rpnstk+rpnsln++;
                AL(rpp->bops,1,char); rpp->blen=0;
              }
              rpp->cval=(*(dwordptr)(opcode+inp[scan].pos+1));
              rpp->place=PCCONST; rpp->tp=SLONG;
             break;
             case OLCDOUBLE:
              initrpnstk();
              if(rpnsln&&rpnstk[rpnsln-1].combineflg)
              { rpp=rpnstk+(rpnsln-1); rpp->combineflg=0;
                RAL(rpp->bops,rpp->blen+4,char);
              }
              else
              { rpp=rpnstk+rpnsln++;
                AL(rpp->bops,4,char); rpp->blen=0;
              }
              dbl= *(double *)(opcode+(inp[scan].pos+1));
              rpp->place=PCMATH; rpp->tp=SDOUBLE;
              if(dbl==0.0) { R2=0xd9; R2=0xee; }
              else if(dbl==1.0) { R2=0xd9; R2=0xe8; }
              else if(fabs(dbl-3.1415926535897931)<2e-14) { R2=0xd9; R2=0xeb; }
              else if(fabs(dbl-3.3219280948873622)<2e-14) { R2=0xd9; R2=0xe9; }
              else if(fabs(dbl-1.4426950408889634)<2e-14) { R2=0xd9; R2=0xea; }
              else if(fabs(dbl-0.3010299956639812)<2e-14) { R2=0xd9; R2=0xec; }
              else if(fabs(dbl-0.6931471805599453)<2e-14) { R2=0xd9; R2=0xed; }
              else
              { struct dblxref *dbxp;
                rpp->place=PCMEMORY; rpp->sect=SCINTPUBLIC;
                for(dbxp=dbxr,a=0;a<dbcnt;a++,dbxp++)
                  if(dbxp->dbl==dbl)
                  { rpp->scoff=dbxp->off;
                   break;
                  }
                if(a>=dbcnt)
                { RAL(exttbl,exttblsz+1,struct exttbl);
                  exttbl[exttblsz].tp=SDOUBLE;
                  exttbl[exttblsz].presz=exttbl[exttblsz].size=sodouble;
                  exttbl[exttblsz].scope=SCPSTATIC;
                  exttbl[exttblsz].prepres=1;
                  Scp(&(exttbl[exttblsz].nm),"");
                  AL(exttbl[exttblsz].pre,sodouble,char);
                  for(a=0;a<sodouble;a++)
                    exttbl[exttblsz].pre[a]=opcode[inp[scan].pos+1+a];
                  RAL(dbxr,dbcnt+1,struct dblxref);
                  dbxr[dbcnt].dbl=dbl; dbxr[dbcnt++].off=exttblsz;
                  rpp->scoff=exttblsz++;
                }
              }
             break;
             case OVINC:
              a=0;
             goto varoper;
             case OVDEC:
              /* must be memory or pointer; load value inc the other */
              a=1;
             varoper:
              rpp=rpnstk+(rpnsln-1);
              if(opcode[inp[scan+1].pos]==OPOP)
              {justonvar:
                if(rpp->lexist) /*OCONVERT probably did this*/
                { bo=monoploadit(rpp,0,0); /*IAM:monop needed?*/
                  memtmp=genmemin(rpp->llprg,rpp->lplace,-1,rpp->sect
                    ,rpp->scoff,rpp->lboff,1,rpp->bpoff);
                  /* index last location that things were at */
                  switch(rpp->ltp%SUNSIGNED)
                  { case SCHAR:
                     movechar(rpp);
                     x=0x88;
                    goto voplcon;
                    case SSHORT: x=0x89;
                    voplcon:
                     /* inc/dec erg ; ereg doesn't matter-already con. to int
                      * operand: mov [mem],rg
                      * fe regmem+0/1  66 seg 88/89 memtmp */
                     RAL(rpp->bops,5+rpp->blen+memtmp.sz,char);
                     R1=0xfe;
                     if(bo.m.sz!=1)
                      illegaltype("non-register INCDEC");
                     R1=(*bo.m.stf)+(a<<3);
                     rpp->gzf=1;
                    vopmove:
                     if(x!=0x88&&rpp->ltp!=SPOINTER) R1=0x66;
                     (*memtmp.stf)+=(rpp->argreg<<3);
                     R1=x; memcpy(rpp->bops+rpp->blen,memtmp.stf,memtmp.sz);
                     rpp->blen+=memtmp.sz;
                     xrfill(rpp,memtmp);
                    break;
                    case SFLOAT:
                     /* fld1
                      * faddp/subp st(1)
                      * fstp [mem]
                      * d9 e8 d8 c1/e1 seg d9 mem+3 */
                     RAL(rpp->bops,rpp->blen+4+memtmp.sz,char);
                     RS1=0xe8d9; RSI1; R1=0xd8; R1=a?0xe1:0xc1;
                     R1=0xd9; *memtmp.stf+=18;
                     memcpy(rpp->bops+rpp->blen,memtmp.stf,memtmp.sz);
                     rpp->blen+=memtmp.sz;
                     xrfill(rpp,memtmp);
                    break;
                    default: illegaltype("INCDEC1");
printf("tp %d place %d argreg %d ltp %d lplace %d lreg %d\n"
,rpp->tp,rpp->place,rpp->argreg,rpp->ltp,rpp->lplace,rpp->llprg);
                  }
                }
                else /*not lexist*/
                { bo=monoploadit(rpp,1,0);
if((*bo.m.stf&0xff)>=0xc0) fprintf(stderr,"non memory weird.\n");
                  switch(rpp->tp%SUNSIGNED)
                  { case SINT:
                    case SLONG:
                     /* inc/dec [mem]
                      * seg ff mem+0/1*/
                     *bo.m.stf+=(a<<3); addinstr(rpp,bo,0xff);
                    break;
                    case SDOUBLE:
                     /* fld1
                      * fadd/subr [mem]
                      * fstp [mem]
                      * d9 e8 seg dc mem+0/48 seg dd mem+18*/
                     RAL(rpp->bops,rpp->blen+4+2*bo.m.sz,char);
                     memtmp=bo.m;
                     RS1=0xe8d9; RSI1;
                     R1=0xdc; *bo.m.stf+=a*0x48;
                     memcpy(rpp->bops+rpp->blen,bo.m.stf,bo.m.sz);
                     rpp->blen+=bo.m.sz; xrfill(rpp,bo.m);
                     bo.m=memtmp;
                     R1=0xdd; *bo.m.stf+=a*0x18;
                     memcpy(rpp->bops+rpp->blen,bo.m.stf,bo.m.sz);
                     rpp->blen+=bo.m.sz; xrfill(rpp,bo.m);
                    break;
                    case SPOINTER:
                     /* inc/dec/add/sub [mem],sz
                      * (ff regmem+0/1)||(83/81 regmem+0/5 sz) */
                     if(rpp->size==1)
                     { *bo.m.stf+=(a<<3); addinstr(rpp,bo,0xff); }
                     else if(rpp->size>127)
                     { *bo.m.stf+=a*0x28; addinstr(rpp,bo,0x81);
                       RAL(rpp->bops,4+rpp->blen,char);
                       RB1=rpp->size; RBI1;
                     }
                     else
                     { *bo.m.stf+=a*0x28; addinstr(rpp,bo,0x83);
                       RAL(rpp->bops,1+rpp->blen,char);
                       R1=rpp->size;
                     }
                    break;
                    default: illegaltype("INCDEC2");
                  }
                }
                scan++; bopsload();
               break; /*out of operator switch*/
              }
            /*else not about to pop(because of break)*/
              bo=monoploadit(rpp,0,0);
              if(!rpp->lexist||(rpp->lplace!=PCMEMORY&&rpp->lplace
                !=PCLSTPOINT))
              { fatal=1; yyerror("1++ or -- without lvalue"); break; }
              memtmp=genmemin(rpp->llprg,rpp->lplace,-1,rpp->sect,rpp->scoff
                ,rpp->lboff,1,rpp->bpoff);
              if(rpp->argreg<0) illegaltype("4");
              if(rpp->lplace==PCLSTPOINT)
              { itmp=findreg(0,rpp->reguse,0,0,rpp->reguse,rpp->argreg
                  ,-1,rpp->llprg,-1);
                /*avoid 1 and 2 and 1 and 2 lexist*/
              }
              else
                itmp=findreg(0,rpp->reguse,0,0,rpp->reguse,rpp->argreg,-1,-1
                    ,-1);
              rpp->reguse[itmp].use=1;
              switch(rpp->ltp%SUNSIGNED)
              { case SCHAR:
                 movechar(rpp);
                 x=0x88;
                goto varopint;
                case SINT:
                case SPOINTER:
                case SLONG:
                 /* mov xx,erg
                  * inc/dec exx || add/sub exx,sz(pointer)
                  * mov [mem],exx/xl
                  * 8b c0+rg+xx<<3 (40/48+rg | 81/83 c0+xx sz) sg (88 89) mem*/
                 x=0x89;
                varopint:
                 if(bo.m.sz!=1)
                 { fatal=1; yyerror("illegal reg INCDEC"); }
                 RAL(rpp->bops,rpp->blen+memtmp.sz+9,char);
                 R1=0x8b; R1=(*bo.m.stf)+(itmp<<3);
                 if(rpp->argreg<0||rpp->argreg>7)
                 { fatal=1; yyerror("illegal register"); }
                 if(rpp->ltp%SUNSIGNED!=SPOINTER||rpp->size==1)
                   R1=(a?0x48:0x40)+itmp; /* inc/dec xx */
                 else if(rpp->size>127) /* add/sub xx,sz */
                 { R1=0x81; R1=0xc0+itmp+a*(5<<3); RB1=rpp->size; RBI1; }
                 else /* add/sub xx,sz */
                 { R1=0x83; R1=0xc0+itmp+a*(5<<3); R1=rpp->size; }
                 R1=x; *memtmp.stf+=(itmp<<3);
                 memcpy(rpp->bops+rpp->blen,memtmp.stf,memtmp.sz);
                 rpp->blen+=memtmp.sz;
                 xrfill(rpp,memtmp);
                break;
                case SSHORT:
                 /* mov xx,erg
                  * inc/dec exx
                  * operand: mov [mem],xx
                  * 8b c0+rg+xx<<3 40/48+rg 66 sg (88 89) mem*/
                 if(bo.m.sz!=1)
                 { fatal=1; yyerror("illegal reg INCDEC"); }
                 RAL(rpp->bops,rpp->blen+memtmp.sz+8,char);
                 R1=0x8b; R1=(*bo.m.stf)+(itmp<<3);
                 if(rpp->argreg<0||rpp->argreg>7)
                 { fatal=1; yyerror("illegal register"); }
                 R1=(a?0x48:0x40)+itmp; /* inc/dec xx */
                 R1=0x66;
                 R1=0x89; *memtmp.stf+=(itmp<<3);
                 memcpy(rpp->bops+rpp->blen,memtmp.stf,memtmp.sz);
                 rpp->blen+=memtmp.sz;
                 xrfill(rpp,memtmp);
                break;
                case SFLOAT:
                 x=0xd9;
                goto varopmath;
                case SDOUBLE:
                 x=0xde;
                varopmath:
                 /* fld st(0)
                  * fld1
                  * faddp/fsubp st(1),st(0)
                  * fstp dw/qw [mem]
                  * d9 c0 d9 e8 de (c1 e9) seg (d9 de) mem+3<<3 */
                 RAL(rpp->bops,rpp->blen+memtmp.sz+7,char);
                 RS1=0xc0d9; RSI1; RS1=0xe8d9; RSI1; RS1=a?0xe9de:0xc1de; RSI1;
                 R1=x; *memtmp.stf+=24;
                 memcpy(rpp->bops+rpp->blen,memtmp.stf,memtmp.sz);
                 rpp->blen+=memtmp.sz;
                 xrfill(rpp,memtmp);
                break;
                default: illegaltype("l");
              }
              rpp->gzf=rpp->gcsof=rpp->boff=rpp->lexist=0;
             break;
             case OINCV:
              a=0;
             goto opervar;
             case ODECV:
              /* must be memory or pointer; load inc and store */
              a=1;
             opervar:
              rpp=rpnstk+(rpnsln-1);
              if(opcode[inp[scan+1].pos]==OPOP) goto justonvar;
              bo=monoploadit(rpp,0,0);
              if(!rpp->lexist||(rpp->lplace!=PCMEMORY&&rpp->lplace!=PCLSTPOINT))
              { fatal=1; yyerror("2++ or -- without lvalue"); break; }
              memtmp=genmemin(rpp->llprg,rpp->lplace,-1,rpp->sect,rpp->scoff
                ,rpp->lboff,1,rpp->bpoff);
              switch(rpp->ltp%SUNSIGNED)
              { case SCHAR:
                 movechar(rpp);
                 x=0x88;
                goto opvarint;
                case SLONG:
                case SINT:
                case SPOINTER:
                 /* inc/dec erg
                  * mov [mem],erg/rl
                  * (40/48)+rg seg 88/89 mem */
                 x=0x89;
                opvarint:
                 RAL(rpp->bops,rpp->blen+memtmp.sz+8,char);
                 if(rpp->argreg<0||rpp->argreg>7)
                 { fatal=1; yyerror("illegal register"); }
                 if(rpp->ltp%SUNSIGNED!=SPOINTER||rpp->size==1)
                   R1=(a?0x48:0x40)+rpp->argreg; /* inc/dec xx */
                 else if(rpp->size>127) /* add/sub xx,sz */
                 { R1=0x81; R1=0xc0+rpp->argreg+a*(5<<3);
                   RB1=rpp->size; RBI1;
                 }
                 else /* add/sub xx,sz */
                 { R1=0x83; R1=0xc0+rpp->argreg+a*(5<<3); R1=rpp->size; }
                 R1=x; *(memtmp.stf)+=rpp->argreg<<3;
                 memcpy(rpp->bops+rpp->blen,memtmp.stf,memtmp.sz);
                 rpp->blen+=memtmp.sz;
                 xrfill(rpp,memtmp);
                 rpp->gzf=1;
                break;
                case SSHORT:
                 /* inc/dec erg
                  * operand: mov [mem],rg/rl
                  * (40/48)+rg 66 seg 88/89 mem */
                 RAL(rpp->bops,rpp->blen+memtmp.sz+4,char);
                 if(rpp->argreg<0||rpp->argreg>7)
                 { fatal=1; yyerror("illegal register"); }
                 R1=(a?0x48:0x40)+rpp->argreg;
                 R1=0x66;
                 R1=0x89; *(memtmp.stf)+=rpp->argreg<<3;
                 memcpy(rpp->bops+rpp->blen,memtmp.stf,memtmp.sz);
                 rpp->blen+=memtmp.sz;
                 xrfill(rpp,memtmp);
                 rpp->gzf=1;
                break;
                case SFLOAT:
                 x=0xd9;
                goto opvarmath;
                case SDOUBLE:
                 /* fld1
                  * faddp/fsubp st(1),st(0)
                  * fst dw/qw [mem]
                  * d9 e8 de (c1 e9) seg (d9 de) mem+2<<3 */
                 x=0xde;
                opvarmath:
                 RAL(rpp->bops,rpp->blen+memtmp.sz+5,char);
                 RS1=0xe8d9; RSI1; RS1=a?0xe9de:0xc1de; RSI1;
                 R1=x; *memtmp.stf+=16;
                 memcpy(rpp->bops+rpp->blen,memtmp.stf,memtmp.sz);
                 rpp->blen+=memtmp.sz;
                 xrfill(rpp,memtmp);
                 rpp->gzf=0;
                break;
                default: illegaltype("m");
              }
              rpp->gcsof=rpp->boff=rpp->lexist=0;
             break;
             case OPTRCONVERT:
              /* make existent pointer PCLSTPOINT. */
              rpp=rpnstk+(rpnsln-1);
              if(opcode[inp[scan+1].pos]==OCALL
               ||opcode[inp[scan+1].pos]==OCALL0)
              { /* call r/m32; */
                if(opcode[inp[scan].pos+1]!=SFUNC) illegaltype("pcall");
                monoploadit(rpp,1,1); /*make ready to access*/
                /* access it's memory version */
                memtmp=genmemin(rpp->argreg,rpp->place,rpp->argreg,rpp->sect
                  ,rpp->scoff,rpp->boff,1,rpp->bpoff);
                RAL(rpp->bops,rpp->blen+memtmp.sz+1,char);
                R2=0xff; *memtmp.stf+=0x10; /* call r/m32 */
                memcpy(rpp->bops+rpp->blen,memtmp.stf,memtmp.sz);
                rpp->blen+=memtmp.sz;
                xrfill(rpp,memtmp);
                scan++;
               goto pointercall;
              }
              if(rpp->tp!=SPOINTER) { illegaltype("n"); break; }
              if(rpp->place!=PCREG) monoploadit(rpp,0,1);
              rpp->place=PCLSTPOINT; rpp->tp=opcode[inp[scan].pos+1];
              rpp->size=(*(dwordptr)(opcode+inp[scan].pos+2));
              rpp->lexist=0;
              rpp->gzf=rpp->gcsof=0;
             break;
             case OCONVERT:
              rpp=rpnstk+(rpnsln-1);
              x=opcode[inp[scan].pos+1];/*to be converted to this*/
              switch(rpp->tp%SUNSIGNED)
              { case SCHAR:
                 mklexist(rpp);
                 switch(x%SUNSIGNED)
                 { case SCHAR:
                    rpp->lexist=0;
                   break;
                   case SSHORT:
                    bo=monoploadit(rpp,1,0);
                    if(rpp->place!=PCREG||rpp->argreg!=0)
                    { b=0;
                      /* mov[zs]x reg,[mem]
                       * 0f b6/be mem */
                      if(rpp->argreg>=4&&rpp->place==PCREG)
                      { lexistaxmov(rpp,0);
                        regloadit(rpp,rpp,rpp->place   /*put low in ax*/
                          ,rpp->place==PCSTACK?-1:rpp->argreg,0,0);
                       goto handleinax;
                      }
                     movextend: /* b+1 is number of bytes in input */
                      a=findreg(0,rpp->reguse,0,0,rpp->reguse
                          ,rpp->place==PCLSTPOINT?rpp->argreg:-1,-1,-1,-1);
                      RAL(rpp->bops,rpp->blen+1,char);
                      R1=0x0f;
                      *bo.m.stf+=(a<<3);
                      addinstr(rpp,bo,b+(rpp->tp>=SUNSIGNED?0xb6:0xbe));
                      rpp->place=PCREG; rpp->boff=0; rpp->argreg=a;
                      rpp->reguse[a].use=1;
                    }
                    else /* it is already in AX */
                    { /* cbw --or-- xor ah,ah
                       * (66 98--30 e4) */
                     handleinax:
                      RAL(rpp->bops,rpp->blen+2,char);
                      if(rpp->tp>=SUNSIGNED) RS1=0xe430;
                      else RS1=0x9866;
                      RSI1;
                      rpp->place=PCREG; rpp->boff=rpp->argreg=0;
                    }
                   break;
                   case SINT:
                   case SLONG:
                   case SPOINTER:
                    bo=monoploadit(rpp,1,0);
                    b=0;
                   goto movextend;
                   case SFLOAT:
                   case SDOUBLE:
                    /* cbw --or-- xor ah,ah
                     * push eax
                     * fild wo [bp+x]
                     * wait
                     * add esp,4
                     * (66 98--30 e4)
                     *  50 df/db 85 bpoff 9b 83 c4 2/4 */
                    if(rpp->place==PCMATH) break;
                    bo=monoploadit(rpp,1,0);
                    if(rpp->place!=PCREG||rpp->argreg!=0)
                    { /* mov[zs]x reg,[mem]
                       * 0f b6/be mem */
                      if(rpp->argreg>=4&&rpp->place==PCREG)
                      { lexistaxmov(rpp,0);
                        regloadit(rpp,rpp,rpp->place   /*put low in ax*/
                          ,rpp->place==PCSTACK?-1:rpp->argreg,0,0);
                       goto handleinax2;
                      }
                      a=findreg(0,rpp->reguse,0,0,rpp->reguse
                          ,rpp->place==PCLSTPOINT?rpp->argreg:-1,-1,-1,-1);
                      RAL(rpp->bops,rpp->blen+1,char);
                      R1=0x0f;
                      *bo.m.stf+=(a<<3);
                      addinstr(rpp,bo,(rpp->tp>=SUNSIGNED?0xb6:0xbe));
                      rpp->argreg=a; /* place, and boff written below. */
                      rpp->reguse[a].use=1;
                    }
                    else /* it is already in AX */
                    { /* cbw --or-- xor ah,ah
                       * (66 98--30 e4) */
                     handleinax2:
                      RAL(rpp->bops,rpp->blen+2,char);
                      if(rpp->tp>=SUNSIGNED) RS1=0xe430;
                      else RS1=0x9866;
                      RSI1;
                      rpp->place=PCREG; rpp->boff=rpp->argreg=0;
                      rpp->reguse->use=1;
                    }
                    RAL(rpp->bops,rpp->blen+16,char);
                    R1=0x50+rpp->argreg; R1=0xdf; R1=0x85;
                    RAL(rpp->bpxref,rpp->bpxcnt+1,long);
                    rpp->bpxref[rpp->bpxcnt++]=rpp->blen;
                    RB1=rpp->bpoff-4; RBI1;
                    if(rpp->bpoff-4<rpp->maxoff) rpp->maxoff=rpp->bpoff-4;
                    if(rpp->maxfltlev<1) rpp->maxfltlev=1;
                    R1=0x9b; RS1=0xc483; RSI1; R1=0x4;
                    rpp->place=PCMATH; rpp->boff=0;
                   break;
                   case SSTRUCT:
                   default: illegaltype("o");
                 }
                break;
                case SSHORT:
                 switch(x%SUNSIGNED)
                 { case SCHAR:
                   case SSHORT:
                   break;
                   case SINT:
                   case SLONG:
                   case SPOINTER:
                    mklexist(rpp);
                    /* cwde --or-- and eax,0ffff
                     * (98--25 ff ff 0 0) */
                    bo=monoploadit(rpp,1,0);
                    if(rpp->place!=PCREG||((rpp->argreg||rpp->tp>=SUNSIGNED)
                        &&rpp->argreg<4))
                    { b=1;
                     goto movextend;
                    }
                    lexistaxmov(rpp,0);
                    if(rpp->argreg)
                      regloadit(rpp,rpp,rpp->place /*put low in ax*/
                        ,rpp->place==PCSTACK?-1:rpp->argreg,0,0);
                    RAL(rpp->bops,rpp->blen+8,char);
                    if(rpp->tp>=SUNSIGNED/*||x>=SUNSIGNED*/)
                    { RS1=0xff25; RSI1; R1=0xff; RS1=0; RSI1; }
                    else R1=0x98; /*only idiot to get pointer out of short */
                    rpp->place=PCREG; rpp->boff=rpp->argreg=0;
                    rpp->reguse->use=1;
                   break;
                   case SFLOAT:
                   case SDOUBLE:
                    mklexist(rpp);
                    /* U: movzx erg,rg
                     * stkload
                     * fild wo/dw [bp+]
                     * wait
                     * add esp,4
                     * (U: 0f b7 mem+arg<<3) df/db 86 bpoff 9b 83 c4 2/4 */
                    if(rpp->place==PCMATH) break;
                    bo=monoploadit(rpp,1,0);
                    if(rpp->tp>=SUNSIGNED)
                    { if(rpp->place==PCSTACK) bo=monoploadit(rpp,0,0);
                      RAL(rpp->bops,rpp->blen+1,char);
                      a=findreg(0,rpp->reguse,0,0,rpp->reguse
                          ,rpp->place==PCLSTPOINT?rpp->argreg:-1,-1,-1,-1);
                      RAL(rpp->bops,rpp->blen+1,char);
                      R1=0x0f;
                      *bo.m.stf+=(a<<3);
                      addinstr(rpp,bo,0xb7);
                      rpp->argreg=a; /* place, and boff written below. */
                      rpp->reguse[a].use=1;
                      rpp->place=PCREG; rpp->tp=SINT+(rpp->tp&SUNSIGNED);
                    }
                    if(rpp->place==PCREG||rpp->tp>=SUNSIGNED)
                      stkload(rpp);
                    memtmp=genmemin(rpp->argreg,rpp->place,rpp->argreg
                      ,rpp->sect,rpp->scoff,rpp->boff,1,rpp->bpoff);
                    RAL(rpp->bops,rpp->blen+5+memtmp.sz,char);
                    R1=rpp->tp>=SUNSIGNED?0xdb:0xdf;
                    memcpy(rpp->bops+rpp->blen,memtmp.stf,memtmp.sz);
                    rpp->blen+=memtmp.sz; xrfill(rpp,memtmp);
                    R1=0x9b;
                    if(rpp->bpoff<rpp->maxoff) rpp->maxoff=rpp->bpoff;
                    if(rpp->maxfltlev<1) rpp->maxfltlev=1;
                    if(rpp->place==PCSTACK)
                    { RS1=0xc483; RSI1; R1=0x4;
                      rpp->bpoff+=0x4;
                    }
                    rpp->place=PCMATH;
                   break;
                   case SSTRUCT:
                   default: illegaltype("p");
                 }
                break;
                case SINT:
                case SLONG:
                 switch(x%SUNSIGNED)
                 { case SCHAR:
                   case SSHORT:
                   case SINT:
                   case SLONG:
                   case SPOINTER:
                   break;
                   case SFLOAT:
                   case SDOUBLE:
                    mklexist(rpp);
                    monoploadit(rpp,1,0);
                    fltload(rpp);
                   break;
                   case SSTRUCT:
                   default: illegaltype("q");
                 }
                break;
                case SPOINTER:
                 switch(x%SUNSIGNED)
                 { case SCHAR:
                   case SSHORT:
                   case SINT:
                   case SLONG:
                      /* get rid of boff: */
                    if(rpp->place==PCREG&&rpp->boff) monoploadit(rpp,1,0);
                   break;
                   case SPOINTER:
                   break;
                   case SFLOAT:
                   case SDOUBLE:
                    mklexist(rpp);
                    monoploadit(rpp,1,0);
                    fltload(rpp);
                   break;
                   case SSTRUCT:
                   default: illegaltype("q");
                 }
                break;
                case SFLOAT:
                case SDOUBLE:
                 switch(x%SUNSIGNED)
                 { case SCHAR:
                   case SSHORT:
                    monoploadit(rpp,0,0);
                    /* fldcw _dcc387rndchop
                     * push eax
                     * fistp dw [bp+]
                     * wait
                     * fldcw _dcc387rndnear
                     * d9 mem+28 50 db 9d bpoff 9b d9 mem+28 */
                   floattonormalint:
                    rpp->bpoff-=4;
                    RAL(rpp->bops,rpp->blen+20,char);
                    R1=0xd9; R1=0x2d;
                    RAL(rpp->exref,2+rpp->exrcnt,struct externxref);
                    b=alloc387rnd();
                    rpp->exref[rpp->exrcnt].ptrfnc=0;
                    rpp->exref[rpp->exrcnt].off=rpp->blen;
                    rpp->exref[rpp->exrcnt++].scoff=b+1; /* chop */
                    RB1=0x0; RBI1;

                    RS1=0xdb50; RSI1; R1=0x9d;
                    RAL(rpp->bpxref,rpp->bpxcnt+1,long);
                    rpp->bpxref[rpp->bpxcnt++]=rpp->blen;
                    RB1=rpp->bpoff; RBI1; R1=0x9b;
                    R1=0xd9; R1=0x2d;
                    rpp->exref[rpp->exrcnt].ptrfnc=0;
                    rpp->exref[rpp->exrcnt].off=rpp->blen;
                    rpp->exref[rpp->exrcnt++].scoff=b; /* nearest */
                    RB1=0x0; RBI1;
                    rpp->place=PCSTACK;
                    if(rpp->bpoff<rpp->maxoff) rpp->maxoff=rpp->bpoff;
                   break;
                   case SINT:
                   case SLONG:
                   case SPOINTER:
                    monoploadit(rpp,0,0);
                    if(x<SUNSIGNED) goto floattonormalint;
                    /* fldcw _dcc387rndchop
                     * sub esp,8
                     * fistp qw [ebp+]
                     * wait
                     * fldcw _dcc387rndnear
                     * LOAD
                     * add esp,4
                     * d9 2d chp 83 ec 8 df bd bpoff 9b d9 2d ne LD 83 c4 4*/
                    rpp->bpoff-=8;
                    RAL(rpp->bops,rpp->blen+22,char);
                    R1=0xd9; R1=0x2d;
                    RAL(rpp->exref,2+rpp->exrcnt,struct externxref);
                    b=alloc387rnd();
                    rpp->exref[rpp->exrcnt].ptrfnc=0;
                    rpp->exref[rpp->exrcnt].off=rpp->blen;
                    rpp->exref[rpp->exrcnt++].scoff=b+1; /* chop */
                    RB1=0x0; RBI1;

                    RS1=0xec83; RSI1; RS1=0xdf08; RSI1; R1=0xbd;
                    RAL(rpp->bpxref,rpp->bpxcnt+1,long);
                    rpp->bpxref[rpp->bpxcnt++]=rpp->blen;
                    RB1=rpp->bpoff; RBI1; R1=0x9b;
                    rpp->place=PCSTACK; rpp->tp=x;
                    R1=0xd9; R1=0x2d;
                    rpp->exref[rpp->exrcnt].ptrfnc=0;
                    rpp->exref[rpp->exrcnt].off=rpp->blen;
                    rpp->exref[rpp->exrcnt++].scoff=b; /* nearest */
                    RB1=0x0; RBI1;
                    monoploadit(rpp,0,0);
                    RAL(rpp->bops,rpp->blen+3,char);
                    if(rpp->bpoff<rpp->maxoff) rpp->maxoff=rpp->bpoff;
                    RS1=0xc483; RSI1; R1=0x4;
                    rpp->bpoff+=4;
                   break;
                   case SFLOAT:
                    if(rpp->tp!=SFLOAT) monoploadit(rpp,0,0);
                   break;
                   case SDOUBLE:
                    if(rpp->tp!=SDOUBLE)
                    { mklexist(rpp);
                      monoploadit(rpp,0,0);
                    }
                   break;
                   case SSTRUCT:
                   default: illegaltype("r");
                 }
                break;
                case SSTRUCT:
                default: illegaltype("s");
              }
              if(rpp->lexist==1&&rpp->lplace!=PCMEMORY
               &&rpp->lplace!=PCLSTPOINT)
                rpp->lexist=0;
              rpp->tp=x;
              if(x==SSTRUCT||x==SPOINTER)
                rpp->size=(*(dwordptr)(opcode+inp[scan].pos+2));
              rpp->gzf=rpp->gcsof=0;
             break;
             case OSTOPTR: /* used with arrays to for indexing */
              rpp=rpnstk+(rpnsln-1);
              if((rpp->place!=PCMEMORY&&rpp->place!=PCLSTPOINT)
                ||rpp->tp!=SPOINTER)
                  illegaltype("t");
              leareg(rpp,1);
              rpp->gzf=rpp->gcsof=0;
             break;
             case OTOPTR:
              rpp=rpnstk+(rpnsln-1);
              if(rpp->tp==SFUNC)
              { /* mov rg,off
                 * b8+rg offst */
                if(rpp->place!=PCMEMORY) illegaltype("t2");
                a=findreg(0,rpp->reguse,0,0,rpp->reguse,-1,-1,-1,-1);
                RAL(rpp->bops,rpp->blen+5,char);
                R1=0xb8+a;
                RAL(rpp->exref,rpp->exrcnt+1,struct externxref);
                rpp->exref[rpp->exrcnt].off=rpp->blen;/* blck blnk */
                rpp->exref[rpp->exrcnt].ptrfnc=1;
                rpp->exref[rpp->exrcnt++].scoff=rpp->scoff;
                RB1=0x0; RBI1;
                rpp->size=0;
                rpp->tp=SPOINTER; rpp->place=PCREG;
                rpp->argreg=a; rpp->reguse[a].use=1; rpp->boff=0;
              }
              else
              { if(rpp->place!=PCMEMORY&&rpp->place!=PCLSTPOINT)
                  illegaltype("t3");
                leareg(rpp,1);
                rpp->size=typesize(1);
              }
              rpp->gzf=rpp->gcsof=0;
             break;
             case ORETURN:
              /* ? fild wo [bp]
               * add esp,spsmaxt
               * popad
               * ret
               * (df 45 0) 81 c5 spsmaxt c3*/
              if(rpnsln) { fatal=1; yyerror("return: something on stack"); }
              RAL(bops,blen+19,char);
              if(ftp==SFLOAT||ftp==SDOUBLE)
              { bops[blen++]=0xdf; bops[blen++]=0x45; bops[blen++]=0; }
              if(spsmaxt)
               if(spsmaxt<128&&spsmaxt>=-128)
               { bops[blen++]=0x83; bops[blen++]=0xc4; bops[blen++]=spsmaxt; }
               else
               { bops[blen++]=0x81; bops[blen++]=0xc4;
                 *(dwordptr)(bops+blen)=spsmaxt; blen+=4;
               }
              bops[blen++]=0x61; bops[blen++]=0xc3;
             break;
             case OVALRET:
              /* if int put in ax; jmp to handle; float put on stack */
              /* figure out how to put something on the stack and return */
              if(rpnsln!=1) { fatal=1; yyerror("ret:illegal # of arguments"); }
              rpp=rpnstk+(rpnsln-1);
              if(rpp->tp!=SSTRUCT) monoploadit(rpp,0,0);
              switch(rpp->tp%SUNSIGNED)
              { case SCHAR:
                 /* cbw||xor ah,ah
                  * cwde
                  * mov [bp+1c],eax
                  * (66 98||30 e4) 98 */
                 RAL(rpp->bops,rpp->blen+6,char);
                 if(rpp->tp>=SUNSIGNED) RS1=0x9866;
                 else RS1=0xe430;
                 RSI1; R1=0x98;
                goto valretint;
                case SSHORT:
                /* cwde */
                 RAL(rpp->bops,rpp->blen+4,char);
                 R1=0x98;
                goto valretint;
                case SLONG:
                case SINT:
                 /* mov [ebp+1c],erg /*poped into AX
                  * 89 45 1c */
                 RAL(rpp->bops,rpp->blen+4,char);
                valretint:
                 if(rpp->argreg<0||rpp->argreg>7) illegaltype("invalret");
                 R1=0x89; R1=0x45+(rpp->argreg<<3); R1=0x1c;
                break;
                case SPOINTER:
                 /* mov [ebp+10],erg /*poped into BX
                  * 89 45 10 */
                 RAL(rpp->bops,rpp->blen+3,char);
                 if(rpp->argreg<0||rpp->argreg>7)
                  illegaltype("invalret");
                 R1=0x89; R1=0x45+(rpp->argreg<<3); R1=0x10;
                break;
                case SFLOAT:
                case SDOUBLE: /* nothing */
                break;
                case SSTRUCT:
                 /* lea ebx,place
                  * mov ebx,offset place
                  * push size
                  * push ebx
                  * push transferarea location
                  * call memcpy
                  * add esp,0c
                  * ebxstuff 6a|68 size 53 68 extern e8 memcpy 83 c4 c */
                 leareg(rpp,1);

                 RAL(rpp->bops,rpp->blen+19,char);
                 if(rpp->size<128&&rpp->size>=-128)
                 { R1=0x6a; R1=rpp->size; } /* push sz */
                 else
                 { R1=0x68; RB1=rpp->size; RBI1; } /* push sz */
                 R1=0x50+rpp->argreg; R1=0x68;
                 RAL(rpp->exref,2+rpp->exrcnt,struct externxref);
                 rpp->exref[rpp->exrcnt].ptrfnc=0;
                 rpp->exref[rpp->exrcnt].off=rpp->blen;
                 rpp->exref[rpp->exrcnt++].scoff=structalloc(rpp->size);
                 RB1=0x0; RBI1;

                 R1=0xe8; /* this is call rel32. need link to account this */
                 rpp->exref[rpp->exrcnt].ptrfnc=0;
                 rpp->exref[rpp->exrcnt].off=rpp->blen;
                 rpp->exref[rpp->exrcnt++].scoff=allocmemcpy();
                 rpp->reguse[3].use=1; /* ebx from memcpy return */
                 RB1=0x0; RBI1;
                 RS1=0xc483; RSI1; R1=0xc;
                break;
                default: illegaltype("A");
              }
              /* add esp,spsmaxt
               * popad
               * ret
               * 81 c5 spsmaxt 61 c3*/
              RAL(rpp->bops,rpp->blen+8,char);
              if(spsmaxt)
               if(spsmaxt<128&&spsmaxt>=-128)
               { RS1=0xc483; RSI1; R1=spsmaxt; }
               else
               { RS1=0xc481; RSI1; RB1=spsmaxt; RBI1; }
              RS1=0xc361; RSI1;
              bopsload();
              if(rpnsln) { fatal=1; yyerror("endoffunc: something on stack"); }
             break;
             case OLDFNCARG:
              /* push on stack */
              /* after loadit; set up so that we don't have ever climb sz */
              rpp=rpnstk+(rpnsln-1);
              stkload(rpp);
              callstksz[calllev-1]+=typesize(1);
              if(!rpp->ncbcnt||!rpp->ncb[rpp->ncbcnt-1].call)
                illegaltype("LDF out of order");
              rpp->ncb[rpp->ncbcnt-1].off=rpp->blen;
              rpp->ncb[rpp->ncbcnt-1].nbp=rpp->bpoff;
              rpp->ncb[rpp->ncbcnt-1].hidn=0;
              /* code is placed in structure of nested calls! */
              rpp->combineflg=1; /* don't zero bpoff */
              rpp->gzf=rpp->gcsof=0;
             break;
             case OPOP:
              /* if memory or point issue warning; if float do fstp st0 if stck
               * add esp,2,4 or 8 */
              rpp=rpnstk+(rpnsln-1);
              switch(rpp->place)
              { case PCMEMORY:
                case PCLSTPOINT:
                 a=opcode[inp[scan-1].pos];
                 if(a!=OCALL&&a!=OCALL0)
                   yyerror("warning: something calculated isn't used");
                break;
                case PCMATH:
                 /* fstp st(0)
                  * dd d8 */
                 RAL(rpp->bops,rpp->blen+2,char);
                 RS1=0xd8dd; RSI1;
                break;
                case PCSTACK:
                 /* add esp,2/4/8
                  * 83 c4 2/4/8 */
                 RAL(rpp->bops,rpp->blen+3,char);
                 RS1=0xc483; RSI1;
                 switch(rpp->tp%SUNSIGNED)
                 { case SCHAR:
                   case SSHORT:
                   case SINT:
                   case SLONG:
                   case SPOINTER:
                   case SFLOAT:
                    R1=4;
                   break;
                   case SDOUBLE:
                    R1=8;
                   break;
                   default: illegaltype("u");
                 }
                break;
                default: fatal=1; yyerror("unknown place for OPOP");
                case PCREG:
                case PCCONST: ; /* FOR: { a=0,b=4; } */
              }
              rpp->gzf=rpp->gcsof=0;
              bopsload();
             break;
             case OSTCLL:
              /* set up diff. tbl to keep track of how much stack for each */
              callstksz[calllev++]=0;
              startncb++;
             break;
             case OCALL:
             case OCALL0:
              /* call seg:off
               * (CALL only): add esp,callstksz
               * (9a segmnt offset -or- seg ff genmem+3) 83/81 c4 imm8/imm16 */
              rpp=rpnstk+(rpnsln-1);
              if(rpp->place==PCMEMORY)
              { RAL(rpp->bops,rpp->blen+5,char);
                R1=0xe8; /* this is call rel32. need link to account this */
                RAL(rpp->exref,1+rpp->exrcnt,struct externxref);
                rpp->exref[rpp->exrcnt].ptrfnc=0;
                rpp->exref[rpp->exrcnt].off=rpp->blen;
                rpp->exref[rpp->exrcnt++].scoff=rpp->scoff;
                RB1=0x0; RBI1;
              }
             pointercall:
              if(opcode[inp[scan].pos]==OCALL)
              { /* add esp,size */
                RAL(rpp->bops,rpp->blen+6,char);
                if(callstksz[calllev-1]<=127&&callstksz[calllev-1]>=(-128))
                { RS1=0xc483; RSI1; R1=callstksz[calllev-1]; }
                else
                { RS1=0xc481; RSI1; RB1=callstksz[calllev-1]; RBI1; }
                rpp->bpoff+=callstksz[--calllev];
                if(--rpp->ncbcnt<0) illegaltype("1ncbcnt");
                if(!rpp->ncb[rpp->ncbcnt].call) illegaltype("not call");
                if(!rpp->ncbcnt) free(rpp->ncb);
                else RAL(rpp->ncb,rpp->ncbcnt,struct nestcombined);
              }
              rpp->boff=rpp->lexist=0;
              rpp->tp=opcode[inp[scan].pos+1];
              rpp->size=(*(dwordptr)(opcode+(inp[scan].pos+2)));
              switch(rpp->tp%SUNSIGNED)
              { case SCHAR:
                case SSHORT:
                case SINT:/*ax*/
                case SLONG:
                 rpp->place=PCREG;
                 rpp->argreg=0;
                 rpp->reguse->use=1;
                break;
                case SFLOAT:
                case SDOUBLE:
                 if(rpp->maxfltlev<1) rpp->maxfltlev=1;
                 rpp->place=PCMATH;
                break;
                case SPOINTER:/*es/bx*/
                 rpp->place=PCREG; rpp->argreg=3; rpp->reguse[3].use=1;
                break;
                case SSTRUCT:
                 /* make place=transfer location */
                 rpp->place=PCMEMORY;
                 rpp->sect=SCPUBLIC; /* structalloc already flags scoff */
                 rpp->scoff=structalloc(rpp->size);
                break;
                default: illegaltype("FUNC");
              }
              rpp->gzf=rpp->gcsof=0;
             break;
             case OPOINT:
              /* add cnst to locate ;boff=you know what*/
              rpp=rpnstk+(rpnsln-1);
              if(rpp->place!=PCMEMORY&&rpp->place!=PCLSTPOINT)
              { fatal=1; yyerror("not lval on . operator"); }
              rpp->boff+=(*(dwordptr)(opcode+inp[scan].pos+1));
              rpp->tp=opcode[inp[scan].pos+5]; rpp->lexist=0;
              rpp->size=(*(dwordptr)(opcode+inp[scan].pos+6));
              rpp->gzf=rpp->gcsof=0;
             break;
             case OFPOINT:
              /* this should currently be error */
              fatal=1; yyerror("field . not implemented");
             break;
             case OARROW:
              /* add const to pointer; like PTRCONVERT and POINT combined*/
              /* make existent pointer PCLSTPOINT. */
              rpp=rpnstk+(rpnsln-1);
              if(rpp->tp!=SPOINTER) { fatal=1; yyerror("-> on non-pointer"); }
              if(rpp->place!=PCREG) monoploadit(rpp,0,1);
              rpp->boff=(*(dwordptr)(opcode+inp[scan].pos+1));
              rpp->place=PCLSTPOINT;
              rpp->tp=opcode[inp[scan].pos+5]; rpp->lexist=0;
              rpp->size=(*(dwordptr)(opcode+inp[scan].pos+6));
              rpp->gzf=rpp->gcsof=0;
             break;
             case OFARROW:
              /* currently error */
              fatal=1; yyerror("field -> not implement misc");
             break;
             case OLASTASGN:
              /* if ip-1 was convert reconvert; see below*/
              rpp=rpnstk+(rpnsln-1);
              monoploadit(rpp,1,0); /* if last is addition on pointer */
              if(!rpp->lexist||(rpp->lplace!=PCMEMORY&&rpp->lplace!=PCLSTPOINT))
              { fatal=1; yyerror("op= doesn't have an lvalue"); printrpn(rpp); }
              memtmp=genmemin(rpp->llprg,rpp->lplace,-1,rpp->sect,rpp->scoff
                ,rpp->lboff,1,rpp->bpoff);
              switch(rpp->ltp%SUNSIGNED)
              { case SCHAR:
                 movechar(rpp);
                 x=0x88;
                goto lasgnint;
                case SINT:
                case SLONG:
                case SPOINTER:
                 x=0x89;
                lasgnint:
                 /* mov [mem],erg/rl
                  * seg 88/89 mem */
                 RAL(rpp->bops,rpp->blen+memtmp.sz+5,char);
                 if(rpp->argreg<0||rpp->argreg>7)
                 { fatal=1; yyerror("illegal register LSTASGN"); }
                 R2=x; *memtmp.stf+=rpp->argreg<<3;
                 memcpy(rpp->bops+rpp->blen,memtmp.stf,memtmp.sz);
                 rpp->blen+=memtmp.sz;
                 xrfill(rpp,memtmp);
                break;
                case SSHORT:
                 /* operand: mov [mem],rg/rl
                  * 66 seg 88/89 mem */
                 RAL(rpp->bops,rpp->blen+memtmp.sz+5,char);
                 R2=0x66;
                 if(rpp->argreg<0||rpp->argreg>7)
                 { fatal=1; yyerror("illegal register LSTASGN"); }
                 R2=0x89; *memtmp.stf+=rpp->argreg<<3;
                 memcpy(rpp->bops+rpp->blen,memtmp.stf,memtmp.sz);
                 rpp->blen+=memtmp.sz;
                 xrfill(rpp,memtmp);
                break;
                case SSTRUCT:
                 fatal=1; yyerror("struct op= struct is illegal");
                break;
                case SFLOAT:
                 x=0xd9;
                goto lasgnflt;
                case SDOUBLE:
                 /* fst(p) dw/qw [mem]
                  * d9/dd mem+(2/3)<<3 */
                 x=0xdd;
                lasgnflt:
                 RAL(rpp->bops,rpp->blen+memtmp.sz+1,char);
                 R2=x; *memtmp.stf+=opcode[inp[scan+1].pos]==OPOP?24:16;
                 memcpy(rpp->bops+rpp->blen,memtmp.stf,memtmp.sz);
                 rpp->blen+=memtmp.sz;
                 xrfill(rpp,memtmp);
                break;
                default: illegaltype("v");
              }
              rpp->boff=rpp->lexist=0;
              if(opcode[inp[scan+1].pos]==OPOP)
              { scan++; bopsload(); }
              rpp->gzf=rpp->gcsof=0;
             break;
             case OASSIGN:
              /* MUST BE MEMORY;store there if ip+1=OPOP: use fstp else fst */
              if(rpp->place!=PCMEMORY&&rpp->place!=PCLSTPOINT)
              { fatal=1; yyerror("= doesn't have an lvalue"); printrpn(rpp); }
              if(rpp->tp!=SSTRUCT)
                bo=binaryloadit(1,1,0,0,RGNONE,0,0,-1,0,0,0,0);
              /*SC/DST/noSM/nostch/norg/NA/rgfld/nomth/nodt/dxok/nlstASgn,ncj*/
              lstasgflg=opcode[inp[scan+1].pos]==OPOP;
              switch(rpp->tp%SUNSIGNED)
              { case SCHAR:
                 movechar(rpp);
                 x=0x88;
                goto asgnint;
                case SLONG:
                case SPOINTER:
                case SINT:
                 x=0x89;
                asgnint:
                 /* mov [mem],erg
                  * seg 88/89 mem */
                 if(bo.const)
                 { addinstr(rpp,bo,x==0x89?0xc7:0xc6);
                   RAL(rpp->bops,rpp->blen+4,char);
                   if(x==0x89) { RB2=bo.cval; RBI2; }
                   else R2=bo.cval;
                 }
                 else addinstr(rpp,bo,x);
                break;
                case SSHORT:
                 RAL(rpp->bops,rpp->blen+1,char);
                 R2=0x66; /* operand size prefix */
                 if(bo.const)
                 { addinstr(rpp,bo,0xc7);
                   RAL(rpp->bops,rpp->blen+2,char);
                   RS2=bo.cval; RSI2;
                 }
                 else addinstr(rpp,bo,0x89);
                break;
                case SSTRUCT:
                 /*  rpn-1 lastpoint bx
                  * push size
                  * push ebx
                  *  rpp lastpoint bx
                  * push ebx
                  * call memcpy
                  * add esp,0c
                  * 6a|68 sz 53 stf 53 e8 memcpy 83 c4 0c */
                 a=leareg(rpp,0);
                 RAL(rpp->bops,rpp->blen+1,char);
                 R1=0x50+a;
                 rpp->bpoff-=4;

                 rpp++; /* rpn-1 */
                 if(rpp->tp!=SSTRUCT)
                 { fatal=1; yyerror("bad struct types"); }
                 a=leareg(rpp,0);
                 RAL(rpp->bops,rpp->blen+2+soint,char);
                 if(rpp->size<128&&rpp->size>=-128)
                 { R1=0x6a; R1=rpp->size; } /* push sz */
                 else
                 { R1=0x68; RB1=rpp->size; RBI1; } /* push sz */
                 R1=0x50+a; /* push ebx */
                 rpp->bpoff-=8;

                 rpp--; /* rpn-2 */
                 { struct stack rpn;
                   rpn= *rpp; *rpp= rpnstk[rpnsln-1]; rpnstk[rpnsln-1]=rpn;
                 }
                 for(a=0;a<8;a++) rpp->reguse[a].use|=rpp[1].reguse[a].use;
                 combinerpns(rpp+1,rpp,1);

                 RAL(rpp->bops,rpp->blen+8,char);
                 R2=0xe8; /* this is call rel32. need link to account this */
                 RAL(rpp->exref,1+rpp->exrcnt,struct externxref);
                 rpp->exref[rpp->exrcnt].ptrfnc=0;
                 rpp->exref[rpp->exrcnt].off=rpp->blen;
                 rpp->exref[rpp->exrcnt++].scoff=allocmemcpy();
                 rpp->reguse[3].use=1; /* ebx from memcpy return */
                 RB2=0x0; RBI2;
                 RS2=0xc483; RSI2; R2=0xc;
                 rpp->bpoff+=12;

                 rpp->gzf=rpp->gcsof=0;
                 /*fatal=1; yyerror("struct=struct not implemented");*/
                break;
                case SFLOAT:
                 x=0xd9;
                goto asgnflt;
                case SDOUBLE:
                 /* fst(p) dw/qw [mem]
                  * d9/dd mem+(2/3)<<3 */
                 x=0xdd;
                asgnflt:
                 RAL(rpp->bops,rpp->blen+bo.m.sz+1,char);
                 R2=x; *bo.m.stf+=lstasgflg?24:16;
                 memcpy(rpp->bops+rpp->blen,bo.m.stf,bo.m.sz);
                 rpp->blen+=bo.m.sz;
                 xrfill(rpp,bo.m); rpp->place=PCMATH;
                break;
                default: illegaltype("w");
              }
              rpp->boff=rpp->lexist=0;
              rpp->gzf=rpp->gcsof=0;
              rpnsln--;
              if(lstasgflg)
              { scan++; bopsload(); }
             break;
/*IAMfuture: restrict # of registers saved by keeping track of usage and adding
more to xref because of differing room needed*/
             case OFUNC:
             case OSTATFUNC:
fprintf(stderr,"func [%s]\n",opcode+inp[scan].pos+1);
              /* nothing; figuring out heading wil be done after func intern.
                 are scanned */
              /* not above: init bpoff not;add code for init memory,etc; */
              /* pushad
               * mov ebp,esp
               * sub esp,spsmaxt
               * 60 8b ec 81 ec spsmaxt */
              a=strlen(opcode+inp[scan].pos+1);
              RAL(bops,blen+a+20+solong,char);
              bops[blen++]=opcode[inp[scan].pos]; /* keep track wether STAT */
              memcpy(bops+blen,opcode+inp[scan].pos+1,a+2); blen+=a+2;
              if(opcode[inp[scan].pos+a+2]==SSTRUCT
                ||opcode[inp[scan].pos+a+2]==SPOINTER)
              { *(dwordptr)(bops+blen)=(*(dwordptr)(inp[scan].pos+a+3+opcode));
                blen+=solong;
              }
              bops[blen++]=0x60; bops[blen++]=0x8b; bops[blen++]=0xec;
              if(spsmaxt)
               if(spsmaxt<128&&spsmaxt>=(-128))
               { bops[blen++]=0x83; bops[blen++]=0xec; bops[blen++]=spsmaxt; }
               else
               { bops[blen++]=0x81; bops[blen++]=0xec;
                 *(dwordptr)(bops+blen)=spsmaxt; blen+=4;
               }
              for(a=1;opcode[inp[scan].pos+a++];);
              b=opcode[inp[scan].pos+a++];
              if(b==SPOINTER||b==SSTRUCT) a+=4;
              a+=4;
             goto funcldpredef;
             case OBLOCK:
              a=5;
             funcldpredef:
              /* handle total stack needed for function;use stck;tot&maxt
               * bpoff will already be initialized from 1st pass
               * load autinit stuff */
              if(rpnsln)
              { fatal=1; yyerror("stuff on stack at new { state }"); }
              b=(*(dwordptr)(opcode+inp[scan].pos+a)); a+=4;
               /*size array*/
              while(b)
              { int toff,tlen;
                toff=(*(dwordptr)(opcode+inp[scan].pos+a))-spsmaxt;
                a+=4;
                 /* stkoff */
                b-=solong+1+(tlen=opcode[inp[scan].pos+a++]);
                switch(tlen) /* length of value */
                { case 1:
                   /* mov [bp+],imb
                    * c6 45/85 off byte */
                   RAL(bops,blen+7,char);
                   bops[blen++]=0xc6;
                   if(toff<=127&&toff>=(-128))
                   { bops[blen++]=0x45; bops[blen++]=toff; }
                   else
                   { bops[blen++]=0x85;
                     *(dwordptr)(bops+blen)=toff; blen+=4;
                   }
                   bops[blen++]=opcode[inp[scan].pos+a++];
                  break;
                  case 2:
                   /* operand: mov [bp+],imm16 */
                   RAL(bops,blen+9,char);
                   bops[blen++]=0x66;
                   bops[blen++]=0xc7;
                   if(toff<=127&&toff>=(-128))
                   { bops[blen++]=0x45; bops[blen++]=toff; }
                   else
                   { bops[blen++]=0x85;
                     *(dwordptr)(bops+blen)=toff; blen+=4;
                   }
                   *(wordptr)(bops+blen)=(*(wordptr)
                    (opcode+inp[scan].pos+a));
                   a+=2; blen+=2;
                  break;
                  case 4:
                  case 8:
                   /* mov [bp+],imm16 */
                   RAL(bops,blen+3*tlen,char);
                   for(;tlen;tlen-=4)
                   { bops[blen++]=0xc7;
                     if(toff<=127&&toff>=(-128))
                     { bops[blen++]=0x45; bops[blen++]=toff; }
                     else
                     { bops[blen++]=0x85;
                       *(dwordptr)(bops+blen)=toff; blen+=4;
                     }
                     *(dwordptr)(bops+blen)=(*(dwordptr)
                      (opcode+inp[scan].pos+a));
                     a+=4; blen+=4; toff+=4;
                   }
                  break;
                  default: yyerror("illegal autoinit size");
                }
              }
/*fprintf(stderr
,"[scan].pos %d  [scan+1].pos %d  a(off) %d  size of init array %d\n"
,inp[scan].pos,inp[scan+1].pos,a,b);*/
             break;
             default: fprintf(stderr,"#2unknown pseudocode %d\n",ch);
           }
          break;
          case TLABEL: /* add to str label */
           SRDLABEL(opcode+inp[scan].pos+1,b);
           if(rpnsln)
           { rpp=rpnstk+(rpnsln-1);
             for(a=0;a<rpp->loccnt;a++)
              if(rpp->loc[a].lab==b)
              { if(rpp->loc[a].place==PCMATH) fltload(rpp);
                else
                { monoploadit(rpp,1,0);
                  if(rpp->place!=PCREG||rpp->argreg!=rpp->loc[a].argreg)
                  { regloadit(rpp,rpp,rpp->place,rpp->place==PCSTACK
                      ?-1:rpp->argreg,0,rpp->loc[a].argreg);
                    rpp->place=PCREG; rpp->argreg=rpp->loc[a].argreg;
                    rpp->boff=0;
                  }
if(rpp->tp!=rpp->loc[a].tp)
{ fatal=1; yyerror("type mismatch with ?:"); }
                  rpp->tp=rpp->loc[a].tp;
                  if(rpp->loc[a].place!=PCREG) illegaltype("labreg");
                }
               break;
              }
             for(a=0;a<rpp->hblkcnt;a++)
               if(b==rpp->hblk[a].srchlab) rpp->hblk[a].cntnusrch=0;
             if(!rpp->lbcnt) { AL(rpp->lbt,1,struct labels); }
             else RAL(rpp->lbt,rpp->lbcnt+1,struct labels);
             rpp->lbt[rpp->lbcnt].off=rpp->blen;
             rpp->lbt[rpp->lbcnt++].block=b;
             rpp->gzf=rpp->gcsof=0;
           }
           else
           { if(b>=lbtbllen)
             { RAL(lbtbl,b+1,struct labels);
               while(b>=lbtbllen) lbtbl[lbtbllen++].here=0;
             }
             if(lbtbl[b].here)
             { fatal=1; sprintf(temp,"2 definitions of label number %d",b);
               yyerror(temp);
             }
             lbtbl[b].block=blcnt-1;
             lbtbl[b].off=blen;
             lbtbl[b].here=1;
           }
          break;
          case TJMP: /* start new str block */
           if(rpnsln)
           { struct locations *lcn;
             rpp=rpnstk+(rpnsln-1);
             monoploadit(rpp,0,0); rpp->lexist=0;
             RAL(rpp->bops,rpp->blen+2,char);
             RSI1;
             if(rpp->loccnt) { RAL(rpp->loc,rpp->loccnt+1,struct locations); }
             else AL(rpp->loc,1,struct locations);
             lcn=rpp->loc+rpp->loccnt++;
             srchlab=lcn->lab=(*(labelptr)(opcode+(inp[scan].pos+1)));
             lcn->tp=rpp->tp;
             lcn->place=rpp->place;
             if(lcn->place==PCREG)
             { if(rpp->argreg<0||rpp->argreg>7)
               { fatal=1; yyerror("location"); rpp->argreg=0;/*recovery*/ }
               lcn->argreg=rpp->argreg;
             }
             rpp->gzf=rpp->gcsof=0;
           }
           else
           { RAL(bops,blen+2,char);
             blen+=2;
           }
          goto ldnewblock;
          case TTESTJMP:
          /*MORE: add indicator if flags set properly already */
           rpp=rpnstk+(rpnsln-1);
           if(rpp->gzf)
           { int t;
             t=rpp->tp%SUNSIGNED;
             if(t!=SCHAR&&t!=SSHORT&&t!=SINT&&t!=SLONG)
                illegaltype("zero flag");
             RAL(rpp->bops,rpp->blen+5,char);
           }
           else
           { bo=monoploadit(rpp,0,0);
             switch(rpp->tp%SUNSIGNED)
             { case SCHAR:
                if(rpp->place!=PCREG||rpp->argreg<0||rpp->argreg>7)
                   illegaltype("1TESTJMP arg");
                /* or rl,rl
                 * 08 mem+rg */
                *bo.m.stf+=(rpp->argreg<<3);
                addinstr(rpp,bo,0x8);
                RAL(rpp->bops,rpp->blen+9,char);
               break;
               case SSHORT:
                /* or rg,rg
                 * 66 09 c0+rg<<3 */
                RAL(rpp->bops,rpp->blen+1,char);
                R1=0x66;
               ttestreg:
                if(rpp->place!=PCREG||rpp->argreg<0||rpp->argreg>7)
                   illegaltype("2TESTJMP arg");
                *bo.m.stf+=(rpp->argreg<<3);
                addinstr(rpp,bo,0x9);
                RAL(rpp->bops,rpp->blen+9,char);
               break;
               case SINT:
               case SLONG:
               case SPOINTER:
                /* or erg,erg
                 * 09 c0+rg<<3 */
               goto ttestreg;
               case SFLOAT:
               case SDOUBLE:
                /* ftst
                 * fstsw ax
                 * sahf
                 * d9 e4 df e0 9e */
                RAL(rpp->bops,rpp->blen+15,char);
                RS1=0xe4d9; RSI1; RS1=0xe0df; RSI1; R1=0x9e;
               break;
               default: illegaltype("x");
             }
           }
           /* jz off8
            * jmp off8
            */
           if(inp[scan].sp) rpp->blen+=2; /* jz short */
           else rpp->blen+=4; /* jz short;jmp short */
           if(rpnsln==1&&!nestquest) bopsload();
           srchlab=(*(labelptr)(opcode+(inp[scan].pos+3)));
          goto ldnewblock;
          case TCMPJMP: /* start new str block */
           a=opcode[inp[scan].pos]; a=a==OEQ||a==ONEQ;
           if(rpp->place==PCCONST&&rpp->cval==0&&((rpnstk[rpnsln-1].gzf
             &&rpnstk[rpnsln-1].gcsof)||(rpnstk[rpnsln-1].gzf&&a)))
           { int t;
             bo.swtched=1;
             t=rpnstk[rpnsln-1].tp%SUNSIGNED;
             if(t!=SCHAR&&t!=SSHORT&&t!=SINT) illegaltype("2zero flag");
             RAL(rpp->bops,rpp->blen+5,char);
             if(rpp->tp!=rpnstk[rpnsln-1].tp)
             { yyerror("1not converted right"); }
             *rpp=rpnstk[rpnsln-1];
           }
           else if(rpnstk[rpnsln-1].place==PCCONST&&rpnstk[rpnsln-1].cval==0
             &&((rpp->gzf&&rpp->gcsof)||(rpp->gzf&&a)))
/*MERE:NOT NOW. enable gzf for float and allow use of ftst when 0 */
           { int t;
             bo.swtched=0;
             t=rpp->tp%SUNSIGNED;
             if(t!=SCHAR&&t!=SSHORT&&t!=SINT) illegaltype("3zero flag");
             RAL(rpp->bops,rpp->blen+5,char);
             if(rpp->tp!=rpnstk[rpnsln-1].tp)
             { yyerror("2not converted right"); }
           }
           else
           { bo=binaryloadit(1,0,1,1,RGNONE,0,0,-1,0,1,0,0);
             /*SC,nDM,SM,swchble,norstr,NA,nolm,lngmth,nolgdf,ndx,nlstas,cjmp*/
             if(rpp->tp!=rpnstk[rpnsln-1].tp&&((rpp->tp==SPOINTER
               &&rpnstk[rpnsln-1].tp!=SINT)||(rpp->tp==SINT
               &&rpnstk[rpnsln-1].tp!=SPOINTER)))
             { yyerror("not converted right"); }
             switch(rpp->tp%SUNSIGNED)
             { case SCHAR: a=0x38;
                if(bo.const)
                { /* cmp rg1,cnst */
                  addinstr(rpp,bo,0x80);
                  RAL(rpp->bops,rpp->blen+9,char);
                  R2=bo.cval;
                 break;
                }
               goto comparison;
               case SINT:
               case SPOINTER:
               case SLONG:
                a=0x39;
               comparison:
                /* cmp erg1/rgl1,erg2/rgl2
                 * 38/39 c8 */
                if(bo.const) addcinstr(rpp,bo,a>>3); /* cmp arg,const */
                else addinstr(rpp,bo,a); /* cmp arg,arg */
                RAL(rpp->bops,rpp->blen+9,char);
               break;
               case SSHORT:
                /* cmp rg1,rg2
                 * 66 39 c8 */
                RAL(rpp->bops,rpp->blen+1,char);
                R1=0x66;
                if(bo.const) addcinstr(rpp,bo,0x39>>3); /* cmp arg,const */
                else addinstr(rpp,bo,0x39); /* cmp arg,arg */
                RAL(rpp->bops,rpp->blen+9,char);
               break;
               case SFLOAT:
               case SDOUBLE:
                if(bo.fltsrcmem)
                { RAL(rpp->bops,rpp->blen+bo.m.sz+1,char);
                  switch(bo.tp)
                  { case SDOUBLE: /*fcomp qw []*/
                     R2=0xdc;
                     *bo.m.stf+=0x18;
                    break;
                    case SFLOAT:  /*fcomp dw []*/
                     R2=0xd8;
                     *bo.m.stf+=0x18;
                    break;
                    default: illegaltype("OCMPJMP");
                  }
                  memcpy(rpp->bops+rpp->blen,bo.m.stf,bo.m.sz);
                  rpp->blen+=bo.m.sz;
                  xrfill(rpp,bo.m);
                }
                else
                { RAL(rpp->bops,rpp->blen+2,char);
                  RS2=0xd9de; RSI2; /* fcompp st(1),st */
                  bo.swtched= !bo.swtched;
                }
                RAL(rpp->bops,rpp->blen+11,char);
                RS1=0xe0df; RSI1; R1=0x9e; /* fstsw ax; sahf */
                rpp->place=PCMATH;
                   /*not really, but simplest method to signal unsing*/
               break;
               default: illegaltype("y");
             }
           }
           if(inp[scan].sp) rpp->blen+=2; /* jcc short */
           else rpp->blen+=4; /* jcc short;jmp short */
           rpnsln--;
           if(rpnsln==1&&!nestquest) bopsload();
           srchlab=(*(wordptr)(opcode+(inp[scan].pos+3)));
          goto ldnewblock;
          case TCASECMP: /* start new str block */
           if(rpnsln)
           { rpp=rpnstk+(rpnsln-1);
             monoploadit(rpp,0,0);
             lastcaserg=rpp->argreg;
             if(lastcaserg<0||lastcaserg>7||rpp->place!=PCREG
               ||rpp->tp%SUNSIGNED!=SINT)
              illegaltype("a");
             bopsload();
           }
           if(rpnsln) illegaltype("stack exists in casecmp");
           RAL(bops,blen+10,char);
           a=(*(dwordptr)(opcode+inp[scan].pos+1));
           if(a<128&&a>=-128)
           { bops[blen++]=0x83; /* cmp erg,ib */
             bops[blen++]=0xf8+lastcaserg; bops[blen++]=a;
           }
           else if(!lastcaserg) /*==AX*/
           { bops[blen++]=0x3d;  /* cmp eax,idw */
             *(dwordptr)(bops+blen)=a; blen+=4;
           }
           else
           { bops[blen++]=0x81; /* cmp erg,idw */
             bops[blen++]=0xf8+lastcaserg;
             *(dwordptr)(bops+blen)=a; blen+=4;
           }
           blen+=2; /*small jump*/
          ldnewblock:
           if(rpnsln)
           { struct hiddenblock *hbk;
             /* put in table in rpnstk */
             rpp=rpnstk+(rpnsln-1);
             for(a=0;a<rpp->ncbcnt;a++) rpp->ncb[a].hidn++;
             if(!rpp->hblkcnt) { AL(rpp->hblk,1,struct hiddenblock); }
             else RAL(rpp->hblk,rpp->hblkcnt+1,struct hiddenblock);
             hbk=rpp->hblk+rpp->hblkcnt++;
             hbk->lbt=rpp->lbt;           hbk->lbcnt=rpp->lbcnt;
             hbk->bops=rpp->bops;         hbk->blen=rpp->blen;
             hbk->bpxref=rpp->bpxref;     hbk->bpxcnt=rpp->bpxcnt;
             hbk->exref=rpp->exref;       hbk->exrcnt=rpp->exrcnt;
             hbk->swtched=bo.swtched;
             hbk->unsgn=rpp->tp>=SUNSIGNED||rpp->tp==SPOINTER
                ||rpp->place==PCMATH;
             hbk->jmppos=scan;
             hbk->cntnusrch=1; hbk->srchlab=srchlab;
             rpp->combineflg=1; /* 0 bpoff */
             rpp->lbcnt=rpp->blen=rpp->bpxcnt=rpp->exrcnt=0;
             AL(rpp->exref,1,struct externxref);
             AL(rpp->bpxref,1,long);
             AL(rpp->bops,1,char);
           }
           else
           { RAL(block,blcnt+1,struct block);
             block[blcnt].outoff=block[blcnt-1].outoff+blen;
             block[blcnt-1].len=blen; block[blcnt-1].ops=bops;
             block[blcnt-1].virtualm=VMNEW;
             virtualmfree(blcnt-1);
             block[blcnt-1].jmppos=scan;
             block[blcnt-1].swtched=bo.swtched;
             block[blcnt-1].unsgn=rpp->tp>=SUNSIGNED||rpp->tp==SPOINTER
                ||rpp->place==PCMATH;
             block[blcnt-1].jmpsz=JSSMALL;
             AL(bops,1,char);
             blen=0;
             blcnt++;
           }
          break;
          default:
           fatal=1;
           yyerror("internal error: unknown inp.tp\n");
        }
      }
/*IAM(future): register usage optimisation: see OFUNC*/
      /* ? fild wo [bp]
       * add esp,spsmaxt
       * popad
       * ret
       * (df 45 0) 81 c5 spsmaxt 61 c3*/
      if(rpnsln) { fatal=1; yyerror("endofprog: something on stack"); }
      RAL(bops,blen+17,char);
      if(ftp==SFLOAT||ftp==SDOUBLE)
      { bops[blen++]=0xdf; bops[blen++]=0x45; bops[blen++]=0; }
      if(spsmaxt)
       if(spsmaxt<128&&spsmaxt>=-128)
       { bops[blen++]=0x83; bops[blen++]=0xc4; bops[blen++]=spsmaxt; }
       else
       { bops[blen++]=0x81; bops[blen++]=0xc4;
         *(dwordptr)(bops+blen)=spsmaxt; blen+=4;
       }
      bops[blen++]=0x61; bops[blen++]=0xc3;
      RAL(block,blcnt+1,struct block);
      block[blcnt].outoff=block[blcnt-1].outoff+blen;
      block[blcnt-1].virtualm=VMNEW;
      block[blcnt-1].len=blen; block[blcnt-1].ops=bops;
      AL(bops,1,char); /* because it is freed/ then RAL */
      block[blcnt-1].jmppos=scan;
     /*PASS3:
      * optimise jump offset type (near; far)
      */
      if(labxcnt>=lbtbllen)
      { RAL(lbtbl,labxcnt+1,struct labels);
        while(labxcnt>=lbtbllen) lbtbl[lbtbllen++].here=0;
      }
      for(a=0;a<labxcnt;a++)
      { if(!labxref[a].xrefed||labxref[a].dst==a) continue;
        for(itmp=b=a;labxref[b].xrefed&&labxref[b].dst!=b
           ;itmp=b,b=labxref[b].dst);
        b=itmp;
if(labxref[b].dst>=lbtbllen||!lbtbl[labxref[b].dst].here)
{ fatal=1; yyerror("internal error deleted jmp"); }
        lbtbl[a]=lbtbl[labxref[b].dst];
      }
/* CHECK all offsets ENCODE all jmps here(not above/although up mks room)
 * REALLOCATE(and flag that such was done) if needed for longer jmps
 * repeat ENTIRE process until flag doesn't get set
 */
      do
      { itmp=0;
        for(a=0;a<blcnt-1;a++)
        { virtualmalloc(a);
          switch(inp[block[a].jmppos].tp)
          { case TCMPJMP:
            case TTESTJMP:
             x=(*(labelptr)(opcode+inp[block[a].jmppos].pos+(1+SAL)));
             if(!lbtbl[x].here)
             { sprintf(temp,"0unknown label %d",x); fatal=1; yyerror(temp); }
             j2off=block[lbtbl[x]
               .block].outoff+lbtbl[x].off-(block[a].outoff+block[a].len);
             x=(*(labelptr)(opcode+inp[block[a].jmppos].pos+1));
             if(!lbtbl[x].here)
             { sprintf(temp,"1unknown label %d",x); fatal=1; yyerror(temp); }
             j1off=block[lbtbl[x]
               .block].outoff+lbtbl[x].off-(block[a].outoff+block[a].len);
             if(inp[block[a].jmppos].sp)
             { /* SPECIAL SHORT (both)
                * jcc short
                * xx bt
                * SPECIAL LONG (both)
                * jcc imm32
                * 0f xx+10 long */
               if(inp[block[a].jmppos].sp==TSPECIAL1) j1off=j2off;
               if(j1off<128&&j1off>=-128) /*Small*/
               { block[a].ops[block[a].len-2]=genjcc(inp[block[a].jmppos].pos
                  ,block[a].swtched,inp[block[a].jmppos].sp==TSPECIAL1
                  ,block[a].unsgn);
                 block[a].ops[block[a].len-1]=j1off;
               }
               else
               { if(block[a].jmpsz==JSSMALL)
                 { RAL(block[a].ops,block[a].len+4,char);
                   block[a].len+=4;
                   block[a].jmpsz=JS1BIG;
                   for(itmp=a+1;itmp<blcnt;itmp++) block[itmp].outoff+=4;
                   itmp=1;
                 }
                 block[a].ops[block[a].len-6]=0x0f;
                 block[a].ops[block[a].len-5]=genjcc(inp[block[a].jmppos].pos
                  ,block[a].swtched,inp[block[a].jmppos].sp==TSPECIAL1
                  ,block[a].unsgn)+0x10;
                 *(dwordptr)(block[a].ops+(block[a].len-4))=j1off;
               }
             }
             else
             { int is2;
               /* SMALL:
                * jcc short
                * jmp short
                * xx bt eb bt
                * 1BIG:
                * 2BIG:
                * jcc short
                * jmp long
                * xx bt e9 long
                * ABIG:
                * jcc long
                * jmp long
                * 0f xx+10 long e9 long */
               b=block[a].jmpsz;
               if(j1off<126&&j1off>=-130&&j2off<128&&j2off>=-128) /* SMALL */
               { block[a].ops[block[a].len-4]=genjcc(inp[block[a].jmppos].pos
                  ,block[a].swtched,0,block[a].unsgn);
                 block[a].ops[block[a].len-3]=j1off+2;
                 block[a].ops[block[a].len-2]=0xeb;
                 block[a].ops[block[a].len-1]=j2off;
               }
/*MERE:future reversed small */
               else if((is2=j2off<123&&j2off>=-133)||(j1off<123&&j1off>=-133))
               { if(b==JSSMALL)
                 { RAL(block[a].ops,block[a].len+3,char);
                   block[a].len+=3;
                   block[a].jmpsz=JS1BIG;
                   for(itmp=a+1;itmp<blcnt;itmp++) block[itmp].outoff+=3;
                   itmp=1;
                 }
                 block[a].ops[block[a].len-7]=genjcc(inp[block[a].jmppos].pos
                  ,block[a].swtched,is2,block[a].unsgn);
                 block[a].ops[block[a].len-6]=(is2?j2off:j1off)+5;
                 block[a].ops[block[a].len-5]=0xe9;
                 *(dwordptr)(block[a].ops+(block[a].len-4))
                  =is2?j1off:j2off;
               }
/*MERE:future possible use of long jcc makes alternate to above possible*/
               else /* ABIG */
               { if(b==JSSMALL)
                 { RAL(block[a].ops,block[a].len+7,char);
                   block[a].len+=7;
                   block[a].jmpsz=JSABIG;
                   for(itmp=a+1;itmp<blcnt;itmp++) block[itmp].outoff+=7;
                   itmp=1;
                 }
                 else if(b==JS1BIG)
                 { RAL(block[a].ops,block[a].len+4,char);
                   block[a].len+=4;
                   block[a].jmpsz=JSABIG;
                   for(itmp=a+1;itmp<blcnt;itmp++) block[itmp].outoff+=4;
                   itmp=1;
                 }
                 block[a].ops[block[a].len-11]=0x0f;
                 block[a].ops[block[a].len-10]=genjcc(inp[block[a].jmppos].pos
                  ,block[a].swtched,1,block[a].unsgn)+0x10;
                 *(dwordptr)(block[a].ops+(block[a].len-9))=j2off+5;
                 block[a].ops[block[a].len-5]=0xe9;
                 *(dwordptr)(block[a].ops+(block[a].len-4))=j1off;
               }
             }
            break;
            case TJMP:
             x=(*(labelptr)(opcode+inp[block[a].jmppos].pos+1));
             j1off=block[lbtbl[x]
               .block].outoff+lbtbl[x].off-(block[a].outoff+block[a].len);
             /* jmp short/long
              * eb/e9 short/long */
             if(j1off<128&&j1off>=-128) /*Small*/
             { block[a].ops[block[a].len-2]=0xeb;
               block[a].ops[block[a].len-1]=j1off;
             }
             else
             { if(block[a].jmpsz==JSSMALL)
               { RAL(block[a].ops,block[a].len+3,char);
                 block[a].len+=3;
                 block[a].jmpsz=JS1BIG;
                 for(itmp=a+1;itmp<blcnt;itmp++) block[itmp].outoff+=3;
                 itmp=1;
               }
               block[a].ops[block[a].len-5]=0xe9;
               *(dwordptr)(block[a].ops+(block[a].len-4))=j1off;
             }
            break;
            case TCASECMP:
             x=(*(labelptr)(opcode+inp[block[a].jmppos].pos+soint+1));
             if(!lbtbl[x].here)
             { sprintf(temp,"2unknown label %d",x); fatal=1; yyerror(temp); }
             j1off=block[lbtbl[x]
               .block].outoff+lbtbl[x].off-(block[a].outoff+block[a].len);
             /* SHORT (both)
              * je short
              * 74 bt
              * LONG (both)
              * je long
              * 0f 84 long */
             if(j1off<128&&j1off>=-128) /*Small*/
             { block[a].ops[block[a].len-2]=0x74;
               block[a].ops[block[a].len-1]=j1off;
             }
             else
             { if(block[a].jmpsz==JSSMALL)
               { RAL(block[a].ops,block[a].len+4,char);
                 block[a].len+=4;
                 block[a].jmpsz=JS1BIG;
                 for(itmp=a+1;itmp<blcnt;itmp++) block[itmp].outoff+=4;
                 itmp=1;
               }
               block[a].ops[block[a].len-6]=0x0f;
               block[a].ops[block[a].len-5]=0x84;
               *(dwordptr)(block[a].ops+(block[a].len-4))=j1off;
             }
            break;
            default: fatal=1; yyerror("unknown tp of instruction");
          }
          virtualmfree(a);
        }
      } while(itmp);
     /*PASS4:
      * write to disk
      */
      a=block[blcnt-1].outoff+block[blcnt-1].len;
      fwrite(&a,4,1,outfile);
      for(a=0;a<blcnt;a++)
      { /* write a "block" */
        virtualmalloc(a);
        fwrite(block[a].ops,block[a].len,sizeof(char),outfile);
        virtualmdump(a);
        free(block[a].ops);
      }
      for(a=0;a<exrcnt;a++) exref[a].off+=block[exref[a].blck].outoff;
      fwrite(&exrcnt,sizeof(long),1,outfile);
      fwrite(exref,sizeof(struct externxref),exrcnt,outfile);
     /*clear everything*/
      RAL(inp,BUFSZ,struct opcode);
      RAL(lbtbl,1,struct labels);
      if(!fread(&oplen,1,sizeof(oplen),infile)) break;
      RAL(opcode,oplen,char);
      fread(opcode,oplen,sizeof(char),infile);
      RAL(block,1,struct block);
      RAL(bops,1,char);
      RAL(exref,1,struct externxref);
      RAL(labxref,1,struct labxref);
    }
/*memintegritycheck();*/
    /* write out opcode- it contains all the necessary tables */
    fwrite(&oplen,sizeof(long),1,outfile);
    fwrite(opcode,1,oplen,outfile);
    fwrite(&exttblsz,sizeof(exttblsz),1,outfile);
    for(a=0;a<exttblsz;a++)
    { b=strlen(exttbl[a].nm)+1;
      fwrite(&b,1,1,outfile);
      fwrite(exttbl[a].nm,1,b,outfile);
      free(exttbl[a].nm);
      fwrite(&exttbl[a].scope,1,1,outfile);
      fwrite(&exttbl[a].tp,1,1,outfile);
      if(exttbl[a].tp==SPOINTER||exttbl[a].tp==SSTRUCT
         ||exttbl[a].tp==SARRAY)
        fwrite(&exttbl[a].size,sizeof(long),1,outfile);
      fwrite(&exttbl[a].prepres,1,1,outfile);
      if(exttbl[a].prepres)
      { fwrite(&exttbl[a].presz,sizeof(long),1,outfile);
        fwrite(exttbl[a].pre,1,exttbl[a].presz,outfile);
        free(exttbl[a].pre);
      }
    }
    /* close files and exit */
    fclose(infile);
    fclose(outfile);
  }
  exit(fatal);
}
